/**
 * Function to hide large MLC/Dyn settings values
 */
window.limit_ips_in_container = 100;
let list_x_tags = ['url', 'args', 'body', 'cookie', 'ua', 'referer', 'other_headers'];

$(document).ready(function () {
    let home = document.getElementById('home').textContent;
    var showChar = 600;
    var ellipsestext = "";
    var moretext = "";
    var lesstext = "";

    let data;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + '/get_settings_text/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            data = $.parseJSON(response);
            moretext = data.more_button_text;
            lesstext = data.less_button_text;

            $('.hide_items').each(function () {
                var content = $(this).html();

                if (content.length > showChar) {

                    var c = content.substr(0, showChar);
                    var h = content.substr(showChar, content.length - showChar);
                    var elements_number = h.split(",").length - 1;
                    var html;
                    if (elements_number === 0) {
                        html = c + '<span class="moreellipses">' + ellipsestext + '</span><span class="morecontent"><span>'
                            + h + '</span>&nbsp;&nbsp;' +
                            '<div style="margin-bottom: 9px"><button style="position: relative; left: 50%;" class="more_button">' + moretext + '</button></div>' +
                            '</span>';
                    } else {
                        html = c + '<span class="moreellipses">' + ellipsestext + '</span><span class="morecontent"><span>'
                            + h + '</span>&nbsp;&nbsp;' +
                            '<div style="margin-bottom: 9px"><button style="position: relative; left: 50%;" class="more_button">' + moretext + ' +' + elements_number + '</button></div>' +
                            '</span>';
                    }

                    $(this).html(html);
                }

            });

            $(".more_button").click(function () {
                if ($(this).hasClass("less")) {
                    $(this).removeClass("less");
                    let element_number = $(this)[0].parentElement.parentElement.firstChild.textContent.split(",").length - 1;
                    if (element_number === 0) {
                        $(this).html(moretext);
                    } else {
                        $(this).html(moretext + ' +' + element_number);
                    }
                } else {
                    $(this).addClass("less");
                    $(this).html(lesstext);
                }
                $(this).parent().prev().toggle();
                $(this).prev().toggle();
                return false;
            });

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });


});

/**
 * Function searches all occurrences of characters in a string
 * @param str Original string
 * @param substr Search string
 * @returns {*[]} Array of occurrences
 */
function getListIdx(str, substr) {
    let listIdx = [];
    let lastIndex = -1;
    while ((lastIndex = str.indexOf(substr, lastIndex + 1)) !== -1) {
        listIdx.push(lastIndex)
    }
    return listIdx
}

/**
 * Function to hide large data in action log table
 */
$(document).ready(function () {
    let home = document.getElementById('home').textContent;
    var ellipsestext = "";
    var moretext = "";
    var lesstext = "";
    var showLines = 10;

    let data;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + '/get_settings_text/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            data = $.parseJSON(response);
            moretext = data.more_button_text;
            lesstext = data.less_button_text;

            $('.hide_log').each(function () {
                var content = $(this).html();

                if (content.split('\n').length > showLines) {

                    var indx = getListIdx(content, '\n');

                    var c = content.substr(0, indx[showLines - 1]);
                    var h = content.substr(indx[showLines - 1], content.length - indx[showLines - 1]);
                    var html;

                    html = c + '<span class="moreellipses">' + ellipsestext + '</span><span class="morecontent"><span>'
                        + h + '</span>&nbsp;&nbsp;' +
                        '<div style="margin-bottom: 9px"><button style="position: relative; left: 50%;" class="more_button_log">' + moretext + '</button></div>' +
                        '</span>';


                    $(this).html(html);
                }

            });

            $(".more_button_log").click(function () {
                if ($(this).hasClass("less")) {
                    $(this).removeClass("less");

                    $(this).html(moretext);

                } else {
                    $(this).addClass("less");
                    $(this).html(lesstext);
                }
                $(this).parent().prev().toggle();
                $(this).prev().toggle();
                return false;
            });

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });


});

/**
 * Function to display the selected tab in the side menu
 */
$(document).ready(function () {
    let pathname = window.location.pathname.slice(0, -1);
    pathname = pathname.substring(pathname.lastIndexOf('/') + 1);
    if (pathname === 'keys') {
        $('.tab_list_keys').addClass('active');
    }
    if (pathname === 'dyn') {
        $('.tab_dyn_settings').addClass('active');
    }
    if (pathname === 'mlc') {
        $('.tab_mlc_settings').addClass('active');
    }
    if (pathname === 'rule_management') {
        $('.tab_rule_management').addClass('active');
    }
    if (pathname === 'bs') {
        $('.tab_bs_management').addClass('active');
    }
    if (pathname === 'action_log_tab') {
        $('.tab_action_log').addClass('active');
    }
});

$(document).ready(function () {
    $('.tab_rule_management').on('click', function () {
        function setCookie(name, value, options = {}) {
            options = {
                path: '/',
                ...options
            };
            if (options.expires instanceof Date) {
                options.expires = options.expires.toUTCString();
            }
            let updatedCookie = encodeURIComponent(name) + "=" + encodeURIComponent(value);
            for (let optionKey in options) {
                updatedCookie += "; " + optionKey;
                let optionValue = options[optionKey];
                if (optionValue !== true) {
                    updatedCookie += "=" + optionValue;
                }
            }
            document.cookie = updatedCookie;
        }

        function deleteCookie(name) {
            setCookie(name, "", {
                'max-age': -1
            })
        }

        deleteCookie('erl_page');
    });

});


/**
 * Sending a request to add a key
 */
function send_request_to_add_key() {
    let home = document.getElementById('home').textContent;
    $('#key_exist').css({'display': 'none'});
    $('#key_not_valid').css({'display': 'none'});
    $('#key_error').css({'display': 'none'});
    $('#tariff_not_valid').css({'display': 'none'});
    $('#email_error').css({'display': 'none'});
    $('#add_key_key_input').css({'border-color': '#D5E4F3'});
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + '/add_key/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#add_key_form').serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $('#key_exist').css({'display': 'none'});
            $('#key_not_valid').css({'display': 'none'});
            $('#waf_id_exist').css({'display': 'none'});
            $('#key_error').css({'display': 'none'});
            $('#email_error').css({'display': 'none'});
            $('#error_plan').css({'display': 'none'});
            $('#error_plan').css({'display': 'none'});
            if (response === '{"status": "key exist"}') {
                $('#key_exist').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "not valid"}') {
                $('#key_not_valid').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "waf id exist"}') {
                $('#waf_id_exist').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "error"}') {
                $('#key_error').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "email error"}') {
                $('#email_error').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "Not available for this plan"}') {
                $('#error_plan').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else {
                let key_length = $("#add_key_key_input").val().length;
                $("#last_row_key_table").before(response);
                $("#add_key_form")[0].reset();
                $("#add_key").modal("hide");
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });
}

/**
 * Sending a request to edit key
 * @param id Key id
 */
function edit_key(id) {
    let home = document.getElementById('home').textContent;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + '/edit_key/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#edit_key_form_' + id).serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            let description = $('#edit_key_input_' + id).val();
            data.keys.forEach(function (item, i, arr) {
                $('#list_key_table_row_description_' + item).text(description);
                $('#delete_key_input_' + item).val(description);
                $('#edit_key_input_' + item).val(description);
            });
            $("#key_edit_" + id).modal("hide");

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Sending a request to delete key
 * @param id Key id
 */
function removeKey(id) {
    let home = document.getElementById('home').textContent;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + '/remove_key/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {key_id: id},
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $("#list_key_table_row_" + id).hide();
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Function to show Add key modal window
 */
function show_modal_AddKey() {
    $("#add_key").modal("show");
}

/**
 * Function to show Add user modal window
 */
function show_modal_AddUser() {
    $("#email_exist").hide();
    $("#add_user").modal("show");
}

/**
 * Function to show Set user status modal window
 */
function show_modal_set_user_status(user_id) {
    $("#user_set_status_" + user_id).modal("show");
}

/**
 * Function to show Add ERL modal window
 * @param key_id Key id
 */
function show_modal_AddErl(key_id) {
    $('#add_erl_key').val(key_id);
    $("#add_erl").modal("show");
}

/**
 * Function to show Add Model modal window
 */
function show_modal_AddModel() {
    $("#add_model").modal("show");
}

/**
 * Function to show Model training modal window
 * @param key Key id
 * @param id_model Id model in table
 */
function show_modal_model_training(key, id_model) {
    $('#model_training_modal_key_input').val(key);
    $('#model_training_modal_counter_input').val(id_model);
    $("#model_training_modal").modal("show");
}

/**
 * Function to show Model copy modal window
 * @param key Key id
 * @param model Model name
 */
function show_modal_copy_model(key, model) {
    let home = document.getElementById('home').textContent;
    $('#exceeds_model_limit_error').hide();
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + '/get_vhost_list/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            $('#model_copy_modal_key_input').val(key);
            $('#model_copy_modal_src_model').val(model);
            $('#model_copy_modal_select').empty();
            $.each(data.vhost_list, function (index, value) {
                let option = '<option value="' + value + '">' + value + '</option>';
                $('#model_copy_modal_select').prepend(option);
            });

            let select_vhost_label = $('#model_copy_modal_select_label');
            let select_vhost_label_text = $('#model_copy_select_vhost_text').val();
            let new_select_vhost_label_text = select_vhost_label_text.slice(0, -1);
            select_vhost_label.text(new_select_vhost_label_text + ' ' + model + ':');

            $("#model_copy_modal").modal("show");
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });

}

/**
 * Function to show Model delete modal window
 * @param key Key id
 * @param id_model Id model in table
 */
function show_modal_model_delete(key, id_model) {
    $('#model_delete_modal_key_input').val(key);
    $('#model_delete_modal_counter_input').val(id_model);
    $("#model_delete_modal").modal("show");
}


/**
 * Function to show Add WL modal window
 * @param key_id Key id
 */
function show_modal_Add_WL(key_id) {
    $('#add_wl_key').val(key_id);
    $("#add_wl").modal("show");
}

/**
 * Function to show Edit WL modal window
 * @param rule_id Selected rule id
 * @param key_id Selected key id
 */
function show_modal_Edit_WL(rule_id, key_id) {
    $("#edit_wl_" + rule_id + '_' + key_id).modal("show");
}


/**
 * Function to show vhost training modal window
 * @param key_id Selected rule id
 * @param vhost Selected vhost
 */
function show_modal_vhost_set_training(key_id, vhost) {
    let home = document.getElementById('home').textContent;
    $("#vhost_set_training_key_id").val(key_id);
    $("#vhost_set_training_vhost").val(vhost);
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + '/get_model_duration/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key_id,
            model: vhost
        },
        
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            if (data.status === 'success') {
                $("#vhost_set_training_duration").val(data.duration);
            }
            $("#vhost_set_training").modal("show");
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });

}

/**
 * Tab's switching
 */
$(function () {
    $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
        let target = $(this).data('target') || $(this).attr('href');
        $('.left-sidebar').toggleClass('moved', target === '#tab_user_table');
        $('a[data-toggle="tab"]').each(function () {
            let element_target = $(this).data('target') || $(this).attr('href');
            $(this).toggleClass('active', target === element_target);
        });

        let tab_href = $(this).attr('href');
        if ((tab_href !== '#tab_user_table') && (typeof tab_href !== "undefined")
            && (tab_href !== '#modal_add_user') && ((tab_href !== '#modal_add_key'))) {
            $('#filter_list').hide();
            $('#add_user_button').hide();
        } else {
            $('#filter_list').show();
            $('#add_user_button').show();
        }

    });
});

/**
 * Function displays a question mark when hover the mouse over the setting name
 */
$(function () {
    let selected_element;
    $(".settings_label")
        .mouseenter(function (e) {
            let element_class = e.currentTarget.className;
            if (element_class.includes('openapi__vhost_list')) {
                selected_element = $('.openapi_vhosts_list_question');
                selected_element.show();
            }
            if (element_class.includes('vhosts_list')) {
                selected_element = $('.vhosts_list_question');
                selected_element.show();
            }
            if (element_class.includes('models_list')) {
                selected_element = $('.models_list_question');
                selected_element.show();
            }
            if (element_class.includes('ai_extra')) {
                selected_element = $('.ai_extra_question');
                selected_element.show();
            }
            if (element_class.includes('ddos_enable_label')) {
                selected_element = $('.ddos_enable_question');
                selected_element.show();
            }
            if (element_class.includes('ddos_wl_ip')) {
                selected_element = $('.ddos_wl_ip_question');
                selected_element.show();
            }
            if (element_class.includes('ddos_wl_url')) {
                selected_element = $('.ddos_wl_url_question');
                selected_element.show();
            }
            if (element_class.includes('ddos_interval')) {
                selected_element = $('.ddos_interval_question');
                selected_element.show();
            }
            if (element_class.includes('ddos_latest_only')) {
                selected_element = $('.ddos_latest_only_question');
                selected_element.show();
            }
            if (element_class.includes('ddos_send_possible')) {
                selected_element = $('.ddos_send_possible_question');
                selected_element.show();
            }
            if (element_class.includes('brute_enable_label')) {
                selected_element = $('.brute_enable_question');
                selected_element.show();
            }
            if (element_class.includes('brute_detect_label')) {
                selected_element = $('.brute_detect_question');
                selected_element.show();
            }
            if (element_class.includes('flood_detect_label')) {
                selected_element = $('.flood_detect_question');
                selected_element.show();
            }
            if (element_class.includes('brute_wl_host_label')) {
                selected_element = $('.brute_wl_host_question');
                selected_element.show();
            }
            if (element_class.includes('brute_wl_ip_label')) {
                selected_element = $('.brute_wl_ip_question');
                selected_element.show();
            }
            if (element_class.includes('brute_interval_label')) {
                selected_element = $('.brute_interval_question');
                selected_element.show();
            }
            if (element_class.includes('brute_max_val_label')) {
                selected_element = $('.brute_max_val_question');
                selected_element.show();
            }
            if (element_class.includes('brute_latest_only_label')) {
                selected_element = $('.brute_latest_only_question');
                selected_element.show();
            }
            if (element_class.includes('brute_send_possible_label')) {
                selected_element = $('.brute_send_possible_question');
                selected_element.show();
            }

            if (element_class.includes('nwaf_ai_extra_host_lm_label')) {
                selected_element = $('.nwaf_ai_extra_host_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_ai_extra_host_wl_label')) {
                selected_element = $('.nwaf_ai_extra_host_wl_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_bf_detect_host_lm_label')) {
                selected_element = $('.nwaf_bf_detect_host_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_body_exclude_label')) {
                selected_element = $('.nwaf_body_exclude_question');
                selected_element.show();
            }           
            if (element_class.includes('nwaf_body_bin_exclude_label')) {
                selected_element = $('.nwaf_body_bin_exclude_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_ddos_detect_host_lm_label')) {
                selected_element = $('.nwaf_ddos_detect_host_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_host_lm_label')) {
                selected_element = $('.nwaf_host_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_host_wl_label')) {
                selected_element = $('.nwaf_host_wl_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_ip_lm_label')) {
                selected_element = $('.nwaf_ip_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_ip_wl_label')) {
                selected_element = $('.nwaf_ip_wl_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_rfc_violation_wl_label')) {
                selected_element = $('.nwaf_rfc_violation_wl_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_rfc_violation_lm_label')) {
                selected_element = $('.nwaf_rfc_violation_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_limit_label')) {
                selected_element = $('.nwaf_limit_question');
                selected_element.show();
            }
            
            if (element_class.includes('nwaf_mla_host_lm_label')) {
                selected_element = $('.nwaf_mla_host_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_put_body_exclude_label')) {
                selected_element = $('.nwaf_put_body_exclude_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_rmq_host_exclude_label')) {
                selected_element = $('.nwaf_rmq_host_exclude_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_openapi_url_wl_label')) {
                selected_element = $('.nwaf_openapi_url_wl_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_openapi_ip_wl_label')) {
                selected_element = $('.nwaf_openapi_ip_wl_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_openapi_url_lm_label')) {
                selected_element = $('.nwaf_openapi_url_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_openapi_ip_lm_label')) {
                selected_element = $('.nwaf_openapi_ip_lm_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_post_body_exclude_label')) {
                selected_element = $('.nwaf_post_body_exclude_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_url_wl_label')) {
                selected_element = $('.nwaf_url_wl_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_b64_decode_disable_label')) {
                selected_element = $('.nwaf_b64_decode_disable_question');
                selected_element.show();
            }
            if (element_class.includes('nwaf_geoip_mla_disable_label')) {
                selected_element = $('.nwaf_geoip_mla_disable_question');
                selected_element.show();
            }
        })
        .mouseleave(function (e) {
            //setTimeout(() => selected_element.hide(), 1000);
            if (typeof selected_element !== 'undefined') {
                selected_element.hide();
            }

        });

});

/**
 * The function displays a modal window with information about setting
 */
$(document).ready(function () {
    let home = document.getElementById('home').textContent;
    let data;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + '/get_settings_text/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            data = $.parseJSON(response);
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });
    $('.settings_info').on('click', function (e) {
        let element_class = e.currentTarget.className;
        let info_text;
        $('#modal_settings_info_body').html("");

        let q_class;
        let list_classes = String(element_class).split(" ");
        for (let cls_item of list_classes) {
            if (cls_item.endsWith('_question')) {
                q_class = cls_item.replace('_question', '');
                break;
            }
        }

        if (data[q_class] !== undefined) {
            info_text = data[q_class]
        }


        $('#modal_settings_info_body').html(info_text);
        $('#modal_settings_info').modal('show');
    });

    $('.erl_multiline_info').on('click', function (e) {
        $('#modal_settings_info_body').html(data.erl_multiline_info);
        $('#modal_settings_info').modal('show');
    });


}); 

/**
 * Sending a request to delete models
 */
function deleteModel() {
    let home = document.getElementById('home').textContent;
    let key = $('#model_delete_modal_key_input').val();
    let id_model = $('#model_delete_modal_counter_input').val();
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let model_row = $('#table_modal_list_models_model_name_' + key + '_' + id_model);
    event.preventDefault();
    
    $.ajax({
        url: home + '/delete_model/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key,
            model: model_row.val()
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $('#table_modal_list_models_row_' + key + '_' + id_model).hide();
            $('#table_main_list_models_row_' + key + '_' + id_model).hide();
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Sending a request to training models
 */
function modelTraining() {
    let home = document.getElementById('home').textContent;
    let key = $('#model_training_modal_key_input').val();
    let id_model = $('#model_training_modal_counter_input').val();
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let model_row = $('#table_modal_list_models_model_name_' + key + '_' + id_model);
    let model_img = $('#table_modal_list_models_img_' + key + '_' + id_model);
    let main_model_status = $('#table_main_list_models_status_' + key + '_' + id_model);
    let duration = $('#modal_list_models_retraining_duration_' + key + '_' + id_model);
    event.preventDefault();
    $.ajax({
        url: home + '/model_training/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key,
            model: model_row.val(),
            duration: duration.val(),
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            if (data.status === 'success') {
                let img = data.img;
                model_img[0].src = document.location.protocol + '//' + document.location.host + img;
                main_model_status.removeClass('vhost_training_status_enable').addClass('vhost_training_status_disable');
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Function to show row with input training period
 * @param key_id Selected key
 * @param model_id Id model in table
 */
function show_model_retraining_row(key_id, model_id) {
    let home = document.getElementById('home').textContent;
    let vhost = $('#table_modal_list_models_model_name_' + key_id + '_' + model_id).val();
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + '/get_model_duration/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key_id,
            model: vhost
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            if (data.status === 'success') {
                $("#modal_list_models_retraining_duration_" + key_id + '_' + model_id).val(data.duration);
                $('#table_modal_list_models_retraining_row_' + key_id + '_' + model_id).show();
            } else {
                $("#modal_list_models_retraining_duration_" + key_id + '_' + model_id).val();
                $('#table_modal_list_models_retraining_row_' + key_id + '_' + model_id).show();
            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });

}

/**
 * Function to hide row with input training period
 * @param key_id Selected key
 * @param model_id Id model in table
 */
function hide_model_retraining_row(key_id, model_id) {
    $('#table_modal_list_models_retraining_row_' + key_id + '_' + model_id).hide();
}

/**
 * Function to set training period
 * @param key Selected key
 * @param id_model Id model in table
 */
function set_model_retraining_duration(key, id_model) {
    let home = document.getElementById('home').textContent;
    let model = $('#table_modal_list_models_model_name_' + key + '_' + id_model).val();
    let duration = $("#modal_list_models_retraining_duration_" + key + '_' + id_model).val();
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + '/set_model_training_duration/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key,
            model: model,
            duration: duration

        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            if (data.status === 'success') {

            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
    $('#table_modal_list_models_retraining_row_' + key + '_' + id_model).hide();
}

/**
 * The function displays a modal window with editing settings
 * @param setting_name Setting name
 * @param setting_id Setting id
 * @param module_name Module name
 * @param key_id Lic key id
 */
function showEditSettingModal(setting_name, setting_id, module_name, key_id) {
    let input_domain_new_cell = $('#input_domain_new_cell');
    let input_new_cell = $('#input_new_cell');
    let input_zones_cell = $('#input_zones_cell');
    let td_input_domain_new_cell = $('#td_input_domain_new_cell');
    let vhost_retraining_button_title = $('#vhost_retraining_button_title').text();
    let vhost_delete_button_title = $('#vhost_delete_button_title').text();
    input_new_cell.attr("placeholder", "");
    input_zones_cell.css({'display': 'none'});
    input_domain_new_cell.css({'display': 'none'});
    td_input_domain_new_cell.css({'display': 'none'});
    $('#edit_setting > .modal-dialog > .m_content').css({'width': '338px'});
    $('.table_modal_set_setting').css({'width': '306px'});
    input_new_cell.css({'width': '247px'});
    if (setting_id === 'main_vhosts_list') {
        $('#edit_setting_button').html('Ok');
    } else {
        $('#edit_setting_button').text($('#edit_setting_button_text').text());
    }

    let placeholder_ip = pgettext('placeholder ip input ws', '10.0.0.1');
    let placeholder_url = pgettext('placeholder url input ws', 'example.com/admin/upload.php');
    let placeholder_vhost = pgettext('placeholder vhost input ws', 'example.com');

    if (setting_id === 'nwaf_ip_lm' || setting_id === 'nwaf_ip_wl' || setting_id === 'nwaf_openapi_ip_wl'
        || setting_id === 'nwaf_openapi_ip_lm' || setting_id === 'ddos__wl_ip' || setting_id === 'brute__wl_ip'){
        input_new_cell.attr("placeholder", placeholder_ip);
    } else if (setting_id === 'nwaf_b64_decode_disable' || setting_id === "nwaf_url_wl"
        || setting_id === "nwaf_body_bin_exclude" || setting_id === 'nwaf_body_exclude'
        || setting_id === 'nwaf_rfc_violation_wl' || setting_id === 'nwaf_rfc_violation_lm'
        || setting_id === 'nwaf_openapi_url_lm' || setting_id === 'nwaf_openapi_url_wl'
        || setting_id === 'ddos__wl_url' || setting_id === 'brute__brute_detect'
        || setting_id === 'brute__flood_detect'){
        input_new_cell.attr("placeholder", placeholder_url);
    } else {
        input_new_cell.attr("placeholder", placeholder_vhost);
    }


    if (setting_id === 'nwaf_ip_wl' || setting_id === 'nwaf_ip_lm' || setting_id === 'nwaf_openapi_ip_lm'
        || setting_id === 'nwaf_openapi_ip_wl'){
        input_domain_new_cell.attr("placeholder", placeholder_vhost);
    }


    if ((setting_id === 'nwaf_ip_lm') || (setting_id === 'nwaf_ip_wl') || (setting_id === 'nwaf_openapi_ip_wl') ||
        (setting_id === 'nwaf_openapi_ip_lm')) {
        input_domain_new_cell.css({'display': 'block'});
        td_input_domain_new_cell.css({'display': 'block'});
        input_new_cell.css({'width': '225px'});
        $('#edit_setting > .modal-dialog > .m_content').css({'width': '550px'});
        $('.table_modal_set_setting').css({'width': '508px'});
    } else if (setting_id === 'nwaf_b64_decode_disable') {
        input_zones_cell.css({'display': 'block'});
        $('#edit_setting > .modal-dialog > .m_content').css({'width': '450px'});
        $('.table_modal_set_setting').css({'width': '408px'});
    }

    $('#edit_setting').modal('show');
    $('#error_edit_setting').css({'display': 'none'});
    $('#other_settings').css({'display': 'block'});
    $('#setting_name').val(setting_id);
    $('#setting_module_name').val(module_name);
    $('#key_id').val(key_id);
    $('.table_modal_set_setting').attr("id", "setting_table_" + setting_id);
    let setting_val = $('#' + setting_id + '_input_' + key_id).val();
    let settings_array = setting_val.split(', ');
    let id_table = 'setting_table_' + setting_id;
    $('#' + id_table + ' .box_set_settings').each(function (index, value) {
        if (((($(this).html().indexOf('<label>')) === -1) && (($(this).html().indexOf('add_new_cell()')) === -1))) {
            $(this).remove()
        }
    });
    if (settings_array[0] !== '') {

        let tbody = document.getElementById(id_table);

        for (let i = 0; i < settings_array.length; i++) {
            let new_div = document.createElement('div');
            new_div.className = 'box_set_settings';
            let td_str = '';
            if (setting_id === 'main_vhosts_list') {
                td_str += '<div class="vhost_name" style="text-align: center;">'
                    + settings_array[i] + '</div>' +
                    '<sub><button title="' + vhost_delete_button_title + '" onclick="delete_cell(this,\'vhost_list\',\'' + key_id + '\')" ' +
                    'style="display:none; outline: none; border: 0; background: transparent; padding: 0; padding-left: 2px;">' +
                    '<span aria-hidden="true">&times;</span></button></sub>';
            } else {
                td_str += settings_array[i] + '<sub><button onclick="delete_cell(this)" ' +
                    'style="display:none; outline: none; border: 0; background: transparent; padding: 0; padding-left: 2px;">' +
                    '<span aria-hidden="true">&times;</span></button></sub>';
            }
            new_div.innerHTML = td_str;
            tbody.appendChild(new_div);
            td_str = '';
        }


    }


}

$(document).on('mouseover', '.box_set_settings', function (e) {
    this.style.paddingRight = '5px';
    this.style.paddingLeft = '8px';
    $(this.querySelector('.box_set_settings button')).show();
}).on('mouseout', '.box_set_settings', function (e) {
    this.style.paddingRight = '10px';
    this.style.paddingLeft = '10px';
    $(this.querySelector('.box_set_settings button')).hide();
});

/**
 * The function sets the value of the setting on the page
 */
function setEditSetting() {
    $('#error_edit_setting').css({'display': 'none'});
    $('#error_max_models_edit_setting').css({'display': 'none'});
    let setting_id = $('#setting_name').val();
    let setting_module = $('#setting_module_name').val();
    let key_id = $('#key_id').val();
    let id_table = 'setting_table_' + setting_id;
    let edit_setting_array = [];
    let cell_text;
    if (setting_id === 'nwaf_b64_decode_disable_info') {
        let zones = [];
        $('input[name="zones"]:checked').each(function () {
            zones.push(this.value);
        });
        if (zones.length === 0) {
            zones.push('BODY', 'Path', 'ARGS', 'HEADERS','none');
        }
        edit_setting_array.push(...zones);
    }
    $('#' + id_table + ' .box_set_settings').each(function () {
        if ((($(this).html().indexOf('<label>')) === -1) && (($(this).html().indexOf('add_new_cell()')) === -1)) {
            if (setting_id === 'main_vhosts_list') {
                cell_text = $(this).find('.vhost_name').text();
            } else {
                cell_text = $(this).html();
            }
            cell_text = cell_text.replace(/<.+>/, '');
            edit_setting_array.push(cell_text);
        }
    });

    let url = '';
    let edit_setting_input_text = edit_setting_array.join(', ');
    let home = document.getElementById('home').textContent;
    if (setting_module === 'mlc') {
        url = home + '/set_settings/';
    }
    if (setting_module === 'dyn') {
        url = home + '/dyn_settings/';
    }
    if (setting_id === 'main_vhosts_list') {
        $('#' + id_table + ' .box_set_settings').each(function () {
            if ((($(this).html().indexOf('<label>')) === -1) && (($(this).html().indexOf('add_new_cell()')) === -1)) {
                $(this).remove();
            }
        });
        $('#' + setting_id + '_input_' + key_id).val(edit_setting_input_text);
        $('#' + setting_id + '_text_' + key_id).text(edit_setting_input_text);
        $('#edit_setting').modal('hide');
    } else {
        const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
        event.preventDefault();
        $.ajax({
            url: url,
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            dataType: "html",
            data: {
                key: key_id,
                setting_name: setting_id,
                setting_text: edit_setting_input_text,
            },
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(response);
                    return;
                }
                let data = $.parseJSON(response);
                if (data.status === 'success') {
                    $('#' + id_table + ' .box_set_settings').each(function () {
                        if ((($(this).html().indexOf('<label>')) === -1) && (($(this).html().indexOf('add_new_cell()')) === -1)) {
                            $(this).remove();
                        }
                    });
                    $('#edit_setting').modal('hide');

                    $('#' + setting_id + '_input_' + key_id).val(edit_setting_input_text);
                    $('#' + setting_id + '_text_' + key_id).text(edit_setting_input_text);


                }
                if (data.status === 'error') {
                    $('#error_edit_setting').css({'display': 'block'});
                }
                if (data.status === 'exceeds the host limit') {
                    $('#error_max_models_edit_setting').css({'display': 'block'});
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    }

}

/**
 * The function adds a new cell to the settings editing window
 */
function add_new_cell() {
    let home = document.getElementById('home').textContent;
    $('#error_max_models_edit_setting').css({'display': 'none'});
    let vhost_delete_button_title = $('#vhost_delete_button_title').text();
    let setting_name = $('#setting_name').val();
    let id_table = 'setting_table_' + setting_name;
    let key_id = $('#key_id').val();
    let input_new_cell = $('#input_new_cell');
    let input_domain_new_cell = $('#input_domain_new_cell');

    if (input_new_cell.val().trim() == '') {
        return;
    }
    if (setting_name === 'main_vhosts_list') {
        const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
        event.preventDefault();
        $.ajax({
            url: home + '/update_vhost_list/',
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            dataType: "html",
            data: {
                key: key_id,
                vhost: input_new_cell.val().trim().replace(/(,\s|\s|,)/g, ',').trim(),
                action: 'add',
            },
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(response);
                    return;
                }
                let data = $.parseJSON(response);
                if (data.status === 'exceeds the host limit') {
                    $('#error_max_models_edit_setting').css({'display': 'block'});
                }
                if (data.status === 'success') {
                    let include_text_list = input_new_cell.val().trim().replace(/(,\s|\s|,)/g, ',').trim().split(',');
                    for (let i of include_text_list) {
                        if (i.trim() == '') {
                            continue;
                        }
                        let x = document.createElement('div');
                        x.className = 'box_set_settings';
                        x.innerHTML = '<div class="vhost_name" style="text-align: center;">'
                            + i.trim() + '</div>' +
                            '<sub><button title="' + vhost_delete_button_title + '" onclick="delete_cell(this,\'vhost_list\',\'' + key_id + '\')" style="display:none;' +
                            'outline: none; border: 0; background: transparent; padding: 0; padding-left: 2px;">' +
                            '<span aria-hidden="true">&times;</span></button></sub>';

                        let tbody = document.getElementById(id_table);
                        tbody.appendChild(x);
                    }

                    input_new_cell.val('');
                    let edit_setting_array = [];
                    $('#' + id_table + ' .box_set_settings').each(function () {
                        if ((($(this).html().indexOf('<label>')) === -1) && (($(this).html().indexOf('add_new_cell()')) === -1)) {
                            let cell_text = $(this).find('.vhost_name').text();
                            cell_text = cell_text.replace(/<.+>/, '');
                            edit_setting_array.push(cell_text);
                        }
                    });
                    let edit_setting_input_text = edit_setting_array.join(', ');


                    $('#' + setting_name + '_input_' + key_id).val(edit_setting_input_text);
                    $('#' + setting_name + '_text_' + key_id).text(edit_setting_input_text);
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });

    } else {
        let include_text_list = [];
        let split_input = input_new_cell.val().trim().replace(/(,\s|\s|,)/g, ',').split(',');
        if ((setting_name === 'nwaf_ip_lm' || setting_name === 'nwaf_ip_wl' || setting_name === 'nwaf_openapi_ip_wl'
            || setting_name === 'nwaf_openapi_ip_lm') && (input_domain_new_cell.val() !== '')) {
            for (let i of split_input) {
                include_text_list.push('domain=' + input_domain_new_cell.val() + ' ' + i)
            }
        } else if (setting_name === 'nwaf_b64_decode_disable') {
            let zones = [];
            $('input[name="zones"]:checked').each(function () {
                zones.push(this.value);
            });
            if (zones.length === 0) {
                zones.push('BODY', 'Path', 'ARGS', 'HEADERS','none');
            }
            let input_string;
            for (let i of split_input) {
                input_string = i + ' z:';
            }
            input_string = input_string + zones.join('|');
            include_text_list.push(input_string);
        } else {
            for (let i of split_input) {
                include_text_list.push(i);
            }
        }
        for (let i of include_text_list) {
            let x = document.createElement('div');
            x.className = 'box_set_settings';
            x.innerHTML = i +
                '<sub><button onclick="delete_cell(this)" ' +
                'style="display:none; outline: none; border: 0; background: transparent; padding: 0; padding-left: 2px;">' +
                '<span aria-hidden="true">&times;</span></button></sub>';

            input_new_cell.val('');
            input_domain_new_cell.val('');

            let tbody = document.getElementById(id_table);
            tbody.appendChild(x);
        }
    }

}

/**
 * The function adds a new cell to the settings editing window
 * @param element Element to be removed
 * @param type Name setting
 * @param key_id Selected key
 */
function delete_cell(element, type = '', key_id = '') {
    let home = document.getElementById('home').textContent;
    let setting_name = $('#setting_name').val();
    let id_table = 'setting_table_' + setting_name;
    $('#error_max_models_edit_setting').css({'display': 'none'});
    if (type === 'vhost_list') {
        let vhost = element.closest('.box_set_settings').textContent.replace('×', '');
        const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
        event.preventDefault();
        $.ajax({
            url: home + '/update_vhost_list/',
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            dataType: "html",
            data: {
                key: key_id,
                vhost: vhost,
                action: 'del',
            },
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(response);
                    return;
                }
                let edit_setting_array = [];
                $('#' + id_table + ' .box_set_settings').each(function () {
                    if ((($(this).html().indexOf('<label>')) === -1) && (($(this).html().indexOf('add_new_cell()')) === -1)) {
                        let cell_text = $(this).find('.vhost_name').text();
                        cell_text = cell_text.replace(/<.+>/, '');
                        edit_setting_array.push(cell_text);
                    }
                });
                let edit_setting_input_text = edit_setting_array.join(', ');


                $('#' + setting_name + '_input_' + key_id).val(edit_setting_input_text);
                $('#' + setting_name + '_text_' + key_id).text(edit_setting_input_text);
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    }
    element.closest('.box_set_settings').remove();
}

/**
 * The function sends a request to edit the ERL rule
 * @param id Id rule
 * @param key_id Selected key
 */
function edit_erl(id, key_id) {
    $('.error_edit_erl').css({'display': 'none'});
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: '/erl/edit/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#edit_erl_form_' + id + '_' + key_id).serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let get_data = $.parseJSON(response);
            if (get_data.status === 'success') {
                $('.erl_row_id_' + id).text(get_data.row.id);
                if (get_data.row.active) {
                    $('.erl_row_options_active_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                    $.each($('.erl_row_options_active_' + id), function () {

                    });

                    $('.edit_erl_form_active_' + id).prop('checked', true);
                } else {
                    $('.erl_row_options_active_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                    $.each($('.erl_row_options_active_' + id), function () {
                    });

                    $('.edit_erl_form_active_' + id).prop('checked', false);
                }


                if (get_data.row.ip !== '') {
                    $('.erl_row_options_ip_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                } else {
                    $('.erl_row_options_ip_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                }
                $('.edit_erl_form_ip_' + id).val(get_data.row.ip);

                if (get_data.row.country !== '') {
                    $('.erl_row_options_country_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                } else {
                    $('.erl_row_options_country_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                }

                if (get_data.row.country !== '') {
                    $('.erl_row_options_block_proxy_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                } else {
                    $('.erl_row_options_block_proxy_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                }

                if (get_data.row.country !== '') {
                    $('.erl_row_options_block_tor_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                } else {
                    $('.erl_row_options_block_tor_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                }

                $('.edit_erl_form_country_' + id).val(get_data.row.country);

                $('.erl_row_domain_' + id).text(get_data.row.domain);
                $('.edit_erl_form_domain_' + id).val(get_data.row.domain);

                $('.erl_row_url_' + id).text(get_data.row.url);
                $('.edit_erl_form_url_' + id).val(get_data.row.url);

                $('.erl_row_args_' + id).text(get_data.row.args);
                $('.edit_erl_form_args_' + id).val(get_data.row.args);

                $('.erl_row_none_' + id).text(get_data.row.none);
                $('.edit_erl_form_none_' + id).val(get_data.row.none);

                $('.erl_row_body_' + id).text(get_data.row.body);
                $('.edit_erl_form_body_' + id).val(get_data.row.body);

                $('.erl_row_cookie_' + id).text(get_data.row.cookie);
                $('.edit_erl_form_cookie_' + id).val(get_data.row.cookie);

                $('.erl_row_ua_' + id).text(get_data.row.ua);
                $('.edit_erl_form_ua_' + id).val(get_data.row.ua);

                $('.erl_row_referer_' + id).text(get_data.row.referer);
                $('.edit_erl_form_referer_' + id).val(get_data.row.referer);

                let other_headers = get_data.row.other_headers;
                if (typeof other_headers !== 'undefined') {
                    other_headers = other_headers.replace('\n', '<br>');
                } else {
                    other_headers = '';
                }
                $('.erl_row_other_headers_' + id).html(other_headers);
                $('.edit_erl_form_other_headers_' + id).val(other_headers.replace('<br>', ''));

                if (get_data.row.api) {
                    $('.erl_row_options_api_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                    $('.edit_erl_form_api_' + id).prop('checked', true);
                } else {
                    $('.erl_row_options_api_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                    $('.edit_erl_form_api_' + id).prop('checked', false);
                }
                if (get_data.row.lm) {
                    $('.erl_row_options_lm_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                    $('.edit_erl_form_monitoring_' + id).prop('checked', true);
                } else {
                    $('.erl_row_options_lm_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                    $('.edit_erl_form_monitoring_' + id).prop('checked', false);
                }
                if (get_data.row.noban) {
                    $('.erl_row_options_noban_' + id).removeClass('option_status_inactive').addClass('option_status_active');
                    $('.edit_erl_form_noban_' + id).prop('checked', true);
                } else {
                    $('.erl_row_options_noban_' + id).removeClass('option_status_active').addClass('option_status_inactive');
                    $('.edit_erl_form_noban_' + id).prop('checked', false);
                }
                if (get_data.row.no_cookie) {
                    $('.edit_erl_form_no_cookie_' + id).prop('checked', true);
                } else {
                    $('.edit_erl_form_no_cookie_' + id).prop('checked', false);
                }
                if (get_data.row.no_ua) {
                    $('.edit_erl_form_no_ua_' + id).prop('checked', true);
                } else {
                    $('.edit_erl_form_no_ua_' + id).prop('checked', false);
                }
                if (get_data.row.no_referer) {
                    $('.edit_erl_form_no_referer_' + id).prop('checked', true);
                } else {
                    $('.edit_erl_form_no_referer_' + id).prop('checked', false);
                }
                if (get_data.row.block_proxy) {
                    $('.edit_erl_form_block_proxy_' + id).prop('checked', true);
                } else {
                    $('.edit_erl_form_block_proxy_' + id).prop('checked', false);
                }
                if (get_data.row.block_tor) {
                    $('.edit_erl_form_block_tor_' + id).prop('checked', true);
                } else {
                    $('.edit_erl_form_block_tor_' + id).prop('checked', false);
                }

                $("#edit_erl_" + id + '_' + key_id).modal("hide");
            } else {
                $('.error_edit_erl').css({'display': 'block'});
            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * The function sends a request to add the ERL rule
 */
function add_erl() {
    if (add_erl.cantClick) {
        event.preventDefault();
        return;
    }
    add_erl.cantClick = true;
    $('#error_add_erl').css({'display': 'none'});
    let key_id = $('#add_erl_key').val();
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    event.preventDefault();
    $.ajax({
        url: home + '/erl/add/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#add_erl_form').serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            if (response !== '{"status": "error"}') {
                $('#erl_row_head_' + key_id).after(response);

                $("#add_erl").modal("hide");
                $('#add_erl_form').trigger('reset');
            } else {
                $('#error_add_erl').css({'display': 'block'});
            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });

    setTimeout(() => {
        add_erl.cantClick = false;
    }, 1000);
}

/**
 * Sending a request to delete ERL
 * @param id ERL id
 * @param key License key
 */
function removeERL(id, key) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    event.preventDefault();
    $.ajax({
        url: home + '/erl/delete/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            erl_id: id,
            lic_keys_select: key
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $(".list_erl_table_row_" + id).hide();
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Function to enable multiselect plugin
 */
$(document).ready(function () {
    let zone_select_title = $('#zone_select_title').text();
    let zone_selected_title = $('#zone_selected_title').text();
    let zone_all_selected_title = $('#zone_all_selected_title').text();
    $('.zone_select').multiselect({
        nonSelectedText: zone_select_title,
        nSelectedText: zone_selected_title,
        allSelectedText: zone_all_selected_title,
        numberDisplayed: 1,
    });
    $('[data-toggle="tooltip"]').tooltip({
        placement: 'bottom',
    });
    $('.action_log_table').DataTable({
        bAutoWidth: false,
        "pageLength": 100,
        "orderable": false,
        "targets": 'no-sort',
        "bSort": false,
        searching: false,
        info: false,
        bFilter: false,
        "pagingType": "numbers",
        "lengthChange": false,
        language: {
            "zeroRecords": " "
        },
    });

});

/**
 * Function to show input custom zone in add/edit WL modal window
 * @param element Selected element
 * @param rule_id Selected rule
 * @param extension_id Id extension field
 */
function show_input_custom_zone(element, rule_id = '', extension_id) {
    if (element.value === 'custom_zone') {
        $('#input_extension_custom_zone_' + rule_id + '_' + extension_id).css({'display': 'block'});
    } else {
        $('#input_extension_custom_zone_' + rule_id + '_' + extension_id).css({'display': 'none'});
    }

}

/**
 * The function sends a request to add the WL rule
 */
function add_wl() {
    if (add_wl.cantClick) {
        event.preventDefault();
        return;
    }
    add_wl.cantClick = true;
    let add_domain = $('#add_wl_domain');
    let add_wl_id = $('#add_wl_id');
    let add_zone = $('#zone');
    let validate = true;

    $('#error_add_wl').css({'display': 'none'});

    add_domain.css({'border-color': '#134473'});

    $('.zone_validation').css({'display': 'none'});

    if ((add_zone.val() === null) && ($('#add_other_zone').val() === '')) {
        event.preventDefault();
        $('.zone_validation').css({'display': 'block'});
        validate = false;

    }
    if (add_wl_id.val() === '') {
        event.preventDefault();
        $('.wl_id_validation').css({'display': 'block'});
        add_wl_id.css({'border-color': 'red'});
        validate = false;

    }
    if (validate) {
        let key_id = $('#add_wl_key').val();
        let div_extension = $('.extension_add');
        let extension_array = [];
        $.each(div_extension, function () {

            let extension_select = $(this).find('select').val();
            if (extension_select === 'custom_zone') {
                extension_select = $(this).find('.extension_custom_zone').val().trim();
            }
            let extension_text = $(this).find('.extension_text').val().trim();
            let extension_regex = $(this).find('.regex_extension').is(':checked');

            extension_array.push(extension_select + ';' + extension_text + ';' + extension_regex);

        });
        const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
        let home = document.getElementById('home').textContent;
        event.preventDefault();
        $.ajax({
            url: home + '/add_dyn_rule/',
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            dataType: "html",
            data: {
                form: $('#add_wl_form').serialize(),
                extension: extension_array,
            },
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(response);
                    return;
                }
                if (response !== '{"status": "error"}') {
                    $('#wl_table_' + key_id + ' > tbody:last-child').prepend(response);
                    let zone_select_title = $('#zone_select_title').text();
                    let zone_selected_title = $('#zone_selected_title').text();
                    let zone_all_selected_title = $('#zone_all_selected_title').text();
                    $('.zone_select').multiselect({
                        nonSelectedText: zone_select_title,
                        nSelectedText: zone_selected_title,
                        allSelectedText: zone_all_selected_title,
                        numberDisplayed: 1,
                    });
                    $('#add_wl').modal('hide');
                    $('#add_wl_form').trigger('reset');
                    $('.zone_select').multiselect('refresh');
                    $('.wl_group').remove();
                } else {
                    $('#error_add_wl').css({'display': 'block'});
                }

            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });
    }
    setTimeout(() => {
        add_wl.cantClick = false;
    }, 1000);
}

/**
 * The function sends a request to edit the WL rule
 * @param id Id rule
 * @param key_id Selected key
 */
function edit_wl(id, key_id) {
    event.preventDefault();
    $('.error_edit_wl').css({'display': 'none'});
    let div_extension = $('.extension_' + id);
    let extension_array = [];
    $.each(div_extension, function () {

        let extension_select = $(this).find('select').val();
        if (extension_select === 'custom_zone') {
            extension_select = $(this).find('.extension_custom_zone').val().trim();
        }
        let extension_text = $(this).find('.extension_text').val().trim();
        let extension_regex = $(this).find('.regex_extension').is(':checked');

        extension_array.push(extension_select + ';' + extension_text + ';' + extension_regex);

    });
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    let home = document.getElementById('home').textContent;
    if (extension_array[0].substr(0, 4)=='none'){
    extension_array[0]=""
    }
    
    $.ajax({
        url: home + '/edit_dyn_rule/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            form: $('#edit_wl_form_' + id).serialize(),
            extension: extension_array,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let get_data = $.parseJSON(response);
            if (get_data.status === 'success') {
                let rid = get_data.row.rid;
                $('.row_wl_id_' + rid).text(get_data.row.wl_id);
                //$('.edit_wl_form_rid_' + rid).val(get_data.row.wl_id);
                if (get_data.row.active === 'True') {
                    $('.wl_row_options_active_' + id).removeClass('status_active_off').addClass('status_active_on');
                    $.each($('.wl_row_options_active_' + id), function () {

                    });

                    $('.edit_wl_form_active_' + rid).prop('checked', true);
                } else {
                    $('.wl_row_options_active_' + id).removeClass('status_active_on').addClass('status_active_off');
                    $.each($('.wl_row_options_active_' + id), function () {

                    });
                    $('.edit_wl_form_active_' + rid).prop('checked', false);
                }

                $('.row_type_' + rid).text(get_data.row.type);

                $('.row_domain_' + rid).text(get_data.row.domain);
                $('.edit_wl_form_domain_' + rid).val(get_data.row.domain);

                let mz = get_data.row.mz;
                let mz_array = mz.split('|');
                mz_array.forEach(function (item, i, arr) {
                    $('#edit_wl_form_zone_select_' + rid + 'option[value=' + item.toLowerCase() + ']').prop('selected', true);
                });

                if (get_data.row.px) {
                    $('.row_px_' + rid).text('True');
                } else {
                    $('.row_px_' + rid).text('False');
                }
                $('.row_pattern_' + rid).text(get_data.row.pattern);
                $('.row_score_' + rid).text(get_data.row.score);
                $('.row_tag_' + rid).text(get_data.row.tag);
                $('.row_mz_' + rid).text(get_data.row.mz);
                if (get_data.row.extension) {
                $('.row_extension_' + rid).text(get_data.row.extension);
                } else {
                $('.row_extension_' + rid).text('');
                }
                $('#edit_wl_' + id + '_' + key_id).modal('hide');
            } else {
                $('.error_edit_wl').css({'display': 'block'});
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Funcion to add extension field in add/edit WL modal window
 * @param id Rule id
 */
function add_extension(id) {
    let wl_extension_title = $('.wl_extension_title').text();
    let wl_extension_regex_title = $('.wl_extension_regex_title').text();
    let wl_extension_select_zone_title = $('.wl_extension_select_zone_title').text();
    let wl_extension_custom_zone_input = $('.wl_extension_custom_zone_input').text();
    let wl_extension_input = $('.wl_extension_input').text();
    let add_group_class = '';
    if (id === 'add') {
        add_group_class = ' wl_group';
    }

    let last_ext_count = Number($('.extension_count_' + id + ':last').val()) + 1;
    $('.extension_count_' + id + ':last').val(last_ext_count);


    $('#last_extension_field_' + id).before('<div class="extension_' + id + add_group_class + '">\n' +
        '                        <div class="form-group" style="text-align: center">\n' +
        '                            <div class="col-sm-12">\n' +
        '                                <label for="select_extension_' + id + '_' + last_ext_count + '"\n' +
        '                                       style="font-weight: 200;">' + wl_extension_title + '</label>\n' +
        '                                <br>\n' +
        '                            </div>\n' +
        '                        </div>\n' +
        '                        <div class="form-group" style="text-align: center">\n' +
        '                            <div class="col-sm-4">\n' +
        '                                <select id="select_extension_' + id + '_' + last_ext_count + '" class="form-control"\n' +
        '                                        onchange="show_input_custom_zone(this,\'' + id + '\',\'' + last_ext_count + '\')">\n' +
        '                                    <option value="none">' + wl_extension_select_zone_title + '\n' +
        '                                    </option>\n' +
        '                                    <option value="body">BODY\n' +
        '                                    </option>\n' +
        '                                    <option value="url">Path\n' +
        '                                    </option>\n' +
        '                                    <option value="args">ARGS\n' +
        '                                    </option>\n' +
        '                                    <option value="headers">\n' +
        '                                        HEADERS\n' +
        '                                    </option>\n' +
        '                                </select>\n' +
        '                            </div>\n' +
        '                            <div class="col-sm-5">\n' +
        '                                <input type="text" title="' + wl_extension_input + '"\n' +
        '                                       class="form-control extension_text" value=""\n' +
        '                                       placeholder="' + wl_extension_input + '"\n' +
        '                                       style="background-color: #ffffff; border-radius: 0px; border-width: 0px; border-bottom-width: 1px; text-align: center; box-shadow: none;">\n' +
        '                            </div>\n' +
        '                            <div class="col-sm-3">\n' +
        '                                <input class="form-check-input regex_extension" type="checkbox" value="true"\n' +
        '                                       id="regex_rl_' + id + '_' + last_ext_count + '">\n' +
        '                                <label class="form-check-label" for="regex_rl_' + id + '_' + last_ext_count + '">\n' +
        '                                    ' + wl_extension_regex_title + '\n' +
        '                                </label>\n' +
        '                            </div>\n' +
        '                        </div>\n' +
        '                    </div>');
}


/**
 * The function sends a request to remove the WL rule
 * @param id Rule id
 * @param key Selected key
 */
function remove_wl(id, key) {
    event.preventDefault();
    let home = document.getElementById('home').textContent;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + '/delete_dyn_rule/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            lic_key: key,
            rid: id,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $(".wl_row_" + id).hide();
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * The function send request to enable/disable brute or ddos MLC setting
 * @param element Selected element
 * @param key_id Selected key
 */
function change_set_settings_checkbox(element, key_id) {
    let checkbox_name = element.name;
    let checkbox_status = element.checked;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    let home = document.getElementById('home').textContent;
    $.ajax({
        url: home + '/set_settings/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key_id,
            setting_name: checkbox_name,
            setting_text: checkbox_status,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            if (checkbox_name === 'brute__enable') {
                if (checkbox_status) {
                    $('#brute_force_block_' + key_id).show();
                } else {
                    $('#brute_force_block_' + key_id).hide();
                }
            }
            if (checkbox_name === 'ddos__enable') {
                if (checkbox_status) {
                    $('#ddos_block_' + key_id).show();
                } else {
                    $('#ddos_block_' + key_id).hide();
                }
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * The function send request to edit numerical values of MLC setting
 * @param element Selected element
 * @param key_id Selected key
 */
function change_set_settings_numbers(element, key_id) {
    let selected_element;
    let input_name;
    if (element === 'ddos_interval') {
        selected_element = $('#ddos__interval_input_' + key_id);
        input_name = 'ddos__interval';
    } else if (element === 'brute_interval') {
        selected_element = $('#brute__interval_input_' + key_id);
        input_name = 'brute__interval';
    } else if (element === 'brute_max_val') {
        selected_element = $('#brute__max_val_input_' + key_id);
        input_name = 'brute__max_val';
    }
    let input_value = selected_element.val();
    $('#' + input_name + '_input_' + key_id).css({'border-color': '#D5E4F3'});
    $('#' + input_name + '_error_' + key_id).hide();
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    let home = document.getElementById('home').textContent;
    $.ajax({
        url: home + '/set_settings/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key_id,
            setting_name: input_name,
            setting_text: input_value,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            if (data.status === 'error') {
                $('#' + input_name + '_error_' + key_id).show();
                $('#' + input_name + '_input_' + key_id).css({'border-color': 'red'});
            }
            if (data.status === 'success') {

            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * The function of sending a request for training models
 */
function vhost_training() {
    let key_id = $('#vhost_set_training_key_id').val();
    let vhost = $('#vhost_set_training_vhost').val();
    let duration = $('#vhost_set_training_duration').val();

    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    event.preventDefault();
    $.ajax({
        url: home + '/model_training/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key_id,
            model: vhost,
            duration: duration,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);

            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * The function show modal window for edit nwaf limit setting
 * @param key_id Selected key
 * @param limit_id Selected nwaf limit
 */
function show_modal_edit_nwaf_limit(key_id, limit_id = '') {
    $("#error_nwaf_limit").css({'display': 'none'});
    $("#edit_nwaf_limit_key_id").val(key_id);
    $("#edit_nwaf_limit_id").val(limit_id);
    if (limit_id !== '') {
        let domain = $("#nwaf_limit_domain_" + key_id + '_' + limit_id).text().replace(/\s/g, '').replace('domain=', '');
        let block_time = $("#nwaf_limit_block_time_" + key_id + '_' + limit_id).text().replace('block_time=', '');
        let rate = $("#nwaf_limit_rate_" + key_id + '_' + limit_id).text().replace('rate=', '');
        if (rate.indexOf('r/m') > 0) {
            $('#edit_nwaf_limit_rate_type option[value="r/m"]').prop('selected', true);
        } else {
            $('#edit_nwaf_limit_rate_type option[value="r/s"]').prop('selected', true);
        }
        let new_rate = rate.replace('r/m', '').replace('r/s', '');
        $("#edit_nwaf_limit_rate").val(new_rate);
        $("#edit_nwaf_limit_domain").val(domain);
        $("#edit_nwaf_limit_block_time").val(block_time);
    } else {
        $("#edit_nwaf_limit_rate").val(5);
        $("#edit_nwaf_limit_domain").val('');
        $("#edit_nwaf_limit_block_time").val(600);
        $('#edit_nwaf_limit_rate_type option[value="r/m"]').prop('selected', true);
    }

    $("#edit_nwaf_limit").modal("show");

}

/**
 * Function to check int value
 * @param value Checked value
 * @returns {boolean} True of false
 */
function isInt(value) {
    let x = parseFloat(value);
    return !isNaN(value) && (x | 0) === x;
}

/**
 * Function to set nwaf limit value
 */
function set_edit_nwaf_limit() {
    $("#error_nwaf_limit").css({'display': 'none'});
    let limit_id = $("#edit_nwaf_limit_id").val();
    let key_id = $("#edit_nwaf_limit_key_id").val();
    let rate_val = $("#edit_nwaf_limit_rate").val();
    let rate = 'rate=' + rate_val + $("#edit_nwaf_limit_rate_type").val();
    let block_time_val = $("#edit_nwaf_limit_block_time").val();
    let block_time = 'block_time=' + block_time_val;
    if ((!isInt(rate_val)) || (!isInt(block_time_val))) {
        $("#error_nwaf_limit").css({'display': 'block'});
        event.preventDefault();
        return;
    }
    let domain = $("#edit_nwaf_limit_domain").val();
    let nwaf_limit_array = [];
    if (domain !== '') {
        domain = 'domain=' + domain;
        $("#nwaf_limit_domain_" + key_id + '_' + limit_id).text(domain);
    } else {
        domain = '';
        $("#nwaf_limit_domain_" + key_id + '_' + limit_id).text(domain);
    }

    $("#nwaf_limit_block_time_" + key_id + '_' + limit_id).text(block_time);
    $("#nwaf_limit_rate_" + key_id + '_' + limit_id).text(rate);

    if (limit_id === '') {
        let last_limit_id = Number($('.last_limit_id_' + key_id + ':last').val()) + 1;
        $('#add_nwaf_limit_button_' + key_id).after('<div style="margin-left: 56px;" class="nwaf_limit_divs_' + key_id + '"\n' +
            '     id="nwaf_limit_div_' + key_id + '_' + last_limit_id + '"><span\n' +
            '        class="nwaf_limit_domain_' + key_id + '"\n' +
            '        id="nwaf_limit_domain_' + key_id + '_' + last_limit_id + '">' + domain + '</span>\n' +
            '    <span class="nwaf_limit_rate_' + key_id + '"\n' +
            '          id="nwaf_limit_rate_' + key_id + '_' + last_limit_id + '">' + rate + '</span>\n' +
            '    <span class="nwaf_limit_block_time_' + key_id + '"\n' +
            '          id="nwaf_limit_block_time_' + key_id + '_' + last_limit_id + '">' + block_time + '</span>\n' +
            '    <button type="button"\n style="color: #285283" ' +
            '            onclick="show_modal_edit_nwaf_limit(\'' + key_id + '\',\'' + last_limit_id + '\')"\n' +
            '            class="btn action"><i class="fa fa-pencil" aria-hidden="true"></i></button>\n' +
            '    <button type="button" style="color: #285283" \n' +
            '            onclick="delete_nwaf_limit(this,\'' + key_id + '\')"\n' +
            '            class="btn action"><i class="fa fa-times-circle" aria-hidden="true"></i></button>\n' +
            '</div>');

    }
    let nwaf_limit_div = $('.nwaf_limit_divs_' + key_id);

    $.each(nwaf_limit_div, function () {
        let limit = '';
        let div_domain = $(this).find('.nwaf_limit_domain_' + key_id).text();
        let div_rate = $(this).find('.nwaf_limit_rate_' + +key_id).text();
        let div_block_time = $(this).find('.nwaf_limit_block_time_' + +key_id).text();
        if (div_domain === '') {
            limit = div_rate + ' ' + div_block_time;
        } else {
            limit = div_domain.replace(/\s/g, '').replace('\\n', '') + ' ' + div_rate + ' ' + div_block_time;
        }
        nwaf_limit_array.push(limit);
    });

    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    event.preventDefault();
    $.ajax({
        url: home + '/dyn_settings/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key_id,
            setting_name: 'nwaf_limit',
            nwaf_limit_array: nwaf_limit_array
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            if (response === '{"status": "error"}') {
                $("#error_nwaf_limit").css({'display': 'block'});
            } else {
                $("#edit_nwaf_limit").modal("hide");
            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });


}

/**
 * The function deletes the selected nwaf limit
 * @param element Selected nwaf limit
 * @param key_id Selected key
 */
function delete_nwaf_limit(element, key_id) {
    element.closest('div').remove();
    let nwaf_limit_array = [];

    let nwaf_limit_div = $('.nwaf_limit_divs_' + key_id);

    $.each(nwaf_limit_div, function () {
        let limit = '';
        let div_domain = $(this).find('.nwaf_limit_domain_' + key_id).text();
        let div_rate = $(this).find('.nwaf_limit_rate_' + +key_id).text();
        let div_block_time = $(this).find('.nwaf_limit_block_time_' + +key_id).text();
        if (div_domain === '') {
            limit = div_rate + ' ' + div_block_time;
        } else {
            limit = div_domain.replace(/\s/g, '').replace('\\n', '') + ' ' + div_rate + ' ' + div_block_time;
        }
        nwaf_limit_array.push(limit);
    });

    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    event.preventDefault();
    $.ajax({
        url: home + '/dyn_settings/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key_id,
            setting_name: 'nwaf_limit',
            nwaf_limit_array: nwaf_limit_array
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);

            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}


/**
 * Check match passwords when editing user
 * @param id User id
 */
function checkPasswords(id) {

    if ($('#inputPassword_' + id).val() !== $('#inputConfirmPassword_' + id).val()) {
        $('#helpBlockPass_' + id).show();
        $('#PasswordForm_' + id).addClass('has-error');
        $('#ConfirmPasswordForm_' + id).addClass('has-error');

        $('#SaveButton_' + id).prop('disabled', true);

    } else {
        $('#helpBlockPass_' + id).hide();
        $('#PasswordForm_' + id).removeClass('has-error');
        $('#ConfirmPasswordForm_' + id).removeClass('has-error');

        $('#SaveButton_' + id).prop('disabled', false);
    }
}

/**
 * Show/Hide password when editing user
 * @param id User id
 */
function showPassword(id) {
    $('#PasswordEye_' + id).toggleClass("fa-eye fa-eye-slash");

    $('#ConfirmPasswordEye_' + id).toggleClass("fa-eye fa-eye-slash");

    $('#CurrentPasswordEye_' + id).toggleClass("fa-eye fa-eye-slash");

    if ($('#ConfirmPasswordEye_' + id).attr('class') === 'fa fa-eye') {
        $('#inputPassword_' + id).attr('type', 'text');
        $('#inputConfirmPassword_' + id).attr('type', 'text');
        $('#inputCurrentPassword_' + id).attr('type', 'text');
    } else if ($('#CurrentPasswordEye_' + id).attr('class') === 'fa fa-eye') {
        $('#inputPassword_' + id).attr('type', 'text');
        $('#inputConfirmPassword_' + id).attr('type', 'text');
        $('#inputCurrentPassword_' + id).attr('type', 'text');
    } else {
        $('#inputPassword_' + id).attr('type', 'password');
        $('#inputConfirmPassword_' + id).attr('type', 'password');
        $('#inputCurrentPassword_' + id).attr('type', 'password');
    }

}


function delete_erl_element(element) {
    let next_operator = $(element).next().next();
    let next_operator_data = next_operator.attr('data-operator');
    let prev_operator = $(element).prev().prev();
    let prev_operator_data = prev_operator.attr('data-operator');

    let operator_value = '';
    if (typeof prev_operator_data === 'undefined') {
        operator_value = next_operator_data;
    } else {
        operator_value = prev_operator_data;
    }

    if (operator_value === 'nor') {
        operator_value = '|!'
    } else if (operator_value === 'or') {
        operator_value = '|'
    } else if (operator_value === 'nand') {
        operator_value = '&!'
    } else if (operator_value === 'not') {
        operator_value = '!'
    } else if (operator_value === 'and') {
        operator_value = '&'
    }

    if (typeof operator_value === 'undefined') {
        operator_value = '';
    }

    let element_span = $(element).prev();
    let element_span_text = element_span.text();


    if (typeof prev_operator_data === 'undefined') {
        element_span_text = element_span_text + operator_value;
        $(next_operator).next('br').remove();
        $(next_operator).prev('br').remove();
        next_operator.remove();
    } else {
        element_span_text = operator_value + element_span_text;
        $(prev_operator).next('br').remove();
        $(prev_operator).prev('br').remove();
        prev_operator.remove();
    }

    let add_erl_rule_form = '#add_erl_rule_form';
    let erl_box = element.closest('div');
    let zone = $(erl_box).find('.elr_box_title').attr('data-zone');
    let input_value = $(add_erl_rule_form).find('input[name=' + zone + ']').val();

    if (operator_value === '!') {
        $(next_operator).next('br').remove();
        $(next_operator).prev('br').remove();
        next_operator.remove();
    }

    $(add_erl_rule_form).find('input[name=' + zone + ']').val(input_value.replace(element_span_text, ''));

    if (operator_value === '!') {
        $(add_erl_rule_form).find('input[name=' + zone + ']').val($(add_erl_rule_form).find('input[name=' + zone + ']').val().slice(1));
    }

    element_span.remove();
    element.remove();


}


function add_erl_page() {
    let control = ''
    let classic = document.querySelector('.erl_block_title').innerText.trim()
    let all_block = document.querySelector('#extension_erl').querySelectorAll('.erl_block_title')
    let dict_operators = {'nor': '|!', 'or': '|', 'nand': '&!', 'not': '!', 'and': '&'}
    let operat = document.querySelectorAll('#extension_erl_select_operator')
    let operators = operat[operat.length - 2]
    let controlers = operators.options[operators.selectedIndex].value

    $('#end_of_life_error').css({'display': 'none'});
    if ($('#add_erl_form_end_of_life').val() === '0') {
        $('#end_of_life_error').show();
        return;
    }
    $('#error_add_rule_erl').css({'display': 'none'});
    let url = '';
    let home = document.getElementById('home').textContent;
    if ($('#add_erl_form_erl_id').val() === '') {
        url = home + '/erl/add/'
    } else {
        url = home + '/erl/edit/'
    }

    let erl_data_map = {};
    let data = $('.erl_row_data');

    let div_array = Array.prototype.slice.call(data);

    div_array.forEach(function (item, i, arr) {
        if ($(item).attr('id') === 'erl_row_other_headers' || $(item).is(':hidden')) {
            delete arr[i];
        }
    });

    let erl_data_array = [];
    div_array.forEach(function (item, i, arr) {

        let zone = $(item.closest('.erl_row_data')).attr('info');

        if (item.classList.contains('erl_row_data_other_headers')){
            zone = $(item.closest('#erl_row_other_headers')).attr('info');
        }

        if (zone === 'other_headers' || zone === 'other_headers_x') {
            let key_operator = $(item).find('select')[0].value;
            if (key_operator === 'not') {
                key_operator = '!!'
            } else {
                key_operator = ''
            }
            let key_value = $(item).find('input')[0].value;
            let headers_value_array = Array.prototype.slice.call($(item).find('#headers_value')[0].childNodes);
            let header_value = [];
            headers_value_array.forEach(function (item, i, arr) {

                let value = '';
                let select_value_operator = $(item).find('select').val();
                let input_value_operator = $(item).find('input').val();
                if (typeof select_value_operator !== 'undefined') {
                     if (select_value_operator === 'nor') {
                        select_value_operator = '|!'
                    } else if (select_value_operator === 'or') {
                        select_value_operator = '|'
                    } else if (select_value_operator === 'nand') {
                        select_value_operator = '&!'
                    } else if (select_value_operator === 'not') {
                        select_value_operator = '!'
                    } else if (select_value_operator === 'and') {
                        select_value_operator = '&'
                    } else if (select_value_operator === 'none') {
                        select_value_operator = ''
                    }
                    header_value.push(select_value_operator);
                }
                if (typeof input_value_operator !== 'undefined') {
                    header_value.push(input_value_operator);
                }

            });

            let other_headers = '"' + key_operator + key_value + ":" + header_value.join('') + '"';


            if (typeof erl_data_map[zone] !== 'undefined') {
                if (other_headers !== '":"') {
                    erl_data_map[zone] = erl_data_map[zone] + ',' + other_headers;
                }
            } else {
                if (other_headers !== '":"') {
                    erl_data_map[zone] = other_headers;
                }

            }

        } else if (zone !== 'no_cookie' && zone !== 'no_ua' && zone !== 'no_referer' && zone !== 'block_tor' && zone !== 'block_proxy') {

            let operator = $(item).find('select')[0].value;

            let select_val = operator;
             if (select_val === 'nor') {
                select_val = '|!'
            } else if (select_val === 'or') {
                select_val = '|'
            } else if (select_val === 'nand') {
                select_val = '&!'
            } else if (select_val === 'not') {
                select_val = '!'
            } else if (select_val === 'and') {
                select_val = '&'
            }

	    control = $(item).find('select').val()
            if ($(item).find('input').is(':checked')) {

                let textarea_val = $(item).find('textarea')[0].value;

                let input_val_array = textarea_val.split('\n');
                input_val_array.forEach(function (item, i, arr) {
                    arr[i] = item.replaceAll('&', '\\&').replaceAll('|', '\\|').replaceAll('!', '\\!');
                });
                let input_val = input_val_array.join(select_val);

                if (input_val !== '') {
                    if (typeof erl_data_map[zone] !== 'undefined') {
                        erl_data_map[zone] = erl_data_map[zone] + select_val + input_val;

                    } else {
                        erl_data_map[zone] = input_val;
                    }
                }
            } else {
                let input_val = $(item).find('textarea')[0].value;
                input_val = input_val.replaceAll('&', '\\&');
                input_val = input_val.replaceAll('|', '\\|');
                input_val = input_val.replaceAll('!', '\\!');
                if (dict_operators[control] === undefined){
                input_val = input_val.replaceAll('\n', dict_operators[controlers])
                }else{
                input_val = input_val.replaceAll('\n', dict_operators[control])
                }

                if (input_val !== '') {
                    if (typeof erl_data_map[zone] !== 'undefined') {
                        erl_data_map[zone] = erl_data_map[zone] + select_val + input_val;
                    } else {
                        if (select_val === '!') {
                            erl_data_map[zone] = select_val + input_val;
                        } else {
                            erl_data_map[zone] = input_val;
                        }

                    }
                }

           }
        }

    });

    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    erl_data_map['lic_keys_select'] = $('#add_erl_form_key').val();
    erl_data_map['csrfmiddlewaretoken'] = csrftoken;
    erl_data_map['erl_id'] = $('#add_erl_form_erl_id').val();

    if ($('#add_erl_form_active').is(':checked')) {
        erl_data_map['active'] = 'true'
    }

    if ($('#add_erl_form_api').is(':checked')) {
        erl_data_map['api'] = 'true'
    }

    if ($('#add_erl_form_noban').is(':checked')) {
        erl_data_map['noban'] = 'true'
    }

    if ($('#add_erl_form_monitoring').is(':checked')) {
        erl_data_map['lm'] = 'true'
    }

    if ($('#activate_erl_form_no_cookie').is(':checked')) {
        erl_data_map['no_cookie'] = 'true'
    }

    if ($('#activate_erl_form_no_ua').is(':checked')) {
        erl_data_map['no_ua'] = 'true'
    }

    if ($('#activate_erl_form_no_referer').is(':checked')) {
        erl_data_map['no_referer'] = 'true'
    }

    if ($('#activate_erl_form_block_tor').is(':checked')) {
        erl_data_map['block_tor'] = 'true'
    }

    if ($('#activate_erl_form_block_proxy').is(':checked')) {
        erl_data_map['block_proxy'] = 'true'
    }

    if ($('#add_erl_form_end_of_life').val() === '') {
        erl_data_map['end_of_life'] = 'none';
    } else {
        erl_data_map['end_of_life'] = $('#add_erl_form_end_of_life').val();
    }

    if (typeof erl_data_map['domain'] == "undefined") {
        erl_data_map['domain'] = '';
    }
    if (typeof erl_data_map['url'] == "undefined") {
        erl_data_map['url'] = '';
    }
    if (typeof erl_data_map['url_x'] == "undefined") {
        erl_data_map['url_x'] = '';
    }
    if (typeof erl_data_map['country'] == "undefined") {
        erl_data_map['country'] = '';
    }
    if (typeof erl_data_map['ip'] == "undefined") {
        erl_data_map['ip'] = '';
    }
    if (typeof erl_data_map['args'] == "undefined") {
        erl_data_map['args'] = '';
    }
    if (typeof erl_data_map['args_x'] == "undefined") {
        erl_data_map['args_x'] = '';
    }
    if (typeof erl_data_map['body'] == "undefined") {
        erl_data_map['body'] = '';
    }
    if (typeof erl_data_map['body_x'] == "undefined") {
        erl_data_map['body_x'] = '';
    }
    if (typeof erl_data_map['ua'] == "undefined") {
        erl_data_map['ua'] = '';
    }
    if (typeof erl_data_map['ua_x'] == "undefined") {
        erl_data_map['ua_x'] = '';
    }
    if (typeof erl_data_map['cookie'] == "undefined") {
        erl_data_map['cookie'] = '';
    }
    if (typeof erl_data_map['cookie_x'] == "undefined") {
        erl_data_map['cookie_x'] = '';
    }
    if (typeof erl_data_map['referer'] == "undefined") {
        erl_data_map['referer'] = '';
    }
    if (typeof erl_data_map['referer_x'] == "undefined") {
        erl_data_map['referer_x'] = '';
    }
    if (typeof erl_data_map['other_headers'] == "undefined") {
        erl_data_map['other_headers'] = '';
    }
    if (typeof erl_data_map['other_headers_x'] == "undefined") {
        erl_data_map['other_headers_x'] = '';
    }

    function request(){
    event.preventDefault();
    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: erl_data_map,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            if (response !== '{"status": "error"}') {
                document.location.href = home + "/rule_management/";
            } else {
                $('#error_add_rule_erl').css({'display': 'block'});
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });

    }

    request()

}

function add_erl_element(element) {
    if ($(element).parent().parent().attr('id') !== 'erl_row_other_headers') {
        $(element).parent().parent().find('#delete_erl_row_div button').show();
        let zone = $(element.closest('.erl_row_data')).attr('info');

        $(element).parent().hide();
        let erl_row = $('#erl_row.erl_row_template').clone(true);
        $($(erl_row).find('#delete_erl_row_div button')).show();

        erl_row.removeClass('erl_row_template');

        let regex_block = erl_row.find('#regexp_erl_row_div');

        let base_zone = zone;
        let check_regex = false;
        if (base_zone.endsWith('_x')) {
            base_zone = base_zone.slice(0, -2);
            check_regex = true;
        }

        regex_block.find('input').prop('checked', check_regex);

        if (list_x_tags.includes(base_zone)){
            regex_block.show();
        } else {
            regex_block.hide();
        }

        erl_row.attr('info', zone);

        let select = $($(erl_row).find('select')[0]);

        let select_zone = $($(erl_row).find('select')[1]);

        $(select).find("option[value='not']").remove();
        $(select).find("option[value='none']").remove();
        select.empty();
        select.prepend('<option value="nand">' + erl_nand_operator_text + '</option>');
        select.prepend('<option value="nor">' + erl_nor_operator_text + '</option>');
        select.prepend('<option value="and">' + erl_and_operator_text + '</option>');
        select.prepend('<option value="or">' + erl_or_operator_text + '</option>');
        $(select).find("option:first").prop('selected', true);

        let input = $($(erl_row).find('textarea')[0]);
        input.val('');

        // let checkbox_multiline_input = $($(erl_row).find('input')[0]);
        // checkbox_multiline_input.attr('onchange', 'set_extension_multiline_input(this)');
        //checkbox_multiline_input.prop('checked', false);

        $(select_zone).find("option[value='" + zone + "']").prop('selected', true);

        $(element).parent().parent().after(erl_row);
        $(element).parent().parent().next().find('#add_element_div').show();

        $(erl_row).show();
    } else {
        let zone = $(element.closest('#erl_row_other_headers')).attr('info');
        let erl_row = $('.erl_row_other_headers');
        erl_row.attr('info', zone);
        erl_row = $(erl_row[0]).clone();
        let regex_block = erl_row.find('#regexp_erl_row_div');

        let base_zone = zone;
        let check_regex = false;
        if (base_zone.endsWith('_x')) {
            base_zone = base_zone.slice(0, -2);
            check_regex = true;
        }

        regex_block.find('input').prop('checked', check_regex);

        if (list_x_tags.includes(base_zone)){
            regex_block.show();
        } else {
            regex_block.hide();
        }
        $(erl_row).removeClass('erl_row_other_headers');
        $($(erl_row).find('select')[0]).empty();
        $($(erl_row).find('select')[0]).prepend('<option value="not">' + erl_not_operator_text + '</option>');
        $($(erl_row).find('select')[0]).prepend('<option value="none"></option>');
        $($(erl_row).find('select')[0]).find("option:first").prop('selected', true);
        $($(erl_row).find('#delete_erl_row_div')).show();
        $(element).parent().hide();
        $(element).parent().parent().after(erl_row);
        $(element).parent().parent().next().find('#add_element_div').show();
        $(element).parent().parent().find('#delete_erl_row_div').show();
        $(erl_row).show();
    }

}

function delete_erl_row(element) {
    let row_data = element.closest('.erl_row_data');
    if (row_data.id === null || row_data.id === undefined || row_data.id === ''){
        row_data = row_data.parentElement;
    }
    let tag_value = row_data.getAttribute('info');
    if (tag_value.endsWith('_x')){
        tag_value = tag_value.slice(0, -2);
    }

    let prev_elem = row_data.previousElementSibling;
    let next_elem = row_data.nextElementSibling;
    let prev_elem_equal = false;
    let next_elem_equal = false;

    if (prev_elem !== null && prev_elem !== undefined){
        prev_elem_equal = prev_elem.getAttribute('info') === tag_value;
    }

    if (next_elem !== null && next_elem !== undefined){
        next_elem_equal = next_elem.getAttribute('info') === tag_value;
    }

    if (!prev_elem_equal && !next_elem_equal){
        if (tag_value === 'no_cookie' || tag_value === 'cookie') {
            let no_cookie_text = $('#no_cookie_text').val();
            $('#select_erl_block').append('<option value="no_cookie">' + no_cookie_text + '</option>');
            $('#select_erl_block').append('<option value="cookie">' + 'Cookie' + '</option>');
        } else if (tag_value === 'no_ua' || tag_value === 'ua') {
            let no_ua_text = $('#no_ua_text').val();
            $('#select_erl_block').append('<option value="no_ua">' + no_ua_text + '</option>');
            $('#select_erl_block').append('<option value="ua">' + 'User-Agent' + '</option>');
        } else if (tag_value === 'no_referer' || tag_value === 'referer'){
            let no_referer_text = $('#no_referer_text').val();
            $('#select_erl_block').append('<option value="no_referer">' + no_referer_text + '</option>');
            $('#select_erl_block').append('<option value="referer">' + 'Referer' + '</option>');
        } else if (tag_value === 'block_proxy') {
            if ($('#select_erl_block').find('option[value=block_tor]').length <= 0 && $("#activate_erl_form_block_tor").length <= 0) {
                $('#select_erl_block').append('<option value="block_tor">' + $('#block_tor_text').val() + '</option>');
            }
            $('#select_erl_block').append('<option value="block_proxy">' + $('#block_proxy_text').val() + '</option>');
        } else if (tag_value === 'block_tor') {
            if ($('#select_erl_block').find('option[value=block_tor]').length === 0) {
                $('#select_erl_block').append('<option value="block_tor">' + $('#block_tor_text').val() + '</option>');
            }
        } else if (prev_elem && prev_elem.classList.contains('erl_block_title')) {
            $('#select_erl_block').append('<option value="' + tag_value + '">' + prev_elem.textContent + '</option>');
        }
    }

    if (($(element).parent().parent().next().attr('id') !== 'erl_row')) {
        $(prev_elem).find('#add_element_div').show();
    } else {
        if (($(element).parent().parent().next().is(':hidden'))) {
            $(prev_elem).find('#add_element_div').show();
        }
    }
    if ($(element).parent().parent().parent().attr('id') === 'erl_row_other_headers') {
        let block_other_headers = document.querySelectorAll('#erl_row_other_headers')
        if (block_other_headers.length === 2) {
            $('div.erl_block_title:contains("Other headers")').css('display', 'none');
        }

        $(element).parent().parent().parent().remove();
    } else {
        $(element).parent().parent().remove();
    }

    if (!prev_elem_equal && !next_elem_equal && prev_elem && prev_elem.classList.contains('erl_block_title')) {
        prev_elem.remove();
    }
}

added_zones = [];

$(document).ready(function () {
    erl_not_operator_text = $('#erl_not_operator_text').val();
    erl_nor_operator_text = $('#erl_nor_operator_text').val();
    erl_or_operator_text = $('#erl_or_operator_text').val();
    erl_nand_operator_text = $('#erl_nand_operator_text').val();
    erl_and_operator_text = $('#erl_and_operator_text').val();


    $('#erl_form_inputs').find('input').each(function () {
        added_zones.push(this.name);
        $('#select_erl_block').find('option[value=' + this.name + ']').remove();
        $('#select_erl_block').find('option[value=' + "no_" + this.name + ']').remove();
        if (this.name.endsWith('_x')){
            $('#select_erl_block').find('option[value=' + this.name.slice(0, -2) + ']').remove();
            $('#select_erl_block').find('option[value=' + "no_" + this.name.slice(0, -2) + ']').remove();
        }
        if (this.name.startsWith('no_')){
            $('#select_erl_block').find('option[value=' + this.name.slice(3) + ']').remove();
        }
    });

});

function add_erl_box(data) {
    let values = $(".add_erl_input").map((i, el) => $(el).val()).get();
    let zone_select = $($(data).find('select')[1]);
    let zone = zone_select.val();
    added_zones.push(zone);
    let select_operator = $($(data).find('select')[0]);
    let zone_text = $(zone_select).find('option:selected')[0].text;
    let div = data.childNodes;
    let div_array = Array.prototype.slice.call(div);
    let div_array_slice = div_array.slice(1);
    let erl_array = [];
    let erl_data_array = [];
    let operator_value = $(select_operator).find('option:selected')[0].value;
    let operator_text = $(select_operator).find('option:selected')[0].text;
    let not_operator = '';
    let not_value = '';
    if (operator_value === 'not') {
        not_operator = '<div class="elr_box_operator" data-operator="not">' + operator_text + '</div>';
        not_value = '!';
    }
    div_array_slice.forEach(function (item, i, arr) {

        let item_id = $(item).attr('id');
        if (item_id === 'add_erl_input_div') {
            if ($(item).find('input').is(':checked')) {
                let prev_elem = $(item).prev();
                let select_prev = prev_elem.find('select');
                if (select_prev.attr('id') === 'extension_erl_select_zone') {
                    prev_elem = $(item).prev().prev();
                    select_prev = prev_elem.find('select');
                }

                let select_prev_text = prev_elem.find('select option:selected')[0].text;

                let select_val = select_prev.val();
                if (select_val === 'nor') {
                    select_val = '|!'
                } else if (select_val === 'or') {
                    select_val = '|'
                } else if (select_val === 'nand') {
                    select_val = '&!'
                } else if (select_val === 'not') {
                    select_val = '!'
                } else if (select_val === 'and') {
                    select_val = '&'
                }

                let test_arr = $(item).find('textarea')[0].value.split('\n');

                test_arr.forEach(function (item, i, arr) {
                    erl_array.push('<span>' + item + '</span>' +
                        '<button onclick="delete_erl_element(this)" type="button" ' +
                        'style="outline: none; border: 0; background: transparent;">' +
                        '<span aria-hidden="true">&times;</span></button>');
                    erl_array.push('<div class="elr_box_operator" data-operator="' + select_val + '">' + select_prev_text + '</div>');
                });
                erl_array.pop();

                let input_val = $(item).find('textarea')[0].value.replaceAll('\n', ' ' + select_val + ' ');
                let input_val_array = input_val.split(' ');
                erl_data_array = erl_data_array.concat(input_val_array);
            } else {
                let input_val = $(item).find('textarea')[0].value;
                erl_array.push('<span>' + input_val + '</span>' +
                    '<button onclick="delete_erl_element(this)" type="button" ' +
                    'style="outline: none; border: 0; background: transparent;">' +
                    '<span aria-hidden="true">&times;</span></button>');
                erl_data_array.push(input_val);
            }
        }
        if (item_id === 'div_erl_select_operator') {
            let select_text = $(item).find('select option:selected')[0].text;
            let select_val = $(item).find('select option:selected')[0].value;
            erl_array.push('<div class="elr_box_operator" data-operator="' + select_val + '">' + select_text + '</div>');
            if (select_val === 'nor') {
                select_val = '|!'
            } else if (select_val === 'or') {
                select_val = '|'
            } else if (select_val === 'nand') {
                select_val = '&!'
            } else if (select_val === 'not') {
                select_val = '!'
            } else if (select_val === 'and') {
                select_val = '&'
            }
            erl_data_array.push(select_val);

        }
    });
    erl_data_array = erl_data_array.slice(1);
    erl_array = erl_array.slice(1);
    if (operator_value === 'not') {
        erl_array[0] = not_operator + erl_array[0];
        erl_data_array[0] = not_value + erl_data_array[0];
    }


    let zone_box = '.' + zone + '_box';
    let add_erl_rule_form = '#add_erl_rule_form';
    if ($(add_erl_rule_form).find('input[name=' + zone + ']').length) {
        let text_operator_value = $(select_operator).find('option:selected')[0].value;
        let operator_value = $(select_operator).find('option:selected')[0].value;
        let operator_text = $(select_operator).find('option:selected')[0].text;
        if (operator_value === 'nor') {
            operator_value = '|!'
        } else if (operator_value === 'or') {
            operator_value = '|'
        } else if (operator_value === 'nand') {
            operator_value = '&!'
        } else if (operator_value === 'not') {
            operator_value = '!'
        } else if (operator_value === 'and') {
            operator_value = '&'
        }

        let input_value = $(add_erl_rule_form).find('input[name=' + zone + ']').val();
        $(add_erl_rule_form).find('input[name=' + zone + ']').val(input_value + operator_value + erl_data_array.join(''));
        let div_content = erl_array.join('');

    } else {
        let div_content = erl_array.join('');
        div_content = '<div class="elr_box_title" data-zone="' + zone + '">' + zone_text + '</div>' + div_content;

        jQuery('<input>', {
            name: zone,
            type: '',
            value: erl_data_array.join(''),
        }).appendTo('#erl_form_inputs');
    }


    $('.new_erl_input').remove();
    $('.new_erl_operator').remove();
    //$('.add_erl_input').val('');
}

function change_zone(element) {
    let zone_val = $(element).val();
    let extension_erl_select_operator = $(element).parent().prev().find('select');
    extension_erl_select_operator.empty();

    if (zone_val === 'other_headers') {
        $(element).parent().parent().find('.other_headers_inputs').show();
        $(element).parent().parent().find('textarea').hide();
        $(element).parent().parent().find('#multiline_input').hide();
        $(element).parent().parent().find('label').hide();
        extension_erl_select_operator.prepend('<option value="none"></option>');
    } else {
        $(element).parent().parent().find('.other_headers_inputs').hide();
        $(element).parent().parent().find('textarea').show();
        $(element).parent().parent().find('#multiline_input').show();
        $(element).parent().parent().find('label').show();
        if (!(added_zones.includes(zone_val))) {
            extension_erl_select_operator.prepend('<option value="not">' + erl_not_operator_text + '</option>');
            extension_erl_select_operator.prepend('<option value="none"></option>');
        } else {
            extension_erl_select_operator.prepend('<option value="nand">' + erl_nand_operator_text + '</option>');
            extension_erl_select_operator.prepend('<option value="nor">' + erl_nor_operator_text + '</option>');
            extension_erl_select_operator.prepend('<option value="and">' + erl_and_operator_text + '</option>');
            extension_erl_select_operator.prepend('<option value="or">' + erl_or_operator_text + '</option>');
        }
    }


    $('#select option:first').prop('selected', true);
    extension_erl_select_operator.find("option:first").prop('selected', true);
}


function set_extension_multiline_input(element) {
    let div_parent = $(element).parent();
    let prev_element_id = $(element).parent().parent().parent().parent().prev().attr('id');
    let select_operator = div_parent.parent().parent().parent().find('select')[0];
    let select_zone = div_parent.parent().parent().parent().find('select')[1];
    let select_zone_val = $(select_zone).val();
    let select_operator_val = $(select_operator).val();
    let textarea = $(div_parent).find('textarea');
    $(select_operator).empty();

    element.classList.toggle('_multiline')

    if (element.classList.contains('_multiline')) {
        $(textarea).attr('rows', 5);
        $(textarea).attr('rows', 5).css({'resize': 'none'});
        $(element).parent().parent().parent().parent().find('#div_erl_select_operator').css({'height': '131px'});
        $(element).parent().parent().parent().parent().find('#delete_erl_row_div').css({'height': '131px'});
        $(element).parent().parent().parent().parent().find('#add_erl_input_div').css({'height': '131px'});
        $(element).parent().parent().parent().parent().find('#regexp_erl_row_div').css({'height': '131px'});
        $(element).parent().parent().parent().parent().find('.col-sm-8').css({'height': '131px'});
        $(element).parent().parent().parent().parent().find('textarea').css({'height': '120px'});

        $(select_operator).prepend('<option value="nand">' + erl_nand_operator_text + '</option>');
        $(select_operator).prepend('<option value="nor">' + erl_nor_operator_text + '</option>');
        $(select_operator).prepend('<option value="and">' + erl_and_operator_text + '</option>');
        $(select_operator).prepend('<option value="or">' + erl_or_operator_text + '</option>');

    } else {
        $(textarea).attr('rows', 1);
        $(textarea).attr('rows', 1).css({'resize': 'none'});
        $(element).parent().parent().parent().parent().find('#div_erl_select_operator').css({'height': '45px'});
        $(element).parent().parent().parent().parent().find('#delete_erl_row_div').css({'height': '45px'});
        $(element).parent().parent().parent().parent().find('#add_erl_input_div').css({'height': '45px'});
        $(element).parent().parent().parent().parent().find('#regexp_erl_row_div').css({'height': '45px'});
        $(element).parent().parent().parent().parent().find('.col-sm-8').css({'height': '40px'});
        $(element).parent().parent().parent().parent().find('textarea').css({'height': '37px'});


        if (typeof prev_element_id === 'undefined') {
            $(select_operator).prepend('<option value="not">' + erl_not_operator_text + '</option>');
            $(select_operator).prepend('<option value="none"></option>');
        } else {
            $(select_operator).prepend('<option value="nand">' + erl_nand_operator_text + '</option>');
            $(select_operator).prepend('<option value="nor">' + erl_nor_operator_text + '</option>');
            $(select_operator).prepend('<option value="and">' + erl_and_operator_text + '</option>');
            $(select_operator).prepend('<option value="or">' + erl_or_operator_text + '</option>');
        }
    }
    $(select_operator).find("option[value='" + select_operator_val + "']").prop('selected', true);
}

function edit_erl_page(id) {
    let erl_form = $('#edit_erl_form_' + id);
    $('#error_add_rule_erl').css({'display': 'none'});
    $('#end_of_life_error').css({'display': 'none'});
    erl_form.submit();

}

function quest(obj) {

    let home = document.getElementById('home').textContent;
    let data;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + '/get_settings_text/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            data = $.parseJSON(response);


            let element_class = obj.className
            let info_text;
            $('#modal_settings_info_body').html("");

            let q_class;
            let list_classes = String(element_class).split(" ");
            for (let cls_item of list_classes) {
                if (cls_item.endsWith('_question')) {
                    q_class = cls_item.replace('_question', '');
                    break;
                }
            }

            if (data[q_class] !== undefined) {
                info_text = data[q_class]
            }


            $('#modal_settings_info_body').html(info_text);
            $('#modal_settings_info').modal('show');

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });


    $('.erl_multiline_info').on('click', function (e) {
        $('#modal_settings_info_body').html(data.erl_multiline_info);
        $('#modal_settings_info').modal('show');
    });

}

function add_other_headers_value(element) {
    let input_div = $($(element).prev().parent()).find('input').clone();
    let select_div = $($(element).prev().parent().prev()).find('select').clone();
    $(element).after(input_div);
    $(element).after(select_div);
}


function add_erl_block() {
    if ($('#select_erl_block').find('option:selected')[0]){
    let select_erl_block_value = $('#select_erl_block').find('option:selected')[0].value;

    let select_erl_block_text = '';

    if (select_erl_block_value === 'no_cookie') {
        select_erl_block_text = 'Cookie';
    } else if (select_erl_block_value === 'no_ua') {
        select_erl_block_text = 'User-Agent';
    } else if (select_erl_block_value === 'no_referer') {
        select_erl_block_text = 'Referer';
    } else {
        select_erl_block_text = $('#select_erl_block').find('option:selected')[0].text;
    }


    $($('#select_erl_block').find('option:selected')[0]).remove();
    let erl_row;
    if (select_erl_block_value === 'other_headers') {
        erl_row = $('#erl_row_other_headers').clone();
        $(erl_row).find('#delete_erl_row_div').css("display", "block")
    } else if (select_erl_block_value === 'no_cookie' || select_erl_block_value === 'no_ua' || select_erl_block_value === 'no_referer' || select_erl_block_value === 'block_tor' || select_erl_block_value === 'block_proxy') {
        if (select_erl_block_value === 'no_cookie'){
            $('#select_erl_block').find('option[value=' + "cookie" + ']').remove();
        } else if (select_erl_block_value === 'block_proxy'){
            $('#select_erl_block').find('option[value=' + "block_tor" + ']').remove();
        } else if (select_erl_block_value === 'no_referer'){
            $('#select_erl_block').find('option[value=' + "referer" + ']').remove();
        } else if (select_erl_block_value === 'no_ua'){
            $('#select_erl_block').find('option[value=' + "ua" + ']').remove();
        }
        erl_row = $('#erl_row_'+select_erl_block_value).clone();
        $($(erl_row).find('#add_erl_form_'+select_erl_block_value)).attr('id', 'activate_erl_form_'+select_erl_block_value);
        $(erl_row).find('#delete_erl_row_div').css("display", "flex");
    } else {
        $('#erl_row').find('#delete_erl_row_div > button').css("display", "block")
        erl_row = $('#erl_row.erl_row_template').clone(true);

        erl_row.removeClass('erl_row_template');

        let regex_block = erl_row.find('#regexp_erl_row_div');

        let base_zone = select_erl_block_value;
        let check_regex = false;
        if (base_zone.endsWith('_x')) {
            base_zone = base_zone.slice(0, -2);
            check_regex = true;
        }

        regex_block.find('input').prop('checked', check_regex);

        if (list_x_tags.includes(base_zone)){
            regex_block.show();
        } else {
            regex_block.hide();
        }

        if (select_erl_block_value === 'cookie') {
            $('#select_erl_block').find('option[value=' + "no_cookie" + ']').remove();
            $($(erl_row).find('#delete_erl_row_div button')).show();
        } else if (select_erl_block_value === 'referer'){
            $('#select_erl_block').find('option[value=' + "no_referer" + ']').remove();
            $($(erl_row).find('#delete_erl_row_div button')).show();
        } else if (select_erl_block_value === 'ua'){
            $('#select_erl_block').find('option[value=' + "no_ua" + ']').remove();
            $($(erl_row).find('#delete_erl_row_div button')).show();
        }

    }
    let zone_select = erl_row.find('select')[1];
    added_zones.push(select_erl_block_value);
    $(erl_row).attr("info", select_erl_block_value);
    $(zone_select).find('option[value=' + select_erl_block_value + ']').prop('selected', true);
    $($(erl_row).find('#add_element_div')).show();
    $($(erl_row).find('textarea')).val('');
    $($(erl_row).find('textarea')).attr('rows', 1).css({'resize': 'none'});
    $($(erl_row).find('textarea')).attr('rows', 1).css({'height': '35px'});
    if (select_erl_block_value !== 'no_cookie' && select_erl_block_value !== 'no_ua' && select_erl_block_value !== 'no_referer' && select_erl_block_value !== 'block_tor' && select_erl_block_value !== 'block_proxy') {
        $($(erl_row).find('input')).prop('checked', false);
        $($(erl_row).find('#div_erl_select_operator').css({'height': '45px'}));
        $($(erl_row).find('#delete_erl_row_div').css({'height': '45px'}));
        $($(erl_row).find('#delete_erl_row_div button')).show();
        erl_row.css({'display': 'block'});
    }else{
        erl_row.css({'display': 'flex'});
    }
    let tag_question;
    if (!select_erl_block_value.startsWith('no_')){
        tag_question = select_erl_block_value;
    } else {
        tag_question = select_erl_block_value.slice(3);
    }

    let block = jQuery('<div>', {
        class: 'erl_block_title',
        html: select_erl_block_text + '<span style ="margin-left: 10px;" onClick="quest(this)" class="settings_info nwaf_'+tag_question+'_question fa fa-question"></span>',
    });

    $('.erl_block_container').prepend(erl_row);
    $('.erl_block_container').prepend(block);

}}

function add_headers_value(element) {

    let div_headers = $(element).parent().prev();
    let row_width = $(div_headers).parent().parent().width();

    let div1 = $($(div_headers).find('div')[0]).clone();
    let div2 = $($(div_headers).find('div')[1]).clone();
    let div3 = $($(div_headers).find('div')[2]).clone();

    $(div1).css({'display': 'block'})
    $(div2).css({'display': 'block'})
    $(div3).css({'display': 'block'})
    let select_operator = $($(div1).find('select'));
    $($(div2).find('input').val(''));
    $(div3).show();

    $(select_operator).empty();

    if ($(div_headers).find('div').is(':visible')){
        $(select_operator).prepend('<option value="nand">' + erl_nand_operator_text + '</option>');
        $(select_operator).prepend('<option value="nor">' + erl_nor_operator_text + '</option>');
        $(select_operator).prepend('<option value="or">' + erl_or_operator_text + '</option>');
        $(select_operator).prepend('<option value="and">' + erl_and_operator_text + '</option>');
    } else {
        $(select_operator).prepend('<option value="not">' + erl_not_operator_text + '</option>');
        $(select_operator).prepend('<option selected value="none"></option>');
    }

    $(select_operator).find("option:first").prop('selected', true);

    let value_count = $(div_headers).find('input').length + 1;
    $($(div2).find('input').attr('placeholder', 'Value' + value_count));

    $(div_headers).append(div1);
    $(div_headers).append(div2);
    $(div_headers).append(div3);
}

function delete_headers_value(element) {

    let prev_div = $(element).parent().prev();
    let prev_prev_div = $(element).parent().prev().prev();
    $(prev_div).remove();
    $(prev_prev_div).remove();
    $(element).parent().hide();
    
    let div_headers = $(element).parent().prev().parent();

    let value_count = $(div_headers).find('input').length - 1;
    let val_number = 0;
    $(div_headers).find('input').each(function () {
        val_number++;
        $(this).attr('placeholder', 'Value' + val_number);
    });
}

function erl_change_regex_mode(element){
    let erl_row = $(element.closest('.erl_row_data'));
    let row_id = erl_row.attr('id');
    if (row_id === null || row_id === undefined || row_id === ''){
        erl_row = erl_row.parent();
    }
    let zone = erl_row.attr('info');

    if (element.checked){
        erl_row.attr("info", zone + "_x");
    } else {
        erl_row.attr("info", zone.slice(0, -2));
    }
}

function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}


$(function () {
    $(".erl_multiline_label")
        .mouseenter(function (e) {
            let span = $($(e.currentTarget).find('span'));
            span.show();
        })
        .mouseleave(function (e) {
            let span = $($(e.currentTarget).find('span'));
            span.hide();

        });

});

function send_request_to_copy_modal() {
    let key = $('#model_copy_modal_key_input').val();
    let src_model = $('#model_copy_modal_src_model').val();
    let list_models = $('#table_main_list_models_' + key);
    let list_models_count = list_models.children().length + 1;
    let dst_model = $('#model_copy_modal_select option:selected').text();
    let model_retrained_text = $('#model_retrained_text').val();

    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    event.preventDefault();
    $.ajax({
        url: home + '/copy_model/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {
            key: key,
            src_model: src_model,
            dst_model: dst_model,
            models_count: list_models_count,
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            if (response === '{"status": "host does not exist"}') {
                $('#exceeds_model_not_exist_error').show();
            } else {

                let new_div = $('<div>', {
                    'id': 'table_main_list_models_row_' + key + '_' + list_models_count,
                    text: dst_model,
                    'title': model_retrained_text,
                    css: {
                        'display': 'inline-block',
                        'margin-right': '10px',
                    },
                });

                $('<div>', {
                    'id': 'table_main_list_models_status_' + key + '_' + list_models_count,
                    'class': 'vhost_training_status_disable',
                    'title': model_retrained_text,
                }).appendTo(new_div);

                $('<input>').attr({
                    type: 'hidden',
                    id: 'table_main_list_models_row_' + key + '_' + list_models_count,
                    value: dst_model,
                }).appendTo(new_div);

                $(list_models).append(new_div);

                $('#table_modal_list_models_' + key + ' > tbody:last-child').prepend(response);

                $("#model_copy_modal").modal("hide");
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });

}

function showListDomain(elem, key_id) {
    let table = document.querySelector('#dyn_bl_table_' + key_id);
    document.querySelector('#list_domain_' + key_id).innerHTML = '';
    for (let i of table.querySelectorAll('.domain')) {
        if (i.innerText == pgettext('my_waf_bl', 'Applies to all domains')) {
            continue;
        }
        let tmp = document.createElement('a');
        tmp.setAttribute('onclick', 'setDomainFromList(this, ' + key_id + ')');
        tmp.className = 'cursor-pointer item-list-domains';
        tmp.innerHTML = i.innerText;
        document.querySelector('#list_domain_' + key_id).appendChild(tmp);
    }

    if (document.querySelector('#list_domain_' + key_id).childElementCount > 0 && elem.classList.contains('btn-show-list-domains')) {
        $('#list_domain_' + key_id).toggle('slow');
    }
}

function setDomainFromList(elem, key_id) {
    $('#input_domain_' + key_id).val(elem.innerText);
    $('#list_domain_' + key_id).hide('slow');
}

function toggleMultilineInput(elem, key_id) {
    if ($('#input_ip_' + key_id).is(':visible')) {
        let tmp = $('#input_ip_' + key_id).val();

        tmp = tmp.replaceAll(' ; ', '; ').replaceAll(' , ', '; ').replaceAll(' ; ', '').replaceAll(' , ', '');
        tmp = tmp.replaceAll('; ', '\n').replaceAll(', ', '\n').replaceAll(';', '\n').replaceAll(',', '\n').replaceAll(' ', '\n');
        while (tmp.includes('\n\n') || tmp.includes(';;') || tmp.includes('; ;') || tmp.includes(',,') || tmp.includes(', ,')) {
            tmp = tmp.replaceAll('\n\n', '\n').replaceAll(';;', ';').replaceAll('; ;', ';')
                .replaceAll(', ,', ',').replaceAll(',,', ',');
        }
        $('#input_multi_ip_' + key_id).val(tmp);
    } else {
        let tmp = $('#input_multi_ip_' + key_id).val();

        tmp = tmp.replaceAll(';\n', '; ').replaceAll(',\n', '; ').replaceAll('\n', '; ').replaceAll(', ', '; ');
        tmp = tmp.replaceAll(';', '; ').replaceAll(',', '; ');
        while (tmp.includes('\n\n') || tmp.includes(';;') || tmp.includes('; ;') || tmp.includes(',,') || tmp.includes(', ,')) {
            tmp = tmp.replaceAll('\n\n', '\n').replaceAll(';;', ';').replaceAll('; ;', ';')
                .replaceAll(', ,', ',').replaceAll(',,', ',');
        }
        $('#input_ip_' + key_id).val(tmp);
    }
    $('#input_ip_' + key_id).toggle();
    $('#input_multi_ip_' + key_id).toggle();
}

function sendToBL(key_id, api = false) {
    let domain = $('#input_domain_' + key_id).val();
    let is_multi = !$('#input_ip_' + key_id).is(':visible');
    let ips = '';
    if (is_multi) {
        ips = $('#input_multi_ip_' + key_id).val();
    } else {
        ips = $('#input_ip_' + key_id).val();
    }
    ips = ips.replaceAll(';\n', ';').replaceAll(',\n', ';').replaceAll('\n', ';').replaceAll(', ', ';')
        .replaceAll(',', ';').replaceAll('; ', ';').replaceAll(' ', ';');
    if (ips !== '') {
        let data = {'key_id': key_id, 'ips': ips};
        if (domain !== '') {
            data['domain'] = domain;
        } else {
            data['domain'] = "__ALL__";
        }

        if (api) {
            data['api'] = 'yes';
        }

        const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
        let home = document.getElementById('home').textContent;
        $.ajax({
            url: home + '/bl/add/',
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            dataType: "html",
            data: data,
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(response);
                    return;
                }
                let data = JSON.parse(response);
                
                let domain = data['domain'];
                if (domain == "__ALL__") {
                    domain = pgettext('my_waf_bl', 'Applies to all domains');
                }
                let table = document.querySelector('#dyn_bl_table_' + key_id);
                if (table.classList.contains('hidden')) {
                    table.classList.remove('hidden');
                }
                let domain_is_exists = null;
                for (let i of table.querySelectorAll('.domain')) {
                    if (domain == i.innerText.split()) {
                        domain_is_exists = i.closest('tr');
                        break;
                    }
                }
                if (domain_is_exists == null && data['count'] !== 0) {
                    let tr = document.createElement('tr');
                    tr.classList.add('key_table_row');
                    let domain_td = document.createElement('td');
                    let ips_td = document.createElement('td');
                    domain_td.className = 'vertical-align domain';
                    domain_td.title = pgettext('my_waf_bl', 'Domains');
                    domain_td.innerHTML = '<div class="bl_domain">\n' +
                        '   <span>' + domain + '</span>\n' +
                        '   <a class="del_bl_domain" style="display: none;" ' +
                        '       title="' + pgettext('my_waf_bl', 'Remove') + '">\n' +
                        '       <i class="fa fa-trash"></i>\n' +
                        '   </a>\n' +
                        '</div>';
                    ips_td.className = 'vertical-align';
                    ips_td.title = pgettext('my_waf_bl', 'IPs');
                    ips_td.style.textAlign = 'center';
                    let a = document.createElement('a');
                    let hidden = document.createElement('input');
                    hidden.type = 'hidden';
                    hidden.className = 'row-domain';
                    hidden.value = data['domain'];
                    a.className = 'count-ips';
                    a.innerText = '0';
                    ips_td.appendChild(a);
                    tr.appendChild(hidden);
                    tr.appendChild(domain_td);
                    tr.appendChild(ips_td);
                    table.querySelector('tbody').appendChild(tr);
                    domain_is_exists = tr;
                }
                if (domain_is_exists != null) {
                    domain_is_exists.querySelector('.count-ips').innerHTML = data['count'];
                    let container_ips = document.querySelector('#container_ips_' + key_id);
                    let block_ips = container_ips.closest('.block-ips');
                    block_ips.querySelector('.search-ips').value = '';
                    if ($(block_ips).is(':visible') && block_ips.querySelector('.selected_domain').value === data['domain']) {
                        container_ips.innerHTML = '';
                        for (let i of data['ips']) {
                            let div = document.createElement('div');
                            let btn_remove = document.createElement('sub');
                            let span = document.createElement('span');
                            div.className = 'btn btn-primary bl_ip';
                            if (i.includes('__ALL__')) {
                                div.classList.add('all');
                                div.title = pgettext('my_waf_bl', 'Applies to all domains');
                            } else {
                                btn_remove.title = pgettext('my_waf_bl', 'Remove IP');
                                btn_remove.className = 'bl_ip_remove';
                                btn_remove.innerHTML = '<i class="fa fa-close"></i>';
                            }
                            span.className = 'ip';
                            span.innerHTML = i.replace('__ALL__', '').replace(' api=yes', '*');
                            if (container_ips.childElementCount > window.limit_ips_in_container) {
                                div.style.display = 'none';
                            }
                            div.appendChild(span);
                            if (!i.includes('__ALL__')) {
                                div.appendChild(btn_remove);
                            }
                            container_ips.appendChild(div);

                        }
                        block_ips.querySelector('.count-ips').textContent = data['ips'].length;

                    }
                    if (container_ips.childElementCount > window.limit_ips_in_container) {
                        let btn_more = document.createElement('div');
                        btn_more.className = 'btn-more show_ips';
                        btn_more.innerText = pgettext('my_waf_bl', 'More');
                        container_ips.appendChild(btn_more);
                    }

                }
                if (data['duplicates'] !== null && data['duplicates'] !== undefined) {
                    let info_div = document.querySelector('#info_for_add_ips_' + key_id);
                    $(info_div.querySelector('.dupl-box')).show();
                    $(info_div.querySelector('.error-box')).hide();
                    let dubl_ips = info_div.querySelector('.dubl_ips');
                    dubl_ips.innerHTML = String(data['duplicates']).replaceAll(' api=yes', '*');
                    $(info_div).show(0).delay(5000).hide(0);
                } else {
                    if (is_multi) {
                        $('#input_multi_ip_' + key_id).val('');
                    } else {
                        $('#input_ip_' + key_id).val('');
                    }
                    $('#input_domain_' + key_id).val('');
                }

            },
            error: function (response) {
                try {
                    let data = JSON.parse(response.responseText);
                    let msg;
                    if (data['duplicates'] !== undefined && data['duplicates'] != null){
                        msg = data['duplicates'];
                    } else {
                        msg = data['description']
                    }

                    let info_div = document.querySelector('#info_for_add_ips_' + key_id);
                    $(info_div.querySelector('.dupl-box')).hide();
                    $(info_div.querySelector('.error-box')).show();
                    let dubl_ips = info_div.querySelector('.info_error');
                    dubl_ips.innerHTML = String(msg).replaceAll(' api=yes', '*');
                    $(info_div).show(0).delay(5000).hide(0);

                } catch {
                    show_messages_from_response(response.responseText)
                }
            }
        });
    }

}

$(document).on('click', function (e) {
    if (e.target.closest('.list-domains') == null && e.target.closest('.btn-show-list-domains') == null
        && !e.target.classList.contains('.list-domains') && !e.target.classList.contains('.btn-show-list-domains')
        && e.target.closest('.list-ip-hints') == null && !e.target.classList.contains('.list-ip-hints')
        && !e.target.closest('.filters-select-list') && !e.target.classList.contains('.btn-show-filters-list')
        && !e.target.closest('.btn-show-filters-list')) {
        $('.list-domains').each(function () {
            $(this).hide('slow');
        });
        $('.list-ip-hints').each(function () {
            $(this).hide();
        });
        $('.filters-select-list').each(function () {
            $(this).hide();
        });

    }
});


$(document).on('mouseover', '.bl_domain', function (e) {
    $(this.querySelector('.del_bl_domain')).show();
}).on('mouseout', '.bl_domain', function (e) {
    $(this.querySelector('.del_bl_domain')).hide();
});

$(document).on('mouseover', '.bl_ip', function (e) {
    if (this.querySelector('.bl_ip_remove') != null) {
        this.style.paddingRight = '4px';
        this.style.paddingLeft = '8px';
        $(this.querySelector('.bl_ip_remove')).show();
    }
}).on('mouseout', '.bl_ip', function (e) {
    if (this.querySelector('.bl_ip_remove') != null) {
        this.style.paddingRight = '10px';
        this.style.paddingLeft = '10px';
        $(this.querySelector('.bl_ip_remove')).hide();
    }
});

$(document).on('click', '.del_bl_domain', function (e) {
    let data = {}
    data['key_id'] = this.closest('.table').querySelector('.key_id').value;
    data['del_domain'] = 1;
    let domain = this.closest('tr').querySelector('.row-domain').value;
    if (domain === pgettext('my_waf_bl', 'Applies to all domains')) {
        domain = '__ALL__';
    }
    data['domain'] = domain;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    let row_domain = this.closest('tr');
    $.ajax({
        url: home + '/bl/del/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            row_domain.remove();
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
});

$(document).on('click', '.bl_ip_remove', function (e) {
    if (this.classList.contains('all')) {
        return;
    }
    let data = {}
    let key_id = this.closest('.block-ips').querySelector('.key_id').value;
    let domain = this.closest('.block-ips').querySelector('.selected_domain').value;
    let ip = this.closest('.bl_ip');
    data['key_id'] = key_id;
    data['ip'] = this.closest('.bl_ip').querySelector('span').innerText
        .replace('*', ' api=yes');
    if (ip.classList.contains('all')) {
        domain = "__ALL__";
    }
    data['domain'] = domain;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    let block_ips = this.closest('.block-ips');
    $.ajax({
        url: home + '/bl/del/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = JSON.parse(response);
            if (domain === "__ALL__" || ip.classList.contains('all')) {
                domain = pgettext('my_waf_bl', 'Applies to all domains');
            }
            let table = document.querySelector('#dyn_bl_table_' + key_id);
            let domain_is_exists = null;
            for (let i of table.querySelectorAll('.domain')) {
                if (domain == i.innerText.split()) {
                    domain_is_exists = i.closest('tr');
                    break;
                }
            }
            ip.remove();
            domain_is_exists.querySelector('.count-ips').innerHTML = data['count'];
            if (data['count'] == 0) {
                domain_is_exists.remove();
                $(block_ips).hide()
            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
});

$(document).on('click', '.btn-more.hide_ips', function (e) {
    let container_ips = this.closest('.container-ips');
    let search = this.closest('.block-ips').querySelector('.search-ips').value;
    this.classList.add('show_ips');
    this.classList.remove('hide_ips');
    let c = 0;
    this.innerHTML = pgettext('my_waf_bl', 'More');
    for (let i of container_ips.children) {
        c++;
        if (c > window.limit_ips_in_container || i.classList.contains('btn-more')) {
            $(i).show();
        } else {
            $(i).hide();
        }
    }
});

$(document).on('click', '.btn-more.show_ips', function (e) {
    let container_ips = this.closest('.container-ips');
    let search = this.closest('.block-ips').querySelector('.search-ips').value;
    this.classList.add('hide_ips');
    this.classList.remove('show_ips');
    this.innerHTML = pgettext('my_waf_bl', 'Hide');
    let c = 0;
    for (let i of container_ips.children) {
        $(i).show();
    }
});

$(document).on('click', '.count-ips', function (e) {
    let key_id = this.closest('.table').querySelector('.key_id').value;
    let domain = this.closest('tr').querySelector('.row-domain').value;
    let container_ips = document.querySelector('#container_ips_' + key_id);
    let block_ips = container_ips.closest('.block-ips');
    $(block_ips).show();
    block_ips.querySelector('.selected_domain').value = domain;
    if (domain == '__ALL__') {
        block_ips.querySelector('span.domain').innerHTML = pgettext('my_waf_bl', 'Applies to all domains');
    } else {
        block_ips.querySelector('span.domain').innerHTML = domain;
    }
    let data = {}
    data['key_id'] = key_id;
    data['domain'] = domain;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    container_ips.innerHTML = '';
    let loading_div = document.createElement('div');
    loading_div.className = 'loading-div-ips';
    loading_div.innerHTML = pgettext('my_waf_bl', 'Loading, please wait');
    container_ips.appendChild(loading_div);
    container_ips.classList.toggle('blur-block');
    block_ips.querySelector('.search-ips').value = '';
    $.ajax({
        url: home + '/bl/get/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = JSON.parse(response);
            let domain = data['domain'];
            if (domain === "__ALL__") {
                domain = pgettext('my_waf_bl', 'Applies to all domains');
            }
            let table = document.querySelector('#dyn_bl_table_' + key_id);
            let domain_is_exists = null;
            for (let i of table.querySelectorAll('.domain')) {
                if (domain == i.innerText.split()) {
                    domain_is_exists = i.closest('tr');
                    break;
                }
            }
            domain_is_exists.querySelector('.count-ips').innerHTML = data['count'];
            for (let i of data['ips']) {
                let div = document.createElement('div');
                let span = document.createElement('span');
                let btn_remove = document.createElement('sub');
                div.className = 'btn btn-primary bl_ip';
                if (i.includes('__ALL__')) {
                    div.classList.add('all');
                    div.title = pgettext('my_waf_bl', 'Applies to all domains');
                } else {
                    btn_remove.title = pgettext('my_waf_bl', 'Remove IP');
                    btn_remove.className = 'bl_ip_remove';
                    btn_remove.innerHTML = '<i class="fa fa-close"></i>';

                }
                span.className = 'ip';
                span.innerHTML = i.replace('__ALL__', '')
                    .replace(' api=yes', '*');

                if (container_ips.childElementCount > window.limit_ips_in_container) {
                    div.style.display = 'none';
                }
                div.appendChild(span);
                if (!i.includes('__ALL__')) {
                    div.appendChild(btn_remove);
                }
                container_ips.appendChild(div);
            }
            if (container_ips.childElementCount > window.limit_ips_in_container) {
                let btn_more = document.createElement('div');
                btn_more.className = 'btn-more show_ips';
                btn_more.innerText = pgettext('my_waf_bl', 'More');
                container_ips.appendChild(btn_more);
            }
            block_ips.querySelector('.count-ips').textContent = data['ips'].length;
            for (let child of block_ips.querySelector('.filters-select-list').children) {
                child.classList.remove('active');
            }
            block_ips.querySelector('.filter-select').classList.add('active');
            loading_div.remove();
            container_ips.classList.remove('blur-block');
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });

});

$(document).on('click', '.del-ips-search', function (input) {
    let container_ips = this.closest('.block-ips').querySelector('.container-ips');
    let key_id = this.closest('.block-ips').querySelector('.key_id').value;
    let domain = this.closest('.block-ips').querySelector('.selected_domain').value;
    let block_ips = container_ips.closest('.block-ips');
    let search_input = this.closest('.block-ips').querySelector('.search-ips');
    let search = search_input.value;
    $(block_ips).show();
    block_ips.querySelector('.selected_domain').value = domain;
    let data = {}
    data['key_id'] = key_id;
    data['domain'] = domain;
    data['search'] = search.replaceAll(';\n', ';').replaceAll(',\n', ';').replaceAll('\n', ';').replaceAll(', ', ';')
        .replaceAll(',', ';').replaceAll('; ', ';').replaceAll(' ', ';');
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    $.ajax({
        url: home + '/bl/del/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $(search_input).val('')
            $(search_input).trigger('change');
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
});


$(document).keypress(function (e) {
    if (e.which == 13) {
        if (document.activeElement === document.getElementById("search_ip_bs")) {
            let value = document.getElementById("search_ip_bs").value;
            fetch(home + `/bs_managment/?search=${value}`).then(res => res.text()
            ).then(html => {
                document.getElementById('content_id').innerHTML = html;
            });
        } else if (document.activeElement.classList.contains('wl_input_search_ip_global')){
            search(null, false);
        }
    }
});

function search(key_id, api = false) {

    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    let domain_list = document.getElementsByClassName('wl_input_search_ip_global')
    let domain = ''
    let key_list = $('.bl_rule')
    let selected_key = null;
    for (let i of key_list) {
        if ($(i).hasClass('active')) {
            selected_key = $(i).find('a').attr('href').replace('#', '')
        }
    }
    for (let i of domain_list) {
        if (i.value) {
            domain = i.value
        }
    }
    let data = {}
    data['domain'] = domain;
    data['key'] = selected_key;
    $.ajax({
        url: home + '/bl/search/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data:data,
        success: function (response, textStatus, xhr) {
            if (xhr.status === 255) {
                show_messages_from_response(response);
                return;
            }
            let data = JSON.parse(response);
            let tr_elem_table = ''

            let table = document.getElementById(`dyn_bl_table_${selected_key}`);
            table = $(table).find('.key_table_row')

            for (let i = 0; i < table.length; i++) {
                table[i].style.display = 'none'
            }

            if (data['status'] === 'ok' && Object.keys(data['messages']).length !== 0) {
                for (let i = 0; i < table.length; i++) {
                    let tr = table[i]
                    let elem = tr.querySelector('input')
                    let key = Object.keys(data['messages'])
                    if (elem.value === key[0]) {
                        let local = table[0].innerHTML
                        table[0].innerHTML = table[i].innerHTML
                        table[i].innerHTML = local
                        table[0].style.display = null
                    }
                }
            }
            if (data['status'] === 'ok' && Object.keys(data['messages']).length !== 0) {

                for (let i = 0; i < table.length; i++) {
                    let elem = table[i].querySelector('input')
                    if (elem.value === "__ALL__") {
                        let local = table[0].innerHTML
                        table[0].innerHTML = table[i].innerHTML
                        table[i].innerHTML = local
                        table[0].style.display = null
                    }
                }
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}


$(document).on('change', '.search-ips', function (input) {
    let container_ips = this.closest('.block-ips').querySelector('.container-ips');
    let c = 0;
    let key_id = this.closest('.block-ips').querySelector('.key_id').value;
    let domain = this.closest('.block-ips').querySelector('.selected_domain').value;
    let search_select_type = $('#filter_select_list_' + key_id + ' .filter-select.active input').val();
    let block_ips = container_ips.closest('.block-ips');
    $(block_ips).show();
    block_ips.querySelector('.selected_domain').value = domain;
    let data = {}
    data['key_id'] = key_id;
    data['domain'] = domain;
    data['select_type'] = search_select_type;
    data['search'] = this.value.replaceAll(';\n', ';').replaceAll(',\n', ';').replaceAll('\n', ';').replaceAll(', ', ';')
        .replaceAll(',', ';').replaceAll('; ', ';').replaceAll(' ', ';');
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    container_ips.innerHTML = '';
    let loading_div = document.createElement('div');
    loading_div.className = 'loading-div-ips';
    loading_div.innerHTML = pgettext('my_waf_bl', 'Loading, please wait');
    container_ips.appendChild(loading_div);
    container_ips.classList.toggle('blur-block');

    $.ajax({
        url: home + '/bl/get/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = JSON.parse(response);
            let domain = data['domain'];
            if (domain == "__ALL__") {
                domain = pgettext('my_waf_bl', 'Applies to all domains');
            }
            let table = document.querySelector('#dyn_bl_table_' + key_id);
            let domain_is_exists = null;
            for (let i of table.querySelectorAll('.domain')) {
                if (domain == i.innerText.split()) {
                    domain_is_exists = i.closest('tr');
                    break;
                }
            }
            for (let i of data['ips']) {
                let div = document.createElement('div');
                let span = document.createElement('span');
                div.className = 'btn btn-primary bl_ip';
                if (i.includes('__ALL__')) {
                    div.classList.add('all');
                    div.title = pgettext('my_waf_bl', 'Applies to all domains');
                } else {
                    div.title = pgettext('my_waf_bl', 'Remove IP');
                }
                span.className = 'ip';
                span.innerHTML = i.replace('__ALL__', '').replace(' api=yes', '*');
                if (container_ips.childElementCount > window.limit_ips_in_container) {
                    div.style.display = 'none';
                }
                div.appendChild(span);
                container_ips.appendChild(div);
            }
            if (container_ips.childElementCount > window.limit_ips_in_container) {
                let btn_more = document.createElement('div');
                btn_more.className = 'btn-more show_ips';
                btn_more.innerText = pgettext('my_waf_bl', 'More');
                container_ips.appendChild(btn_more);
            }
            block_ips.querySelector('.count-ips').textContent = data['ips'].length;
            loading_div.remove();
            container_ips.classList.remove('blur-block');
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
});

$(document).on('click', '.bl_ip', function (e) {
    if (e.target.closest('.bl_ip_remove') || this.classList.contains('bl_ip_remove') ||
        (this.classList.contains('all') && this.classList.contains('bl_ip'))) {
        return;
    }

    function parse(str) {
        let args = [].slice.call(arguments, 1),
            i = 0;

        return str.replace(/%s/g, () => args[i++]);
    }

    let modal = $("#menuIPModal");
    let ip = this.closest('.bl_ip').querySelector('.ip').innerText.trim();
    let domain = this.closest('.block-ips').querySelector('.selected_domain').value;
    let key_id = this.closest('.block-ips').querySelector('.key_id').value;

    let flagAPI = ip.includes('*');
    ip = ip.replace('*', '');

    $("#info_bl_ip_for_menu").val(ip);
    $("#info_bl_domain_for_menu").val(domain);
    $("#info_bl_api_for_menu").val(flagAPI);
    $("#info_bl_key_id_for_menu").val(key_id);

    if (flagAPI) {
        $("#bl_menu_toggle_api_flag").text(gettext('Don\'t send to API'));
    } else {
        $("#bl_menu_toggle_api_flag").text(gettext('Send to API'));
    }
    modal.find('.modal-body .modal_body_content').html(parse(gettext('Select an action for <br> <code>%s</code>'), ip));

    modal.modal("show");
});

$(document).on('click', '#bl_menu_toggle_api_flag', function (e) {
    let ip = $("#info_bl_ip_for_menu").val();
    let domain = $("#info_bl_domain_for_menu").val();
    let flagAPI = $("#info_bl_api_for_menu").val();
    let key_id = $("#info_bl_key_id_for_menu").val();
    let data = {'key_id': key_id, 'ips': ip};
    if (domain !== '') {
        data['domain'] = domain;
    } else {
        data['domain'] = "__ALL__";
    }

    if (flagAPI.toLowerCase() === 'false') {
        data['api'] = 'yes';
    }
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    $.ajax({
        url: home + '/bl/add/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = JSON.parse(response);
            let domain = data['domain'];
            if (domain == "__ALL__") {
                domain = pgettext('my_waf_bl', 'Applies to all domains');
            }
            let table = document.querySelector('#dyn_bl_table_' + key_id);
            if (table.classList.contains('hidden')) {
                table.classList.remove('hidden');
            }
            let domain_is_exists = null;
            for (let i of table.querySelectorAll('.domain')) {
                if (domain == i.innerText.split()) {
                    domain_is_exists = i.closest('tr');
                    break;
                }
            }
            if (domain_is_exists == null && data['count'] !== 0) {
                let tr = document.createElement('tr');
                tr.classList.add('key_table_row');
                let domain_td = document.createElement('td');
                let ips_td = document.createElement('td');
                domain_td.className = 'vertical-align domain';
                domain_td.title = pgettext('my_waf_bl', 'Domains');
                domain_td.innerHTML = '<div class="bl_domain">\n' +
                    '   <span>' + domain + '</span>\n' +
                    '   <a class="del_bl_domain" style="display: none;" ' +
                    '       title="' + pgettext('my_waf_bl', 'Remove') + '">\n' +
                    '       <i class="fa fa-trash"></i>\n' +
                    '   </a>\n' +
                    '</div>';
                ips_td.className = 'vertical-align';
                ips_td.title = pgettext('my_waf_bl', 'IPs');
                ips_td.style.textAlign = 'center';
                let a = document.createElement('a');
                let hidden = document.createElement('input');
                hidden.type = 'hidden';
                hidden.className = 'row-domain';
                hidden.value = data['domain'];
                a.className = 'count-ips';
                a.innerText = '0';
                ips_td.appendChild(a);
                tr.appendChild(hidden);
                tr.appendChild(domain_td);
                tr.appendChild(ips_td);
                table.querySelector('tbody').appendChild(tr);
                domain_is_exists = tr;
            }
            if (domain_is_exists != null) {
                domain_is_exists.querySelector('.count-ips').innerHTML = data['count'];
                let container_ips = document.querySelector('#container_ips_' + key_id);
                let block_ips = container_ips.closest('.block-ips');
                block_ips.querySelector('.search-ips').value = '';
                if ($(block_ips).is(':visible') && block_ips.querySelector('.selected_domain').value === data['domain']) {
                    container_ips.innerHTML = '';
                    for (let i of data['ips']) {
                        let div = document.createElement('div');
                        let btn_remove = document.createElement('sub');
                        let span = document.createElement('span');
                        div.className = 'btn btn-primary bl_ip';
                        if (i.includes('__ALL__')) {
                            div.classList.add('all');
                            div.title = pgettext('my_waf_bl', 'Applies to all domains');
                        } else {
                            btn_remove.title = pgettext('my_waf_bl', 'Remove IP');
                            btn_remove.className = 'bl_ip_remove';
                            btn_remove.innerHTML = '<i class="fa fa-close"></i>';
                        }
                        span.className = 'ip';
                        span.innerHTML = i.replace('__ALL__', '').replace(' api=yes', '*');
                        if (container_ips.childElementCount > window.limit_ips_in_container) {
                            div.style.display = 'none';
                        }
                        div.appendChild(span);
                        if (!i.includes('__ALL__')) {
                            div.appendChild(btn_remove);
                        }
                        container_ips.appendChild(div);

                    }
                }
                if (container_ips.childElementCount > window.limit_ips_in_container) {
                    let btn_more = document.createElement('div');
                    btn_more.className = 'btn-more show_ips';
                    btn_more.innerText = pgettext('my_waf_bl', 'More');
                    container_ips.appendChild(btn_more);
                }

            }
            if (data['duplicates'] !== null && data['duplicates'] !== undefined) {
                let info_div = document.querySelector('#info_for_add_ips_' + key_id);
                $(info_div.querySelector('.dupl-box')).show();
                $(info_div.querySelector('.error-box')).hide();
                let dubl_ips = info_div.querySelector('.dubl_ips');
                dubl_ips.innerHTML = String(data['duplicates']).replaceAll(' api=yes', '*');
                $(info_div).show(0).delay(5000).hide(0);
            }

        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let info_div = document.querySelector('#info_for_add_ips_' + key_id);
                $(info_div.querySelector('.dupl-box')).hide();
                $(info_div.querySelector('.error-box')).show();
                let dubl_ips = info_div.querySelector('.info_error');
                dubl_ips.innerHTML = String(data['duplicates']).replaceAll(' api=yes', '*');
                $(info_div).show(0).delay(5000).hide(0);

            } catch {
                show_messages_from_response(response.responseText)
            }
        }
    });
});

$(document).on('click', '#bl_menu_remove', function (e) {
    let ip = $("#info_bl_ip_for_menu").val();
    let domain = $("#info_bl_domain_for_menu").val();
    let flagAPI = $("#info_bl_api_for_menu").val();
    let key_id = $("#info_bl_key_id_for_menu").val();
    let data = {}
    data['key_id'] = key_id;
    data['ip'] = (flagAPI.toLowerCase() === 'false') ? ip : ip + ' api=yes';
    data['domain'] = domain;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;
    let container_ips = document.querySelector('#container_ips_' + key_id);
    let block_ips = container_ips.closest('.block-ips');
    let ip_elem = null;
    for (let i of block_ips.querySelectorAll('.bl_ip')) {
        if (i.querySelector('.ip') !== null && i.querySelector('.ip').textContent.replace('*', '') === ip) {
            ip_elem = i;
            break;
        }
    }
    if (ip_elem == null) {
        ip_elem = document.createElement('div');
    }
    $.ajax({
        url: home + '/bl/del/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = JSON.parse(response);
            if (domain == "__ALL__" || ip_elem.classList.contains('all')) {
                domain = pgettext('my_waf_bl', 'Applies to all domains');
            }
            let table = document.querySelector('#dyn_bl_table_' + key_id);
            let domain_is_exists = null;
            for (let i of table.querySelectorAll('.domain')) {
                if (domain == i.innerText.split()) {
                    domain_is_exists = i.closest('tr');
                    break;
                }
            }
            ip_elem.remove();
            domain_is_exists.querySelector('.count-ips').innerHTML = data['count'];
            if (data['count'] == 0) {
                domain_is_exists.remove();
                $(block_ips).hide()
            }

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
});

$(document).on('keyup', '.search-ips', function (e) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').textContent;

    let key_id = this.closest('.block-ips').querySelector('.key_id').value;
    let list = $('#list_ip_hints_' + key_id);
    let search_value = $('#ips_search_' + key_id).val();
    let search_select_type = $('#filter_select_list_' + key_id + ' .filter-select.active input').val();
    let domain = this.closest('.block-ips').querySelector('.selected_domain').value;

    let data = {};
    data['key_id'] = key_id;
    data['domain'] = domain;
    data['select_type'] = search_select_type;
    data['search'] = '';

    if (e.key !== 'Enter') {
        if (list.is(":hidden")) {
            list.show();
        }
        if (search_value.length === 0) {
            list.hide();
            return;
        }
        let search_list = search_value.replaceAll(' ', '').split(',');
        let search_last = search_list.pop().trim();
        list.empty()
        $.ajax({
            url: home + '/bl/get/',
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            dataType: "html",
            data: data,
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(response);
                    return;
                }
                let data = JSON.parse(response);

                for (let i of data['ips']) {
                    let ip = i.replace('__ALL__', '').replace(' api=yes', '');

                    if (ip.startsWith(search_last) && !search_list.includes(ip)) {
                        let tmp = document.createElement('a');
                        tmp.className = 'cursor-pointer item-list-ip-hints';
                        tmp.innerHTML = ip;
                        list.append(tmp);

                    }
                }
            },
            error: function (response) {
                show_messages_from_response(response.responseText)
            }
        });

    } else {
        list.hide();
    }
});

$(document).on('click', '.item-list-ip-hints', function (e) {
    let key_id = this.closest('.block-ips').querySelector('.key_id').value;
    let search_input = $('#ips_search_' + key_id);
    let list = $('#list_ip_hints_' + key_id);
    let search_value = search_input.val();
    let search_last = search_value.replaceAll(' ', '').split(',').pop().trim();

    if (this.textContent.startsWith(search_last)) {
        if (search_last.length === 0) {
            search_value = search_value.trimRight() + ' ' + this.textContent.trim();
        } else {
            search_value = search_value.replace(search_last, this.textContent);

        }
        search_input.val(search_value);
        let e = jQuery.Event("change");
        e.key = 'Enter';
        search_input.trigger(e);
        list.hide();
    }

});

$(document).on('click', '.filter-select', function () {
    let key_id = this.closest('.block-ips').querySelector('.key_id').value;
    let search_input = $('#ips_search_' + key_id);
    if (this.classList.contains('active')) {
        return;
    }

    for (let i of this.parentElement.children) {
        i.classList.remove('active');
    }

    this.classList.add('active');

    let e = jQuery.Event("change");
    e.key = 'Enter';
    search_input.trigger(e);
});

function show_btn_send_api(elem, key_id) {
    let btn_send_api = document.querySelector('#set_with_api_' + key_id)
    if (btn_send_api === null || btn_send_api === undefined) {
        return
    }
    $(btn_send_api).toggle((e = elem) => {
        let elemIcon = e.querySelector('.fa');
        let elemAPI = e.parentElement.nextElementSibling;
        if ($(elemAPI).is(':visible')) {
            elemIcon.classList.remove('fa-chevron-down');
            elemIcon.classList.add('fa-chevron-up');
        } else {
            elemIcon.classList.add('fa-chevron-down');
            elemIcon.classList.remove('fa-chevron-up');
        }
    });

}
