from django.urls import re_path
from admin_panel.views import edit_user, delete_user, add_user, manage_request, remove_request, remove_scan, \
    IndexView, EmailConfigView, CleaningConfigView, remove_task, cleaning_run, get_rule_wl, add_wl
from django.conf import settings
from django.contrib.auth.decorators import login_required

home_page = settings.HOME_PAGE[:-1]


urlpatterns = [
    re_path(r'^$', login_required(IndexView.as_view()), name='index admin'),
    re_path(r'edit_user/', edit_user, name='Edit user'),
    re_path(r'edit_email_config/', login_required(EmailConfigView.as_view()), name='Edit email config'),
    re_path(r'cleaning_scheduler/remove_task/', remove_task, name='Remove cleaning task'),
    re_path(r'cleaning_scheduler/manage_task/', login_required(CleaningConfigView.as_view()), name='Add cleaning task'),
    re_path(r'cleaning_scheduler/run/', cleaning_run, name='Run cleaning task'),
    re_path(r'delete_user/', delete_user, name='Delete user'),
    re_path(r'add_user/', add_user, name='Add user'),
    re_path(r'manage_request/', manage_request, name='Manage request'),
    re_path(r'remove_request/', remove_request, name='Remove request'),
    re_path(r'remove_scan/', remove_scan, name='Remove scan'),
    re_path(r'get_rule_wl/', get_rule_wl, name='Get rule wl'),
    re_path(r'add_wl/', add_wl, name='Add rule wl'),

]
