import ipaddress


def ip_split(ip_string):
    return ip_string.replace(' ', '').split(',')


def ip_validate(addr):
    try:
        try:
            return ipaddress.ip_address(addr)
        except ValueError:
            return ipaddress.ip_network(addr)
    except ValueError:
        return None


def serializable_user(user):
    return {
        "id": user.id,
        'email': user.email,
        'password': '',
        'active': user.is_active,
        'role': user.get_role(),
        'waf_alias': user.waf_alias.replace(' ', ''),
        'combined': user.combined,
        'domain': str(user.domain).replace('sub_', '*.'),
        'acl': user.acl
    }
