from django.core.management.base import BaseCommand
from django.db import connection
from django.conf import settings
import os


class Command(BaseCommand):
    help = 'Resolving migration conflicts'

    def handle(self, *args, **kwargs):
        try:
            with connection.cursor() as cursor:
                if 'django_migrations' not in connection.introspection.table_names():
                    return
                try:
                    cursor.execute("SELECT id FROM django_migrations WHERE name='0070_possible_and_remove_bot'")
                except Exception as e:
                    print('An error occurred while checking for invalid migrations: {}'.format(e))

                get_id = cursor.fetchone()
                base = str(settings.BASE_DIR) + '/main/migrations'
                if get_id is None:
                    sql = "DELETE FROM django_migrations WHERE name='{0}'"
                    cursor.execute(sql.format('0058_logs_possible'))
                    connection.commit()
                    cursor.execute(sql.format('0059_remove_logs_bot'))
                    connection.commit()
                    files = os.listdir(base)
                    try:
                        for file in files:
                            if file == '0058_logs_possible.py':
                                os.remove(base + '/' + file)
                            if file == '0059_remove_logs_bot.py':
                                os.remove(base + '/' + file)
                            if file == '0059_remove_logs_possible.py':
                                os.remove(base + '/' + file)
                            if file == '0060_logs_possible.py':
                                os.remove(base + '/' + file)
                            if file == '0061_remove_logs_bot.py':
                                os.remove(base + '/' + file)
                    except Exception as e:
                        print('An error occurred while clearing invalid migrations: {}'.format(e))

                    try:
                        cursor.execute("ALTER TABLE attack DROP COLUMN possible")
                    except Exception as e:
                        print('An error occurred when deleting the "possible" column: {}'.format(e))

                    try:
                        cursor.execute("ALTER TABLE attack ADD COLUMN bot bool")
                    except Exception as e:
                        print('An error occurred when adding the "bot" column: {}'.format(e))
        except Exception:
            print('Checking migrations. The connection to the database is not established.')
