from django.core.management.base import BaseCommand
from django.db import connection


class Command(BaseCommand):
    help = 'Actions for post migrate'

    def handle(self, *args, **kwargs):
        try:
            with connection.cursor() as cursor:
                try:
                    sql_update = """UPDATE main_wafuser
                                    SET ws_toggle=FALSE, oa_toggle=FALSE, mt_toggle=FALSE, last_update=CURRENT_DATE
                                    FROM (SELECT id FROM main_wafuser WHERE is_admin=FALSE
                                        AND last_update is null)
                                    AS subquery WHERE main_wafuser.id=subquery.id"""
                    cursor.execute(sql_update)
                except Exception as e:
                    print('An error occurred when setting default values for existing users: {}'.format(e))

                try:
                    sql_update = """UPDATE main_wafuser
                                    SET last_update=CURRENT_DATE
                                    FROM (SELECT id FROM main_wafuser WHERE is_admin=TRUE AND last_update is null)
                                    AS subquery WHERE main_wafuser.id=subquery.id"""
                    cursor.execute(sql_update)
                except Exception as e:
                    print('An error occurred when setting default values for existing administrators: {}'.format(e))
        except Exception as e:
            print(f'Checking after migrations. The connection to the database is not established.{e}')
