# -*- coding: utf-8 -*-
# Generated by Django 1.10.6 on 2017-04-26 15:37
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='WAFUSER',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('email', models.EmailField(max_length=255, unique=True, verbose_name='E-mail адрес')),
                ('priv_useradmin', models.BooleanField(default=False, verbose_name='Администратор')),
                ('priv_readuser', models.BooleanField(default=True, verbose_name='Пользователь(read only)')),
                ('is_active', models.BooleanField(default=True, verbose_name='Активен')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='EmailIsActive',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_active', models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name='EmailNotificationList',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('email', models.EmailField(blank=True, max_length=254, verbose_name='E-mail')),
                ('is_licence', models.BooleanField(verbose_name='Срок лицезии')),
                ('is_attack', models.BooleanField(verbose_name='Аттаки')),
                ('is_backend', models.BooleanField(verbose_name='Back-end')),
            ],
        ),
        migrations.CreateModel(
            name='EmailNotificationSettings',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('server', models.TextField(blank=True, verbose_name='Адрес почтового сервера')),
                ('server_port', models.IntegerField(blank=True, verbose_name='Порт сервера')),
                ('login', models.TextField(blank=True, verbose_name='Логин(e-mail)')),
                ('passwd', models.TextField(blank=True, verbose_name='Пароль')),
            ],
        ),
        migrations.CreateModel(
            name='Learning',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rule_id', models.IntegerField(blank=True)),
                ('vhost', models.TextField(blank=True)),
            ],
        ),
        migrations.CreateModel(
            name='Logs',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_time', models.DateTimeField(verbose_name='Date')),
                ('vhost', models.TextField(max_length=255, verbose_name='Domain')),
                ('ip', models.TextField(verbose_name="Attacker's IP")),
                ('rule_id', models.PositiveIntegerField(verbose_name='Rule id')),
                ('protocol', models.TextField(max_length=1024, null=True, verbose_name='Protocol')),
                ('method', models.TextField(max_length=1024, verbose_name='Method')),
                ('uri', models.TextField(max_length=1024, verbose_name='URL')),
                ('content', models.TextField(max_length=1024, verbose_name='Content')),
                ('content_length', models.TextField(max_length=1024, verbose_name='Content Length')),
                ('learning', models.BooleanField(verbose_name='Learning Mode')),
                ('wl', models.BooleanField(verbose_name='White List')),
                ('zone', models.TextField(blank=True, verbose_name='Zone')),
                ('param', models.TextField(blank=True, verbose_name='Parameter')),
                ('useragent', models.TextField(blank=True, verbose_name='User-agent')),
                ('referer', models.TextField(blank=True, verbose_name='Referer')),
                ('comment', models.TextField(blank=True, verbose_name='Comment')),
                #                ('score', models.IntegerField(blank=True, null=True, verbose_name='Score')),
                #                ('comment', models.TextField(blank=True, null=True, verbose_name='Score Type')),
                #               ('score_type', models.TextField(blank=True, null=True, verbose_name='Score Type')),
            ],
            options={
                'db_table': 'attack',
            },
        ),
        migrations.CreateModel(
            name='RequestLimit',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.IntegerField(blank=True, verbose_name='Параметр')),
                ('rate', models.IntegerField(blank=True, null=True, verbose_name='Количество запросов')),
                ('block_time', models.IntegerField(blank=True, null=True, verbose_name='Время блокировки')),
            ],
        ),
        migrations.CreateModel(
            name='WebSiteGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(null=True)),
                ('users', models.ManyToManyField(null=True, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Websites',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('domain', models.CharField(max_length=255, verbose_name='Домен')),
                ('is_active', models.BooleanField(default=True, verbose_name='Активен')),
                ('is_learning', models.BooleanField(default=False, verbose_name='Режим обучения')),
                ('add_date', models.DateTimeField(auto_now=True, verbose_name='Добавлен')),
                ('expire_date', models.DateTimeField(default=None, verbose_name='Срок лицензии')),
                ('backend_ip', models.TextField(blank=True, null=True, verbose_name='Back-end IP')),
            ],
        ),
        migrations.CreateModel(
            name='WhiteList',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('vhost', models.TextField(blank=True, verbose_name='Домен')),
                ('url', models.TextField(blank=True, verbose_name='URL')),
                ('zone', models.TextField(blank=True, verbose_name='Зона')),
                ('pattern', models.TextField(blank=True, verbose_name='Паттерн')),
            ],
        ),
        migrations.AddField(
            model_name='websitegroup',
            name='websites',
            field=models.ManyToManyField(null=True, to='main.Websites'),
        ),
    ]
