from django.db import models
from .wafuser import WAFUSER


class LicKeys(models.Model):

    # init
    user = models.ForeignKey(WAFUSER, on_delete=models.CASCADE)
    key = models.TextField(blank=False, verbose_name='Key')
    description = models.TextField(blank=False, verbose_name='User description')
    activated = models.BooleanField(default=False, verbose_name='Key activated')

    class Meta:
        db_table = 'settings_lickeys'

    def get_formated_key(self):
        # The user is identified by their email address
        if self.key and len(self.key) > 6:
            log_key = 'xxx' + self.key[-6:]
        else:
            log_key = self.key
        return log_key


class ModelInterval(models.Model):
    user = models.ForeignKey(WAFUSER, on_delete=models.CASCADE)
    model_name = models.TextField(blank=False, verbose_name='Model name')
    interval = models.TextField(blank=False, verbose_name='Time interval')
    key = models.ForeignKey(LicKeys, on_delete=models.CASCADE, null=True)

    class Meta:
        db_table = 'settings_model_interval'


class ErlEndOfLife(models.Model):
    rid = models.IntegerField(primary_key=True, verbose_name='ERL id')
    interval = models.TextField(blank=False, verbose_name='Time interval')
    end_timestamp = models.TextField(blank=False, verbose_name='Time interval')
    key = models.ForeignKey(LicKeys, on_delete=models.CASCADE, null=True)

    class Meta:
        db_table = 'settings_erl_end_of_life'


class Geo_Tokens(models.Model):
    waf_id = models.TextField(primary_key=True, verbose_name='waf_id')
    geo_token = models.TextField(blank=False, verbose_name='geo_token')

    class Meta:
        db_table = 'geo_tokens'
