from django.db import models
from main.models.logs import Logs


class ScanRequest(models.Model):
    log = models.OneToOneField(Logs, on_delete=models.CASCADE, null=True)
    status = models.IntegerField(default=0)
    description = models.CharField(max_length=255, blank=True, verbose_name='description')
    created_at = models.DateTimeField(blank=True, auto_now_add=True)


class ScannerReport(models.Model):
    scan_date = models.DateTimeField(blank=True, verbose_name='Date of scanning start')
    mz = models.TextField(blank=True, verbose_name='Match Zone')
    content = models.TextField(blank=True, verbose_name='Scanning results')
    domain = models.TextField(blank=True, verbose_name='Domain')
    type = models.TextField(blank=True, verbose_name='Vulnerability type')
    method = models.TextField(blank=True, verbose_name='Request method')
    url = models.TextField(blank=True, verbose_name='URL')
    param = models.TextField(blank=True, verbose_name='Vulnerability parameter')
    payload = models.TextField(blank=True, verbose_name='Payload')
    data = models.TextField(blank=True, verbose_name='POST-data')
    waf_alias = models.TextField(blank=True, verbose_name='WAF ID', db_column='waf_id')

    class Meta:
        db_table = 'scan_report'
