from django.db import models
from main.models.wafuser import WAFUSER
from main.models.logs import Logs


class WhitelistRequest(models.Model):
    user = models.ForeignKey(WAFUSER, on_delete=models.CASCADE)
    log = models.ForeignKey(Logs, on_delete=models.CASCADE)
    user_comment = models.TextField(blank=True, verbose_name='User comment')
    admin_comment = models.TextField(blank=True, verbose_name='Administrator comment')
    record_date = models.DateTimeField(blank=False, verbose_name='Date')
    is_deleted = models.BooleanField(default=False, verbose_name='Deleted')
    done = models.BooleanField(blank=False, default=False, verbose_name='Completed')
