class OtherRouter(object):
    apps_list = ['admin', 'auth', 'contenttypes', 'sessions', 'messages', 'staticfiles', 'main']

    def db_for_read(self, model, **hints):
        if model._meta.db_table == 'mt_export':
            return 'waf'
        elif model._meta.db_table == 'mt_main':
            return 'waf'
        if model._meta.app_label in self.apps_list:
            return 'default'

        return None

    def db_for_write(self, model, **hints):
        if model._meta.db_table == 'mt_export':
            return 'waf'
        elif model._meta.db_table == 'mt_main':
            return 'waf'
        if model._meta.app_label in self.apps_list:
            return 'default'
        return None

    def allow_relation(self, obj1, obj2, **hints):
        if obj1._meta.app_label in self.apps_list or obj2._meta.app_label in self.apps_list:
            return True

        return None

    def allow_migrate(self, db, app_label, model_name=None, **hints):
        if app_label in self.apps_list:
            return db == 'default'

        return None
