import operator
from functools import reduce
from django.db.models import Q
from django.db.models.query import EmptyQuerySet
from main.models.logs import Logs
from main.utils import convert_to_punycode
from django.db import connections

host_s = []
ip_s = []
type_s = []
bt = []
rule = []
mz = []
group_id = []
waf_id = []
recheck = []
possible = []
url = []
host_without_negative = []
host_with_negative = []
ip_without_negative = []
ip_with_negative = []
type_without_negative = []
type_with_negative = []
bt_with_negative = []
bt_without_negative = []
rule_with_negative = []
rule_without_negative = []
mz_with_negative = []
mz_without_negative = []
group_id_with_negative = []
group_id_without_negative = []
waf_id_with_negative = []
waf_id_without_negative = []
recheck_with_negative = []
recheck_without_negative = []
possible_with_negative = []
possible_without_negative = []
url_with_negative = []
url_without_negative = []
cc_with_negative = []
cc_without_negative = []
fulltext_with_negative = []
fulltext_without_negative = []
param_without_negative = []
param_with_negative = []


def clear_filters():
    host_s.clear()
    ip_s.clear()
    type_s.clear()
    bt.clear()
    rule.clear()
    mz.clear()
    group_id.clear()
    possible.clear()
    url.clear()
    waf_id.clear()
    host_without_negative.clear()
    host_with_negative.clear()
    ip_without_negative.clear()
    ip_with_negative.clear()
    type_without_negative.clear()
    type_with_negative.clear()
    bt_with_negative.clear()
    bt_without_negative.clear()
    rule_with_negative.clear()
    rule_without_negative.clear()
    mz_with_negative.clear()
    mz_without_negative.clear()
    group_id_with_negative.clear()
    group_id_without_negative.clear()
    waf_id_with_negative.clear()
    waf_id_without_negative.clear()
    recheck_with_negative.clear()
    recheck_without_negative.clear()
    possible_with_negative.clear()
    possible_without_negative.clear()
    cc_with_negative.clear()
    cc_without_negative.clear()
    fulltext_with_negative.clear()
    fulltext_without_negative.clear()
    param_without_negative.clear()
    param_with_negative.clear()


def check_exist_cc():
    try:
        count = Logs.objects.using('waf').all().count()
        if count > 0:
            Logs.objects.using('waf').first().cc
            on_cc = True
        else:
            r = "SELECT * FROM information_schema.columns WHERE column_name = 'cc' AND table_name = 'attack'"
            with connections['waf'].cursor() as cursor:
                cursor.execute(r)
                res = cursor.fetchone()
                if res is None:
                    on_cc = False
                else:
                    on_cc = True
    except Exception:
        on_cc = False
    return on_cc


def filters_distribution(i):
    on_cc = check_exist_cc()
    i = i.strip()
    if 'h:' in i:
        if i[0] == '!':
            if i[3] != '':
                host_with_negative.append(convert_to_punycode(i[3:]))
        else:
            host_without_negative.append(convert_to_punycode(i[2:]))
    elif 'mz:' in i:
        if i[0] == '!':
            if i[4] != '':
                mz_with_negative.append(i[4:])
                if 'url' in i[4:]:
                    mz_with_negative.append('uri')
                elif 'other_headers' in i[4:]:
                    mz_with_negative.append('headers')
                elif 'headers' in i[4:]:
                    mz_with_negative.append('other_headers')

        else:
            mz_without_negative.append(i[3:])
            if 'url' in i[3:]:
                mz_without_negative.append('uri')
            elif 'other_headers' in i[3:]:
                mz_without_negative.append('headers')
            elif 'headers' in i[3:]:
                mz_without_negative.append('other_headers')

    elif 'group_id:' in i:
        if i[0] == '!':
            if i[10] != '':
                group_id_with_negative.append(i[10:])
        else:
            group_id_without_negative.append(i[9:])
    elif 'waf_id:' in i:
        if i[0] == '!':
            if i[8] != '':
                waf_id_with_negative.append(i[8:])
        else:
            waf_id_without_negative.append(i[7:])
    elif 'bt:' in i:
        if i[0] == '!':
            if i[4] != '':
                bt_with_negative.append(i[4:])
        else:
            bt_without_negative.append(i[3:])
    elif 'rule:' in i:
        if i[0] == '!':
            if i[6] != '':
                rule_with_negative.append(i[6:])
        else:
            rule_without_negative.append(i[5:])

    elif 'ip:' in i:
        if i[0] == '!':
            if i[4] != '':
                ip_with_negative.append(i[4:])
        else:
            ip_without_negative.append(i[3:])
    elif 'cc:' in i:
        # off CC
        if on_cc:
            if i[0] == '!':
                if i[4] != '':
                    cc_with_negative.extend(i[4:].split('|'))
            else:
                cc_without_negative.extend(i[3:].split('|'))
    elif 't:' in i:
        bt_s = ''
        if 't:mla' in i:
            bt_s = '3'
        elif 't:antivirus' in i:
            bt_s = '4'
        elif 't:error' in i or 't:internal_error' in i:
            bt_s = '5'
        elif 't:bf' in i:
            bt_s = '7'
        elif 't:brute' in i:
            bt_s = '7'
        elif 't:brute-force' in i:
            bt_s = '7'
        elif 't:mlc' in i:
            bt_s = '8'
        elif 't:flood' in i:
            bt_s = '9'
        elif 't:ddos' in i:
            bt_s = '10'
        elif 't:oapi' in i:
            bt_s = '14'
        elif 't:bl' in i:
            bt_s = '16'
        else:
            if i[0] == '!':
                if i[3] != '':
                    type_with_negative.append(i[3:])
            else:
                type_without_negative.append(i[2:])

        if i[0] == '!':
            if bt_s != '':
                bt_with_negative.append(bt_s)
        else:
            if bt_s != '':
                bt_without_negative.append(bt_s)
    elif 'vuln' in i:
        if i[0] == '!':
            recheck_without_negative.append(1)
        else:
            recheck_without_negative.append(2)
    elif 'possible' in i:
        if '!possible' in i:
            possible_with_negative.append(False)
        else:
            possible_without_negative.append(True)
    elif 'url:' in i:
        if i[0] == '!':
            if i[5] != '':
                url_with_negative.append(i[5:])
        else:
            url_without_negative.append(i[4:])
    else:
        if i[0] == '!':
            fulltext_with_negative.append(convert_to_punycode(i[1:]))
        else:
            fulltext_without_negative.append(convert_to_punycode(i))


def search_filter(s, ws):
    on_cc = check_exist_cc()

    s = s.lower()

    # for bt 5
    s = s.replace('internal error', 'internal_error')
    clear_filters()
    ws2 = ws
    main_clear = Logs.objects.using('waf').none()
    # complex filtration
    if ' and ' in s or ' or ' in s:
        filters_with_and = []
        filters_with_or = []
        if 'or' in s:
            search_list = s.split(' or ')
            for i in search_list:
                if 'and' in i:
                    filters_with_and.append(i)
                else:
                    filters_with_or.append(i)
        else:
            filters_with_and.append(s)

        if filters_with_and:
            for i in ''.join(filters_with_and).split(' and '):
                filters_distribution(i)

        # Result, but need fix
        if host_without_negative:
            # We call the OR operator without negation because
            if isinstance(main_clear, EmptyQuerySet) is False:
                for q in set(host_without_negative):
                    if q[0] == '*' or q[0] == '.':
                        main_clear = main_clear & ws.filter((Q(vhost__icontains=q[1:])))
                    else:
                        main_clear = main_clear & ws.filter((Q(vhost=q)))
            else:
                f = Q()
                for q in set(host_without_negative):
                    if q[0] == '*' or q[0] == '.':
                        f &= Q(vhost__icontains=q[1:])
                    else:
                        f &= Q(vhost=q)
                main_clear = main_clear | ws.filter(f)
        if host_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                for q in set(host_with_negative):
                    if q[0] == '*' or q[0] == '.':
                        main_clear = main_clear & ws.filter((~Q(vhost__icontains=q[1:])))
                    else:
                        main_clear = main_clear & ws.filter((~Q(vhost=q)))
            else:
                f = Q()
                for q in set(host_with_negative):
                    if q[0] == '*' or q[0] == '.':
                        f = f & (~Q(vhost__icontains=q[1:]))
                    else:
                        f = f & (~Q(vhost=q))
                main_clear = main_clear | ws.filter(f)
        if cc_without_negative:
            f = Q()
            for cc in set(cc_without_negative):
                f |= Q(cc__iexact=cc)
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(f)
            else:
                main_clear = main_clear | ws.filter(f)
        if cc_with_negative:
            f = Q()
            for cc in set(cc_with_negative):
                f = f & (~Q(cc__iexact=cc))
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(f)
            else:
                main_clear = main_clear | ws.filter(f)
        if ip_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(ip__icontains=q) for q in ip_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(ip__icontains=q) for q in ip_without_negative)))
        if ip_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(ip__icontains=q) for q in ip_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(ip__icontains=q) for q in ip_with_negative)))
        if type_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(description__icontains=q) for q in
                                                            type_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(description__icontains=q) for q in
                                                            type_without_negative)))
        if type_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(description__icontains=q) for q in type_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(description__icontains=q) for q in type_with_negative)))
        if rule_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(rule_id=q) for q in
                                                            rule_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(rule_id=q) for q in
                                                            rule_without_negative)))
        if rule_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(rule_id=q) for q in rule_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(rule_id=q) for q in rule_with_negative)))
        if bt_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(bt=q) for q in
                                                            bt_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(bt=q) for q in
                                                            bt_without_negative)))
        if bt_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(bt=q) for q in bt_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(bt=q) for q in bt_with_negative)))
        if mz_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(mz__iexact=q) for q in
                                                            mz_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(mz__iexact=q) for q in
                                                            mz_without_negative)))
        if mz_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(mz__iexact=q) for q in mz_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(mz__iexact=q) for q in mz_with_negative)))
        if group_id_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(group_id__iexact=q) for q in
                                                            group_id_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(group_id__iexact=q) for q in
                                                            group_id_without_negative)))
        if group_id_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(group_id__iexact=q) for q in group_id_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(group_id__iexact=q) for q in group_id_with_negative)))
        if waf_id_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(alias__icontains=q) for q in
                                                            waf_id_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(alias__icontains=q) for q in
                                                            waf_id_without_negative)))
        if waf_id_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(alias__icontains=q) for q in waf_id_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(alias__icontains=q) for q in waf_id_with_negative)))

        if recheck_without_negative:
            ids = []
            if isinstance(main_clear, EmptyQuerySet) is False:
                for q in recheck_without_negative:
                    for obj in Logs.objects.filter((Q(scanrequest__status__exact=q))):
                        ids.append(obj.id)
                main_clear = main_clear & ws.filter(id__in=ids)
            else:
                for q in recheck_without_negative:
                    for obj in Logs.objects.filter((Q(scanrequest__status__exact=q))):
                        ids.append(obj.id)
                    main_clear = main_clear | ws.filter(id__in=ids)

        if recheck_with_negative:
            request_ids = []
            if isinstance(main_clear, EmptyQuerySet) is False:
                for q in recheck_with_negative:
                    for obj in Logs.objects.filter(scanrequest__status__exact=q):
                        request_ids.append(obj.request_id)
                if request_ids:
                    main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                               (~Q(request_id=req) for req in request_ids)))
            else:
                for q in recheck_with_negative:
                    for obj in Logs.objects.filter(scanrequest__status__exact=q):
                        request_ids.append(obj.request_id)
                if request_ids:
                    main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                               (~Q(request_id=req) for req in request_ids)))

        if possible_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(Q(possible=bool(True)))
            else:
                main_clear = main_clear | ws.filter(Q(possible=bool(True)))

        if possible_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(~Q(possible=bool(True)))
            else:
                main_clear = main_clear & ws.filter(~Q(possible=bool(True)))

        if url_without_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.or_,
                                                           (Q(url__icontains=q) for q in
                                                            url_without_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.or_,
                                                           (Q(url__icontains=q) for q in
                                                            url_without_negative)))

        if url_with_negative:
            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & ws.filter(reduce(operator.and_,
                                                           (~Q(url__icontains=q) for q in
                                                            url_with_negative)))
            else:
                main_clear = main_clear | ws.filter(reduce(operator.and_,
                                                           (~Q(url__icontains=q) for q in
                                                            url_with_negative)))

        if fulltext_without_negative:
            f = Q()
            wstmp = ws
            for q in fulltext_without_negative:
                f &= (Q(description__icontains=q) | Q(vhost__icontains=q) | Q(ip__icontains=q) |
                      Q(method__icontains=q) | Q(url__icontains=q) | Q(param__icontains=q) |
                      Q(ua__icontains=q) | Q(referer__icontains=q) | Q(other_headers__icontains=q) |
                      Q(cookie__icontains=q) | Q(request_id__icontains=q) | Q(alias__icontains=q))

                wstmp &= ws.filter(f) | ws.extra(where=["convert_from(body,'UTF8') ILIKE %s"],
                                                 params=["%" + q.replace('\\', '\\\\') + "%"])

            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & wstmp
            else:
                main_clear = main_clear | wstmp
        if fulltext_with_negative:
            f = Q()
            wstmp = ws
            for q in fulltext_with_negative:
                f &= (~Q(description__icontains=q) & ~Q(vhost__icontains=q) & ~Q(ip__icontains=q) &
                      ~Q(method__icontains=q) & ~Q(url__icontains=q) & ~Q(param__icontains=q) &
                      ~Q(ua__icontains=q) & ~Q(referer__icontains=q) & ~Q(other_headers__icontains=q) &
                      ~Q(cookie__icontains=q) & ~Q(request_id__icontains=q) & ~Q(alias__icontains=q))
                wstmp &= ws.filter(f) & ws.extra(where=["convert_from(body,'UTF8') NOT ILIKE %s"],
                                                 params=["%" + q.replace('\\', '\\\\') + "%"])

            if isinstance(main_clear, EmptyQuerySet) is False:
                main_clear = main_clear & wstmp
            else:
                main_clear = main_clear | wstmp

        ws = main_clear

        if filters_with_or:
            clear_filters()

            for i in filters_with_or:
                filters_distribution(i)

            main_clear = Logs.objects.using('waf').none()

            if host_without_negative:
                # We call the OR operator without negation because
                if isinstance(main_clear, EmptyQuerySet) is False:
                    for q in host_without_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear | ws2.filter((Q(vhost__icontains=q[1:])))
                        else:
                            main_clear = main_clear | ws2.filter((Q(vhost=q)))
                else:
                    for q in host_without_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear | ws2.filter((Q(vhost__icontains=q[1:])))
                        else:
                            main_clear = main_clear | ws2.filter((Q(vhost=q)))
            if host_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    for q in host_with_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear | ws2.filter((~Q(vhost__icontains=q[1:])))
                        else:
                            main_clear = main_clear | ws2.filter((~Q(vhost=q)))
                else:
                    for q in host_with_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear | ws2.filter((~Q(vhost__icontains=q[1:])))
                        else:
                            main_clear = main_clear | ws2.filter((~Q(vhost=q)))
            if cc_without_negative:
                f = Q()
                for cc in set(cc_without_negative):
                    f |= Q(cc__iexact=cc)
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(f)
                else:
                    main_clear = main_clear | ws2.filter(f)
            if cc_with_negative:
                f = Q()
                for cc in set(cc_with_negative):
                    f = f & (~Q(cc__iexact=cc))

                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(f)
                else:
                    main_clear = main_clear | ws2.filter(f)
            if ip_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(ip__icontains=q) for q in ip_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(ip__icontains=q) for q in ip_without_negative)))
            if ip_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(ip__icontains=q) for q in ip_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(ip__icontains=q) for q in ip_with_negative)))
            if type_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(description__icontains=q) for q in
                                                                 type_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(description__icontains=q) for q in
                                                                 type_without_negative)))
            if type_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(description__icontains=q) for q in
                                                                 type_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(description__icontains=q) for q in
                                                                 type_with_negative)))
            if rule_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(rule_id=q) for q in
                                                                 rule_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(rule_id=q) for q in
                                                                 rule_without_negative)))
            if rule_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(rule_id=q) for q in rule_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(rule_id=q) for q in rule_with_negative)))
            if bt_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(bt=q) for q in
                                                                 bt_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(bt=q) for q in
                                                                 bt_without_negative)))
            if bt_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(bt=q) for q in bt_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(bt=q) for q in bt_with_negative)))
            if mz_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(mz__iexact=q) for q in
                                                                 mz_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(mz__iexact=q) for q in
                                                                 mz_without_negative)))
            if mz_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(mz__iexact=q) for q in mz_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(mz__iexact=q) for q in mz_with_negative)))
            if group_id_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(group_id__iexact=q) for q in
                                                                 group_id_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(group_id__iexact=q) for q in
                                                                 group_id_without_negative)))
            if group_id_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(group_id__iexact=q) for q in
                                                                 group_id_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(group_id__iexact=q) for q in
                                                                 group_id_with_negative)))
            if waf_id_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(alias__icontains=q) for q in
                                                                 waf_id_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(alias__icontains=q) for q in
                                                                 waf_id_without_negative)))
            if waf_id_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(alias__icontains=q) for q in waf_id_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(alias__icontains=q) for q in waf_id_with_negative)))

            if recheck_without_negative:
                ids = []
                if isinstance(main_clear, EmptyQuerySet) is False:
                    for q in recheck_without_negative:
                        for obj in Logs.objects.filter((Q(scanrequest__status__exact=q))):
                            ids.append(obj.id)
                        main_clear = main_clear | ws2.filter(id__in=ids)
                else:
                    for q in recheck_without_negative:
                        for obj in Logs.objects.filter((Q(scanrequest__status__exact=q))):
                            ids.append(obj.id)
                    main_clear = main_clear | ws2.filter(id__in=ids)

            if recheck_with_negative:
                request_ids = []
                if isinstance(main_clear, EmptyQuerySet) is False:
                    for q in recheck_with_negative:
                        for obj in Logs.objects.filter(scanrequest__status__exact=q):
                            request_ids.append(obj.request_id)
                    if request_ids:
                        main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                    (~Q(request_id=req) for req in request_ids)))
                else:
                    for q in recheck_with_negative:
                        for obj in Logs.objects.filter(scanrequest__status__exact=q):
                            request_ids.append(obj.request_id)
                    if request_ids:
                        main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                    (~Q(request_id=req) for req in request_ids)))

            if possible_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(Q(possible=bool(True)))
                else:
                    main_clear = main_clear | ws2.filter(Q(possible=bool(True)))

            if possible_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(~Q(possible=bool(True)))
                else:
                    main_clear = main_clear | ws2.filter(~Q(possible=bool(True)))

            if url_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(url__icontains=q) for q in url_without_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.or_,
                                                                (Q(url__icontains=q) for q in url_without_negative)))
            if ip_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(url__icontains=q) for q in url_with_negative)))
                else:
                    main_clear = main_clear | ws2.filter(reduce(operator.and_,
                                                                (~Q(url__icontains=q) for q in url_with_negative)))

            if fulltext_without_negative:
                f = Q()
                wstmp = Logs.objects.none()
                for q in fulltext_without_negative:
                    f |= (Q(description__icontains=q) | Q(vhost__icontains=q) | Q(ip__icontains=q) |
                          Q(method__icontains=q) | Q(url__icontains=q) | Q(param__icontains=q) |
                          Q(ua__icontains=q) | Q(referer__icontains=q) | Q(other_headers__icontains=q) |
                          Q(cookie__icontains=q) | Q(request_id__icontains=q) | Q(alias__icontains=q))
                    wstmp |= ws2.filter(f) | ws.extra(where=["convert_from(body,'UTF8') ILIKE %s"],
                                                      params=["%" + q.replace('\\', '\\\\') + "%"])

                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | wstmp
                else:
                    main_clear = main_clear | wstmp
            if fulltext_with_negative:
                f = Q()
                wstmp = Logs.objects.none()
                for q in fulltext_with_negative:
                    f |= (~Q(description__icontains=q) & ~Q(vhost__icontains=q) & ~Q(ip__icontains=q) &
                          ~Q(method__icontains=q) & ~Q(url__icontains=q) & ~Q(param__icontains=q) &
                          ~Q(ua__icontains=q) & ~Q(referer__icontains=q) & ~Q(other_headers__icontains=q) &
                          ~Q(cookie__icontains=q) & ~Q(request_id__icontains=q) & ~Q(alias__icontains=q))
                    wstmp = ws2.filter(f).extra(where=["convert_from(body,'UTF8') NOT ILIKE %s"],
                                                params=["%" + q.replace('\\', '\\\\') + "%"])

                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear | wstmp
                else:
                    main_clear = main_clear | wstmp

            ws = ws | main_clear

    # simple filtration
    else:
        s = s.strip()
        # find only host
        if 'h:' in s and len(s) > 2:
            if '!h:' in s:
                if len(s) > 3:
                    if s[3] == '*' or s[3] == '.':
                        ws = ws.filter(~Q(vhost__icontains=convert_to_punycode(s[4:])))
                    else:
                        ws = ws.filter(~Q(vhost=convert_to_punycode(s[3:])))
            else:
                if s[2] == '*' or s[2] == '.':
                    ws = ws.filter(Q(vhost__icontains=convert_to_punycode(s[3:])))
                else:
                    ws = ws.filter(Q(vhost=convert_to_punycode(s[2:])))
        # find only ip
        elif 'ip:' in s and len(s) > 3:
            if '!ip:' in s:
                if len(s) > 4:
                    ws = ws.filter(~Q(ip__icontains=s[4:]))
            else:
                ws = ws.filter(Q(ip__icontains=s[3:]))
        # find only url
        elif 'url:' in s and len(s) > 4:
            if '!url:' in s:
                if len(s) > 5:
                    ws = ws.filter(~Q(url__icontains=s[5:]))
            else:
                ws = ws.filter(Q(url__icontains=s[4:]))

        # find only bt
        elif 'bt:' in s and len(s) > 3:
            if '!bt:' in s:
                if len(s) > 4:
                    ws = ws.filter(~Q(bt=s[4:]))
            else:
                ws = ws.filter(Q(bt=s[3:]))
        # find only type
        elif 't:' in s:
            if s == 't:mla':
                ws = ws.filter(Q(bt=3))
            elif s == '!t:mla':
                ws = ws.filter(~Q(bt=3))
            elif s == 't:antivirus':
                ws = ws.filter(Q(bt=4))
            elif s == '!t:antivirus':
                ws = ws.filter(~Q(bt=4))
            elif s == 't:error' or s == 't:internal_error':
                ws = ws.filter(Q(bt=5))
            elif s == '!t:error' or s == '!t:internal_error':
                ws = ws.filter(~Q(bt=5))
            elif s == 't:bf':
                ws = ws.filter(Q(bt=7))
            elif s == '!t:bf':
                ws = ws.filter(~Q(bt=7))
            elif s == 't:brute':
                ws = ws.filter(Q(bt=7))
            elif s == '!t:brute':
                ws = ws.filter(~Q(bt=7))
            elif s == 't:brute-force':
                ws = ws.filter(Q(bt=7))
            elif s == '!t:brute-force':
                ws = ws.filter(~Q(bt=7))
            elif s == 't:mlc':
                ws = ws.filter(Q(bt=8))
            elif s == '!t:mlc':
                ws = ws.filter(~Q(bt=8))
            elif s == 't:flood':
                ws = ws.filter(Q(bt=9))
            elif s == '!t:flood':
                ws = ws.filter(~Q(bt=9))
            elif s == 't:ddos':
                ws = ws.filter(Q(bt=10))
            elif s == '!t:ddos':
                ws = ws.filter(~Q(bt=10))
            elif s == 't:oapi':
                ws = ws.filter(Q(bt=14))
            elif s == '!t:oapi':
                ws = ws.filter(~Q(bt=14))
            elif s == 't:bl':
                ws = ws.filter(Q(bt=16))
            elif s == '!t:bl':
                ws = ws.filter(~Q(bt=16))
            elif '!t:' in s:
                if len(s) > 3:
                    ws = ws.filter(~Q(description__icontains=s[3:]))
            else:
                if len(s) > 2:
                    ws = ws.filter(Q(description__icontains=s[2:]))
        # find only rule
        elif 'rule:' in s and len(s) > 5:
            if '!rule:' in s:
                if len(s) > 6:
                    ws = ws.filter(~Q(rule_id=s[6:]))
            else:
                ws = ws.filter(Q(rule_id=s[5:]))
        # find only mz
        elif 'mz:' in s and len(s) > 3:
            if '!mz:' in s:
                if len(s) > 4:
                    ws = ws.filter(~Q(mz__iexact=s[4:]))
                    if s[4:] == 'url':
                        ws = ws.filter(~Q(mz__iexact='uri'))
                    elif s[4:] == 'other_headers':
                        ws = ws.filter(~Q(mz__iexact='headers'))
                    elif s[4:] == 'headers':
                        ws = ws.filter(~Q(mz__iexact='other_headers'))

            else:
                f = Q(mz__iexact=s[3:])
                if s[3:] == 'url':
                    f |= Q(mz__iexact='uri')
                elif s[3:] == 'other_headers':
                    f |= Q(mz__iexact='headers')
                elif s[3:] == 'headers':
                    f |= Q(mz__iexact='other_headers')

                ws = ws.filter(f)
        # find only group_id
        elif 'group_id:' in s and len(s) > 9:
            if '!group_id:' in s:
                if len(s) > 10:
                    ws = ws.filter(~Q(group_id__iexact=s[10:]))
            else:
                ws = ws.filter(Q(group_id__iexact=s[9:]))
        # find only waf_id
        elif 'waf_id:' in s and len(s) > 7:
            if '!waf_id:' in s:
                if len(s) > 8:
                    ws = ws.filter(~Q(alias__icontains=s[8:]))
            else:
                ws = ws.filter(Q(alias__icontains=s[7:]))
        # find only recheck
        elif 'vuln' in s:
            ids = []
            if '!' == s[0]:
                for obj in Logs.objects.filter(scanrequest__status__exact=1):
                    ids.append(obj.id)
                ws = ws.filter(id__in=ids)
            else:
                for obj in Logs.objects.filter(scanrequest__status__exact=2):
                    ids.append(obj.id)
                ws = ws.filter(id__in=ids)

        # find only possible
        elif '!possible' in s:
            ws = ws.filter(~Q(possible=True))
        elif 'possible' in s:
            ws = ws.filter(Q(possible=True))

        # find only cc
        elif 'cc:' in s and len(s) > 3:
            # off CC
            if on_cc:
                f = Q()
                if '!cc:' in s:
                    if len(s) > 4:
                        for cc in s[4:].split('|'):
                            f = f & (~Q(cc__iexact=cc))
                else:
                    for cc in s[3:].split('|'):
                        f |= Q(cc__iexact=cc)
                ws = ws.filter(f)
        # parse all blocks
        else:
            f = Q()
            if s[0] == '!':
                f &= (~Q(description__icontains=s[1:]) & ~Q(vhost__icontains=convert_to_punycode(s[1:])) & ~Q(
                    ip__icontains=s[1:]) &
                      ~Q(method__icontains=s[1:]) & ~Q(url__icontains=s[1:]) & ~Q(param__icontains=s[1:]) &
                      ~Q(ua__icontains=s[1:]) & ~Q(referer__icontains=s[1:]) & ~Q(other_headers__icontains=s[1:]) &
                      ~Q(cookie__icontains=s[1:]) & ~Q(request_id__icontains=s[1:]) & ~Q(alias__icontains=s[1:]))
                ws = ws.filter(f).extra(where=["convert_from(body,'UTF8') NOT ILIKE %s"],
                                        params=["%" + s[1:].replace('\\', '\\\\') + "%"])

            else:
                f &= (Q(description__icontains=s) | Q(vhost__icontains=convert_to_punycode(s)) | Q(ip__icontains=s) |
                      Q(method__icontains=s) | Q(url__icontains=s) | Q(param__icontains=s) |
                      Q(ua__icontains=s) | Q(referer__icontains=s) | Q(other_headers__icontains=s) |
                      Q(cookie__icontains=s) | Q(request_id__icontains=s) | Q(alias__icontains=s))
                ws = ws.filter(f) | ws.extra(where=["convert_from(body,'UTF8') ILIKE %s"],
                                             params=["%" + s.replace('\\', '\\\\') + "%"])

    return ws


def scan_search_filter(s, main):
    if s and s != '':
        clear_filters()

        s = s.lower()
        main_clear = Logs.objects.using('waf').none()
        # complex filtration
        if ' and ' in s:
            search_list = s.split(' and ')
            for i in search_list:
                if 'h:' in i:
                    if i[0] == '!':
                        if i[1] != '':
                            host_with_negative.append(convert_to_punycode(i[3:]))
                    else:
                        host_without_negative.append(convert_to_punycode(i[2:]))
                elif 'u:' in i:
                    if i[0] == '!':
                        if i[1] != '':
                            url_with_negative.append(i[3:])
                    else:
                        url_without_negative.append(i[2:])
                elif 't:' in i:
                    if i[0] == '!':
                        if i[1] != '':
                            type_with_negative.append(i[3:])
                    else:
                        type_without_negative.append(i[2:])
                elif 'p:' in i:
                    if i[0] == '!':
                        if i[1] != '':
                            param_with_negative.append(i[3:])
                    else:
                        param_without_negative.append(i[2:])
                else:
                    host_without_negative.append(convert_to_punycode(i))
            if host_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    for q in host_without_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear & main.filter((Q(domain__icontains=q[1:])))
                        else:
                            main_clear = main_clear & main.filter((Q(domain=q)))
                else:
                    for q in host_without_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear | main.filter((Q(domain__icontains=q[1:])))
                        else:
                            main_clear = main_clear | main.filter((Q(domain=q)))
            if host_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    for q in host_with_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear & main.filter((~Q(domain__icontains=q[1:])))
                        else:
                            main_clear = main_clear & main.filter((~Q(domain=q)))
                else:
                    for q in host_with_negative:
                        if q[0] == '*' or q[0] == '.':
                            main_clear = main_clear | main.filter((~Q(domain__icontains=q[1:])))
                        else:
                            main_clear = main_clear | main.filter((~Q(domain=q)))
            if url_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear & main.filter(reduce(operator.or_,
                                                                 (Q(url__icontains=q) for q in
                                                                  url_without_negative)))
                else:
                    main_clear = main_clear | main.filter(reduce(operator.or_,
                                                                 (Q(url__icontains=q) for q in
                                                                  url_without_negative)))
            if url_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear & main.filter(reduce(operator.and_,
                                                                 (~Q(url__icontains=q) for q in url_with_negative)))
                else:
                    main_clear = main_clear | main.filter(reduce(operator.and_,
                                                                 (~Q(url__icontains=q) for q in url_with_negative)))
            if type_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear & main.filter(
                        reduce(operator.or_, (Q(type__icontains=q) for q in type_without_negative))
                    )
                else:
                    main_clear = main_clear | main.filter(
                        reduce(operator.or_, (Q(type__icontains=q) for q in type_with_negative)))
            if type_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear & main.filter(reduce(operator.and_,
                                                                 (~Q(type__icontains=q) for q in
                                                                  type_with_negative)))
                else:
                    main_clear = main_clear | main.filter(reduce(operator.and_,
                                                                 (~Q(type__icontains=q) for q in
                                                                  type_with_negative)))
            if param_without_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear & main.filter(
                        reduce(operator.or_, (Q(param__icontains=q) for q in param_without_negative))
                    )
                else:
                    main_clear = main_clear | main.filter(
                        reduce(operator.or_, (Q(param__icontains=q) for q in param_with_negative)))
            if param_with_negative:
                if isinstance(main_clear, EmptyQuerySet) is False:
                    main_clear = main_clear & main.filter(reduce(operator.and_,
                                                                 (~Q(param__icontains=q) for q in param_with_negative)))
                else:
                    main_clear = main_clear | main.filter(reduce(operator.and_,
                                                                 (~Q(param__icontains=q) for q in param_with_negative)))
            main = main_clear
        # simple filtration
        else:
            # find only host
            if 'h:' in s:
                if '!h:' in s:
                    main = main.filter(~Q(domain__icontains=convert_to_punycode(s[3:])))
                else:
                    main = main.filter(Q(domain__icontains=convert_to_punycode(s[2:])))
            # find only url
            elif 'u:' in s:
                if '!u:' in s:
                    main = main.filter(~Q(url__icontains=s[3:]))
                else:
                    main = main.filter(Q(url__icontains=s[2:]))
            # find only type
            elif 't:' in s:
                if '!t:' in s:
                    main = main.filter(~Q(type__icontains=s[3:]))
                else:
                    main = main.filter(Q(type__icontains=s[2:]))
            elif 'p:' in s:
                if '!p:' in s:
                    main = main.filter(~Q(param__icontains=s[3:]))
                else:
                    main = main.filter(Q(param__icontains=s[2:]))
            # parse all blocks
            else:
                if s[0] == '!':
                    if s[1:] != '':
                        main = main.filter(~Q(type__icontains=s[1:]), ~Q(domain__icontains=convert_to_punycode(s[1:])),
                                           ~Q(url__icontains=s[1:]), ~Q(param__icontains=s[1:]), )
                else:
                    main = main.filter(
                        Q(type__icontains=s) | Q(domain__icontains=s) | Q(url__icontains=s) | Q(param__icontains=s))

    return main
