import logging

from .emails import send_email_after_create_whitelist_request
from .emails import send_email_after_done_whitelist_request
from django.db.models.signals import post_save
from django.dispatch import receiver
from main.models.white_list import WhitelistRequest

logger = logging.getLogger(__name__)


@receiver(post_save, sender=WhitelistRequest)
def whitelist_request_post_save_handler(sender, instance, created, **kwargs):
    try:
        if created:
            send_email_after_create_whitelist_request(instance)
        else:
            if instance.done and instance.is_deleted is False:
                send_email_after_done_whitelist_request(instance)
    except Exception as e:
        logger.error('An error occurred when sending a post request to save whitelist: {}'.format(e))
