/**
 * Filtering users by roles
 */
window.home = document.querySelector('#home').title;
$(document).ready(function () {
    window.role = gettext('All Roles');
    $("#RoleDropdown li").click(function () {
        let role_index = $('#RoleDropdown li').index(this);
        if (role_index === 0) {
            $("#select_role_button").html(gettext('All Roles') + '<span class="caret"></span>');
            window.role = gettext('All Roles');
            search();
        }
        if (role_index === 1) {
            $("#select_role_button").html(gettext('User') + '<span class="caret"></span>');
            window.role = gettext('User');
            search();
        }
        if (role_index === 2) {
            $("#select_role_button").html(gettext('Administrator') + '<span class="caret"></span>');
            window.role = gettext('Administrator');
            search();
        }


    });
});


/**
 * Filtering users by status
 */
$(document).ready(function () {
    window.status = gettext('All Statuses');
    $("#StatusDropdown li").click(function () {
        let role_index = $('#StatusDropdown li').index(this);
        if (role_index === 0) {
            $("#select_status_button").html(gettext('All Statuses') + '<span class="caret"></span>');
            window.status = gettext('All Statuses');
            search();
        }
        if (role_index === 1) {
            $("#select_status_button").html(gettext('Active') + '<span class="caret"></span>');
            window.status = gettext('Active');
            search();
        }
        if (role_index === 2) {
            $("#select_status_button").html(gettext('Inactive') + '<span class="caret"></span>');
            window.status = gettext('Inactive');
            search();
        }


    });
});

/**
 * Show/Hide password when editing user
 * @param id User id
 */
function showPassword(id) {
    $('#PasswordEye_' + id).toggleClass("fa-eye fa-eye-slash");

    $('#ConfirmPasswordEye_' + id).toggleClass("fa-eye fa-eye-slash");

    if ($('#ConfirmPasswordEye_' + id).attr('class') === 'fa fa-eye') {
        $('#inputPassword_' + id).attr('type', 'text');
        $('#inputConfirmPassword_' + id).attr('type', 'text');
    } else {
        $('#inputPassword_' + id).attr('type', 'password');
        $('#inputConfirmPassword_' + id).attr('type', 'password');
    }

}

/**
 * Show/Hide password when adding user
 */
function Add_showPassword() {
    $('#Add_PasswordEye').toggleClass("fa-eye fa-eye-slash");

    $('#Add_ConfirmPasswordEye').toggleClass("fa-eye fa-eye-slash");

    if ($('#Add_ConfirmPasswordEye').attr('class') === 'fa fa-eye') {
        $('#Add_inputPassword').attr('type', 'text');
        $('#Add_inputConfirmPassword').attr('type', 'text');
    } else {
        $('#Add_inputPassword').attr('type', 'password');
        $('#Add_inputConfirmPassword').attr('type', 'password');
    }

}


/**
 * Check match passwords when editing user
 * @param id User id
 */
function checkPasswords(id) {

    if ($('#inputPassword_' + id).val() !== $('#inputConfirmPassword_' + id).val()) {
        $('#helpBlockPass_' + id).show();
        $('#PasswordForm_' + id).addClass('has-error');
        $('#ConfirmPasswordForm_' + id).addClass('has-error');

        $('#SaveButton_' + id).prop('disabled', true);

    } else {
        $('#helpBlockPass_' + id).hide();
        $('#PasswordForm_' + id).removeClass('has-error');
        $('#ConfirmPasswordForm_' + id).removeClass('has-error');

        $('#SaveButton_' + id).prop('disabled', false);
    }

    if (!validationEmail(document.querySelector('#inputEmail_' + id).value)) {
        $('#SaveButton_' + id).prop('disabled', true);
    }


}

/**
 * Check match passwords when adding user
 */
function Add_checkPasswords() {

    if ($('#Add_inputPassword').val() !== $('#Add_inputConfirmPassword').val()) {
        $('#addHelpBlockPass').show();
        $('#Add_PasswordForm').addClass('has-error');
        $('#Add_ConfirmPasswordForm').addClass('has-error');

        $('#Add_SaveButton').prop('disabled', true);

    } else {
        $('#addHelpBlockPass').hide();
        $('#Add_PasswordForm').removeClass('has-error');
        $('#Add_ConfirmPasswordForm').removeClass('has-error');

        $('#Add_SaveButton').prop('disabled', false);
    }
    if (!validationEmail(document.querySelector('#Add_inputEmail').value)) {
        $('#Add_SaveButton').prop('disabled', true);
    }

}


/**
 * Sending a request to edit a user
 * @param id User id
 */
function send_request_to_edit_user(id) {
    let home = window.home;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + 'admin_panel/edit_user/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#edit_form_' + id).serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            location.reload();
        }
    });
}

/**
 * Function to set the role when selected in the roles drop-down menu when editing user
 * @param id User id
 * @param role Selected role
 */
function setRole(id, role) {
    $('#dropdownRoleMenuButton_' + id).html(role);
    $('#RoleInput_' + id).val(role);
}

/**
 * Function to set the role when selected in the roles drop-down menu when adding user
 * @param role Selected role
 */
function Add_setRole(role) {
    $('#Add_dropdownRoleMenuButton').html(role);
    $('#AddRoleInput').val(role);
    let block_modules = document.querySelector('#add_modal .block-modules');
    let toggles = block_modules.querySelectorAll('input');
    for (let i of toggles) {
        if (i.name === 'oa_toggle' || i.name === 'ws_toggle' || i.name === 'mt_toggle') {
            if (role === gettext('Administrator')) {
                i.checked = true;
            } else {
                i.checked = false;

            }
        }
    }
}


/**
 * Function to set the status when selected in the statuses drop-down menu when editing user
 * @param id User id
 * @param status Selected status
 */
function setStatus(id, status) {
    $('#dropdownStatusMenuButton_' + id).html(status);
    $('#StatusInput_' + id).val(status);
}

/**
 * Function to set the status when selected in the statuses drop-down menu when adding user
 * @param status
 */
function Add_setStatus(status) {
    $('#Add_dropdownStatusMenuButton').html(status);
    $('#AddStatusInput').val(status);
}

/**
 * Sending a request to add a user
 */
function send_request_to_add_user() {
    let home = window.home;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + 'admin_panel/add_user/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#add_form').serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            location.reload();
        }
    });
}


/**
 * Sending a request to delete a user
 * @param id User id
 */
function deleteUser(id) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = window.home;
    event.preventDefault();
    $.ajax({
        url: home + 'admin_panel/delete_user/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {user_id: id},
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            location.reload();
        }
    });
}

/**
 * Function to show Add User modal window
 */
function show_modal_AddUser() {
    $("#add_modal").modal("show");

}

/**
 * Function to validate Email
 * @param id User id
 */

function validationEmail(text) {
    let re = /^[\w\-\.]+@[а-яё\w\-]+\.[\wа-яё]{2,}/im;
    return re.test(text)
}

function ValidMail(id) {
    let inputEMail = $('#inputEmail_' + id).val();

    if (!(validationEmail(inputEMail))) {
        $('#SaveButton_' + id).prop('disabled', true);
        $('#inputEmail_' + id)[0].parentElement.parentElement.classList.add('has-error');
    } else {
        $('#SaveButton_' + id).prop('disabled', false);
        $('#inputEmail_' + id)[0].parentElement.parentElement.classList.remove('has-error');
    }

    if ($('#inputPassword_' + id).val() !== $('#inputConfirmPassword_' + id).val()) {
        $('#SaveButton_' + id).prop('disabled', true);
    }

}

/**
 * Function to validate Email when adding user
 */
function AddValidMail() {
    let inputEMail = $('#Add_inputEmail').val();
    if (!(validationEmail(inputEMail))) {
        $('#Add_SaveButton').prop('disabled', true);
        $('#Add_inputEmail')[0].parentElement.parentElement.classList.add('has-error');
    } else {
        $('#Add_SaveButton').prop('disabled', false);
        $('#Add_inputEmail')[0].parentElement.parentElement.classList.remove('has-error');
    }
    if ($('#Add_inputPassword').val() !== $('#Add_inputConfirmPassword').val()) {
        $('#Add_SaveButton').prop('disabled', true);
    }
    let users_email = [];
    for (let i of document.querySelectorAll("#table_users td:first-of-type")){
        users_email.push(i.textContent);
    }

    if (users_email.includes(inputEMail)){
        $('#Add_inputEmail')[0].parentElement.parentElement.classList.add('has-error');
        $('#Add_SaveButton').prop('disabled', true);
        $('#addHelpBlockEmail').show();
    }else{
        $('#Add_inputEmail')[0].parentElement.parentElement.classList.remove('has-error');
        $('#Add_SaveButton').prop('disabled', false);
        $('#addHelpBlockEmail').hide();
    }

}


/**
 * Tab's switching
 */
$(function () {
    $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
        let target = $(this).data('target') || $(this).attr('href');
        $('.left-sidebar').toggleClass('moved', target === '#tab_user_table');
        $('a[data-toggle="tab"]').each(function () {
            let element_target = $(this).data('target') || $(this).attr('href');
            $(this).toggleClass('active', target === element_target);
        });

        let tab_href = $(this).attr('href');
        if ((tab_href !== '#tab_user_table') && (typeof tab_href !== "undefined")) {
            $('#filter_list').hide();
            $('#add_user_button').hide();
        } else {
            $('#filter_list').show();
            $('#add_user_button').show();
        }

    });
});

/**
 * Show modal window with Rule ID info
 */
$(document).on('click', '.rule-info', function (e) {
    let home = window.home;
    var rule_id = e.target.innerHTML;
    rule_id = rule_id.split(" ")[0];
    var row_id = e.target.parentNode.getElementsByClassName('row-id')[0].innerHTML;
    $.get(home + "get_rule/", {rule_id: rule_id, row_id: row_id})
        .success(function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            if (typeof data.id !== 'undefined') {
                if (data.flags == 0) {
                    var flag = gettext('No');
                } else if (data.flags == 2) {
                    var flag = gettext('Yes')
                }

                var zone = JSON.stringify(data.zone.join(","));
                $('#mdialog').css('max-width', '600px');
                $('#mfoot-btn').show();
                $('#rulesTable').show();
                $('#wlTable').show();
                $('#nf').hide();
                $('#ef').hide();
                $('#uds').hide();
                $('#rl-id').text(data.id);
                $('#rl-type').text(data.score_k);
                $('#rl-zone').text(zone.replace(/\,/g, ' | ').replace(/\"/g, ''));
                $('#rl-sc').text(data.score_v);
                $('#rl-targer').text(data.target);
                $('#rl-px').text(flag);
                if (data.plan == -1) {
                    $('#wl-info').empty();
                    $('#wl-info').text(data.wl);
                } else {
                    $('#wl-info').empty();
                    let btn = document.createElement("button");
                    btn.textContent = gettext('Create an exclusion rule');
                    btn.className = 'btn btn-default wl-rule _rule';
                    btn.style.marginBottom = '5px';
                    let hidden_id = document.createElement('input');
                    hidden_id.value = data.wl_data.row_id;
                    hidden_id.type = 'hidden';
                    hidden_id.name = 'row_id';
                    $('#wl-info').append(btn);
                    $('#wl-info').append(hidden_id);
                }
            } else if (data.status === 'empty') {
                setTimeout(function () {
                    $("#rulesModal").modal('hide');
                }, 2000);
                $('#mdialog').css('max-width', '400px');
                $('#ef').css('padding-top', '20px');
                $('#mfoot-btn').hide();
                $('#ef').show();
                $('#nf').hide();
                $('#uds').hide();
                $('#wlTable').hide();
                $('#rulesTable').hide();
            } else if (Number(rule_id) >= 50000) {
                setTimeout(function () {
                    $("#rulesModal").modal('hide');
                }, 2000);
                $('#mdialog').css('max-width', '300px');
                $('#uds').css('padding-top', '20px');
                $('#mfoot-btn').hide();
                $('#uds').show();
                $('#nf').hide();
                $('#ef').hide();
                $('#wlTable').hide();
                $('#rulesTable').hide();
            } else {
                setTimeout(function () {
                    $("#rulesModal").modal('hide');
                }, 2000);
                $('#mdialog').css('max-width', '300px');
                $('#nf').css('padding-top', '20px');
                $('#mfoot-btn').hide();
                $('#nf').show();
                $('#ef').hide();
                $('#uds').hide();
                $('#wlTable').hide();
                $('#rulesTable').hide();
            }

            $('#rulesModal').modal('show');
        });
});

/**
 * Function for searching users by Email
 */
function search() {
    let search_text = $('#search_input').val();
    let table_users = $('#table_users');
    let requests_table = $('#requests_table');
    let scan_table = $('#scan_table');
    let table;
    let column_id;
    let role_user_search = false;
    let status_user_search = false;
    if (table_users.is(':visible')) {
        table = document.getElementById("table_users");
        column_id = 0;
        if (window.role !== gettext('All Roles')) {
            role_user_search = true;
        }
        if (window.status !== gettext('All Statuses')) {
            status_user_search = true;
        }

    }
    if (requests_table.is(':visible')) {
        table = document.getElementById("requests_table");
        column_id = 0;
    }
    if (scan_table.is(':visible')) {
        table = document.getElementById("scan_table");
        column_id = 2;
    }

    let tr = table.getElementsByTagName("tr");
    for (let i = 0; i < tr.length; i++) {
        let td1 = tr[i].getElementsByTagName("td")[column_id];
        if (role_user_search && status_user_search) {
            let txtValue1 = td1.textContent || td1.innerText;
            let td2 = tr[i].getElementsByTagName("td")[2];
            let td3 = tr[i].getElementsByTagName("td")[1];
            let txtValue2 = td2.textContent || td2.innerText;
            let txtValue3 = td3.textContent || td3.innerText;
            if ((txtValue1.indexOf(search_text) > -1) && (txtValue2.indexOf(window.status) > -1) && (txtValue3.indexOf(window.role) > -1)) {
                tr[i].style.display = "";
            } else {
                tr[i].style.display = "none";
            }
        } else if (status_user_search) {
            let txtValue1 = td1.textContent || td1.innerText;
            let td2 = tr[i].getElementsByTagName("td")[2];
            let txtValue2 = td2.textContent || td2.innerText;
            if ((txtValue1.indexOf(search_text) > -1) && (txtValue2.indexOf(window.status) > -1)) {
                tr[i].style.display = "";
            } else {
                tr[i].style.display = "none";
            }
        } else if (role_user_search) {
            let txtValue1 = td1.textContent || td1.innerText;
            let td2 = tr[i].getElementsByTagName("td")[1];
            let txtValue2 = td2.textContent || td2.innerText;
            if ((txtValue1.indexOf(search_text) > -1) && (txtValue2.indexOf(window.role) > -1)) {
                tr[i].style.display = "";
            } else {
                tr[i].style.display = "none";
            }
        } else {
            if (td1) {
                let txtValue1 = td1.textContent || td1.innerText;
                if (txtValue1.indexOf(search_text) > -1) {
                    tr[i].style.display = "";
                } else {
                    tr[i].style.display = "none";
                }
            }
        }
    }
}

/**
 * Sending a request to delete request
 * @param id Id in request's table
 * @param req_id Field Request id
 */
function removeRequest(id, req_id) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = window.home;
    event.preventDefault();
    $.ajax({
        url: home + 'admin_panel/remove_request/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {req_id: req_id},
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $("#requests_table_row_" + id).hide();
        }
    });
}

/**
 * Sending a request to manage request
 * @param id Id in request's table
 */
function send_manage_request(id) {
    event.preventDefault();
    let home = window.home;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + 'admin_panel/manage_request/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#manage_request_form_' + id).serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let comment = $('#make_request_textarea_' + id).val();
            let html = '<div style="height: 100%;"><i class="fa fa-commenting-o" style="font-size: 22px; vertical-align: middle; float: left; margin-right: 10px;" aria-hidden="true"></i>\n' +
                '                            <div style="overflow: auto;">\n' +
                '                                <span style="word-break: break-word;">' + comment + '</span>\n' +
                '                            </div></div>';
            $('#requests_table_row_decision_' + id).html(html);
            let icon = document.getElementById('requests_table_row_status_' + id).getElementsByClassName('fa')[0];
            icon.classList.toggle('fa-square-o');
            icon.classList.toggle('fa-check-square-o');
            $('#requests_table_row_status_' + id).find('span').html(gettext('Completed'));
            $('#requests_table_row_' + id).find('.edit-req').hide();
        }
    });
}

/**
 * Function to check text in Manage Request modal window
 * @param id Id in request's table
 */
function checkText(id) {
    if ($('#make_request_textarea_' + id).val() !== '') {
        $('#make_request_button_' + id).prop('disabled', false);
    } else {
        $('#make_request_button_' + id).prop('disabled', true);
    }
}

/**
 * Sending a request to delete row in scanner's table
 * @param id Id in scanner's table
 */
function removeScan(id) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = window.home;
    event.preventDefault();
    $.ajax({
        url: home + 'admin_panel/remove_scan/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {scan_id: id},
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $("#scanner_row_" + id).hide();
        }
    });
}

/**
 * Email Config
 */

function send_request_to_edit_email_config() {
    let home = window.home;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    var data = $('#edit_form_email_config').serialize();
    data = data.replace('Disable', 'false').replace('Enable', 'true');
    $.ajax({
        url: home + 'admin_panel/edit_email_config/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            data = $('#edit_form_email_config').serializeArray();
            let tmp = false;
            for (let el in data) {
                let val = data[el].value;
                let name = data[el].name;
                if (name === 'send_email') {
                    if (val === 'on') {
                        val = gettext("Enable");
                    } else {
                        val = gettext("Disable");
                    }
                    tmp = true;
                    name = "send_email_text";
                } else if (name == 'encryption') {
                    if (val.toLowerCase().includes('no')) {
                        val = gettext('No')
                    } else {
                        val = val.toUpperCase()
                    }
                }

                let elem = document.getElementById('config_email').getElementsByClassName(name);
                if (elem.length !== 0) {
                    elem[0].innerText = val;
                }
            }
            if (tmp === false) {
                document.getElementById('config_email').getElementsByClassName("send_email_text")[0].innerHTML = gettext("Disable");
            }
            //location.reload();
        }

    });

}

/**
 * Cleaning Config
 */

function send_request_to_edit_cleaning_config(id = null) {
    let home = window.home;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    let data = {};
    if (id === null) {
        data = $('#form_add_task').serialize();
        let el = document.getElementById('form_add_task').querySelector('[name="time_interval"]');
        let res = CheckCountDayTask(el);
        if (!res) {

            return
        }

    } else {
        data = $('#edit_form_task_' + id).serialize();
        let el = document.getElementById('edit_form_task_' + id).querySelector('[name="time_interval"]');
        let res = CheckCountDayTask(el);
        if (!res) {
            return
        }
    }
    $.ajax({
        url: home + 'admin_panel/cleaning_scheduler/manage_task/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: data,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            if (id === null) {
                data = $('#form_add_task').serializeArray().reduce(function (obj, item) {
                    obj[item.name] = item.value;
                    return obj;
                }, {});
                let tbody = document.getElementById('config_cleaning').getElementsByTagName('tbody')[0];
                let tr = document.createElement('tr');
                tr.id = 'tasks_table_row_' + response;
                let title = {
                    'desc': gettext('Description'),
                    'time_interval': gettext('Filter by Date'),
                    'bt': gettext('Filter by BT'),
                    'ip': gettext('Filter by IP'),
                    'vhost': gettext('Filter by Domain'),
                    'url': gettext('Filter by URL'),
                };
                let dict = {};
                let label = document.createElement('label');
                label.className = 'switch';
                label.style.verticalAlign = 'sub';
                let check = '';
                let td = document.createElement('td');
                td.className = 'vertical-align';
                label.innerHTML = `<input id="enable_${response}" name="enable" 
                                onclick="checkbox_toggle(${parseInt(response)})" title="enable" type="checkbox" ${check}>
                                                        '<span class="slider round"></span>`;
                td.appendChild(label);
                tr.appendChild(td);

                for (let el in title) {
                    let val = '';
                    if (el !== 'bt') {
                        val = data[el].trim();
                    } else {
                        for (let i in data) {
                            if (i.toLowerCase() === 'bt1') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '1';

                            } else if (i.toLowerCase() === 'bt2') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '2';
                            } else if (i.toLowerCase() === 'bt3') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '3';
                            } else if (i.toLowerCase() === 'bt4') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '4';
                            } else if (i.toLowerCase() === 'bt5') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '5';
                            } else if (i.toLowerCase() === 'bt6') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '6';
                            } else if (i.toLowerCase() === 'bt7') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '7';
                            } else if (i.toLowerCase() === 'bt8') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '8';
                            } else if (i.toLowerCase() === 'bt9') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '9';
                            } else if (i.toLowerCase() === 'bt10') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '10';
                            } else if (i.toLowerCase() === 'bt14') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '14';
                            } else if (i.toLowerCase() === 'bt16') {
                                if (val !== '') {
                                    val = val + ',';
                                }
                                val = val + '16';
                            }
                        }
                    }
                    let name = el;
                    let td = document.createElement('td');
                    td.className = 'vertical-align';
                    td.title = title[el];
                    let span = document.createElement('span');
                    span.className = name;
                    if (name === 'time_interval') {
                        if (parseInt(val) <= 0 || val === '') {
                            span.innerText = '*';
                        } else {
                            span.innerText = val + gettext(' day(s)');
                        }
                    } else {
                        if (name === 'bt') {
                            if (val.includes(',')) {
                                let is_num = true;
                                for (let i of val.replace(' ', '').split(',')) {
                                    is_num = is_num && !isNaN(i);
                                }
                                if (!is_num) {
                                    val = '*';
                                }
                            } else {
                                if (isNaN(val) === true) {
                                    val = '*';
                                }
                            }

                        }
                        if (val === '') {
                            val = '*';
                        }
                        span.innerText = val;
                    }
                    dict[name] = val;
                    td.appendChild(span);
                    tr.appendChild(td);


                }


                let lasttd = document.createElement('td');
                lasttd.innerHTML = `<button type="button" class="btn action" onclick="show_confirm_run_tasks({'id_task': ${response}, 'desc': '${dict['desc']}'})">
                        <i class="fa fa-play" aria-hidden="true"></i>
                    </button>
                    <button type="button" class="btn action" data-toggle="modal" data-target="#editModalCleaningTask_${response}">
                        <i class="fa fa-pencil" aria-hidden="true"></i>
                    </button>
                    <button type="button" data-toggle="modal" data-target="#remove_task_${response}" class="btn action" style="padding-left: 5px; padding-right: 0; margin-right: 1.5vw;"><i class="fa fa-times" aria-hidden="true"></i></button>
                    `;
                let removeModal = document.querySelector('#config_cleaning').querySelector('div .remove_task').cloneNode(true);
                removeModal.id = 'remove_task_' + response;
                removeModal.querySelector('.m_foot').innerHTML = `<button onclick="removeTask(${response})" type="button" data-dismiss="modal" class="btn m_btn" style="padding-right: 85px; border-right: 1px solid #F2F7F9;">
                        ` + gettext('Yes') + `
                      </button>
                      <button type="button" data-dismiss="modal" class="btn m_btn" aria-label="Close" style="padding-left: 75px; margin-left: 0px;">
                        ` + gettext('No') + `
                      </button>`;
                let editModal = document.querySelector('#config_cleaning').querySelector('div .edit_task').cloneNode(true);
                editModal.id = 'editModalCleaningTask_' + response;
                let formEdit = editModal.querySelector('.form-horizontal');
                formEdit.id = 'edit_form_task_' + response;
                formEdit.querySelector('input[name="id"]').value = response;
                formEdit.querySelector('input[name="time_interval"]').value = dict['time_interval'];
                for (let i of '1,2,3,4,5,6,7,8,9,10,14,16'.replace(" ", "").split(',')) {
                    if (dict['bt'].replace(" ", "").split(',').includes(i)) {
                        formEdit.querySelector('input[name="bt' + i + '"]').checked = true;

                    } else {
                        formEdit.querySelector('input[name="bt' + i + '"]').checked = false;

                    }
                }
                formEdit.querySelector('input[name="ip"]').value = dict['ip'];
                formEdit.querySelector('input[name="vhost"]').value = dict['vhost'];
                formEdit.querySelector('input[name="url"]').value = dict['url'];
                formEdit.querySelector('input[name="desc"]').value = dict['desc'];
                formEdit.querySelector('div.m_foot').innerHTML = `<button data-dismiss="modal"
                                style="border-style: none; background: none;"
                                onclick="send_request_to_edit_cleaning_config(${response})"
                                class="btn btn-default m_btn save_button">` + gettext('Save') + `
                        </button>`;

                lasttd.appendChild(editModal);
                lasttd.appendChild(removeModal);
                tr.appendChild(lasttd);
                tbody.appendChild(tr);

                document.getElementById('add_task').querySelector('form').reset();
            } else {
                data = $('#edit_form_task_' + id).serializeArray();
                let bt = '';
                for (let el in data) {
                    let val = data[el].value;
                    let name = data[el].name;
                    if (name.includes('bt')) {
                        val = name.replace('bt', '');
                        name = 'bt';
                    }
                    let elem = document.getElementById('tasks_table_row_' + id).getElementsByClassName(name);
                    if (elem.length !== 0) {
                        if (name === 'time_interval') {
                            if (parseInt(val) <= 0 || val === '') {
                                elem[0].innerText = '*';
                            } else {
                                elem[0].innerText = val + gettext(' day(s)');
                            }

                        } else {
                            if (val === '') {
                                val = '*';
                            }
                            if (name === 'bt') {
                                if (bt !== '') {
                                    bt = bt + ','
                                }
                                bt = bt + val;
                            } else {
                                elem[0].innerText = val;
                            }
                        }
                    }
                }
                if (bt === '') {
                    bt = '*';
                }
                document.getElementById('tasks_table_row_' + id).getElementsByClassName('bt')[0].innerText = bt;
            }
            if (id === null) {
                $(document.querySelector('#form_add_task').closest('.modal')).modal('hide');
            } else {
                $(document.querySelector('#edit_form_task_' + id).closest('.modal')).modal('hide');
            }
            //location.reload();
        }
    });
}

function removeTask(id) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = window.home;
    event.preventDefault();
    $.ajax({
        url: home + 'admin_panel/cleaning_scheduler/remove_task/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {task_id: id},
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $("#tasks_table_row_" + id).hide();
        }
    });
}

function CheckCountDayTask(el, id = null) {
    if (parseInt(el.value) < 0 || isNaN(el.value) || el.value === '') {
        el.style.color = '#a94442';
        el.style.borderBottomColor = '#a94442';
        if (id !== null) {
            document.getElementById('edit_form_task_' + id).querySelector('[onclick="send_request_to_edit_cleaning_config(' + id + ')"]').classList.add('disabled');
        } else {
            document.getElementById('add_task').querySelector('[onclick="send_request_to_edit_cleaning_config()"]').classList.add('disabled');
        }
        return false;
    } else {
        el.style.color = '#134473';
        el.style.borderBottomColor = '#134473';
        if (id !== null) {
            document.getElementById('edit_form_task_' + id).querySelector('[onclick="send_request_to_edit_cleaning_config(' + id + ')"]').classList.remove('disabled');
        } else {
            document.getElementById('add_task').querySelector('[onclick="send_request_to_edit_cleaning_config()"]').classList.remove('disabled');
        }
        return true;
    }
}

function checkbox_toggle(id) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').title;
    let input = document.getElementById('enable_' + id);
    $.ajax({
        url: home + 'admin_panel/cleaning_scheduler/manage_task/',
        type: "POST",
        dataType: "html",
        data: `${input.name}=${input.checked}&csrfmiddlewaretoken=${csrftoken}&id=${id}`,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);

            }
            //location.reload();
        }
    });
}

function run_tasks(input) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').title;
    $.ajax({
        url: home + 'admin_panel/cleaning_scheduler/run/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: `${input.name}=${1}`,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);

            }
            //alert("Deleted rows: " + response);
            //location.reload();
        }
    });
}

function show_confirm_run_tasks(data = null) {
    function parse(str) {
        let args = [].slice.call(arguments, 1),
            i = 0;

        return str.replace(/%s/g, () => args[i++]);
    }

    let confirm = document.querySelector('#confirmModal');
    let b = confirm.querySelector('.confirm_btn');
    let b_close = confirm.querySelector('.close_btn');
    let modal_dialog = confirm.querySelector('.modal-dialog');
    modal_dialog.style.width = '300px';
    b.classList.add('yes_run_tasks_cleaning');
    b.innerHTML = gettext('Yes');
    b_close.innerHTML = gettext('No');
    b_close.classList.remove('m_btn');
    b_close.classList.remove('btn-primary');
    b_close.classList.add('btn-default');
    if (data !== null) {
        confirm.querySelector('#bodyConfirm').innerHTML = parse(gettext('Run task <code>%s</code>?'), data['desc']);
    } else {
        confirm.querySelector('#bodyConfirm').innerHTML = gettext('Run cleaning tasks?');
    }
    $(confirm).modal('show');
    window.data_to_run_cleaning = data;

}

$(document).on('click', '.yes_run_tasks_cleaning', function (e) {
    let confirm = document.querySelector('#confirmModal');
    let b = confirm.querySelector('.confirm_btn');
    let b_close = confirm.querySelector('.close_btn');
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;

    b.innerHTML = gettext('Yes');
    b_close.innerHTML = gettext('No');
    let modal_dialog = confirm.querySelector('.modal-dialog');
    modal_dialog.style.width = '700px';

    let d = {run_tasks: 1};
    if (window.data_to_run_cleaning !== null) {
        d = {run_tasks: 2, task_data: JSON.stringify(window.data_to_run_cleaning)};
    }

    $.ajax({
        url: home + 'admin_panel/cleaning_scheduler/run/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: d,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            b_close.classList.add('m_btn');
            b_close.classList.add('btn-primary');
            b_close.classList.remove('btn-default');
            b.classList.remove('yes_run_tasks_cleaning');
            window.data_to_run_cleaning = {};

            let infoModal = $('#infoModal');
            $('#bodyInfo').text(pgettext("clean task", "Deleted rows: ") + response);
            infoModal.modal('show');
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
});


$(document).ready(function () {
    let zone_select_title = $('#zone_select_title').text();
    let zone_selected_title = $('#zone_selected_title').text();
    let zone_all_selected_title = $('#zone_all_selected_title').text();
    $('.zone_select').multiselect({
        nonSelectedText: zone_select_title,
        nSelectedText: zone_selected_title,
        allSelectedText: zone_all_selected_title,
        numberDisplayed: 1,
        buttonClass: 'btn multi-select-button',
        optionClass: function (element) {
            return 'multi-select-option'
        },
    });
});


wl_rule_change = false;
$(document).on('click', '.wl-rule', function (e) {
    let home = document.getElementById('home').title;
    $('.wl_group').remove();
    $('#error_add_wl').css({'display': 'none'});
    let wl_rule_modal = $('#wl_rule');
    wl_rule_modal.find('#add_wl_id').val('');
    wl_rule_modal.find('#add_wl_domain').val('');
    $('option', $('.zone_select')).each(function (element) {
        $(this).removeAttr('selected').prop('selected', false);
    });
    let row_id = null;
    if (e.target.classList.contains('_rule')) {
        row_id = e.target.parentNode.querySelector('input[name="row_id"]').value;

    } else {
        row_id = $($(e.target)[0])[0].dataset.row_id;
    }
    $.get("get_rule_wl/", {row_id: row_id})
        .success(function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            wl_rule_modal.modal('show');
            wl_rule_modal.find('#add_wl_id').val(data.wl_id);
            wl_rule_modal.find('#add_wl_domain').val(data.domain);
            wl_rule_modal.find('#add_wl_key').val(data.key_id);
            let mz = [data.mz];
            $('.zone_select').multiselect('select', mz);
            $("#add_wl_form").change(function () {
                wl_rule_change = true;
            });
        });
});

function show_input_custom_zone(element, rule_id = '', extension_id) {
    if (element.value === 'custom_zone') {
        $('#input_extension_custom_zone_' + rule_id + '_' + extension_id).css({'display': 'block'});
    } else {
        $('#input_extension_custom_zone_' + rule_id + '_' + extension_id).css({'display': 'none'});
    }

}

function add_extension(id) {
    wl_rule_change = true;
    let wl_extension_title = $('.wl_extension_title').text();
    let wl_extension_regex_title = $('.wl_extension_regex_title').text();
    let wl_extension_select_zone_title = $('.wl_extension_select_zone_title').text();
    let wl_extension_custom_zone_input = $('.wl_extension_custom_zone_input').text();
    let wl_extension_input = $('.wl_extension_input').text();
    let add_group_class = '';
    if (id === 'add') {
        add_group_class = ' wl_group';
    }

    let last_ext_count = Number($('.extension_count_' + id + ':last').val()) + 1;
    $('.extension_count_' + id + ':last').val(last_ext_count);


    $('#last_extension_field_' + id).before('<div class="extension_' + id + add_group_class + '">\n' +
        '                        <div class="form-group" style="text-align: center">\n' +
        '                            <div class="col-sm-12">\n' +
        '                                <label for="select_extension_' + id + '_' + last_ext_count + '"\n' +
        '                                       style="font-weight: 200;">' + wl_extension_title + '</label>\n' +
        '                                <br>\n' +
        '                            </div>\n' +
        '                        </div>\n' +
        '                        <div class="form-group" style="text-align: center">\n' +
        '                            <div class="col-sm-4">\n' +
        '                                <select id="select_extension_' + id + '_' + last_ext_count + '" class="form-control"\n' +
        '                                        onchange="show_input_custom_zone(this,\'' + id + '\',\'' + last_ext_count + '\')"' +
        ' style="background: #FFFFFF; color: #555; border: 1.5px solid #D5E4F3; font-size: 14px; border-radius: 4px;height: 43px; font-style: normal;" >\n' +
        '                                    <option value="none">' + wl_extension_select_zone_title + '\n' +
        '                                    </option>\n' +
        '                                    <option value="body">BODY\n' +
        '                                    </option>\n' +
        '                                    <option value="url">URL\n' +
        '                                    </option>\n' +
        '                                    <option value="args">ARGS\n' +
        '                                    </option>\n' +
        '                                    <option value="headers">\n' +
        '                                        HEADERS\n' +
        '                                    </option>\n' +
        '                                </select>\n' +
        '                            </div>\n' +
        '                            <div class="col-sm-5">\n' +
        '                                <input type="text" title="' + wl_extension_input + '"\n' +
        '                                       class="form-control extension_text wl-input" value=""\n' +
        '                                       placeholder="' + wl_extension_input + '"\n' +
        '                                       style="background-color: #ffffff; font-size: 16px; border-radius: 0px; border-width: 0px; border-bottom-width: 1px; text-align: center; box-shadow: none;">\n' +
        '                            </div>\n' +
        '                            <div class="col-sm-3">\n' +
        '                                <input class="form-check-input regex_extension no-checkbox-radio" type="checkbox" value="true"\n' +
        '                                       id="regex_rl_' + id + '_' + last_ext_count + '">\n' +
        '                                <label class="form-check-label" for="regex_rl_' + id + '_' + last_ext_count + '" ' +
        'style="font-weight: normal;font-size: 16px;">\n' +
        '                                    ' + wl_extension_regex_title + '\n' +
        '                                </label>\n' +
        '                            </div>\n' +
        '                        </div>\n' +
        '                    </div>');
}


function add_wl(status = '') {
    if ((wl_rule_change === false) && (status !== 'confirm')) {
        $('#confirm_wl').modal('show');
        event.preventDefault();
    } else {
        let home = document.getElementById('home').title;
        if (add_wl.cantClick) {
            event.preventDefault();
            return;
        }
        add_wl.cantClick = true;
        let add_domain = $('#add_wl_domain');
        let add_wl_id = $('#add_wl_id');
        let add_zone = $('#zone');
        let validate = true;

        $('#error_add_wl').css({'display': 'none'});


        $('.zone_validation').css({'display': 'none'});

        if ((add_zone.val() === null) && ($('#add_other_zone').val() === '')) {
            event.preventDefault();
            $('.zone_validation').css({'display': 'block'});
            validate = false;

        }
        if (add_wl_id.val() === '') {
            event.preventDefault();
            $('.wl_id_validation').css({'display': 'block'});
            add_wl_id.css({'border-color': 'red'});
            validate = false;

        }
        if (validate) {
            let key_id = $('#add_wl_key').val();
            let div_extension = $('.extension_add');
            let extension_array = [];
            $.each(div_extension, function () {

                let extension_select = $(this).find('select').val();
                if (extension_select === 'custom_zone') {
                    extension_select = $(this).find('.extension_custom_zone').val().trim();
                }
                let extension_text = $(this).find('.extension_text').val().trim();
                let extension_regex = $(this).find('.regex_extension').is(':checked');

                extension_array.push(extension_select + ';' + extension_text + ';' + extension_regex);

            });
            const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
            event.preventDefault();
            $.ajax({
                url: 'add_wl/',
                headers: {'X-CSRFToken': csrftoken},
                type: "POST",
                dataType: "html",
                data: {
                    form: $('#add_wl_form').serialize(),
                    extension: extension_array,
                },
                success: function (response, textStatus, xhr) {
                    if (xhr.status == 255) {
                        show_messages_from_response(response);
                        return;
                    }
                    if (response !== '{"status": "error"}') {
                        let zone_select_title = $('#zone_select_title').text();
                        let zone_selected_title = $('#zone_selected_title').text();
                        let zone_all_selected_title = $('#zone_all_selected_title').text();
                        $('.zone_select').multiselect({
                            nonSelectedText: zone_select_title,
                            nSelectedText: zone_selected_title,
                            allSelectedText: zone_all_selected_title,
                            numberDisplayed: 1,
                        });
                        $('#wl_rule').modal('hide');
                        $('#add_wl_form').trigger('reset');
                        $('.zone_select').multiselect('refresh');
                        $('.wl_group').remove();
                        wl_rule_change = false;
                    } else {
                        $('#error_add_wl').css({'display': 'block'});
                    }

                }
            });
        }
        setTimeout(() => {
            add_wl.cantClick = false;
        }, 1000);
    }

}
