;(function () {
    google.charts.load('current', {'packages': ['corechart']});

    google.charts.setOnLoadCallback(drawPieChart);
    google.charts.setOnLoadCallback(drawLineChart);

    $('a[href="#tab_attack_charts"]').on('shown.bs.tab', function (e) {
        google.charts.setOnLoadCallback(drawPieChart);
        google.charts.setOnLoadCallback(drawLineChart);
    });

    function drawLineChart() {
        var point_style = 'point {stroke-color: #1a5287; stroke-width: 2; fill-color: none; }';

        var data = google.visualization.arrayToDataTable([
            ['Месяц', 'Количество атак', {'role': 'style'}],
            ['Янв.', 0, point_style],
            ['Февр.', 3, point_style],
            ['Март', 6, point_style],
            ['Апр.', 14, point_style],
            ['Май', 10, point_style],
            ['Июнь', 2, point_style],
            ['Июль', 0, point_style],
            ['Авг.', 7, point_style],
            ['Сен.', 9, point_style],
            ['Окт.', 1, point_style],
            ['Ноя.', 0, point_style],
            ['Дек.', 2, point_style],
        ]);

        var options = {
            backgroundColor: 'transparent',
            colors: ['#1a5287'],
            hAxis: {
                textStyle: {
                    color: '#7697b7',
                    bold: true,
                },
                gridlines: {
                    color: 'red',
                },
            },
            vAxis: {
                textStyle: {
                    color: '#7697b7',
                    bold: true,
                },
            },
            height: 300,
            legend: {
                position: 'bottom',
                textStyle: {
                    color: '#7697b7',
                    bold: true,
                },
            },
            lineWidth: 2,
            pointSize: 10,
        };

        var chart = new google.visualization.LineChart(document.getElementById('line_chart'));

        chart.draw(data, options);
    }

    function drawPieChart() {
        var container = document.getElementById('pie_chart'),
            container_width = container.offsetWidth;

        var data = google.visualization.arrayToDataTable([
            ['Виды атак', 'Количество'],
            ['$XSS', 17],
            ['$TRAVERSAL', 10],
            ['$SQL', 8],
            ['$ATTACK', 15],
            ['$UWA', 16]
        ]);

        var options = {
            backgroundColor: 'transparent',
            colors: ['#cadef0', '#1a5287', '#287ecc', '#53a0ea', '#4d6d8b'],
            pieSliceText: 'value',
            chartArea: {
                left: (container_width >= 450) ? 50 : 30,
                right: (container_width >= 500) ? 50 : 15,
            },
            legend: {
                position: 'left',
                alignment: 'center',
                textStyle: {
                    color: '#134473',
                    bold: true,
                    fontSize: (container_width >= 400) ? 14 : 10,
                }
            },
            tooltip: {
                textStyle: {
                    fontSize: 14,
                },
            },
            fontSize: (container_width >= 400) ? container_width / 25 : 12,
            height: container_width / 1.5,
            pieHole: 0.4,
        };

        var chart = new google.visualization.PieChart(container);
        chart.draw(data, options);
    }
})();
