function show_messages_from_response(data) {
    try {
        if (typeof (data) == "string") {
            data = JSON.parse(data);
        }
        let block_messages = document.getElementById('messages-block');
        if (data['messages'] != null && data['messages'] !== undefined) {
            for (let message of data['messages']) {
                let container = document.createElement('div');
                container.className = 'container-fluid p-0 alert-absolute';
                let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                    '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                    '                  <span aria-hidden="True">&times;</span>\n' +
                    '                </button>\n' +
                    '                ' + message.message + '\n' +
                    '              </div>'
                $(container).html(alert_div);
                block_messages.appendChild(container);
                setTimeout(function () {
                    container.remove()
                }, 10000);

            }
        }

    } catch (e) {

    }

}

function show_confirm_to_bl(ip, waf_id, domain = null) {
    function parse(str) {
        let args = [].slice.call(arguments, 1),
            i = 0;

        return str.replace(/%s/g, () => args[i++]);
    }

    let confirm = document.querySelector('#confirmModal');
    let b = confirm.querySelector('.confirm_btn');
    let b_close = confirm.querySelector('.close_btn');
    b.classList.add('yes_bl_ip');
    b.innerHTML = gettext('Block');
    b_close.innerHTML = gettext('Close');
    b_close.classList.remove('m_btn');
    b_close.classList.remove('btn-primary');
    b_close.classList.add('btn-default');

    if (domain !== null) {
        confirm.querySelector('#bodyConfirm').innerHTML = parse(gettext('Block IP <code>%s</code> for domain <code>%s</code>?'), ip, domain);
    } else {
        confirm.querySelector('#bodyConfirm').innerHTML = parse(gettext('Block IP <code>%s</code>?'), ip);
    }
    $(confirm).modal('show');
    window.data_to_bl = {};
    if (domain !== null) {
        window.data_to_bl['domain'] = domain;
    }
    window.data_to_bl['ip'] = ip;
    window.data_to_bl['waf_id'] = waf_id;
}

$(document).on('click', '.yes_bl_ip', function (e) {
    let confirm = document.querySelector('#confirmModal');
    let b = confirm.querySelector('.confirm_btn');
    let b_close = confirm.querySelector('.close_btn');
    let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();

    b.innerHTML = gettext('Yes');
    b_close.innerHTML = gettext('No');
    $.ajax({
        url: home + 'set_ip_bl/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: window.data_to_bl,
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            b_close.classList.add('m_btn');
            b_close.classList.add('btn-primary');
            b_close.classList.remove('btn-default');
            b.classList.remove('yes_bl_ip');
            window.data_to_bl = {};
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
});
