function debounce(timeout, cb) {
    var expireDate;
    return function () {
        expireDate = Date.now() + timeout;
        setTimeout(function () {
            if (Date.now() >= expireDate)
                cb()
        }, timeout);
    }
}

var $input = $('input[name="daterange"]');
//$input.on('input', debounce(1500, doneTyping));

$('.attack-table-filter').on('keyup', (event) => {
    if (event.key === 'Enter') {
        changeFilterInput(true)
    } else {
        changeFilterInput(false)
    }
});

$(".tab_attack_charts").click(function () {
    $('#tab_attack_charts').show();
    window.lastevent = 'click';
    debounce(1500, doneTyping(true));
    document.getElementById('attack_table_search_input').value = '';
});

$('.input-group-addon:not(#previousfilter, #PreviousScanFilter)').on('click', function () {
    if (($('#tab_attack_charts').is(":visible"))) {
        window.lastevent = 'click';
        debounce(1500, doneTyping(true));
    }

});

function changeFilterInput(searching = true) {
    if (searching) {
        window.search = $('.attack-table-filter').val();
        debounce(1500, doneTyping());
    } else {
        let tab = "charts";
        window.search = $('.attack-table-filter').val();
        var home = document.getElementById('home').title;
        $.get(home + 'list_filters/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&tab=' + tab + '&search=' + encodeURIComponent(window.search)).success(
            function (data) {
                let dict = JSON.parse(data);
                $("#searh_history_list").empty();
                data = JSON.parse(data);
                for (let i in data) {
                    if (data[i] !== window.search)
                        $("#searh_history_list").append('<li class="searh_history_element" value="' + escapeHtml(data[i]) + '">' + escapeHtml(data[i]) + '</li>');

                }
            }
        );

        let search_input = window.search;
        if (search_input === '#clean') {
            search_input = ''
        }

        $("#searh_history_list").children().each(function () {
            if ($(this).text() == window.search || $(this).text() === '') {
                $(this).remove();
            }
        });

        if (search_input !== '' && window.lastevent === '' && $("#searh_history_list").children().lenght !== 0) {
            $('#attack_table_search_input').trigger("focus");
            $("#searh_history_list").show();

        }
        window.lastevent = '';
    }

}

const originalWarn = console.warn;

console.warn = function (...args) {
    const arg = args && args[0];

    if (arg && arg.includes('Attempting to load version \'51\' of Google Charts')) return;

    originalWarn(...args);
};

function doneTyping(clear = false, search = '') {
    let last_search = '';
    let search_text = window.search;
    var home = document.getElementById('home').title;
    let search_input_text = document.getElementById('search-input').value;
    if (search.length > 1) {
        search_text = search;
    }

    if (clear) {
        search_text = '';
        window.search = '';
        last_search = $('.attack-table-filter').val();
        $('.attack-table-filter').val('');
    }

    if ($('#tab_attack_charts').is(":visible")) {
        $('#searh_history').css('display', 'none');
        $('#input-group').css('margin-top', '0px');
        var docHeight = $(document).height();
        $("#overlay")
            .height(docHeight)
            .css({
                'position': 'absolute',
                'top': 0,
                'left': document.getElementById('leftSidebar').offsetWidth,
                'margin-top': '90px',
                'background-color': "rgba(255, 255, 255, 0.6)",
                'width': '100%',
                'z-index': 1020
            });
        $(".loading-container_overlay")
            .css({
                'z-index': 1015,
                'opacity': 1,
            });
        var main_loadingContainer2 = $('.loading-container_overlay');
        $("#overlay").show();
        main_loadingContainer2.show();
        $.get(home + 'charts/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&search=' + search_text + '&q=' + search_input_text, function (data) {

        }).success(
            function (data) {
                if (data === "LOADING, TRY AGAIN LATER") {
                    let divBlock = '<div id="load_again_later" style="position: fixed; left: calc(50% - 520px); top: calc(50% - 95px); font-size: 70px; text-align: center">' +
                        gettext('The summary is being generated.') + ' <br>' + gettext('Please come back later.') + '</div>';
                    $('#overlay').html(divBlock);
                    return 0;
                } else {
                    if (document.getElementById('overlay') !== null) {
                        document.getElementById('overlay').style.display = 'none';
                    }
                }
                let getData = data.split(';');

                $('#line_chart_data').empty();
                $('#line_chart_data').append(getData[0]);
                $('#top10host_data').empty();
                $('#top10host_data').append(getData[1]);
                $('#top10attackers_data').empty();
                $('#top10attackers_data').append(getData[2]);
                $('#today_summary_data').empty();
                $('#today_summary_data').append(getData[3]);
                $('#last24_summary_data').empty();
                $('#last24_summary_data').append(getData[4]);
                $('#last_week_summary_data').empty();
                $('#last_week_summary_data').append(getData[5]);
                $('#last_month_summary_data').empty();
                $('#last_month_summary_data').append(getData[6]);
                $('#brute_force_summary_data').empty();
                $('#brute_force_summary_data').append(getData[7]);
                $('#sms_flood_summary_data').empty();
                $('#sms_flood_summary_data').append(getData[8]);
                $('#internal_errors_summary_data').empty();
                $('#internal_errors_summary_data').append(getData[9]);

                $('#today_all_attacks').empty();
                $('#today_all_attacks').append(getData[10]);

                $('#today_sa').empty();
                $('#today_sa').append(getData[11]);

                $('#today_na').empty();
                $('#today_na').append(getData[12]);

                $('#today_bf').empty();
                $('#today_bf').append(getData[13]);

                $('#today_sms').empty();
                $('#today_sms').append(getData[14]);

                $('#today_ddos').empty();
                $('#today_ddos').append(getData[15]);

                $('#today_av').empty();
                $('#today_av').append(getData[16]);
                
                $('#today_OpenAPI').empty();
                $('#today_OpenAPI').append(getData[17]);

                $('#today_Blocked').empty();
                $('#today_Blocked').append(getData[18]);

                $('#last24_all_attacks').empty();
                $('#last24_all_attacks').append(getData[19]);

                $('#last24_sa').empty();
                $('#last24_sa').append(getData[20]);

                $('#last24_na').empty();
                $('#last24_na').append(getData[21]);

                $('#last24_bf').empty();
                $('#last24_bf').append(getData[22]);

                $('#last24_sms').empty();
                $('#last24_sms').append(getData[23]);

                $('#last24_ddos').empty();
                $('#last24_ddos').append(getData[24]);

                $('#last24_av').empty();
                $('#last24_av').append(getData[25]);

                $('#last24_OpenAPI').empty();
                $('#last24_OpenAPI').append(getData[26]);
                
                $('#last24_Blocked').empty();
                $('#last24_Blocked').append(getData[27]);

                $('#last_week_all_attacks').empty();
                $('#last_week_all_attacks').append(getData[28]);

                $('#last_week_sa').empty();
                $('#last_week_sa').append(getData[29]);

                $('#last_week_na').empty();
                $('#last_week_na').append(getData[30]);

                $('#last_week_bf').empty();
                $('#last_week_bf').append(getData[31]);

                $('#last_week_sms').empty();
                $('#last_week_sms').append(getData[32]);

                $('#last_week_ddos').empty();
                $('#last_week_ddos').append(getData[33]);

                $('#last_week_av').empty();
                $('#last_week_av').append(getData[34]);
                
                $('#last_week_OpenAPI').empty();
                $('#last_week_OpenAPI').append(getData[35]);

                $('#last_week_Blocked').empty();
                $('#last_week_Blocked').append(getData[36]);

                $('#last_month_all_attacks').empty();
                $('#last_month_all_attacks').append(getData[37]);

                $('#last_month_sa').empty();
                $('#last_month_sa').append(getData[38]);

                $('#last_month_na').empty();
                $('#last_month_na').append(getData[39]);

                $('#last_month_bf').empty();
                $('#last_month_bf').append(getData[40]);

                $('#last_month_sms').empty();
                $('#last_month_sms').append(getData[41]);

                $('#last_month_ddos').empty();
                $('#last_month_ddos').append(getData[42]);

                $('#last_month_av').empty();
                $('#last_month_av').append(getData[43]);
                
                $('#last_month_OpenAPI').empty();
                $('#last_month_OpenAPI').append(getData[44]);
		
		        $('#last_month_Blocked').empty();
                $('#last_month_Blocked').append(getData[45]);

                $('#ip_info_data').empty();
                $('#ip_info_data').append(getData[46]);

                $('#description_summary_data').empty();
                $('#description_summary_data').append(getData[47]);

                $('#ddos_summary_data').empty();
                $('#ddos_summary_data').append(getData[48]);
		
		
                let tab = "charts";
                let reset = '';
                if (clear) {
                    reset = '&reset=1';
                }
                $.get(home + 'list_filters/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&tab=' + tab + reset + '&search=' + encodeURIComponent(window.search)).success(
                    function (data) {
                        let dict = JSON.parse(data);
                        $("#searh_history_list").empty();
                        data = JSON.parse(data);
                        for (let i in data) {
                            if (data[i] !== window.search && data !== last_search)
                                $("#searh_history_list").append('<li class="searh_history_element" value="' + escapeHtml(data[i]) + '">' + escapeHtml(data[i]) + '</li>');

                        }
                    }
                );

                let search_input = window.search;
                if (search_input === '#clean') {
                    search_input = ''
                }

                $("#searh_history_list").children().each(function () {
                    if ($(this).text() == window.search || $(this).text() === '') {
                        $(this).remove();
                    }
                });

                if (search_input !== '' && window.lastevent === '' && $("#searh_history_list").children().lenght !== 0) {
                    $('#attack_table_search_input').trigger("focus");
                    $("#searh_history_list").show();

                }
                window.lastevent = '';

                let new_line_chart_Data = document.getElementById("line_chart_data").innerText;
                let new_pie_chart_Data = document.getElementById("top10host_data").innerText;
                let new_column_chart_Data = document.getElementById("top10attackers_data").innerText;
                let new_today_summary_data = document.getElementById("today_summary_data").innerText;
                let new_last24_summary_data = document.getElementById("last24_summary_data").innerText;
                let new_last_week_summary_data = document.getElementById("last_week_summary_data").innerText;
                let new_last_month_summary_data = document.getElementById("last_month_summary_data").innerText;
                let new_brute_force_summary_data = document.getElementById("brute_force_summary_data").innerText;
                let new_sms_flood_summary_data = document.getElementById("sms_flood_summary_data").innerText;
                let new_ddos_summary_data = document.getElementById("ddos_summary_data").innerText;
                let new_internal_errors_summary_data = document.getElementById("internal_errors_summary_data").innerText;
                let new_ip_info_data = document.getElementById("ip_info_data").innerText;
                let new_description_summary_data = document.getElementById("description_summary_data").innerText;

                function resize_charts() {
                    if ($('#attack_by_type').width() <= 1240) {
                        $('#today_piechart').css('width', '325px');
                        $('#today_piechart').css('margin-left', '75px')

                    }
                    if ($('#attack_by_type').width() > 1230) {
                        $('#today_piechart').css('width', '325px');
                    }

                    if ($('#attack_by_type').width() <= 1240) {
                        $('#last24_piechart').css('width', '325px');
                        $('#last24_piechart').css('margin-left', '75px');

                    }
                    if ($('#attack_by_type').width() > 1230) {
                        $('#last24_piechart').css('width', '325px');

                    }

                    if ($('#attack_by_type').width() <= 1240) {
                        $('#last_week_piechart').css('width', '325px');
                        $('#last_week_piechart').css('margin-left', '75px');

                    }
                    if ($('#attack_by_type').width() > 1230) {
                        $('#last_week_piechart').css('width', '325px');

                    }

                    if ($('#attack_by_type').width() <= 1240) {
                        $('#last_month_piechart').css('width', '325px');
                        $('#last_month_piechart').css('margin-left', '75px');

                    }
                    if ($('#attack_by_type').width() > 1230) {
                        $('#last_month_piechart').css('width', '325px');

                    }

                    if ($('#attack_by_type').width() <= 1140) {
                        $('#brute_force_piechart').css('margin-left', '-35px')
                    }

                    if ($('#attack_by_type').width() < 1230) {
                        $('#brute_force_piechart').css('width', '325px');


                    }
                    if ($('#attack_by_type').width() >= 1230) {
                        $('#brute_force_piechart').css('width', '325px');
                    }

                    if ($('#attack_by_type').width() <= 1140) {
                        $('#sms_flood_piechart').css('margin-left', '-35px')
                    }

                    if ($('#attack_by_type').width() < 1230) {
                        $('#sms_flood_piechart').css('width', '325px');


                    }
                    if ($('#attack_by_type').width() >= 1230) {
                        $('#sms_flood_piechart').css('width', '325px');
                    }

                    if ($('#attack_by_type').width() <= 1140) {
                        $('#ddos_piechart').css('margin-left', '-35px')
                    }

                    if ($('#attack_by_type').width() < 1230) {
                        $('#ddos_piechart').css('width', '325px');


                    }
                    if ($('#attack_by_type').width() >= 1230) {
                        $('#ddos_piechart').css('width', '325px');
                    }

                    if ($('#attack_by_type').width() <= 1140) {
                        $('#errors_piechart').css('margin-left', '-35px')
                    }

                    if ($('#attack_by_type').width() < 1230) {
                        $('#errors_piechart').css('width', '325px');


                    }
                    if ($('#attack_by_type').width() >= 1230) {

                        $('#errors_piechart').css('width', '325px');

                    }

                    if ($('#attack_by_type').width() <= 1140) {
                        $('#description_piechart').css('margin-left', '-35px')
                    }

                    if ($('#attack_by_type').width() < 1230) {
                        $('#description_piechart').css('width', '325px');

                    }
                    if ($('#attack_by_type').width() >= 1230) {
                        $('#description_piechart').css('width', '325px');

                    }
                }

                function drawCharts() {

                    resize_charts();

                    drawLineChart(new_line_chart_Data);
                    drawPieChart(new_pie_chart_Data);
                    drawColumnChart(new_column_chart_Data);
                    draw_top_by_ip_chart(new_ip_info_data);


                    setChart();
                }

		//google.charts.load('51', {'packages': ['corechart'], 'callback': drawCharts});
                google.charts.setOnLoadCallback(drawCharts);

                $("#overlay").hide();
                main_loadingContainer2.hide();

                $(".line-chart-filter").change(function () {
                    setChart();
                    if ($(this).prop('checked')) {
                        if (this.value != 'All attacks') {
                            //setColumnChart(this.value, 'checked');
                            //setPieChart(this.value, 'checked');
                        }
                    } else {
                        if (this.value != 'All attacks') {
                            //setColumnChart(this.value, 'not_checked');
                            //setPieChart(this.value, 'not_checked');
                        }
                    }
                });

                $(window).resize(function () {

                    $("[name='line-chart-filter[]']").each(function () {
                        $(this).prop('checked', true);
                    });

                    $("[name='column_chart_filter[]']").each(function () {
                        $(this).prop('checked', true);
                    });

                    google.charts.setOnLoadCallback(drawLineChart(new_line_chart_Data));
                    google.charts.setOnLoadCallback(drawPieChart(new_pie_chart_Data));
                    google.charts.setOnLoadCallback(drawColumnChart(new_column_chart_Data));
                    google.charts.setOnLoadCallback(draw_top_by_ip_chart(new_ip_info_data));
                    google.charts.setOnLoadCallback(draw_today_pieChart(new_today_summary_data));
                    google.charts.setOnLoadCallback(draw_last24_pieChart(new_last24_summary_data));
                    google.charts.setOnLoadCallback(draw_last_week_pieChart(new_last_week_summary_data));
                    google.charts.setOnLoadCallback(draw_last_month_pieChart(new_last_month_summary_data));
                    google.charts.setOnLoadCallback(draw_brute_force_pieChart(new_brute_force_summary_data));
                    google.charts.setOnLoadCallback(draw_sms_flood_pieChart(new_sms_flood_summary_data));
                    google.charts.setOnLoadCallback(draw_ddos_pieChart(new_ddos_summary_data));
                    google.charts.setOnLoadCallback(draw_internal_errors_pieChart(new_internal_errors_summary_data));
                    google.charts.setOnLoadCallback(draw_description_pieChart(new_description_summary_data));

                    resize_charts();

                });

                $('[data-toggle="tab"]').on('shown.bs.tab', function (e) {
                    var activeTab = $(e.target);
                    if (activeTab[0].innerText === gettext('Summary')) {

                        resize_charts();

                        drawLineChart(new_line_chart_Data);
                        drawPieChart(new_pie_chart_Data);
                        drawColumnChart(new_column_chart_Data);
                        draw_top_by_ip_chart(new_ip_info_data);

                    }

                });

                $(".column_chart_filter").change(function () {
                    let search_text = window.search;
                    let search_input_text = document.getElementById('search-input').value;
                    var home = document.getElementById('home').title;
                    state = [];
                    let state_str = '';
                    $("[name='column_chart_filter[]']").each(function () {
                        if ($(this).prop('checked')) {
                        } else {
                            state.push(this.value)
                        }
                    });

                    for (let i = 0; i < state.length; i++) {
                        state_str = state_str + state[i].toString() + "-";
                    }

                    var docHeight = $(document).height();
                    $("#overlay")
                        .height(docHeight)
                        .css({
                            'position': 'absolute',
                            'top': 0,
                            'left': document.getElementById('leftSidebar').offsetWidth,
                            'margin-top': '90px',
                            'background-color': "rgba(255, 255, 255, 0.6)",
                            'width': '100%',
                            'z-index': 1020
                        });
                    $(".loading-container_overlay")
                        .css({
                            'z-index': 1015,
                            'opacity': 1,
                        });
                    var main_loadingContainer2 = $('.loading-container_overlay');
                    $("#overlay").show();
                    main_loadingContainer2.show();

                    if (state.length === 0) {
                        $.get(home + 'charts/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&search=' + encodeURIComponent(search_text) + '&q=' + search_input_text + '&state=clear', function (data) {
                            $("#overlay").show();
                            main_loadingContainer2.show();
                        }).success(
                            function (data) {
                                if (data === "LOADING, TRY AGAIN LATER") {
                                    let divBlock = '<div id="load_again_later" style="position: fixed; left: calc(50% - 520px); top: calc(50% - 95px); font-size: 70px; text-align: center">' +
                                        gettext('The summary is being generated.') + ' <br>' + gettext('Please come back later.') + '</div>';
                                    $('#overlay').html(divBlock);
                                    return 0;
                                } else {
                                    if (document.getElementById('overlay') !== null) {
                                        document.getElementById('overlay').style.display = 'none';
                                    }
                                }

                                $('#ip_info_data').empty();
                                $('#ip_info_data').append(data);

                                new_ip_info_data = document.getElementById("ip_info_data").innerText;
                                draw_top_by_ip_chart(new_ip_info_data);
                                $("#overlay").hide();
                            }
                        );

                    } else {
                        $.get(home + 'charts/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&search=' + encodeURIComponent(search_text) + '&q=' + search_input_text + '&state=' + state_str, function (data) {
                            $("#overlay").show();
                            main_loadingContainer2.show();
                        }).success(
                            function (data) {
                                if (data === "LOADING, TRY AGAIN LATER") {
                                    let divBlock = '<div id="load_again_later" style="position: fixed; left: calc(50% - 520px); top: calc(50% - 95px); font-size: 70px; text-align: center">' +
                                        gettext('The summary is being generated.') + ' <br>' + gettext('Please come back later.') + '</div>';
                                    $('#overlay').html(divBlock);
                                    return 0;
                                } else {
                                    if (document.getElementById('overlay') !== null) {
                                        document.getElementById('overlay').style.display = 'none';
                                    }
                                }
                                $('#ip_info_data').empty();
                                $('#ip_info_data').append(data);

                                new_ip_info_data = document.getElementById("ip_info_data").innerText;
                                draw_top_by_ip_chart(new_ip_info_data);
                                $("#overlay").hide();
                            }
                        );

                    }

                });


                function drawLineChart(get_data) {
                    var point_style = 'point {stroke-color: #1a5287; stroke-width: 2; fill-color: none; }';
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'Date');
                    data.addColumn('number', 'All attacks');
                    data.addColumn('number', 'Signature Analysis');
                    data.addColumn('number', 'Nemesida AI');
                    data.addColumn('number', 'Brute-force');
                    data.addColumn('number', 'Flood');
                    data.addColumn('number', 'DDoS');
                    data.addColumn('number', 'Antivirus');
                    data.addColumn('number', 'API Firewall');
                    data.addColumn('number', 'Blocked');
                    data.addColumn('number', 'Empty');
                    var json_chart_Data = JSON.parse(get_data);
                    var div_width = $('.attack_by_type').width();
                    data.addRows(json_chart_Data);
                    //data.removeColumn(8);
                    var colors = {
                        'All attacks': '#f24840',
                        'Signature Analysis': '#00b6f4',
                        'Nemesida AI': '#032790',
                        'Brute-force': '#eece00',
                        'Flood': '#a45d1f',
                        'DDoS': '#8a6ac8',
                        'Antivirus': '#32BC43',
                        'Blocked': '#000000',
                        'API Firewall':'#00b6f4',
                        'Empty': 'transparent',
                    };
                    var options = {
                        backgroundColor: 'transparent',
                        colors: ['#f24840', '#00b6f4', '#032790', '#eece00', '#a45d1f', '#8a6ac8', '#32BC43', 'transparent'],
                        hAxis: {
                            textStyle: {
                                color: '#7697b7',
                                bold: false,
                            },
                            gridlines: {
                                color: 'red',
                            },
                        },
                        vAxis: {
                            format: '0',
                            textStyle: {
                                color: '#7697b7',
                                bold: false,
                            },
                        },
                        tooltip: {
                            isHtml: true,
                            textStyle: {
                                fontSize: 14,
                            },
                        },
                        height: 445,
                        width: div_width * 1.24,
                        legend: {
                            position: 'none',
                            textStyle: {
                                color: '#fafafa',
                                backgroundColor: '#134473',
                                bold: true,
                            },
                        },
                        lineWidth: 2,
                        pointSize: 10,
                    };

                    if (window.innerWidth < 1700) {
                        options.width = div_width * 1.24 + 21;
                    }

                    var chart = new google.visualization.ChartWrapper({
                        chartType: 'LineChart',
                        containerId: 'line_chart',
                        dataTable: data,
                        options: options,
                    });
                    chart.draw();

                    var marign = -22 + ((1080 - window.innerHeight) / 10);
                    $('#line_chart').css('margin-left', marign);

                    if (data.getNumberOfRows() === 0) {
                        var new_marign = parseInt($('#line_chart').css('margin-left')) - 8;
                        $('#line_chart').css('margin-left', new_marign);

                        $('#line_chart_filter').css('margin-top', -45);
                    }


                    setChart = function () {
                        state = [];
                        $("[name='line-chart-filter[]']:checked").each(function () {
                            state.push(this.value)
                        });
                        if (state.length == 0) {
                            data.addColumn('number', 'Empty');
                            state.push("Empty");
                        }

                        var row;
                        var view = {
                            columns: [0]
                        };
                        for (var i = 0; i < state.length; i++) {
                            view.columns.push(state[i]);
                        }
                        // sort the indices into their original order
                        //view.columns.sort(function (a, b) {
                        //    return (a - b);
                        //});
                        chart.getOptions().colors = [];
                        for (var i = 1; i < view.columns.length; i++) {
                            chart.getOptions().colors.push(colors[view.columns[i]]);
                        }
                        chart.setView(view);
                        chart.draw();
                    }

                    //var lineuri = chart.getImageURI()
                    //return document.getElementById('reportchart2').value = lineuri;

                }


                function drawPieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'Host');
                    data.addColumn('number', 'All attacks');
                    data.addColumn('number', 'Signature Analysis');
                    data.addColumn('number', 'Nemesida AI');
                    data.addColumn('number', 'Brute-force');
                    data.addColumn('number', 'Antivirus');
                    data.addColumn('number', 'API Firewall');
                    data.addColumn('number', 'Blocked IP');
                    
                    
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                        }
                        data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                            ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                    }


                    var options = {
                        title: gettext("Statistic by target"),
                        titleTextStyle: {
                            color: '#2760A0',
                            fontSize: 22,
                            bold: false,
                        },
                        tooltip:
                            {
                                ignoreBounds: true,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'none',
                        sliceVisibilityThreshold: 0,
                        height: 700,
                        width: "100%",
                        colors: ['#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'left',
                            alignment: 'top',
                            textStyle: {
                                color: '#2760A0',
                            },
                        },
                    };

                    if (data.getNumberOfRows() === 0) {
                        data.addRow(['', 0, 0, 0, 0, 0, 0, 0, '']);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#fafafa'];
                    } else {
                        var total = 0;
                        for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                            total = total + data.getValue(y, 1);
                        }

                        for (var x = 0; x < data.getNumberOfRows(); x++) {
                            if (data.getValue(x, 0).length > 40) {
                                var new_str = data.getValue(x, 0).slice(0, 40) + "\n" + data.getValue(x, 0).slice(40);
                                data.setValue(x, 0, new_str);
                            }

                        }

                        for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                            var attack_count = data.getValue(y, 1);
                            if (attack_count > 1000000) {
                                attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            }
                            if (attack_count > 1000) {
                                attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            }
                            data.setValue(y, 0, data.getValue(y, 0) + " - " + attack_count + " (" +
                                ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        }
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('pie_chart'));

                    var view = new google.visualization.DataView(data);

                    view.setColumns([0, 1, 8]);

                    chart.draw(view, options);

                    google.visualization.events.addListener(chart, 'click', function (entry) {
                        if (!entry.targetID.includes("legendentry")) {
                            return;
                        }
                        var targetId = entry.targetID;
                        var rowId = parseInt(targetId.substr(targetId.lastIndexOf("#") + 1, targetId.length - 1));
                        var host = data.getValue(rowId, 0).split(' -')[0];
                        if (host === "") {
                            return;
                        }

                        $('#attack_table_search_input').val("h:" + host);
                        doneTyping(false, "h:" + host);
                    });


                    setPieChart = function (column, col_state) {

                        if (column == "Signature Analysis" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {

                                dif = data.getValue(x, 1) + data.getValue(x, 2);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.round(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '70'});
                        }

                        if (column == "Signature Analysis" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {

                                dif = data.getValue(x, 1) - data.getValue(x, 2);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '70'});
                        }

                        if (column == "Nemesida AI" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {

                                dif = data.getValue(x, 1) + data.getValue(x, 3);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }

                        if (column == "Nemesida AI" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {

                                dif = data.getValue(x, 1) - data.getValue(x, 3);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }

                        if (column == "Brute-force" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 4);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }

                        if (column == "Brute-force" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 4);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }

                        if (column == "Antivirus" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }

                        if (column == "Antivirus" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }
                        if (column == "API Firewall" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }

                        if (column == "API Firewall" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'y': '60'});
                        }

                    }


                }

                function drawColumnChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'Attackers');
                    data.addColumn('number', 'Attacks');
                    data.addColumn('number', 'Signature Analysis');
                    data.addColumn('number', 'Nemesida AI');
                    data.addColumn('number', 'Brute-force');
                    data.addColumn('number', 'Antivirus');
                    data.addColumn('number', 'DDoS');
                    data.addColumn('number', 'Flood');
                    data.addColumn('string', 'GeoIP');
                    
                    data.addColumn('string', 'Country');
                    var json_Data = JSON.parse(get_data);
                    
                    data.addRows(json_Data);
                    data.addColumn('number', 'Percnet');
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});
                    data.sort({
                        column: 1,
                        desc: true
                    });

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                        }
                        if (attack_count === 1) {
                            data.setValue(y, 11, "IP: " + data.getValue(y, 0) + "\n" + gettext('Attack') + ": " + attack_count + ", " +
                                ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%\n" + data.getValue(y, 8));
                        } else {
                            data.setValue(y, 11, "IP: " + data.getValue(y, 0) + "\n" + gettext('Attacks') + ": " + attack_count + ", " +
                                ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%\n" + data.getValue(y, 8));
                        }
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        data.setValue(y, 10, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                    }

                    if (data.getNumberOfRows() == 0) {
                        var max_value = 1;
                    } else {
                        var max_value = data.getValue(0, 1);
                    }

                    var options = {
                        title: gettext("Statistic by IP"),
                        colors: ['#305DCE', '#285283', '#62BCB1', '#E9DE79', '#FFE483', '#FAA75F', '#FC725F', '#E15649', '#DAE5F0', '#4DB4EF'],
                        titleTextStyle: {
                            color: '#2760A0',
                            fontSize: 22,
                            bold: false,
                        },
                        tooltip:
                            {
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },
                        vAxis: {
                            textStyle: {
                                color: '#7C97B4',
                                fontSize: 15,
                            },
                            maxValue: max_value,
                            format: '0',
                        },
                        backgroundColor: 'transparent',
                        height: 535,
                        width: 1325,
                        fontSize: 15,
                        hAxis: {
                            slantedText: true,
                            format: 'long',
                            textStyle: {
                                color: '#2760A0',
                            },
                        },
                        legend: 'none',
                    };

                    var attack_by_type_width = $('#attack_by_type').width();
                    if (attack_by_type_width < 1480) {
                        var wd = 1480 - attack_by_type_width;
                        options.width = 1350 - wd - 40;
                    }
		    
                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 11]);
                    view.setColumns([0, 1, 11, {
                        role: 'style',
                        type: 'string',
                        calc: function (dt, row) {
                            return options.colors[row]
                        }
                    }]);
                    var chart = new google.visualization.ColumnChart(document.getElementById("column_chart"));
                    chart.draw(view, options);
                    configureChart();

                    $("text:contains(" + options.title + ")").attr({'x': '145'});


                    function configureChart() {
                        var chartContainer = document.getElementById('column_chart');
                        var svg = chartContainer.getElementsByTagName('svg')[0];
                        var maxrows = data.getNumberOfRows();

                        var IPlabels = svg.querySelectorAll("text[text-anchor='end']");
                        for (var i = 0; i < maxrows; i++) {
                            var country = data.getValue(i, 9) + '.png';
                            var ipText = IPlabels[i];
                            if (typeof ipText !== 'undefined') {
                                ipText.setAttribute('x', ipText.getAttribute('x') - 10);

                                var x = ipText.getAttribute('x');
                                var y = ipText.getAttribute('y') - 10;
                                var flagIcon = createImage({
                                    href: home + 'static/img/round_flags/' + country,
                                    x: x,
                                    y: y,
                                    width: 20,
                                    height: 20
                                });

                                var ipTextParent = ipText.parentNode;

                                ipTextParent.appendChild(flagIcon);
                                ipText.setAttribute('x', parseFloat(ipText.getAttribute('x')) - 2);

                            }
                        }
                    }


                    function createImage(options) {
                        var image = document.createElementNS('http://www.w3.org/2000/svg', 'image');
                        image.setAttributeNS(null, 'height', options.height);
                        image.setAttributeNS(null, 'width', options.width);
                        image.setAttributeNS('http://www.w3.org/1999/xlink', 'href', options.href);
                        image.setAttributeNS(null, 'x', options.x);
                        image.setAttributeNS(null, 'y', options.y);
                        image.setAttributeNS(null, 'visibility', 'visible');
                        return image;
                    }


                    setColumnChart = function (column, col_state) {
                        if (column == "Signature Analysis" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 2);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }

                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                        if (column == "Signature Analysis" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 2);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }
                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                        if (column == "Nemesida AI" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 3);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }

                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                        if (column == "Nemesida AI" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 3);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }

                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                        if (column == "Brute-force" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 4);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }

                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                        if (column == "Brute-force" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 4);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }

                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                        if (column == "Antivirus" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }

                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }

                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                        if (column == "Antivirus" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }


                            var total = 0;
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                total = total + data.getValue(y, 1);
                            }
                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                if (total === 0) {
                                    data.setValue(y, 6, 0);
                                    continue;
                                }

                                data.setValue(y, 6, ((data.getValue(y, 1) / total) * 100).toFixed(1));
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 7, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 7]);
                            view.setColumns([0, 1, 7, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '80'});
                        }

                    }

                }

                function draw_top_by_ip_chart(get_data) {
                    var data = new google.visualization.DataTable();
                    var div_width = $('.attack_by_type').width();
                    data.addColumn('string', 'Attackers');
                    data.addColumn('number', 'Attacks');
                    data.addColumn('number', 'BT1');
                    data.addColumn('number', 'BT2');
                    data.addColumn('number', 'BT3');
                    data.addColumn('number', 'BT4');
                    data.addColumn('number', 'BT7');
                    data.addColumn('number', 'BT8');
                    data.addColumn('number', 'BT9');
                    data.addColumn('number', 'BT10');
                    data.addColumn('string', 'GeoIP');
                    data.addColumn('string', '24h');
                    data.addColumn('string', 'country');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    //data.addColumn('number', 'Percnet');
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});
                    data.sort({
                        column: 1,
                        desc: true
                    });

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                        }
                        data.setValue(y, 13, "IP: " + data.getValue(y, 0) + "\n" + gettext('Attacks') + ": " + attack_count + ", " +
                            ((data.getValue(y, 1) / total) * 100).toFixed(1) + "% " + data.getValue(y, 11) + '\n' + data.getValue(y, 10));
                    }


                    var options = {
                        colors: ['#285283'],
                        titleTextStyle: {
                            color: '#2760A0',
                            fontSize: 22,
                            bold: false,
                        },
                        tooltip:
                            {
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },
                        vAxis: {
                            textStyle: {
                                color: '#7C97B4',
                                fontSize: 15,
                            },
                            format: '0',
                        },
                        backgroundColor: 'transparent',
                        height: 525,
                        width: div_width * 1.24,
                        fontSize: 15,
                        hAxis: {
                            slantedText: true,
                            format: 'long',
                            textStyle: {
                                color: '#2760A0',
                            },
                        },
                        legend: 'none',
                    };


                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 13]);
                    view.setColumns([0, 1, 13, {
                        role: 'style',
                        type: 'string',
                        calc: function (dt, row) {
                            return options.colors[row]
                        }
                    }]);
                    var chart = new google.visualization.ColumnChart(document.getElementById("column_chart2"));
                    chart.draw(view, options);
                    configureChart();

                    var attack_by_type_width = $('#attack_by_type').width();
                    if (attack_by_type_width < 1480) {
                        $('#column_chart2').css('margin-left', 0);
                    }

                    function configureChart() {
                        var chartContainer = document.getElementById('column_chart2');
                        var svg = chartContainer.getElementsByTagName('svg')[0];
                        var maxrows = data.getNumberOfRows();
			var path = svg.getElementsByTagName("g")
                        var IPlabels = svg.querySelectorAll("text[text-anchor='end']");
                        for (var i = 0; i < maxrows; i++) {
                            var country = data.getValue(i, 12) + '.png';
                            var ipText = IPlabels[i];
                            var text = IPlabels[i].textContent
                            if (text.length > 15){
                            IPlabels[i].textContent = text.slice(0,15);
                            let parent = IPlabels[i].parentNode 
                            }
                            
                            
                            if (typeof ipText !== 'undefined') {
                                ipText.setAttribute('x', ipText.getAttribute('x') -25);

                                var x = ipText.getAttribute('x') ;
                                var y = ipText.getAttribute('y') - 5;
                                var flagIcon = createImage({
                                    href: home + 'static/img/round_flags/' + country,
                                    x: x,
                                    y: y,
                                    width: 20,
                                    height: 20
                                });

                                var ipTextParent = ipText.parentNode;

                                ipTextParent.appendChild(flagIcon);

                                ipText.setAttribute('x', parseFloat(ipText.getAttribute('x')) -5 );
                                
                            }
                        }
                    }


                    function createImage(options) {
                        var image = document.createElementNS('http://www.w3.org/2000/svg', 'image');
                        image.setAttributeNS(null, 'height', options.height);
                        image.setAttributeNS(null, 'width', options.width);
                        image.setAttributeNS('http://www.w3.org/1999/xlink', 'href', options.href);
                        image.setAttributeNS(null, 'x', options.x);
                        image.setAttributeNS(null, 'y', options.y);
                        image.setAttributeNS(null, 'visibility', 'visible');
                        return image;
                    }


                    setColumnChart2 = function (column, col_state) {
                        if (column == "BT1" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 2);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attack') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT1" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 2);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT2" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 3);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT2" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 3);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT3" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 4);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT3" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 4);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attacks') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT4" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attack') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT4" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 5);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attack') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT7" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 6);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attack') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT7" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 6);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attack') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT8" && col_state == 'checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) + data.getValue(x, 7);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attack') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                        if (column == "BT8" && col_state == 'not_checked') {
                            for (var x = 0; x < data.getNumberOfRows(); x++) {
                                dif = data.getValue(x, 1) - data.getValue(x, 7);
                                data.setValue(x, 1, dif);
                            }

                            for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                                var attack_count = data.getValue(y, 1);
                                if (attack_count > 1000) {
                                    attack_count = Math.trunc(attack_count / 1000).toString() + 'K';
                                }
                                data.setValue(y, 8, data.getValue(y, 0) + "\n" + attack_count + " " + gettext('Attack') + " (" +
                                    ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                            }

                            var view = new google.visualization.DataView(data);
                            view.setColumns([0, 1, 8]);
                            view.setColumns([0, 1, 8, {
                                role: 'style',
                                type: 'string',
                                calc: function (dt, row) {
                                    return options.colors[row]
                                }
                            }]);
                            chart.draw(view, options);
                            $("text:contains(" + options.title + ")").attr({'x': '73'});
                        }

                    }

                }

                function draw_today_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'BT');
                    data.addColumn('string', 'full_name');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});
                    data.addColumn('number', 'Percnet');


                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attack') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 10.5,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#E9DE79', '#4DB4EF', '#F2AB6D', '#62BCB1', '#305DCE', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }
                    if (all_data === 0) {
                        data.addRow(['', 1, '', '', 100]);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('today_piechart'));

                    data.sort([{column: 1}]);
                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 3]);

                    chart.draw(view, options);

                    var check_count = 0;
                    var bt = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            bt = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#today_piechart text:contains(" + bt + ")").attr({'y': '85'});
                    }


                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#today_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#today_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });
                }

                function draw_last24_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'BT');
                    data.addColumn('string', 'full_name');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});
                    data.addColumn('number', 'Percnet');


                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attack') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 10.5,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#E9DE79', '#4DB4EF', '#F2AB6D', '#62BCB1', '#305DCE', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }
                    if (all_data === 0) {
                        data.addRow(['', 1, '', '', 100]);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('last24_piechart'));

                    data.sort([{column: 1}]);
                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 3]);

                    chart.draw(view, options);

                    var check_count = 0;
                    var bt = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            bt = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#last24_piechart text:contains(" + bt + ")").attr({'y': '85'});
                    }


                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#last24_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#last24_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });

                }

                function draw_last_week_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'BT');
                    data.addColumn('string', 'full_name');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});
                    data.addColumn('number', 'Percnet');


                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attack') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 10.5,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#E9DE79', '#4DB4EF', '#F2AB6D', '#62BCB1', '#305DCE', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }
                    if (all_data === 0) {
                        data.addRow(['', 1, '', '', 100]);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('last_week_piechart'));

                    data.sort([{column: 1}]);
                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 3]);

                    chart.draw(view, options);

                    var check_count = 0;
                    var bt = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            bt = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#last_week_piechart text:contains(" + bt + ")").attr({'y': '85'});
                    }


                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#last_week_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#last_week_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });

                }

                function draw_last_month_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'BT');
                    data.addColumn('string', 'full_name');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});
                    data.addColumn('number', 'Percnet');

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attack') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else {
                            data.setValue(y, 3, data.getValue(y, 2) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 10.5,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#E9DE79', '#4DB4EF', '#F2AB6D', '#62BCB1', '#305DCE', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }
                    if (all_data === 0) {
                        data.addRow(['', 1, '', '', 100]);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('last_month_piechart'));

                    data.sort([{column: 1}]);
                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 3]);

                    var attack_by_type_width = $('#attack_by_type').width();
                    var table_attack_by_type_width = $('#table_attack_by_type').width();
                    $('#table_attack_by_type').width(attack_by_type_width);

                    chart.draw(view, options);

                    var check_count = 0;
                    var bt = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            bt = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#last_month_piechart text:contains(" + bt + ")").attr({'y': '85'});
                    }


                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#last_month_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#last_month_piechart text:contains(" + bt + ")").attr({'y': '85'});
                        }
                    });


                }

                function draw_brute_force_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'count');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);

                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        var name = data.getValue(y, 0).toLowerCase();
                        var new_name = name[0].toUpperCase() + name.slice(1);
                        var percent_value = ((data.getValue(y, 1) / total) * 100).toFixed(1);
                        if (isNaN(percent_value)) {
                            percent_value = '0';
                        }
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attack') + percent_value + "%)");
                        } else {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 8,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#62BCB1', '#4DB4EF', '#FAA75F', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }

                    if (all_data === 0) {
                        data.addRow(['', 1, '']);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('brute_force_piechart'));

                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 2]);

                    chart.draw(view, options);

                    var check_count = 0;
                    var name = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            name = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#brute_force_piechart text:contains(" + name + ")").attr({'y': '85'});
                    }


                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#brute_force_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#brute_force_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });


                }

                function draw_sms_flood_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'count');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);

                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        var name = data.getValue(y, 0).toLowerCase();
                        var new_name = name[0].toUpperCase() + name.slice(1);
                        var percent_value = ((data.getValue(y, 1) / total) * 100).toFixed(1);
                        if (isNaN(percent_value)) {
                            percent_value = '0';
                        }
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attack') + percent_value + "%)");
                        } else {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 8,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#62BCB1', '#4DB4EF', '#FAA75F', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }

                    if (all_data === 0) {
                        data.addRow(['', 1, '']);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('sms_flood_piechart'));

                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 2]);

                    chart.draw(view, options);


                    var check_count = 0;
                    var name = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            name = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#sms_flood_piechart text:contains(" + name + ")").attr({'y': '85'});
                    }


                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#sms_flood_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#sms_flood_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });


                }


                function draw_ddos_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'count');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);

                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        var name = data.getValue(y, 0).toLowerCase();
                        var new_name = name[0].toUpperCase() + name.slice(1);
                        var percent_value = ((data.getValue(y, 1) / total) * 100).toFixed(1);
                        if (isNaN(percent_value)) {
                            percent_value = '0';
                        }
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attack') + percent_value + "%)");
                        } else {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('Attacks') + percent_value + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 8,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#62BCB1', '#4DB4EF', '#FAA75F', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }

                    if (all_data === 0) {
                        data.addRow(['', 1, '']);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('ddos_piechart'));

                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 2]);

                    chart.draw(view, options);


                    var check_count = 0;
                    var name = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            name = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#ddos_piechart text:contains(" + name + ")").attr({'y': '85'});
                    }

                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#ddos_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#ddos_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });


                }


                function draw_internal_errors_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'count');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        var name = data.getValue(y, 0).toLowerCase();
                        var new_name = name[0].toUpperCase() + name.slice(1);
                        var percent_value = ((data.getValue(y, 1) / total) * 100).toFixed(1);
                        if (isNaN(percent_value)) {
                            percent_value = '0';
                        }
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('errors') + ' (' + percent_value + "%)");
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('errors') + ' (' + percent_value + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('error') + ' (' + percent_value + "%)");
                        } else {
                            data.setValue(y, 2, new_name + ': ' + attack_count + ' ' + gettext('errors') + ' (' + percent_value + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'label',
                        pieSliceTextStyle: {
                            fontSize: 8,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#62BCB1', '#4DB4EF', '#FAA75F', '#285283'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    var all_data = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        all_data = all_data + data.getValue(y, 1);
                    }

                    if (all_data === 0) {
                        data.addRow(['', 1, '']);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];
                    }

                    var chart = new google.visualization.PieChart(document.getElementById('errors_piechart'));

                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 2]);

                    chart.draw(view, options);

                    var check_count = 0;
                    var name = '';
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        if (data.getValue(y, 1) !== 0) {
                            check_count = check_count + 1;
                            name = data.getValue(y, 0);

                        }
                    }
                    if (check_count === 1) {
                        $("#errors_piechart text:contains(" + name + ")").attr({'y': '85'});
                    }

                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                        if (check_count === 1) {
                            $("#errors_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                        if (check_count === 1) {
                            $("#errors_piechart text:contains(" + name + ")").attr({'y': '85'});
                        }
                    });

                }

                function draw_description_pieChart(get_data) {
                    var data = new google.visualization.DataTable();
                    data.addColumn('string', 'name');
                    data.addColumn('number', 'count');
                    var json_Data = JSON.parse(get_data);
                    data.addRows(json_Data);
                    data.addColumn({type: 'string', role: 'tooltip', p: {html: true}});
                    data.addColumn('number', 'Percnet');

                    var total = 0;
                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        total = total + data.getValue(y, 1);
                    }

                    for (var y = 0, maxrows = data.getNumberOfRows(); y < maxrows; y++) {
                        var attack_count = data.getValue(y, 1);
                        if (attack_count > 1000000) {
                            attack_count = Math.round(attack_count / 1000000).toString() + 'M';
                            data.setValue(y, 2, data.getValue(y, 0) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        }
                        if (attack_count > 1000) {
                            attack_count = Math.round(attack_count / 1000).toString() + 'K';
                            data.setValue(y, 2, data.getValue(y, 0) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else if (attack_count == 1) {
                            data.setValue(y, 2, data.getValue(y, 0) + '\n' + attack_count + ' ' + gettext('Attack') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        } else {
                            data.setValue(y, 2, data.getValue(y, 0) + '\n' + attack_count + ' ' + gettext('Attacks') + ((data.getValue(y, 1) / total) * 100).toFixed(1) + "%)");
                        }
                    }


                    var options = {
                        tooltip:
                            {
                                ignoreBounds: false,
                                trigger: 'selection',
                                textStyle: {
                                    bold: false,
                                    color: '#2760A0',
                                },
                            },

                        backgroundColor: 'transparent',
                        pieHole: 0.58,
                        pieSliceText: 'none',
                        pieSliceTextStyle: {
                            fontSize: 8,
                            bold: true,
                        },
                        height: 300,
                        width: 300,
                        colors: ['#285283', '#305DCE', '#62BCB1', '#E9DE79', '#FFE483', '#FAA75F', '#FC725F', '#E15649', '#DAE5F0', '#4DB4EF'],
                        fontSize: 15,
                        legend: {
                            position: 'none',
                        },
                    };

                    if (data.getNumberOfRows() < 1) {
                        data.addRow(['', 1, '', 100]);
                        options.tooltip.trigger = 'none';
                        options.colors = ['#B9CFE4'];

                    }

                    var chart = new google.visualization.PieChart(document.getElementById('description_piechart'));

                    var view = new google.visualization.DataView(data);
                    view.setColumns([0, 1, 2]);

                    chart.draw(view, options);

                    google.visualization.events.addListener(chart, 'onmouseover', function (entry) {
                        chart.setSelection([{row: entry.row}]);
                    });

                    google.visualization.events.addListener(chart, 'onmouseout', function (entry) {
                        chart.setSelection([]);
                    });

                }


            })
    }

}
