function sendData(d, url) {
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    $.ajax({
        url: url,
        type: 'POST',
        data: {
            'data': d,
            csrfmiddlewaretoken: csrftoken
        },
        dataType: 'json',
        success: function (data) {
        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');
                if (data['messages'] != null && data['messages'] != undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });
}

function url_for_adp(url) {

    if (!url.includes(window.location.host)) {
        url = window.location.href + '/' + url;
    }
    url = url.replace(window.location.search, '');
    if (url.includes('admin_panel')) {
        url = url.replace('/admin_panel/', '').replace(window.location.search, '');
        url = url + '&t=p';
    }

    return url;
}

function getCheckedBoxes(chkboxName, attr) {
    var checkboxes = document.getElementsByName(chkboxName);
    var checkboxesChecked = [];
    for (let item of checkboxes) {
        if (item.checked && item.parentElement.parentElement.style.display !== 'none') {
            checkboxesChecked.push(item[attr]);
        }
    }
    return checkboxesChecked.length > 0 ? checkboxesChecked : null;
}

function removeRows(rows) {
    if (rows != null) {
        for (var i = 0; i < rows.length; i++) {
            document.getElementById(rows[i]).parentElement.parentElement.remove()
        }
    }
}

// edit export
$(document).on('click', '.ed', function (e) {
    let id = document.querySelector('#editID').value;
    let row = document.querySelector('#row_export_' + id);
    let home = document.getElementById('home').title;
    $.ajax({
        url: home + 'mt/edit/',
        type: "POST",
        dataType: "html",
        data: $('#bt-edit-form').serialize(),
        success: function (response) {
            response = JSON.parse(response);
            if (response.status === 'success') {
                let data = response.data;
                if (data.args !== '' && data.args != null) {
                    row.querySelector('.contain_args').innerHTML = escapeHtml(data.args);
                }
                if (data.uri !== '' && data.uri != null) {
                    row.querySelector('.contain_uri').innerHTML = escapeHtml(data.uri);
                }
                if (data.cookie !== '' && data.cookie != null) {
                    row.querySelector('.contain_cookie').innerHTML = escapeHtml(data.cookie);
                }
                if (data.ua !== '' && data.ua != null) {
                    row.querySelector('.contain_ua').innerHTML = escapeHtml(data.ua);
                }
                if (data.body !== '' && data.body != null) {
                    row.querySelector('.contain_body').innerHTML = escapeHtml(data.body);
                }
                if (data.referer !== '' && data.referer != null) {
                    row.querySelector('.contain_referer').innerHTML = escapeHtml(data.referer);
                }
                if (data.other_headers !== '' && data.other_headers != null) {
                    row.querySelector('.contain_other_headers').innerHTML = escapeHtml(data.other_headers);
                }
                $('#editModal').modal('hide');
            } else {

            }

        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');
                if (data['messages'] != null && data['messages'] != undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });
});


// export checked
$(document).on('click', '#ec', function (e) {
    var checkedBoxes = getCheckedBoxes("modalCheckBox", 'id');
    if (checkedBoxes != null) {
        var obj = {};
        var i;
        for (i = 0; i < checkedBoxes.length; i++) {
            obj[checkedBoxes[i].split('_')[1]] = document.getElementById(checkedBoxes[i]).value;
        }
        if (obj.args != null) {
            obj.uri = document.getElementById('m_uri').value;
        }
        obj.row_id = document.getElementById('m_id').value;
        obj.bt = document.getElementById('m_bt').value;
        var myJSONText = JSON.stringify(obj);
        sendData(myJSONText, 'model_tuning/export/');
        document.getElementById(obj.row_id).parentElement.parentElement.remove()
    }
});

// check all
$(document).on('click', '#ca', function () {
    ca = document.getElementById('ca');
    var checktoggle = ca.checked;
    var checkboxes = document.getElementsByName('del_check');
    for (var i = 0; i < checkboxes.length; i++) {
        if (checkboxes[i].type == 'checkbox') {
            checkboxes[i].checked = checktoggle;
        }
    }
});

// delete checked
$(document).on('click', '#dc', function () {
    var checkedBoxes = getCheckedBoxes("del_check", 'id');
    if (checkedBoxes != null) {
        var myJSONText = JSON.stringify(checkedBoxes);
        sendData(myJSONText, 'model_tuning/delete/');
        removeRows(checkedBoxes);
    } else {
        $('#exampleModalCenter').modal('show');
    }
});


$(document).on('click', '.del', function (e) {
    document.querySelector('#del_id').value = e.target.closest('tr').querySelector('.row_id').value;
    if (document.querySelector('#del_id').value !== null) {
        $('#exampleModalCenter').modal('show');
    }

});


$(document).on('click', '#da', function () {
    let id = document.querySelector('#del_id').value;
    let row = document.querySelector('#row_export_' + id);
    let home = document.getElementById('home').title;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + 'mt/delete/',
        type: "POST",
        dataType: "html",
        data: `row_id=${id}&csrfmiddlewaretoken=${csrftoken}`,
        success: function (response) {
            response = JSON.parse(response);
            if (response.status === 'success') {
                row.remove()

            } else {

            }

        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');
                if (data['messages'] != null && data['messages'] != undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });

});

//check row
$(document).on('click', '.dr', function (e) {
    var row = e.currentTarget.parentElement.parentElement;
    document.getElementById('detail_row_bt').innerHTML = row.getElementsByClassName('row_bt')[0].innerHTML;
    document.getElementById('detail_row_date').innerHTML = row.getElementsByClassName('row_date')[0].innerHTML;
    document.getElementById('detail_row_id').innerHTML = row.getElementsByClassName('row_id')[0].innerHTML;
    document.getElementById('detail_row_args').innerHTML = row.getElementsByClassName('row_args')[0].innerHTML;
    document.getElementById('detail_row_status').innerHTML = row.getElementsByClassName('row_status')[0].innerHTML;
    document.getElementById('detail_row_ip').innerHTML = row.getElementsByClassName('row_ip')[0].innerHTML;
    document.getElementById('detail_row_host').innerHTML = row.getElementsByClassName('row_host')[0].innerHTML;
    document.getElementById('detail_row_method').innerHTML = row.getElementsByClassName('row_method')[0].innerHTML;
    document.getElementById('detail_row_uri').innerHTML = row.getElementsByClassName('row_uri')[0].innerHTML;
    document.getElementById('detail_row_req_p').innerHTML = row.getElementsByClassName('row_req_p')[0].innerHTML;
    document.getElementById('detail_row_schema').innerHTML = row.getElementsByClassName('row_schema')[0].innerHTML;
    document.getElementById('detail_row_cookie').innerHTML = row.getElementsByClassName('row_cookie')[0].innerHTML;
    document.getElementById('detail_row_ua').innerHTML = row.getElementsByClassName('row_ua')[0].innerHTML;
    document.getElementById('detail_row_body').innerHTML = row.getElementsByClassName('row_body')[0].innerHTML;
    document.getElementById('detail_row_ref').innerHTML = row.getElementsByClassName('row_ref')[0].innerHTML;
    $('#detailModal').modal('show');
});


function sendData(d, url, p = 'main', reload = false) {
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    $.ajax({
        url: url,
        type: 'POST',
        data: {
            'data': d,
            csrfmiddlewaretoken: csrftoken,
            'table': p
        },
        dataType: 'json',
        success: function (data) {
            if (reload) {
                window.location.reload(true);
            }
        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');
                if (data['messages'] != null && data['messages'] != undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });
}

function checkRow(iid) {
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    let row_id = '';
    if (window.row_id !== null && row_id == '') {
        row_id = window.row_id;
    }
    let cls_log = document.querySelector(`#${row_id} .cls_log`).value;
    $.ajax({
        url: 'model_tuning/check/',
        type: 'POST',
        data: {
            'data': iid,
            'cls_log': cls_log,
            csrfmiddlewaretoken: csrftoken
        },
        dataType: 'json',
        success: function (data) {
            if (data.row_count === 0) {
                document.getElementById(row_id).parentElement.parentElement.remove();
                return
            }
            $('#checkTable').find("tr:gt(0)").remove();
            if (Object.keys(data).length === 0) {
                let txt = gettext('The request does not contain<br>any signature');
                document.getElementById('zoneContainer').innerHTML = "<p style='margin-bottom: 0px; margin-top: 20px; color:#1a5388; font-weight: 600;'>" + txt + "</p>";
                document.getElementById('checkTable').style.display = 'none';
                document.getElementById('checkModalDialog').style.maxWidth = "300px";
                setTimeout(function () {
                    $("#checkModal").modal('hide');
                }, 10000);
                document.getElementById('checkButton').style.display = 'none';
            } else {
                document.getElementById('checkTable').style.display = '';
                document.getElementById('checkButton').style.display = '';
                document.getElementById('checkModalDialog').style.maxWidth = "700px";
                for (a = 0; a < Object.keys(data).length; a++) {
                    var key = Object.keys(data)[a];
                    var val = Object.keys(data[key]);
                    dv = Array.from(new Set(data[key][val]));
                    document.getElementById('zoneContainer').innerHTML = "";
                    for (i = 0; i < dv.length; i++) {
                        rule_id = dv[i]['id'];
                        target = dv[i]['target'];
                        score_k = dv[i]['score_k'];
                        score_v = dv[i]['score_v'];
                        zone = key;
                        flags_val = dv[i]['flags'];
                        if (flags_val == 0) {
                            flags = gettext('No');
                        } else {
                            flags = gettext('Yes');
                        }
                        var r = Math.random().toString(36).substring(7);
                        $('#checkTable').find('tbody').append(`<tr style=""><td>${rule_id}</td><td>${score_k}</td><td>${zone}</td><td>${score_v}</td><td id="target_${r}_${rule_id}"></td><td>${flags}</td></tr>`);
                        $('#target_' + r + '_' + rule_id).text(target);
                    }
                }
            }
            $('#checkModal').modal('show');
        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');
                if (data['messages'] != null && data['messages'] != undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });
}

//check row
$(document).on('click', '.cr', function (e) {
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    $(".pop").popover('hide');
    let id = '';
    let row = e.currentTarget.parentElement.parentElement.parentElement;
    if (row.querySelector('.row_id') !== null) {
        id = row.querySelector('.row_id').id;
    }
    if (window.row_id !== null && id == '') {
        if (e.currentTarget.classList.contains('ck_11')) {
            let log_id = e.target.closest('.attack-table-first-row').id;
            window.row_id = log_id;
        }
        id = window.row_id.split('_')[2];
    }
    checkRow(id);
});

// create export
$(document).on('click', '.ct', function (e) {
    let id = '';
    let row = e.currentTarget.parentElement.parentElement.parentElement;
    if (row.querySelector('.row_id') !== null) {
        id = row.querySelector('.row_id').value;
    }
    if (window.row_id !== null && id == '') {
        id = window.row_id.split('_')[2];
    }
    row = document.querySelector('#' + window.row_id);
    var rt = row.querySelector(".req_type").value;
    var rb = row.querySelector(".row_body").value;
    var mz = row.querySelector(".row_mz").value;
    if (typeof rb !== 'undefined' && rb.length != 0) {
        var b = rb[0].innerHTML;
    } else {
        var b = '';
    }
    var bt = row.querySelector(".row_bt").value;
    if (bt == 11 && rt == 'GET') {
        document.getElementById('exportBody').style.display = 'none';
    } else {
        document.getElementById('exportBody').style.display = '';
    }
    document.getElementById('m_id').value = id;
    document.getElementById('m_bt').value = bt;

    if (bt == 12 || bt == 13 || (bt == 11 && mz)) {
        var obj = {};
        obj.row_id = document.getElementById('m_id').value;
        obj.cls_log = document.querySelector('#' + window.row_id + ' .cls_log').value;
        obj.bt = document.getElementById('m_bt').value;
        obj.fields = [];
        var myJSONText = JSON.stringify(obj);
        sendData(myJSONText, 'model_tuning/export/',)
    } else if (bt == 11) {
        $('#exampleModal').modal('show');
    }
    $('body .popover').remove();
    row.querySelector('.pop').classList.add('disabled');
    row.querySelector('.pop').removeAttribute('data-toggle');
    row.querySelector('.pop').removeAttribute('data-popover-content');
});

// create modal export
$(document).on('click', '.ctm', function (e) {
    var row_id = document.getElementById('detailId').value;
    var ii = document.getElementById(row_id);
    var row = ii.parentElement.parentElement;
    var rt = row.getElementsByClassName("req_type")[0].innerHTML;
    var rb = row.getElementsByClassName("row_body");
    if (typeof rb !== 'undefined' && rb.length != 0) {
        var b = rb[0].innerHTML;
    } else {
        var b = '';
    }
    var bt = row.getElementsByClassName("row_bt")[0].firstElementChild.innerText;
    if (bt == 11 && (b == '' || rt == 'GET')) {
        document.getElementById('exportBody').style.display = 'none';
    } else {
        document.getElementById('exportBody').style.display = '';
    }
    document.getElementById('m_id').value = row.getElementsByClassName("row_id")[0].childNodes[1].id;
    document.getElementById('m_bt').value = row.getElementsByClassName("row_bt")[0].firstElementChild.innerHTML;
    if (bt == 12 || bt == 13) {
        var obj = {};
        obj.row_id = document.getElementById('m_id').value;
        obj.bt = document.getElementById('m_bt').value;
        obj.fields = [];
        var myJSONText = JSON.stringify(obj);
        sendData(myJSONText, 'export/');
        document.getElementById(obj.row_id).parentElement.parentElement.remove();
        $('#detailModal').modal('toggle');
    } else if (bt == 11) {
        $('#detailModal').modal('toggle');
        $('#exampleModal').modal('show');
    }
});

// check modal
$(document).on('click', '.chtm', function (e) {
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    var row_id = document.getElementById('detailId').value;
    $('#detailModal').modal('toggle');
    checkRow(row_id);
});


// export checked
$(document).on('click', '#ec', function (e) {
    var checkedBoxes = getCheckedBoxes("modalCheckBox", 'id');
    var bt = document.getElementById('m_bt').value;
    if (bt == 11 && checkedBoxes != null) {
        var arr = [];
        var obj = {};
        var i;
        for (i = 0; i < checkedBoxes.length; i++) {
            arr.push(checkedBoxes[i].split('_')[1]);
        }
        obj.row_id = document.getElementById('m_id').value;
        obj.fields = arr;
        obj.bt = document.getElementById('m_bt').value;
        var myJSONText = JSON.stringify(obj);
        sendData(myJSONText, 'export/');
        document.getElementById(obj.row_id).parentElement.parentElement.remove();
        // uncheck all
        var checkboxes = document.getElementsByName('modalCheckBox');
        for (var i = 0; i < checkboxes.length; i++) {
            if (checkboxes[i].type == 'checkbox') {
                checkboxes[i].checked = false;
            }
        }
        $('#exampleModal').modal('toggle');
    }
});

// check all
$(document).on('click', '#ca', function () {
    ca = document.getElementById('ca');
    var checktoggle = ca.checked;
    var checkboxes = document.getElementsByName('del_check');
    for (var i = 0; i < checkboxes.length; i++) {
        if (checkboxes[i].type == 'checkbox') {
            checkboxes[i].checked = checktoggle;
        }
    }
});

// delete row from main table
$('.dtr').on('click', function (e) {
    $(".pop").popover('hide');
    var row = e.currentTarget.parentElement.parentElement;
    var row_id = row.getElementsByClassName('row_id')[0].childNodes[1].id;
    dda(row_id);
});

// delete row from modal window
$(document).on('click', '.dtmr', function (e) {
    $('#detailModal').modal('toggle');
    var row_id = document.getElementById('detailId').value;
    dda(row_id);
});

function dda(row_id) {
    var del_arr = [row_id];
    var url_string = window.location.href;
    var url = new URL(url_string);
    var c = url.searchParams.get("t");
    if (del_arr != null) {
        var myJSONText = JSON.stringify(del_arr);
        sendData(myJSONText, 'delete/', c);
        removeRows(del_arr);
        var rows = document.getElementById('myTable').getElementsByTagName("tr").length;
        if (rows == 1) {
            var content = document.getElementById('tableContent');
            // content.remove();
            $.ajax({
                url: window.location.href,
                headers: {
                    "Pragma": "no-cache",
                    "Expires": -1,
                    "Cache-Control": "no-cache"
                }
            }).done(function () {
                window.location.reload(true);
            });
        }
    }
}

// delete checked
$(document).on('click', '#dc', function () {
    var checkedBoxes = getCheckedBoxes("del_check", 'id');
    if (checkedBoxes != null) {
        document.getElementById('deleteConfirm').innerHTML = gettext("Delete record(s)?");
        $('#exampleModalCenter').modal('show');
    }
});

//escape html string
function escapeHtml(string) {
    let entityMap = {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#39;',
        '/': '&#x2F;',
        '`': '&#x60;',
        '=': '&#x3D;',
        "\n": '<br>'
    };

    return String(string).replace(/[&<>"'`=\/]|[\n]/g, function (s) {
        return entityMap[s];
    });
}

function reducing_str(value, if_len=15, num=6) {
    if (value.length > if_len)
        return value.slice(0, num).concat('***').concat(value.slice(-num))
    return value
}

function replacing_first_match_string_in_text(text, pattern=/:/, repl_text=': '){
    const lines = text.split('\n');

    const modified_lines = lines.map(line => line.replace(pattern, repl_text));

    return modified_lines.join('\n');
}

//detail row
$(document).on('click', '.dr', function (e) {
    $(".pop").popover('hide');
    var row_id = document.getElementsByClassName('row-id')[0].childNodes[1].value;
    var params = window.location.search.substr(1);
    var url = row_id + "?" + params;
    $.get('model_tuning' + url)
        .done(function (data) {
            if (data.row_count === 0) {
                document.getElementById(row_id).parentElement.parentElement.remove();
                return
            }

            if (data.bt === 11 || data.bt === 13) {
                $('#detailExport').hide()
            } else {
                $('#detailExport').show()
            }
            var arr = ['args', 'uri', 'cookie', 'ua', 'body', 'referer', 'other_headers'];
            document.getElementById('detailId').value = row_id;
            document.getElementById('detail_row_bt').innerHTML = data.bt;
            if (typeof data.ip !== 'undefined') {
                document.getElementById('detail_row_info').innerHTML = data.ip + '<br>' + data.vhost + '<br>' + data.method + ', ' + data.agent + ', ' + data.waf_id + '<br>' + data.timestamp + '<br>' + data.request_id;
            } else {
                document.getElementById('detail_row_info').innerHTML = data.host + '<br>' + data.req_t + '<br>' + data.id + '<br>' + data.date;
            }
            $("#detail_row_args").html(escapeHtml(data.args));
            $("#detail_row_uri").html(escapeHtml(data.uri));
            $("#detail_row_cookie").html(escapeHtml(data.cookie));
            $("#detail_row_ua").html(escapeHtml(data.ua));
            while (data.body.includes('\n\n') || data.body.includes('\r\n\r\n')) {
                data.body = data.body.replace('\n\n', '\n');
                data.body = data.body.replace('\r\n\r\n', '\r\n');
            }
            $("#detail_row_body").html(escapeHtml(data.body));
            $("#detail_row_referer").html(escapeHtml(data.referer));
            $("#detail_row_other_headers").html(escapeHtml(replacing_first_match_string_in_text(data.other_headers, /:/, ": ")));
            for (var i = 0; i < arr.length; i++) {
                if (data[arr[i]] == '' || data[arr[i]] == '-' || data[arr[i]] == null || data[arr[i]] == " ") {
                    document.getElementById('detail_row_' + arr[i]).style.display = 'none';
                    document.getElementById('detail_head_' + arr[i]).style.display = 'none';
                } else {
                    document.getElementById('detail_row_' + arr[i]).style.display = '';
                    document.getElementById('detail_head_' + arr[i]).style.display = '';
                }
            }
            $('#detailModal').modal('show');
        });
});

$("#searchForm").submit(function (eventObj) {
    var url_string = window.location.href;
    var url = new URL(url_string);
    var c = url.searchParams.get("t");
    $('<input />').attr('type', 'hidden')
        .attr('name', "t")
        .attr('value', c)
        .appendTo('#searchForm');
    return true;
});

$(document).on('click', '.edr', function (e) {
    $('#detailModal').modal('toggle');
    var row_id = document.getElementById('detailId').value;
    var params = window.location.search.substr(1);
    var url = "/" + row_id + "?" + params;
    $.get('model_tuning' + url)
        .done(function (data) {
            $('#editID').val(row_id);
            $('#editHost').val(data.host);
            $('#editUri').val(data.uri);
            $('#editArgs').val(data.args);
            while (data.body.includes('\n\n') || data.body.includes('\r\n\r\n')) {
                data.body = data.body.replace('\n\n', '\n');
                data.body = data.body.replace('\r\n\r\n', '\r\n');
            }
            $('#editBody').val(data.body);
            $('#editUA').val(data.ua);
            $('#editCookie').val(data.cookie);
            $('#editContt').val(data.cont_t);
            $('#editRef').val(data.referer);
            if ($('#editUri').val().length == 0) {
                $('.edit-uri').hide();
            } else {
                $('.edit-uri').show();
            }
            if ($('#editArgs').val().length == 0) {
                $('.edit-args').hide();
            } else {
                $('.edit-args').show();
            }
            if ($('#editBody').val().length == 0) {
                $('.edit-body').hide();
            } else {
                $('.edit-body').show();
            }
            if ($('#editUA').val().length == 0) {
                $('.edit-ua').hide();
            } else {
                $('.edit-ua').show();
            }
            if ($('#editCookie').val().length == 0) {
                $('.edit-cookie').hide();
            } else {
                $('.edit-cookie').show();
            }
            if ($('#editContt').val().length == 0) {
                $('.edit-contt').hide();
            } else {
                $('.edit-contt').show();
            }
            if ($('#editRef').val().length == 0) {
                $('.edit-ref').hide();
            } else {
                $('.edit-ref').show();
            }
            if ($('#editHeaders').val().length == 0) {
                $('.edit-headers').hide();
            } else {
                $('.edit-headers').show();
            }
            $('#editModal').modal('show');
        });
});


$(document).on('click', '.ednr', function (e) {
    $('#detailModal').modal('toggle');
    var row_id = document.getElementById('detailId').value;
    var params = window.location.search.substr(1);
    var url = "/" + row_id + "?" + params;
    document.getElementById('bt-edit-form').action = '/editfn/';
    $.get('model_tuning/' + url)
        .done(function (data) {
            $('#editID').val(row_id);
            $('#editHost').val(data.host);
            $('#editUri').val(data.uri);
            $('#editArgs').val(data.args);
            while (data.body.includes('\n\n') || data.body.includes('\r\n\r\n')) {
                data.body = data.body.replace('\n\n', '\n');
                data.body = data.body.replace('\r\n\r\n', '\r\n');
            }
            $('#editBody').val(data.body);
            $('#editUA').val(data.ua);
            $('#editCookie').val(data.cookie);
            $('#editContt').val(data.cont_t);
            $('#editRef').val(data.referer);
            $('#editHeaders').val(data.other_headers);
            if ($('#editUri').val().length == 0) {
                $('.edit-uri').hide();
            } else {
                $('.edit-uri').show();
            }
            if ($('#editArgs').val().length == 0) {
                $('.edit-args').hide();
            } else {
                $('.edit-args').show();
            }
            if ($('#editBody').val().length == 0) {
                $('.edit-body').hide();
            } else {
                $('.edit-body').show();
            }
            if ($('#editUA').val().length == 0) {
                $('.edit-ua').hide();
            } else {
                $('.edit-ua').show();
            }
            if ($('#editCookie').val().length == 0) {
                $('.edit-cookie').hide();
            } else {
                $('.edit-cookie').show();
            }
            if ($('#editContt').val().length == 0) {
                $('.edit-contt').hide();
            } else {
                $('.edit-contt').show();
            }
            if ($('#editRef').val().length == 0) {
                $('.edit-ref').hide();
            } else {
                $('.edit-ref').show();
            }
            if ($('#editHeaders').val().length == 0) {
                $('.edit-headers').hide();
            } else {
                $('.edit-headers').show();
            }
            $('#editModal').modal('show');
        });
});

$(document).on('click', '.er', function (e) {
    let row_id = '';
    try {
        row_id = document.getElementsByClassName('row-id')[0].childNodes[1].value;
    } catch (err) {
        let row = e.currentTarget.parentElement.parentElement;
        row_id = '';
        if (row.querySelector('.row_id') !== null) {
            row_id = row.querySelector('.row_id').value;
        }
    }
    if (window.row_id !== null && row_id == '') {
        row_id = window.row_id.split("_")[window.row_id.split("_").length - 1];
    }

    var params = window.location.search.substr(1);
    var url = '';
    if (params === '') {
        url = "/" + row_id + "?edit=true";
    } else {
        url = "/" + row_id + "?" + params + '&edit=true'
    }
    if (!window.location.href.includes('admin_panel')) {
        let cls_log = document.querySelector('#' + window.row_id + ' .cls_log').value;
        url = url + "&cls_log=" + cls_log;
    }
    $.get(url_for_adp('model_tuning' + url))
        .done(function (data) {
            if (data.row_count === 0) {
                //document.getElementById(row_id).parentElement.parentElement.remove();
                return
            }
            $('#editID').val(data.row_id);
            $('#editCLS').val(data.cls_log);
            $('#editUri').val(data.uri);
            $('#editArgs').val(data.args);
            $('#editBody').val(data.body);
            $('#editUA').val(data.ua);
            $('#editCookie').val(data.cookie);
            $('#editRef').val(data.referer);
            $('#editHeaders').val(data.other_headers);
            var arr = data.mz.split("|");
            //hiding empty inputs
            if ($('#editUri').val().length == 0 || arr.includes('uri') == false) {
                $('.edit-uri').hide();
            } else {
                $('.edit-uri').show();
            }
            if ($('#editBody').val().length == 0 || arr.includes('body') == false) {
                $('.edit-body').hide();
            } else {
                $('.edit-body').show();
            }
            if ($('#editArgs').val().length == 0 || arr.includes('args') == false) {
                $('.edit-args').hide();
            } else {
                $('.edit-args').show();
            }
            if ($('#editUA').val().length == 0 || arr.includes('ua') == false) {
                $('.edit-ua').hide();
            } else {
                $('.edit-ua').show();
            }
            if ($('#editCookie').val().length == 0 || arr.includes('cookie') == false) {
                $('.edit-cookie').hide();
            } else {
                $('.edit-cookie').show();
            }
            if ($('#editRef').val().length == 0 || arr.includes('referer') == false) {
                $('.edit-ref').hide();
            } else {
                $('.edit-ref').show();
            }
            if ($('#editHeaders').val().length == 0 || arr.includes('other_headers') == false) {
                $('.edit-headers').hide();
            } else {
                $('.edit-headers').show();
            }
            window.row_edit_export = row_id;
            $('#editModal').modal('show');
        });
});


$(document).on('click', '.enr', function (e) {
    try {
        var row_id = document.getElementsByClassName('row-id')[0].childNodes[1].value;
    } catch (err) {
        var row = e.currentTarget.parentElement.parentElement;
        var row_id = row.getElementsByClassName('row_id')[0].childNodes[1].id;
    }
    document.getElementById('bt-edit-form').action = '/editfn/';
    var params = window.location.search.substr(1);
    var url = "model_tuning/" + row_id + "?" + params;
    $.get(url)
        .done(function (data) {
            $('#editID').val(row_id);
            $('#editUri').val(data.uri);
            $('#editArgs').val(data.args);
            $('#editBody').val(data.body);
            $('#editUA').val(data.ua);
            $('#editCookie').val(data.cookie);
            $('#editRef').val(data.referer);
            $('#editHeaders').val(data.other_headers);
            // var arr = data.mz.split("|");
            //hiding empty inputs
            if ($('#editUri').val().length == 0 || data.uri === null) {
                $('.edit-uri').hide();
            } else {
                $('.edit-uri').show();
            }
            if ($('#editBody').val().length == 0 || data.body === null) {
                $('.edit-body').hide();
            } else {
                $('.edit-body').show();
            }
            if ($('#editArgs').val().length == 0 || data.args === null) {
                $('.edit-args').hide();
            } else {
                $('.edit-args').show();
            }
            if ($('#editUA').val().length == 0 || data.ua === null) {
                $('.edit-ua').hide();
            } else {
                $('.edit-ua').show();
            }
            if ($('#editCookie').val().length == 0 || data.cookie === null) {
                $('.edit-cookie').hide();
            } else {
                $('.edit-cookie').show();
            }
            if ($('#editRef').val().length == 0 || data.referer === null) {
                $('.edit-ref').hide();
            } else {
                $('.edit-ref').show();
            }
            if ($('#editHeaders').val().length == 0 || data.other_headers === null) {
                $('.edit-headers').hide();
            } else {
                $('.edit-headers').show();
            }
            $('#editModal').modal('show');
        });
});


$(document).on('click', '.custom_check', function (e) {
    var obj = {};
    obj.uri = document.getElementById('customUri').value;
    obj.args = document.getElementById('customArgs').value;
    obj.other_headers = document.getElementById('customHeaders').value;
    obj.body = document.getElementById('customBody').value;
    var myJSONText = JSON.stringify(obj);
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    $.ajax({
        url: 'model_tuning/custom_check/',
        type: 'POST',
        data: {
            'data': myJSONText,
            csrfmiddlewaretoken: csrftoken,
        },
        dataType: 'json',
        success: function (data) {
            $('#checkTable').find("tr:gt(0)").remove();
            if (Object.keys(data).length === 0) {
                document.getElementById('zoneContainer').innerHTML = "<p style='margin-bottom: 0px; margin-top: 20px; color:#1a5388; font-weight: 600;'>The request  does not contain any signature</p>";
                document.getElementById('checkTable').style.display = 'none';
                document.getElementById('checkModalDialog').style.maxWidth = "300px";
                setTimeout(function () {
                    $("#checkModal").modal('hide');
                    $('#customCheckModal').modal('show');
                }, 10000);
                document.getElementById('checkButton').style.display = 'none'
            } else {
                document.getElementById('checkTable').style.display = '';
                document.getElementById('checkButton').style.display = '';
                document.getElementById('checkModalDialog').style.maxWidth = "700px";
                for (a = 0; a < Object.keys(data).length; a++) {
                    var key = Object.keys(data)[a];
                    var val = Object.keys(data[key]);
                    dv = Array.from(new Set(data[key][val]));
                    document.getElementById('zoneContainer').innerHTML = "";
                    for (i = 0; i < dv.length; i++) {
                        rule_id = dv[i]['id'];
                        target = dv[i]['target'];
                        score_k = dv[i]['score_k'];
                        score_v = dv[i]['score_v'];
                        zone = key;
                        flags_val = dv[i]['flags'];
                        if (flags_val == 0) {
                            flags = gettext('No');
                        } else {
                            flags = gettext('Yes');
                        }
                        var r = Math.random().toString(36).substring(7);
                        $('#checkTable').find('tbody').append(`<tr style="font-size:80%"><td>${rule_id}</td><td>${zone}</td><td>${score_k}</td><td>${score_v}</td><td id="target_${r}_${rule_id}"></td><td>${flags}</td></tr>`);
                        $('#target_' + r + '_' + rule_id).text(target);
                    }
                }
            }
            $('#customCheckModal').modal('toggle');
            var button = document.getElementById("checkButton");
            var clickFunction = function (event) {
                $('#customCheckModal').modal('show');
                button.removeEventListener('click', clickFunction, false);
            };
            button.addEventListener("click", clickFunction, false);
            $('#checkModal').modal('show');
        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');
                if (data['messages'] != null && data['messages'] != undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });
});


$(document).on('click', '.attack-table-first-row .pop', function (e) {
    let log_id = e.target.closest('.attack-table-first-row').id;
    window.row_id = log_id;
});

$(document).on('click', '.edit_export', function () {
    let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    let data = $('#editForm').serialize();
    let row = document.querySelector('#row_Logs_' + window.row_edit_export);
    $.ajax({
        url: 'model_tuning/edit_export/',
        type: 'POST',
        data: $('#editForm').serialize(),
        success: function (data) {
            $('body .popover').remove();
            row.querySelector('.pop').classList.add('disabled');
            row.querySelector('.pop').removeAttribute('data-toggle');
            row.querySelector('.pop').removeAttribute('data-popover-content');
            $(document.querySelector('#editForm').closest('.modal')).modal('hide');
        },
        error: function (response) {
            try {
                let data = JSON.parse(response.responseText);
                let block_messages = document.getElementById('messages-block');
                if (data['messages'] != null && data['messages'] != undefined) {
                    for (let message of data['messages']) {
                        let container = document.createElement('div');
                        container.className = 'container-fluid p-0';
                        let alert_div = '<div class="alert ' + message.tags + ' alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                            '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                            '                  <span aria-hidden="True">&times;</span>\n' +
                            '                </button>\n' +
                            '                ' + message.message + '\n' +
                            '              </div>'
                        $(container).html(alert_div);
                        block_messages.appendChild(container);

                    }
                }

            } catch (e) {

            }

        }
    });
});