const list_type_bool_keys = ['proxy_intercept_error', 'ssl_stapling', 'backup', 'down', 'ssl']
const list_type_list_keys = [
    'ssl_ciphers', 'ssl_protocols', 'dns', 'index', 'set_real_ip_from', 'upstream', 'location', 'proxy_set_header',
    'set_real_ip_from'
]
const list_type_int_keys = [
    'fail_timeout', 'max_fails', 'weight', 'client_buffer_body_size', 'client_max_body_size', 'client_body_timeout',
    'listen_port', 'ssl_timeout', 'ssl_session_cache_size', 'proxy_connect_timeout', 'proxy_send_timeout',
    'proxy_read_timeout', 'port', 'size'
]
const list_type_float_keys = ['proxy_http_version',]
const list_type_dynamic_keys = ['servers',]


function show_messages_from_response_error_ssl(data, attr) {
    try {
        if (typeof (data) == "string") {
            data = JSON.parse(data);
        }
        let block_messages = document.getElementById(`messages-block_${attr}`);
        if (data['messages'] != null && data['messages'] != undefined) {

            let container = document.createElement('div');
            container.className = 'container-fluid p-0';
            let alert_div = '<div class="alert alert-dismissible" role="alert" style="margin-bottom: 10px">\n' +
                '                <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n' +
                '                </button>\n' +
                '                ' + data['messages'] + '\n' +
                '              </div>'
            $(container).html(alert_div);
            block_messages.appendChild(container);
            setTimeout(function () {
                container.remove()
            }, 10000);


        }

    } catch (e) {

    }

}

let data_localization = ''

$(document).ready(function () {
    let home = $('#home_page').attr('data-home')
    let data;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    $.ajax({
        url: home + 'nginx/get_settings_info/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            data = $.parseJSON(response);
            data_localization = data

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }

    });
    $('.settings_info').on('click', function (e) {

        let element_class = e.currentTarget.className;
        let settings_name = e.currentTarget.closest('.row').querySelector('input[name=settings_name]').value;
        let info_text;

        if (element_class.includes('vhosts_list_question')) {
            info_text = data[settings_name];
        } else {
            info_text = settings_name
        }

        $('#modal_settings_info_body').html(data[settings_name]).show();

        $('#modal_settings_info').modal('show');
    });


});

function show_info_setting(e){

        let element_class = e.currentTarget.className;
        let settings_name = e.currentTarget.closest('.row').querySelector('input[name=settings_name]').value;
        let info_text;

        if (element_class.includes('vhosts_list_question')) {
            info_text = data_localization[settings_name];
        } else {
            info_text = settings_name
        }

        $('#modal_settings_info_body').html(data_localization[settings_name]).show();

        $('#modal_settings_info').modal('show');
}

$(document).on('mouseover', '.settings_label', function (e) {
    if (this.querySelector('.settings_info') != null) {
        $(this.querySelector('.settings_info')).show();
    }
}).on('mouseout', '.settings_label', function (e) {
    if (this.querySelector('.settings_info') != null) {
        $(this.querySelector('.settings_info')).hide();
    }
});

$(document).on('click', '.select-vhost-block .selected-vhost', function (e) {
    let list_vhost = this.closest('.select-vhost-block').querySelector('.list-vhost');
    let icon = $(this).find('.dropdown_buttons_nginx_svg');

    $(list_vhost).toggle();
    if ($(icon).attr('data-rotate') === 'no'){
        $(icon).css('transform', 'rotate(180deg)')
        $(icon).attr('data-rotate','yes')
    }else{
        $(icon).css('transform', 'rotate(360deg)')
        $(icon).attr('data-rotate','no')
    }

});

$(document).on('click', function (e) {
    if (e.target.closest('.select-vhost-block') == null && !e.target.classList.contains('.select-vhost-block')) {
        $('.list-vhost').each(function () {
            $(this).hide('slow');
        });

    }
});

$(document).on('click', '.list-vhost-item', function (e) {
    let vhost_block = this.closest('.select-vhost-block');
    let span_selected_vhost = vhost_block.querySelector('.selected-vhost span');

    span_selected_vhost.textContent = this.textContent;

});
function choose_vhost_ssl(cert, vhost, elem){

    $('.ssl_cert_vhost_nginx').text(cert)
    let home = document.getElementById('home').title;
    ssl_choose = {
        'name': vhost,
        'certificate_name': cert
    }

    $.ajax({
        url: home + 'nginx/vhost_tab_content/',
        headers: {'X-CSRFToken': csrftoken},
        data: {
                ssl: JSON.stringify(ssl_choose),
                vhost: vhost
            },
        type: "POST",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert(response['messages']);
                return;
            }else{
                document.getElementById('tab_content_nginx_vhost').innerHTML = response
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'vhost');
        }
    });
}

function choose_vhost_dhparam_name(cert, vhost, elem){

    $('.dhparam_name_cert_vhost_nginx').text(cert)
    let home = document.getElementById('home').title;
    ssl_choose = {
        'name': vhost,
        'dhparam_name': cert
    }

    $.ajax({
        url: home + 'nginx/vhost_tab_content/',
        headers: {'X-CSRFToken': csrftoken},
        data: {
                dh_param: JSON.stringify(ssl_choose),
                vhost: vhost
            },
        type: "POST",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert(response['messages']);
                return;
            }else{
                document.getElementById('tab_content_nginx_vhost').innerHTML = response
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'vhost');
        }
    });
}

function set_param_main(data, modal){

    let home = document.getElementById('home').title;
    let url = home + '/nginx/tab_main_nginx/';

    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        data: {
            data: JSON.stringify(data),
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert(response['messages']);
                return;
            }
            modal.modal('hide')
            document.getElementById('main_all_nginx').innerHTML = response
            if (response.status === 'success') {
            } else if (response.status === 'error') {
                $('#error_edit_setting').css({'display': 'block'});
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });

}


function showModalSettingsNginx(name_param, key, elem, zone=null, none_split=null) {
    if(name_param === 'locations'){
        $(`#common_input_settings`).attr('data-key',key)
        $(`#common_input_settings`).attr('data-zone',zone)

     };
     if(name_param === 'ssl'){
        $(`#common_input_settings`).attr('data-key',key)
        $(`#common_input_settings`).attr('data-zone',zone)

     };
     if(name_param === 'main'){
        $(`#common_input_settings`).attr('data-key',key)
        $(`#common_input_settings`).attr('data-zone',zone)

     };
    let parent = $(elem).parent().find('.hide_items').find('p')
    let arr = []
    let str = ''
    for (i of parent){
        let index = $(parent).index(i)
        if(none_split){
            if (index == parent.length-1){
                if (none_split === 'split'){
                    str = $(i).text().replace(/\n/g,'').replace(/ /g,'')
                }else{
                str = $(i).text().replace(/\n/g,'')
                    }
            }else{
                if (none_split === 'split'){
                    str = $(i).text().replace(/\n/g,'').replace(/ /g,'') + ','
                }else{
                str = $(i).text().replace(/\n/g,'') + ','
                    }
            }
        }else{
            if ($(i).attr('data-degree')){
                str = $(i).text().replace(/ /g,'').replace(/\n/g,'') + 'ssl'
            }else{
                str = $(i).text().replace(/ /g,'').replace(/\n/g,'')
            }
        }
        arr.push(str)
    }
    let modal = $('#edit_setting_nginx');
    let settings_name_input = $('#edit_setting_nginx #setting_name');
    let key_input = $('#edit_setting_nginx #key_id');
    let input_settings = $(`#nginx_${name_param}_input_${key}`);
    let span_settings = $(`#nginx_${name_param}_text_${key}`);
    let common_input = $(`#common_input_settings`);

    key_input.val(key);
    $(common_input).attr('data-values',name_param)
    settings_name_input.val(name_param);

    common_input.val(arr.join(" "));
    window.current_table = 'nginx';
    $("body").css({ overflow: 'hidden' })
    modal.modal('toggle');
}


function save_settings() {
    let key_id_requests = $('.key_id_requests').attr('data-key-id')
    let modal = $('#edit_setting_nginx');
    let settings_name = $('#edit_setting_nginx #setting_name').val();
    let key_id = $('#edit_setting_nginx #key_id').val();
    let input_settings = $(`#nginx_${settings_name}_input_${key_id}`);
    let span_settings = $(`#nginx_${settings_name}_text_${key_id}`);
    let common_input = $(`#common_input_settings`);
    const current_table = window.current_table;
    const csrftoken = document.querySelector('input[name=csrfmiddlewaretoken]').value;
    let data_values_input = $(common_input).attr('data-values')
    let vhost_value = $('.select-vhost-block').find('span[data-vhost]').attr('data-vhost')
    let data = {values: $(`#common_input_settings`).val(),
                tag: $(common_input).attr('data-values'),
                vhost: vhost_value
    };
    if($(common_input).attr('data-values') === 'locations'){
        $(`#common_input_settings`).attr('data-key')
        $(`#common_input_settings`).attr('data-zone')
        data = {values: $(`#common_input_settings`).val(),
                    tag: $(common_input).attr('data-values'),
                    vhost: vhost_value,
                    location: $(`#common_input_settings`).attr('data-zone'),
                    key: $(`#common_input_settings`).attr('data-key')
        }
    }if($(common_input).attr('data-values') === 'ssl'){
        $(`#common_input_settings`).attr('data-key')
        $(`#common_input_settings`).attr('data-zone')
        data = {
                    vhost: vhost_value,
                    values: $(common_input).attr('data-values'),
                    param_ssl: $(`#common_input_settings`).attr('data-zone'),
                    value_ssl: $(`#common_input_settings`).val()
        }
    }
    if($(common_input).attr('data-values') === 'main'){
     $(`#common_input_settings`).attr('data-key')
        $(`#common_input_settings`).attr('data-zone')
        data = {

                    param_main: $(`#common_input_settings`).attr('data-zone'),
                    value_main: $(`#common_input_settings`).val()
        }
        set_param_main(data, modal)
    }
    if($(common_input).attr('data-values') !== 'main'){
    let home = document.getElementById('home').title;
    let url = home + '/nginx/vhost_tab_content/?set_param=set_param' + `$vhost=${vhost_value}` + `$key_query_id=${key_id_requests}`;

    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        data: {
            key: key_id,
            data: JSON.stringify(data),
            table: current_table,
            vhost: vhost_value
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response, 'vhost');
                return;
            }
            document.getElementById('tab_content_nginx_vhost').innerHTML = response
            modal.modal('hide')
            if (response.status === 'success') {
                document.getElementById('tab_content_nginx_vhost').innerHTML = response
            } else if (response.status === 'error') {
                $('#error_edit_setting').css({'display': 'block'});
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
    }

}

$(document).on('click', '.modal_nginx_all', function (e) {
    if ($(e.target).closest(".modal_nginx").length) {
            return;
        }
    $('.modal_nginx_all').hide()
    localStorage.clear()

})

$(document).on('click', '.tab_vhost_list', function () {
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/main_vhosts/`).then(res => res.text()).then(html => {document.getElementById('content_nginx_main').innerHTML = html;})
})

$(document).on('click', '.tab_ssl_list', function () {
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/main_ssl/`).then(res => res.text()).then(html => {document.getElementById('content_nginx_main').innerHTML = html;})
})

$(document).on('click', '.tab_upstreams_list', function () {
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/main_upstream/`).then(res => res.text()).then(html => {document.getElementById('content_nginx_main').innerHTML = html;})
})
$(document).on('click', '.tab_location_list', function () {
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/main_location/`).then(res => res.text()).then(html => {document.getElementById('content_nginx_main').innerHTML = html;})
})

function info_host(elem){
    if($(elem).hasClass('arrow_nginx_vhost_sammary')){
        elem = $(elem).parent().parent().parent()
    }else{
        elem = $(elem).parent().parent()
    }
    if($(elem).attr('data-vision')==='off'){
        $(elem).css('border-bottom', '8px solid #D5E4F3')
        $(elem).find('.info_host_nginx').show()
        $(elem).attr('data-vision','on')
        $(elem).find('.arrow_nginx_vhost_sammary').css('transform','rotate(360deg)')
    }else{
        $(elem).css('border-bottom', '')
        $(elem).find('.info_host_nginx').hide()
        $(elem).attr('data-vision','off')
        $(elem).find('.arrow_nginx_vhost_sammary').css('transform','rotate(90deg)')
    }
}

function info_ssl(elem){
    if($(elem).hasClass('arrow_nginx_ssl_sammary')){
            elem = $(elem).parent().parent().parent()
        }else{
            elem = $(elem).parent().parent()
        }
        if($(elem).attr('data-vision')==='off'){
            $(elem).css('border-bottom', '8px solid #D5E4F3')
            $(elem).find('.info_ssl_nginx').show()
            $(elem).attr('data-vision','on')
            $(elem).find('.arrow_nginx_ssl_sammary').css('transform','rotate(360deg)')
        }else{
            $(elem).css('border-bottom', '')
            $(elem).find('.info_ssl_nginx').hide()
            $(elem).attr('data-vision','off')
            $(elem).find('.arrow_nginx_ssl_sammary').css('transform','rotate(90deg)')
        }
}
function info_dh_param(elem){
    if($(elem).hasClass('arrow_nginx_dh_param_sammary')){
            elem = $(elem).parent().parent().parent()
        }else{
            elem = $(elem).parent().parent()
        }
        if($(elem).attr('data-vision')==='off'){
            $(elem).css('border-bottom', '8px solid #D5E4F3')
            $(elem).find('.info_dh_param_nginx').show()
            $(elem).attr('data-vision','on')
            $(elem).find('.arrow_nginx_dh_param_sammary').css('transform','rotate(360deg)')
        }else{
            $(elem).css('border-bottom', '')
            $(elem).find('.info_dh_param_nginx').hide()
            $(elem).attr('data-vision','off')
            $(elem).find('.arrow_nginx_dh_param_sammary').css('transform','rotate(90deg)')
        }
}

function info_upstreams(elem){
    if($(elem).hasClass('arrow_nginx_upstreams_sammary')){
            elem = $(elem).parent().parent().parent()
        }else{
            elem = $(elem).parent().parent()
        }
        if($(elem).attr('data-vision')==='off'){
            $(elem).css('border-bottom', '8px solid #D5E4F3')
            $(elem).find('.info_upstreams_nginx').show()
            $(elem).attr('data-vision','on')
            $(elem).find('.arrow_nginx_upstreams_sammary').css('transform','rotate(360deg)')
        }else{
            $(elem).css('border-bottom', '')
            $(elem).find('.info_upstreams_nginx').hide()
            $(elem).attr('data-vision','off')
            $(elem).find('.arrow_nginx_upstreams_sammary').css('transform','rotate(90deg)')
        }
}

function info_location(elem){
    if($(elem).hasClass('arrow_nginx_location_sammary')){
            elem = $(elem).parent().parent().parent()
        }else{
            elem = $(elem).parent().parent()
        }
        if($(elem).attr('data-vision')==='off'){
            $(elem).css('border-bottom', '8px solid #D5E4F3')
            $(elem).find('.info_location_nginx').show()
            $(elem).attr('data-vision','on')
            $(elem).find('.arrow_nginx_location_sammary').css('transform','rotate(360deg)')
        }else{
            $(elem).css('border-bottom', '')
            $(elem).find('.info_location_nginx').hide()
            $(elem).attr('data-vision','off')
            $(elem).find('.arrow_nginx_location_sammary').css('transform','rotate(90deg)')
        }
}
////////////////////////////////////////modal location////////////////////////////////////////////
function clear_all_element(){
    $('.tab_location_list_root').removeClass('active')
    $('.tab_location_list_proxy_pass').removeClass('active')
    $('.tab_location_list_alias').removeClass('active')
    $('.tab_location_list_memcached_pass').removeClass('active')
    $('#root_location').css('display','none')
    $('#proxy_pass_location').css('display','none')
    $('#alias_location').css('display','none')
    $('#memcached_pass_location').css('display','none')
    $('#root_location').empty()
    $('#proxy_pass_location').empty()
    $('#memcached_pass_location').empty()
    $('#alias_location').empty()
}
function show_modal_nginx_location(zone,value,elem, vhost){
    let h4 = $('h4').attr('data-vhost', vhost)
    let input = $('#input_location_main_modal')
    $(input).val(value)
    $('.modal_main_location').show()
    let root = $(elem).parent().parent().parent()
    let table = $(root).find('.info_location_nginx').find('.location_row')
    let arr_values = []
    let keys = $(table).find('.keys_for_search')
    for (key of keys){
        let key_text = $(key).text().replace(/ /g,'').replace(/\n/g,'')
        let values = $(table).find(`.text_location_open_` + `${$(key).text().replace(/ /g,'').replace(/\n/g,'')}`)

        let loc_arr = {}
        loc_arr[key_text] = []

        for (val of values){

            loc_arr[key_text].push($(val).text().replace(/ /g,'').replace(/\n/g,''))

            }
        arr_values.push(loc_arr)


    }
    clear_all_element()


    if($(root).attr('data-pass_type') === 'root'){
        for (i of arr_values){
            let values_for_input = i[Object.keys(i)[0]].join(" ")
            $('#root_location').append('<div style = "margin-left: 60px;">'+
                            '<p style = "display: inline-block; float: left;position: relative; top:15px">'+Object.keys(i)[0]+'</p>'+
                            `<input class="input_location_${Object.keys(i)[0]}" onfocus="$(this).css('color','#1a5287')" onfocusout="$(this).css('color','grey')" style = "margin-right: 213px;display: inline-block; float: right;margin-top: 10px;background-color:white;width:300px;height: 32px;border: 1.5px solid #D5E4F3;border-radius:4px;text-align: center;color: grey;" value = "${values_for_input}" type="text" name="name" ></div>`)
        }
        let root_location = $('#root_location')
        let text = $(root).find('.info_location_nginx').find('.text_location_open')
        $('#root_location').css('display','flex')
        $('.tab_location_list_root').addClass('active')
    }else if($(root).attr('data-pass_type') === 'proxy_pass'){
        $('#proxy_pass_location').css('display','flex')
        $('.tab_location_list_proxy_pass').addClass('active')
        for (i of arr_values){
            let values_for_input = i[Object.keys(i)[0]].join(" ")
            if (Object.keys(i)[0] !== 'proxy_set_header'){
            $('#proxy_pass_location').append('<div style = "margin-left: 20px;">'+
                            '<p style = "display: inline-block; float: left;position: relative; top:15px">'+Object.keys(i)[0]+'</p>'+
                            `<input class="input_location_${Object.keys(i)[0]}" onfocus="$(this).css('color','#1a5287')" onfocusout="$(this).css('color','grey')" style = "margin-right: 213px;display: inline-block; float: right;margin-top: 10px;background-color:white;width:300px;height: 32px;border: 1.5px solid #D5E4F3;border-radius:4px;text-align: center;color: grey;" value = "${values_for_input}" type="text" name="name" ></div>`)
            }else{
                let key = i[Object.keys(i)[0]]

                $('#proxy_pass_location').append(`
                        <p style="margin-left: -573px;display: inline-block; float: left;position: relative; top:15px">proxy_set_header</p><div data-show="hide" onclick="show_info_about_upstream(this,event)" class="dropdown button_upstreams_modal proxy_set_header_for_add_location_in_vhosts" style="padding-bottom: 20px; margin-right: 340px; float: right; margin-left: 173px; position: relative; top: -15px; width: 150px;">
                    <div style="top: 5px;position: relative;margin-bottom: -28px;display: flex;flex-direction: column; width:300px;border-radius: 7px;margin-left: 42px;" class="btn_nginx_menu">
                        <div>

                            <svg style="transform:rotate(270deg);display:inline-block" class="dropdown_buttons_nginx_svg" xmlns="http://www.w3.org/2000/svg" height="1em" viewBox="0 0 512 512">
                                  <path d="M233.4 406.6c12.5 12.5 32.8 12.5 45.3 0l192-192c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L256
                                  338.7 86.6 169.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3l192 192z"></path></svg>
                        </div>
                        <div style="display: none;text-align: left" class="info_about_upstream">
                            <div class="all_values_header_proxy" style="margin-top: 10px;position: relative;top: 5px;">
                                <div class = "value_location_vhost" >
                                    </div>
                                <i onclick="add_header_proxy_location_modal(this)" class="fa fa-plus"></i>
                            </div>
                        </div>
                    </div>`)

                for (i of key) {
                    $('.value_location_vhost').append(`<div class="add_value_proxy_header">
                                <input class = "input_add_location_host_proxy_header" type="text" name="name" value = '${i}' style="border: 1.5px solid #D5E4F3;border-radius: 4px;display: inline-block;">
                                <svg style="margin-left:200px;position:relative;top:-20px" onclick="delete_header_proxy_location_modal(this)" class="svg_icon_nginx" xmlns="http://www.w3.org/2000/svg" height="1em" viewBox="0 0 448 512">
                <style>svg{fill:#38507a}</style><path d="M135.2 17.7L128 32H32C14.3 32 0 46.3 0 64S14.3 96 32
                96H416c17.7 0 32-14.3 32-32s-14.3-32-32-32H320l-7.2-14.3C307.4 6.8 296.3 0 284.2 0H163.8c-12.1
                0-23.2 6.8-28.6 17.7zM416 128H32L53.2 467c1.6 25.3 22.6 45 47.9 45H346.9c25.3 0 46.3-19.7 47.9-45L416 128z"></path></svg><br>
                                    </div>`)
                }
            }
        }
    }else if($(root).attr('data-pass_type') === 'alias'){
         $('#alias_location').css('display','flex')
         $('.tab_location_list_alias').addClass('active')
        for (i of arr_values){
            let values_for_input = i[Object.keys(i)[0]].join(" ")
            $('#alias_location').append('<div style = "margin-left: 20px;">'+
                            '<p style = "display: inline-block; float: left;position: relative; top:15px">'+Object.keys(i)[0]+'</p>'+
                            `<input class="input_location_${Object.keys(i)[0]}" onfocus="$(this).css('color','#1a5287')" onfocusout="$(this).css('color','grey')" style = "margin-right: 213px;display: inline-block; float: right;margin-top: 10px;background-color:white;width:300px;height: 32px;border: 1.5px solid #D5E4F3;border-radius:4px;text-align: center;color: grey;" value = "${values_for_input}" type="text" name="name" ></div>`)

        }
    }else if($(root).attr('data-pass_type') === 'memcached_pass'){
         $('#memcached_pass_location').css('display','flex')
         $('.tab_location_list_memcached_pass').addClass('active')
        for (i of arr_values){
            let values_for_input = i[Object.keys(i)[0]].join(" ")
            $('#memcached_pass_location').append('<div style = "margin-left: 20px;">'+
                            '<p style = "display: inline-block; float: left;position: relative; top:15px">'+Object.keys(i)[0]+'</p>'+
                            `<input class="input_location_${Object.keys(i)[0]}" onfocus="$(this).css('color','#1a5287')" onfocusout="$(this).css('color','grey')" style = "margin-right: 213px;display: inline-block; float: right;margin-top: 10px;background-color:white;width:300px;height: 32px;border: 1.5px solid #D5E4F3;border-radius:4px;text-align: center;color: grey;" value = "${values_for_input}" type="text" name="name" ></div>`)

        }
        }
}
function delete_server_position_in_upstreams(element) {
    $(element).parent().parent().remove()
    $('.add_upstreams_server').css('margin-top', '20px')

}

function add_server_upstreams(elem){
    let server = $('#input_upstreams_main_modal').val()
    let element_for_append = ''
    let element = ''
    if ($('h4').hasClass('add_new_upstreams')) {
        element_for_append = $('.servers_upstreams_clear_row')
        $(element_for_append[element_for_append.length-1]).css('margin-left', '175px')
        element = $(element_for_append[element_for_append.length-1]).clone()
    }else{
        element_for_append = $(elem).parent().find(`[data-values-upstreams=${server}]`)
        element = $(element_for_append[element_for_append.length-1]).clone()
    }
        $($(elem).parent().find('.values_modal')).append(element)
        $(element).find('.input_upstreams_main_modal_server').val('')
}
function show_input_dhparam_main(elem, event){
    let data_open = $(elem).attr('data-open')

    if (data_open === 'off'){
        $(elem).find('.input_dhparam_main').css('display', 'flex')
        $(elem).attr('data-open','on')

    }else{
        if ($(event.target).closest(".input_dhparam_main").length) {
            return;
        }
        $(elem).find('.input_dhparam_main').css('display', 'none')
        $(elem).attr('data-open','off')

    }

}

function show_input_ssl_main(elem, event){
    let data_open = $(elem).attr('data-open')

    if ($(elem).attr('class') === 'nginx_cert_ssl_main'){
        $('.certificate_key').css('margin-left', '')
    }
    if (data_open === 'off'){
        $(elem).find('.input_ssl_main').css('display', 'flex')
        $(elem).attr('data-open','on')

    }else{
        if ($(event.target).closest(".input_ssl_main").length) {
            return;
        }
        $(elem).find('.input_ssl_main').css('display', 'none')
        $(elem).attr('data-open','off')
        $('.certificate_key').css('margin-left', '50px')
    }
}

function check_value(elem){
    if ($(elem).val().length > 200){
    localStorage.setItem($(elem).attr('data-key'), JSON.stringify($(elem).val()))
    $(elem).val($(elem).val().substring(0,4) + '***...***' + $(elem).val().substr($(elem).val().length - 4))
    }

}


function send_request_to_edit_location(){
    let vhost = $('h4').attr('data-vhost')
    let pass_type = $('.input_location_pass_type').val()
    let parent_element = $('.location_all_elem:visible').find('div')
    let arr_for_api = {}
    arr_for_api["location"] = $('#input_location_main_modal').val()
    arr_for_api["vhost_name"] = vhost
    for (i of parent_element){
        let text = $(i).find('p').text()
        let input = $(i).find('input').val()
        if (text === "vhost_name"){
        }else{
        arr_for_api[text] = input
        }
    }
    let proxy_set_header = $('.proxy_set_header_for_add_location_in_vhosts').find('input')
    let str_proxy_set_header = ''
    for (i of proxy_set_header){
        let index = $(proxy_set_header).index(i)
        if (index == proxy_set_header.length-1){
            str_proxy_set_header = str_proxy_set_header + $(i).val().replace(/\n/g,'')
        }else{
            str_proxy_set_header = str_proxy_set_header + $(i).val().replace(/\n/g,'') + ','
        }
    }
    arr_for_api['proxy_set_header'] = str_proxy_set_header
    delete arr_for_api[""]
    let home = document.getElementById('home').title;
    let url = home + 'nginx/main_location/';
    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        data: {
            data: JSON.stringify(arr_for_api),
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response_error_ssl(response, 'location')
                return;
            }else{
            document.getElementById('nginx_main_locations_settings_all').innerHTML = response
            $('.modal_main_upstreams').hide()
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'location')
        }
    });


}
function show_modal_nginx_upstreams(zone,value,elem,method, param=null){
    if (param) {
        $('h4').addClass('add_new_upstreams')
    }else{
        $('h4').removeClass('add_new_upstreams')
    }

        let input = $('#input_upstreams_main_modal')
        $(input).val(value)
        $('.modal_main_upstreams').show()
        let list_div = $(".button_upstreams_modal")
        $('[data-values-name]').hide()
        $('#upstreams_ec_span').text(method)
        $('.modal_content_nginx').attr('data-upstream',value)
    if (value){
        $(`[data-values-name=${value}]`).show()
    }else{
        $('.servers_upstreams_clear_row').find('.svg_icon_nginx').css('display', 'inline-block')
        $('.servers_upstreams_clear_row').css('display','')
        $('.button_upstreams_modal_clear_row').css('display','')
        $('.add_upstreams_server').css('margin-top', '20px')
    }

}



function show_modal_nginx_dhparam(zone,value,elem,method){
         $('.input_dhparam_cert').val('')
        $('.input_dhparam_cert_key').val('')
    if (value !== ''){
        let root_elem = $(elem).parent().parent().parent()
        $(root_elem).attr('data-cert',value)
        $('.modal_main_dhparam').attr('data-cert',value)
        $('#input_dhparam_main_modal').hide()

    }else{
        $('#input_dhparam_main_modal').show()
    }
    $('.modal_main_dhparam').show()

}

function show_modal_nginx_ssl(zone,value,elem,method){
        $('.input_ssl_cert').val('')
        $('.input_ssl_cert_key').val('')
    if (value !== ''){
        let root_elem = $(elem).parent().parent().parent()
        $(root_elem).attr('data-cert',value)
        $('.modal_main_ssl').attr('data-cert',value)
        $('#input_ssl_main_modal').hide()

    }else{
        $('#input_ssl_main_modal').show()
    }
    $('.modal_main_ssl').show()

}

function show_modal_nginx_vhosts(zone,value,elem,method){
    $('.modal_main_vhost').show()
}
function send_request_to_edit_vhost(){
    let home = document.getElementById('home').title;
    let name = $('.input_vhost_name_vhost').val()
    let listen = $('.input_vhost_listen').val()
    let server_name = $('.input_vhost_server_name').val()
    let root = $('.input_vhost_root').val()
    let index = $('.input_vhost_index').val()
    let add_header = $('.input_vhost_add_header').val()
    let error_page = $('.input_vhost_error_page').val()
    let arr_for_api = {}
    arr_for_api['name'] = name
    arr_for_api['listen'] = listen
    arr_for_api['server_name'] = server_name
    arr_for_api['root'] = root
    arr_for_api['index'] = index
    arr_for_api['add_header'] = add_header
    arr_for_api['error_page'] = error_page

        $.ajax({
            url: home + 'nginx/main_vhosts/',
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            data: {
                insert: JSON.stringify(arr_for_api),
            },
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response_error_ssl(response, 'vhost');
                    return;
                }else{

                document.getElementById('main_vhost_all').innerHTML = response
                $('.modal_main_ssl').hide()
                }
            },
            error: function (response) {
                show_messages_from_response_error_ssl(response, 'vhost');
            }
        });
}

function send_request_to_edit_dhparam(elem){

    if (localStorage.getItem('dhparam_cert_main')){
        let home = document.getElementById('home').title;
        let url = home + 'nginx/main_ssl/';
        let cert = $('.modal_main_dhparam').attr('data-cert')
        if (!cert){
            cert = $('#input_dhparam_main_modal').val()
        }

        data = {
            name: cert,
            dhparam: localStorage.getItem('dhparam_cert_main'),
        }
        $.ajax({
            url: url,
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            data: {
                dh_set: JSON.stringify(data),
            },
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response_error_ssl(response, 'dhparam');
                    return;
                }else{
                    document.getElementById('nginx_main_ssl_settings_all').innerHTML = response
                    $('.modal_main_dhparam').hide()
                }
            },
            error: function (response) {
                show_messages_from_response_error_ssl(response, 'dhparam');
            }
        });

    }
}

function tab_main_nginx_menu(elem) {
    $('.horizontal-item-ngin_menu_sammary').removeClass('active')
    $(elem).addClass('active')
}

function show_elem_in_modal_vhost_locations(elem, root_elem) {
        arr_elems = {
    'proxy_pass': 'proxy_pass_location',
    'root': 'root_location',
    'alias': 'alias_location',
    'memcached_pass':'memcached_pass_location'
    }
    $('.horizontal-item-nginx_add_location').removeClass('active')
    $(root_elem).addClass('active')
    if (elem === 'proxy_pass'){
        $('.modal_content_nginx').css('height', '470px')
    }else if (elem === 'memcached_pass'){
        $('.modal_content_nginx').css('height', '300px')
    }else{
        $('.modal_content_nginx').css('height', '370px')
    }
    $('#proxy_pass_location').hide()
    $('#root_location').hide()
    $('#alias_location').hide()
    $('#memcached_pass_location').hide()
    $(`#${arr_elems[elem]}`).show()

}

function set_location_vhost(call=null){
    let vhost =  $('h4').attr('data-vhost')
    let arr_for_api = {}
    let elem_is_active = $('.location_all_elem:visible').find('div')
    let input = $('#input_location_main_modal').val()
    for (i of elem_is_active) {
        let key = $(i).find('p').text()
        let value = $(i).find('input').val()
        if (value){
            arr_for_api[key] = value
        }
    }

    let proxy_set_header = $('.proxy_set_header_for_add_location_in_vhosts').find('input')
    let str_proxy_set_header = ''
    for (i of proxy_set_header){
        let index = $(proxy_set_header).index(i)
        if (index == proxy_set_header.length-1){
            str_proxy_set_header = str_proxy_set_header + $(i).val().replace(/\n/g,'')
        }else{
            str_proxy_set_header = str_proxy_set_header + $(i).val().replace(/\n/g,'') + ','
        }
    }
    arr_for_api['proxy_set_header'] = str_proxy_set_header
    let pass_type = $('.horizontal-item-nginx_add_location.active').text().replace(/ /g,'').replace(/\n/g,'')
    arr_for_api['pass_type'] = pass_type
    arr_for_api['location'] = input
    arr_for_api['vhost_name'] = vhost
    delete arr_for_api[""]
    let home = document.getElementById('home').title;
    let url = home + 'nginx/main_location/';
    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        data: {
            data: JSON.stringify(arr_for_api),
            vhost: vhost,
            insert: 'insert'
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert('Error'+ ' ' +response['messages'])
                return;
            }else{
            let home = $('#home_page').attr('data-home')
            if (call){
                fetch(home + `nginx/main_vhosts/`).then(res => res.text()).then(html => {
                document.getElementById('main_vhost_all').innerHTML = html;})
                $('.modal_vhost_location').hide()
            }else{
               fetch(home + `nginx/vhost_tab_content/?vhost=${vhost}`).then(res => res.text()).then(html => {
               document.getElementById('tab_content_nginx_vhost').innerHTML = html;})
               $('.modal_vhost_location').hide()
            }}


        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'location_vhost')
        }
    });

}

function send_request_to_edit_ssl(elem){

    if ((localStorage.getItem('ssl_cert_key_main'))&&(localStorage.getItem('ssl_cert_key_main'))){
        let home = document.getElementById('home').title;
        let url = home + 'nginx/main_ssl/';
        let cert = $('.modal_main_ssl').attr('data-cert')
        if (!cert){
            cert = $('#input_ssl_main_modal').val()
        }

        data = {
            name: cert,
            certificate: localStorage.getItem('ssl_cert_main'),
            certificate_key: localStorage.getItem('ssl_cert_key_main')
        }
        $.ajax({
            url: url,
            headers: {'X-CSRFToken': csrftoken},
            type: "POST",
            data: {
                data: JSON.stringify(data),
            },
            success: function (response, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response_error_ssl(response, 'ssl');
                    return;
                }else{
                document.getElementById('nginx_main_ssl_settings_all').innerHTML = response
                $('.modal_main_ssl').hide()
                }
            },
            error: function (response) {
                show_messages_from_response_error_ssl(response, 'ssl');
            }
        });

    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function check_values_upstreams(server,weight,max_fails,max_fail_timeout,
                                Down,Backup,list_servers){
    let local_list_server = {}
    local_list_server['server'] = server
    if (weight){
        local_list_server['weight'] = weight
    }
     if (max_fails){
        local_list_server['max_fails'] = max_fails
    }
     if (max_fail_timeout){
        local_list_server['fail_timeout'] = max_fail_timeout
    }
     if ($(Down).is(':checked')){
        local_list_server['down'] = true
    }
     if ($(Backup).is(':checked')){
        local_list_server['backup'] = true
    }
    list_servers.push(local_list_server)
}
function send_request_to_edit_upstreams(){
    let list_for_api = {}
    let list_servers = []
    let input = $('#input_upstreams_main_modal').val()
    let priorety = $('#upstreams_ec_span').text()
    let upstream = $('.modal_content_nginx').attr('data-upstream')
    let servers = ''
    if (!upstream){
        upstream = $('#input_upstreams_main_modal').val()
        servers = $('.servers_upstreams_clear_row').find('.info_about_upstream')
    }else{
        servers = $(`[data-values-upstreams=${upstream}]`).find('.info_about_upstream')
    }
    for (i of servers) {
        let server = $(i).parent().find('.input_upstreams_main_modal_server').val()
        let weight = $(i).find('.input_upstreams_main_modal_weight').val()
        let max_fails = $(i).find('.input_upstreams_main_modal_max_fails').val()
        let max_fail_timeout = $(i).find('.input_upstreams_main_modal_max_fail_timeout').val()
        let Down = $(i).find('.Down_upstreams').find('input')
        let Backup = $(i).find('.Backup_upstreams').find('input')
        check_values_upstreams(server,weight,max_fails,max_fail_timeout,
                                    Down,Backup,list_servers)
    }
    list_for_api['servers'] = list_servers
    list_for_api['name'] = input
    list_for_api["balancing_method"] = priorety
    let home = document.getElementById('home').title;
    let url = home + 'nginx/main_upstream/?update=update';
    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "GET",
        data: {
            data: JSON.stringify(list_for_api),
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
               show_messages_from_response_error_ssl(response, 'upstreams');
                return;
            }else{
            document.getElementById('nginx_main_upstreams_settings_all').innerHTML = response
            $('.modal_main_upstreams').hide()
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'upstreams');
        }
    });

}

function show_info_about_upstream(elem,event){
    if($(elem).attr('data-show')==='hide'){
        $(elem).find('.info_about_upstream').show()
        $(elem).attr('data-show','show')
        $(elem).find(".dropdown_buttons_nginx_svg").css('transform','rotate(180deg)')
    }else{
    if ($(event.target).closest(".info_about_upstream").length) {
            return;
        }
    if ($(event.target).closest(".dropdown_buttons_nginx_svg").length) {
        $(elem).find('.info_about_upstream').hide()
        $(elem).attr('data-show','hide')
        $(elem).find(".dropdown_buttons_nginx_svg").css('transform','rotate(90deg)')
        }


    }
}

function changes_vhost(vhost){
    let key_id_requests = $('.key_id_requests').attr('data-key-id')
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/vhost_tab_content/?vhost=${vhost}&key_query_id=${key_id_requests}`).then(res => res.text()).then(html => {
    document.getElementById('tab_content_nginx_vhost').innerHTML = html;})
}

function choose_location_vhost(location, vhost){
    let key_id_requests = $('.key_id_requests').attr('data-key-id')
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/vhost_tab_content/?location=${location}&vhost=${vhost}&key_query_id=${key_id_requests}`).then(res => res.text()).then(html => {
    document.getElementById('tab_content_nginx_vhost').innerHTML = html;})
}

function del_upstreams(value){
    let key_id_requests = $('.key_id_requests').attr('data-key-id')
    let home = $('#home_page').attr('data-home')
    let url = home + 'nginx/main_upstream/' + `?del=${value}&key_query_id=${key_id_requests}`;
    fetch(url).then(res => res.text()).then(html => {
    document.getElementById('nginx_main_upstreams_settings_all').innerHTML = html;})
}
function del_locations(value, vhost){
    let key_id_requests = $('.key_id_requests').attr('data-key-id')
    let home = $('#home_page').attr('data-home')
    let url = home + 'nginx/main_location/';
    let data ={'del': value,
                'vhost': vhost
                }
    $.ajax({
        url: url + `&key_query_id=${key_id_requests}` ,
        headers: {'X-CSRFToken': csrftoken},
        data: {
                del_data: JSON.stringify(data),
            },
        type: "POST",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert(response['messages']);
                return;
            }else{
                document.getElementById('nginx_main_locations_settings_all').innerHTML = response
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'location');
        }
    });
}

function delete_dh_param_main(elem){
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/main_ssl/?del_dhparam=${elem}`).then(res => res.text().then(html => {
    document.getElementById('nginx_main_ssl_settings_all').innerHTML = html;}))
}

function delete_ssl_main(elem){
    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/main_ssl/?del=${elem}`).then(res => res.text().then(html => {
    document.getElementById('nginx_main_ssl_settings_all').innerHTML = html;}))
}

function click_li_upstreams(elem){
    $('#upstreams_ec_span').text(elem)
    $('#level_ec_ul').hide()
}
function revert_style_ssl(elem){
    if ($(elem).attr('data-open') === 'hide') {
       $(elem).removeClass('p_hide_text')
       $(elem).attr('data-open','show')
    }else{
        $(elem).attr('data-open','hide')
        $(elem).addClass('p_hide_text')
    }
}
function check_box_vhost_put(text, vhost) {

    let TLSv1 = ''
    let TLSv1_1 = ''
    let TLSv1_2 = ''
    let TLSv1_3 = ''
    if (document.getElementById('check_box_TLSv1').checked){
        TLSv1 = 'TLSv1'
    }
    if (document.getElementById('check_box_TLSv1.1').checked){
        TLSv1_1 = 'TLSv1.1'
    }
    if (document.getElementById('check_box_TLSv1.2').checked){
        TLSv1_2 = 'TLSv1.2'
    }
    if (document.getElementById('check_box_TLSv1.3').checked){
        TLSv1_3 = 'TLSv1.3'
    }
    arr = [TLSv1,TLSv1_1,TLSv1_2,TLSv1_3]
    let str_check_box = arr.join(" ")
    ssl_choose = {
        'name': vhost,
        'ssl_protocols': str_check_box
    }
    $.ajax({
        url: home + 'nginx/vhost_tab_content/',
        headers: {'X-CSRFToken': csrftoken},
        data: {
                ssl: JSON.stringify(ssl_choose),
                vhost: vhost
            },
        type: "POST",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert(response['messages']);
                return;
            }else{
                document.getElementById('tab_content_nginx_vhost').innerHTML = response
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'vhost');
        }
    });
}

function show_modal_locations_vhost(vhost) {
    $('h4').attr('data-vhost', vhost)
    $('.modal_vhost_location').show()
}
function send_request_to_add_vhost_location(call){
    let vhost =  $('h4').attr('data-vhost')
    let table = $('.content_nginx_add_location').find('input')
    let arr_for_api = {}
    for (i of table){
        let text = $(i).val()
        if (text) {
            let key = $(i).parent().find('p').text()
            arr_for_api[key]=text
        }
    }
    arr_for_api['vhost_name'] = vhost
    let home = document.getElementById('home').title;
    let url = home + 'nginx/main_location/';
    $.ajax({
        url: url,
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        data: {
            data: JSON.stringify(arr_for_api),
            vhost: vhost,
            insert: 'insert'
        },
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert('Error'+ ' ' +response['messages'])
                return;
            }else{
            let home = $('#home_page').attr('data-home')
            if (call){
                fetch(home + `nginx/main_vhosts/`).then(res => res.text()).then(html => {
                document.getElementById('main_vhost_all').innerHTML = html;})
                $('.modal_vhost_location').hide()

            }else{
                fetch(home + `nginx/vhost_tab_content/?vhost=${vhost}`).then(res => res.text()).then(html => {
                document.getElementById('tab_content_nginx_vhost').innerHTML = html;})
                $('.modal_vhost_location').hide()
            }}
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'location_vhost')
        }
    });
}
function del_host(vhost){

    let home = $('#home_page').attr('data-home')
    fetch(home + `nginx/main_vhosts/?del=${vhost}`).then(res => res.text().then(html => {
    document.getElementById('main_vhost_all').innerHTML = html;}))
}

function del_ssl_nginx_vhost(cert,vhost){

    ssl_choose = {
        'name': vhost,
        'certificate_name': cert
    }

    $.ajax({
        url: home + 'nginx/vhost_tab_content/',
        headers: {'X-CSRFToken': csrftoken},
        data: {
                ssl_delete: JSON.stringify(ssl_choose),
                vhost: vhost
            },
        type: "POST",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert(response['messages']);
                return;
            }else{
                document.getElementById('tab_content_nginx_vhost').innerHTML = response
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'vhost');
        }
    });

}
function del_dh_param_nginx_vhost(cert,vhost){

    ssl_choose = {
        'name': vhost,
        'dhparam_name': cert
    }

    $.ajax({
        url: home + 'nginx/vhost_tab_content/',
        headers: {'X-CSRFToken': csrftoken},
        data: {
                dh_param_delete: JSON.stringify(ssl_choose),
                vhost: vhost
            },
        type: "POST",
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                alert(response['messages']);
                return;
            }else{
                document.getElementById('tab_content_nginx_vhost').innerHTML = response
            }
        },
        error: function (response) {
            show_messages_from_response_error_ssl(response, 'vhost');
        }
    });

}

function add_header_proxy_location_modal(elem){
    $('.value_location_vhost').append(
    `<div class="add_value_proxy_header">
                                <input class = "input_add_location_host_proxy_header" type="text" name="name" style="border-radius:4px;border: 1.5px solid #D5E4F3;display: inline-block;">
                                <svg style="margin-left:200px;position:relative;top:-20px" onclick="delete_header_proxy_location_modal(this)" class="svg_icon_nginx" xmlns="http://www.w3.org/2000/svg" height="1em" viewBox="0 0 448 512">
                <style>svg{fill:#38507a}</style><path d="M135.2 17.7L128 32H32C14.3 32 0 46.3 0 64S14.3 96 32
                96H416c17.7 0 32-14.3 32-32s-14.3-32-32-32H320l-7.2-14.3C307.4 6.8 296.3 0 284.2 0H163.8c-12.1
                0-23.2 6.8-28.6 17.7zM416 128H32L53.2 467c1.6 25.3 22.6 45 47.9 45H346.9c25.3 0 46.3-19.7 47.9-45L416 128z"></path></svg><br>
                                    </div>`

    )

}
function delete_header_proxy_location_modal(elem){
    $(elem).parent().remove()

}

function changes_key(elem, url_addr='vhost_tab_content', id_update='tab_content_nginx_vhost'){
    let home = $('#home_page').attr('data-home')
    let var_key_id = $(elem).find('a').attr('data-id-key')
    fetch(home + `nginx/${url_addr}/?key_query_id=${var_key_id}`).then(res => res.text()).then(html => {
               document.getElementById(`${id_update}`).innerHTML = html;})
}