from django import template
from django.template.defaultfilters import stringfilter

register = template.Library()


@register.filter
def repl_carriage_transfer(value: str):
    if value:
        return value.replace('\\r', '').replace('\r', '').replace('\\n', '\n')


@register.filter
def add_space(value: str):
    if value:
        res = []

        for i in value.split('\n'):
            res.append(i.replace(':', ': ', 1))

        return '\n'.join(res)


@register.filter
def replace_space(value: str):
    if value:
        return value.replace(" ", "")


@register.filter
@stringfilter
def trim(value: str):
    return value.strip()
