from django import template
from django.utils.translation import gettext as _

register = template.Library()

desc_vuln = {
    'SQLi': _('<Description for SQLi>'),
    'XSS': _('<Description for XSS>'),
    'LFI': _('<Description for LFI>'),
    'RFI': _('<Description for RFI>'),
    'SSTI': _('<Description for SSTI>'),
    'RCE': _('<Description for RCE>'),
    'WAF bypass': _('<Description for WAF bypass>'),
    'UFU': _('<Description for UFU>'),
    'NoSQL': _('<Description for NoSQL>'),
    'Bot': _('<Description for Bot>'),
    'User-defined': _('<Description for User-defined>'),
    'Other': _('<Description for Other>'),
}

desc_types_attack = {
    'Other': _('<Description for type Other>'),
    'SQLi': _('<Description for type SQLi>'),
    'RCE': _('<Description for type RCE>'),
    'Evasion': _('<Description for type Evasion>'),
    'LFI': _('<Description for type LFI>'),
    'Injection': _('<Description for type Injection>'),
    'XSS': _('<Description for type XSS>'),
    'WL': _('<Description for type WL>'),
    'RFI': _('<Description for type RFI>'),
    'Scanner': _('<Description for type Scanner>'),
    'UWA': _('<Description for type UWA>'),
    'OSCI': _('<Description for type OSCI>'),
    'Nemesida AI MLA': _('<Description for type Nemesida AI MLA>'),
    'Nemesida AI MLC': _('<Description for type Nemesida AI MLC>'),
    'Flood': _('<Description for type Flood>'),
    'Virus': _('<Description for type Virus>'),
    'Brute-force': _('<Description for type Brute-force>'),
    'Internal error': _('<Description for type Internal error>'),
    'DDoS': _('<Description for type DDoS>'),
    'Antivirus': _('<Description for type Antivirus>'),
    'Susp. access': _('<Description for type Susp. access>'),
    'Source code disc.': _('<Description for type Source code disc.>'),
    'WAF bypass': _('<Description for WAF bypass>'),
    'UFU': _('<Description for UFU>'),
    'Archive access': _('<Description for type Archive access>'),
    'SSTI': _('<Description for SSTI>'),
    'NoSQL': _('<Description for NoSQL>'),
    'Bot': _('<Description for Bot>'),
    'User-defined': _('<Description for User-defined>'),
    'Nemesida API Firewall': _('<Description for Nemesida API Firewall>'),
    'Blocked IP': _('<Description for Blocked IP>'),
}


@register.filter
def get_desc_vuln(vuln):
    return desc_vuln.get(vuln, vuln)


@register.filter
def get_desc_type(type_attack):
    return desc_types_attack.get(type_attack, type_attack)
