import re
from django import template

register = template.Library()


def multicast(ip):
    reg = re.compile(
        r"(^22[4-9]\.)|(^23\d\.)")
    if reg.match(ip):
        return 'multicast'

    if ip == '::1':
        return 'ipv6lo'

    return False


@register.filter
def multicast_ip(value):
    return multicast(value)
