from django.utils.translation import gettext as _
from django import template

register = template.Library()


@register.filter
def replace_other_headers_erl_operator(value):
    value = str(value).replace('!!', ' ' + _('ERL not operator') + ' ')
    value = list(value)
    len_val = len(value) - 1
    for i in range(len(value)):
        if i <= len_val and i + 1 <= len_val:
            if value[i] == '&' and value[i + 1] != '!' and value[i - 1] != '\\':
                value[i] = ' ' + _('ERL and operator') + ' '

            if value[i] == '|' and value[i + 1] != '!' and value[i - 1] != '\\':
                value[i] = ' ' + _('ERL or operator') + ' '

            if value[i] == '&' and value[i + 1] == '!' and value[i - 1] != '\\':
                value[i] = ' ' + _('ERL nor operator') + ' '
                value[i + 1] = ''

            if value[i] == '|' and value[i + 1] == '!' and value[i - 1] != '\\':
                value[i] = ' ' + _('ERL nand operator') + ' '
                value[i + 1] = ''

            if value[i] == '!' and value[i - 1] != '&' and value[i - 1] != '|' and value[i - 1] != '\\':
                value[i] = ' ' + _('ERL not operator') + ' '

    return ''.join(value)
