from django import template
import os

register = template.Library()


@register.filter
def strip_lines_len(value, length):
    r = '\n'.join(value.splitlines()[:length])
    if len(r) > 2500:
        return strip_len(value, 1500)
    else:
        return '\n'.join(value.splitlines()[:length])


@register.filter
def count_lines(value):
    return len(value.splitlines())


@register.filter
def strip_lines_after_len(value, length):
    r = '\n'.join(value.splitlines()[:length])
    if len(r) > 2500:
        return strip_after_len(value, 1500)
    else:
        return '\n'.join(value.splitlines()[length:])


@register.filter
def count_symbols(value):
    return len(value)


@register.filter
def strip_len(value, length):
    if ' ' in value[length - 150:length + 150]:
        return value[:value.rindex(' ', length - 150, length + 150)]
    else:
        return value[:length]


@register.filter
def strip_after_len(value, length):
    if ' ' in value[length - 150:length + 150]:
        return value[value.rindex(' ', length - 150, length + 150):]
    else:
        return value[length:]
