function sendData(d, url) {
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    $.ajax({
        url: url,
        type: 'POST',
        data: {
            'data': d,
            csrfmiddlewaretoken: csrftoken
        },
        dataType: 'json',
        success: function (data) {
        }
    });
}

function getCheckedBoxes(chkboxName, attr) {
    var checkboxes = document.getElementsByName(chkboxName);
    var checkboxesChecked = [];
    for (let item of checkboxes) {
        if (item.checked && item.parentElement.parentElement.style.display !== 'none') {
            checkboxesChecked.push(item[attr]);
        }
    }
    return checkboxesChecked.length > 0 ? checkboxesChecked : null;
}

function removeRows(rows) {
    if (rows != null) {
        for (var i = 0; i < rows.length; i++) {
            document.getElementById(rows[i]).parentElement.parentElement.remove()
        }
    }
}

// create export
$(document).on('click', '.ct', function (e) {
    var row = e.currentTarget.parentElement.parentElement;
    document.getElementById('m_id').value = row.getElementsByClassName("row_id")[0].childNodes[1].id
    document.getElementById('m_bt').value = row.getElementsByClassName("row_bt")[0].innerHTML
    document.getElementById('m_uri').value = row.getElementsByClassName("row_uri")[0].innerHTML
    document.getElementById('m_args').value = row.getElementsByClassName("row_args")[0].innerHTML
    document.getElementById('m_cookie').value = row.getElementsByClassName("row_cookie")[0].innerHTML
    document.getElementById('m_ua').value = row.getElementsByClassName("row_ua")[0].innerHTML
    document.getElementById('m_reqt').value = row.getElementsByClassName("row_method")[0].innerHTML
    document.getElementById('m_body').value = row.getElementsByClassName("row_body")[0].innerHTML
});

//check row
$(document).on('click', '.cr', function (e) {
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    var id = e.currentTarget.parentElement.parentElement.getElementsByClassName("row_id")[0].innerHTML;
    $.ajax({
        url: 'check/',
        type: 'POST',
        data: {
            'data': id,
            csrfmiddlewaretoken: csrftoken
        },
        dataType: 'json',
        success: function (data) {
            document.getElementById('checkBody').childNodes[1].innerHTML = JSON.stringify(data, null, 4)
            $('#checkModal').modal('show');
        }
    });
});

// export checked
$(document).on('click', '#ec', function (e) {
    var checkedBoxes = getCheckedBoxes("modalCheckBox", 'id');
    if (checkedBoxes != null) {
        var obj = {};
        var i;
        for (i = 0; i < checkedBoxes.length; i++) {
            obj[checkedBoxes[i].split('_')[1]] = document.getElementById(checkedBoxes[i]).value;
        }
        if (obj.args != null) {
            obj.uri = document.getElementById('m_uri').value;
        }
        obj.row_id = document.getElementById('m_id').value
        obj.bt = document.getElementById('m_bt').value
        var myJSONText = JSON.stringify(obj);
        sendData(myJSONText, 'export/')
        document.getElementById(obj.row_id).parentElement.parentElement.remove()
    }
});

// check all
$(document).on('click', '#ca', function () {
    ca = document.getElementById('ca')
    var checktoggle = ca.checked;
    var checkboxes = document.getElementsByName('del_check');
    for (var i = 0; i < checkboxes.length; i++) {
        if (checkboxes[i].type == 'checkbox') {
            checkboxes[i].checked = checktoggle;
        }
    }
});

// delete checked
$(document).on('click', '#dc', function () {
    var checkedBoxes = getCheckedBoxes("del_check", 'id');
    if (checkedBoxes != null) {
        var myJSONText = JSON.stringify(checkedBoxes);
        sendData(myJSONText, 'delete/')
        removeRows(checkedBoxes);
    } else {
        $('#exampleModalCenter').modal('show');
    }
});

$('#da').click(function () {
    sendData('all', 'delete/');
    location.reload();
});

//check row
$(document).on('click', '.dr', function (e) {
    var row = e.currentTarget.parentElement.parentElement;
    document.getElementById('detail_row_bt').innerHTML = row.getElementsByClassName('row_bt')[0].innerHTML;
    document.getElementById('detail_row_date').innerHTML = row.getElementsByClassName('row_date')[0].innerHTML;
    document.getElementById('detail_row_id').innerHTML = row.getElementsByClassName('row_id')[0].innerHTML;
    document.getElementById('detail_row_args').innerHTML = row.getElementsByClassName('row_args')[0].innerHTML;
    document.getElementById('detail_row_status').innerHTML = row.getElementsByClassName('row_status')[0].innerHTML;
    document.getElementById('detail_row_ip').innerHTML = row.getElementsByClassName('row_ip')[0].innerHTML;
    document.getElementById('detail_row_host').innerHTML = row.getElementsByClassName('row_host')[0].innerHTML;
    document.getElementById('detail_row_method').innerHTML = row.getElementsByClassName('row_method')[0].innerHTML;
    document.getElementById('detail_row_uri').innerHTML = row.getElementsByClassName('row_uri')[0].innerHTML;
    document.getElementById('detail_row_req_p').innerHTML = row.getElementsByClassName('row_req_p')[0].innerHTML;
    document.getElementById('detail_row_schema').innerHTML = row.getElementsByClassName('row_schema')[0].innerHTML;
    document.getElementById('detail_row_cookie').innerHTML = row.getElementsByClassName('row_cookie')[0].innerHTML;
    document.getElementById('detail_row_ua').innerHTML = row.getElementsByClassName('row_ua')[0].innerHTML;
    document.getElementById('detail_row_body').innerHTML = row.getElementsByClassName('row_body')[0].innerHTML;
    document.getElementById('detail_row_ref').innerHTML = row.getElementsByClassName('row_ref')[0].innerHTML;
    $('#detailModal').modal('show');
});