window.list_recheck = [];
window.currentTags = {};
window.currentCountryTags = {};
window.currentSubTags = {};
window.csrftoken = document.querySelector('input[name=csrfmiddlewaretoken]').value;

function escapeHtml(text) {
    'use strict';
    return text.replace(/[\"&<>]/g, function (a) {
        return {'"': '&quot;', '&': '&amp;', '<': '&lt;', '>': '&gt;'}[a];
    });
}

function getQueryParams(qs) {
    qs = qs.split("+").join(" ");
    var params = {},
        tokens,
        re = /[?&]?([^=]+)=([^&]*)/g;

    while (tokens = re.exec(qs)) {
        params[decodeURIComponent(tokens[1])]
            = decodeURIComponent(tokens[2]);
    }

    return params;
}

function updateQueryParams(params) {
    if (!params.length) {
        exit();
    }

    var result = [],
        url_parts = location.href.split('#')[0].split('?');

    var base_part = url_parts[0];

    for (var i = 0; i < params.length; i++) {
        result.push(encodeURIComponent(params[i].name) + '=' + encodeURIComponent(params[i].value));
    }

    window.location.href = base_part + '?' + result.join('&');
}

function reloadTagsGroups() {
    let home = document.getElementById('home').title;
    let s = $('.attack-table-filter').val();
    let vhost = [];
    for (let i of document.querySelectorAll('.attack-table-first-lvl-row')) {
        vhost.push(i.querySelector('input[name=vhost]').value);
    }
    $.post(
        home + "get_group_tags/",
        {
            data: JSON.stringify({
                domain: window.domain,
                lvl: 1,
                vhost: vhost,
                description: '',
                bt: '',
                cc: '',
                possible: '',
                search: s,
                start: window.start_date,
                end: window.end_date,
            }),
            csrfmiddlewaretoken: window.csrftoken,
        }
    ).success(
        function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            for (let i of document.querySelectorAll('.attack-table-first-lvl-row')) {
                let divTags = i.querySelector('.tags');
                let vhost = i.querySelector('input[name=vhost]').value;
                $(divTags).empty();
                vhost = vhost.replace(' ', '').replace(/(?:\r\n|\r|\n)/g, '');
                if (!Object.keys(data).includes(vhost)) {
                    continue
                }
                for (let typeAt of data[vhost]) {
                    let tag = document.createElement('a');
                    tag.style = 'cursor: pointer; text-decoration: none; margin-left: 5px;';
                    tag.classList.add('tag');
                    let inpbt = document.createElement('input');
                    inpbt.type = 'hidden';
                    inpbt.name = 'bt';
                    inpbt.value = typeAt['bt'];
                    let inpVhost = document.createElement('input');
                    inpVhost.type = 'hidden';
                    inpVhost.name = 'vhost';
                    inpVhost.value = typeAt['vhost'];
                    tag.appendChild(inpbt);
                    tag.appendChild(inpVhost);
                    let containerTag = document.createElement('span');
                    containerTag.className = 'tag-text';
                    containerTag.textContent = typeAt['tag'];
                    tag.appendChild(containerTag);
                    let count = document.createElement('sub');
                    count.style = 'bottom: 0.75em;';
                    count.textContent = ' ' + typeAt['dcount'];
                    tag.appendChild(count);
                    $(divTags).append(tag);
                }

            }

        }
    ).error(function (response) {
        show_messages_from_response(response.responseText)
    });

}

function reloadFlagsGroups() {
    let home = document.getElementById('home').title;
    let s = $('.attack-table-filter').val();
    let vhost = [];
    for (let i of document.querySelectorAll('.attack-table-first-lvl-row')) {
        vhost.push(i.querySelector('input[name=vhost]').value);
    }
    $.post(
        home + "get_country_tags/",
        {
            data: JSON.stringify({
                domain: window.domain,
                lvl: 2,
                vhost: vhost,
                description: '',
                bt: '',
                possible: '',
                cc: '',
                search: s,
                start: window.start_date,
                end: window.end_date,
            }),
            csrfmiddlewaretoken: window.csrftoken,
        }
    ).success(
        function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            for (let i of document.querySelectorAll('.attack-table-first-lvl-row')) {
                let divCountryTags = i.querySelector('.countryTags');
                let vhost = i.querySelector('input[name=vhost]').value;
                $(divCountryTags).empty();
                vhost = vhost.replace(' ', '').replace(/(?:\r\n|\r|\n)/g, '');
                if (!Object.keys(data).includes(vhost)) {
                    continue
                }
                for (let cc of data[vhost]) {
                    let tagCC = document.createElement('a');
                    tagCC.style = 'margin-left: 5px; margin-right: 5px; text-decoration: none; cursor: pointer;';
                    tagCC.classList.add('countryTag');
                    let inpCC = document.createElement('input');
                    inpCC.type = 'hidden';
                    inpCC.name = 'cc';
                    inpCC.value = cc['cc'];
                    let inpVhost = document.createElement('input');
                    inpVhost.type = 'hidden';
                    inpVhost.name = 'vhost';
                    inpVhost.value = cc['vhost'];
                    tagCC.appendChild(inpCC);
                    tagCC.appendChild(inpVhost);
                    let flag = document.createElement('i');
                    if (cc['cc'] !== 'None' && cc['cc'] !== '  ' && cc['cc'] !== '#null' && cc['cc'] !== null && cc['cc'] !== '') {
                        flag.className = 'fi fis flag-icon flag-icon-squared fi-' + cc['cc'].toLowerCase() + ' attack-table-flag-icon';
                        let regionNames = new Intl.DisplayNames(['en'], {type: 'region'});
                        let country = regionNames.of(cc['cc'].toUpperCase());
                        flag.title = country + ' (' + cc['cc'].toUpperCase() + ')';
                    } else if (cc['cc'] === '#null') {
                        flag.className = 'fa fa-globe unknown-icon';
                        flag.title = gettext('Country not defined');
                    } else {
                        flag.className = 'fa fa-globe unknown-icon';
                        flag.title = gettext('Private IP');

                    }
                    flag.setAttribute('data-html', "true");
                    flag.setAttribute('data-toggle', "tooltip");
                    flag.setAttribute('data-placement', "bottom");
                    $(flag).tooltip({
                        trigger: 'hover',
                    });
                    let containerCC = document.createElement('span');
                    containerCC.className = 'tag-flag ';
                    containerCC.style.paddingBottom = '0.5em';
                    containerCC.appendChild(flag);
                    tagCC.appendChild(containerCC);
                    let countCC = document.createElement('sub');
                    countCC.style = 'bottom: 0.75em;';
                    countCC.textContent = ' ' + cc['dcount'];
                    tagCC.appendChild(countCC);
                    $(divCountryTags).append(tagCC);
                }
                let endtags = document.createElement('a');
                endtags.className = 'ellipsis-end-tags hidden';
                endtags.style = 'margin-left: 3px; text-decoration: none; cursor: pointer;';
                endtags.textContent = '...';
                $(divCountryTags).append(endtags);
                divCountryTags.classList.remove('hidden');
                $(divCountryTags).children('a').addClass('hidden');
                let count = 0;
                let blockWidth = 25;
                let parentWidth = $('.countryTags').parent().width() - 50;
                for (let i of $(divCountryTags).children('.countryTag')) {
                    $(i).removeClass('hidden');
                    blockWidth = blockWidth + $(i).width() + 10;
                    if (blockWidth > parentWidth) {
                        $(i).addClass('hidden');
                        break;
                    }
                    count++;
                }
                if (count != $(divCountryTags).children('.countryTag').length) {
                    $(divCountryTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
                } else {
                    $(divCountryTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
                }
            }

        }
    ).error(function (response) {
        show_messages_from_response(response.responseText)
    });

}

/* ==========================================================================
   DOM Ready
   ========================================================================== */

$(function () {
    if (document.querySelector('#last_search') !== null) {
        let search_input = document.querySelector('#last_search').value;
        if (search_input === '#clean') {
            search_input = ''
        }
        if (document.querySelector('#scanner') === null) {
            $('#attack_table_search_input').val(search_input);
        } else {
            $('.scan-table-filter').val(search_input);
        }
    }
});

$(document).load(function () {
    let home = document.getElementById('home').title;
    $.get(home + 'last_filter/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&num=0' + '&page=' + window.cur_page
    ).success(
        function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            let search_input = JSON.parse(data);
            if (search_input === '#clean') {
                search_input = ''
            }
            $("#attack_searh_history_list").children().each(function () {
                if ($(this).text() == search_input || $(this).text() === '') {
                    $(this).remove();
                }
            });
            $('#attack_table_search_input').val(search_input);
        }
    ).error(function (response) {
        show_messages_from_response(response.responseText)
    });
});

$('#table_group').ready(function () {
    let tableW = $('#tab_attack_table').width();
    let tableO = (tableW - 30);
    let k = (tableO / tableW);
    if (document.querySelector('#table_group') !== null) {
        $('.vhost').width((tableO * 0.2 * k) - 30);
        $('.tags').parent('div').width((($('.vhost').width() + 16) * 2));
    }
});

$('.tags').ready(function () {
    reloadTagsGroups();
});

$('.countryTags').ready(function () {

    reloadFlagsGroups();
});
$('.countryTags_group').ready(function () {

    reloadFlagsGroups();
});

$(window).resize(function () {
    let tableW = $('#tab_attack_table').width();
    let tableO = (tableW - 30);
    let k = (tableO / tableW);
    if (document.querySelector('#table_group') !== null) {
        $('.vhost').width((tableO * 0.2 * k) - 30);
        $('.tags').parent('div').width((($('.vhost').width() + 16) * 2));
    }

    if ($(window).width() <= 1030) {
        $('.attack-table-info-text').width($(window).width() / 3.2);
    } else if ($(window).width() >= 1031 && ($(window).width() <= 1160)) {
        $('.attack-table-info-text').width($(window).width() / 3);
    } else if ($(window).width() >= 1160 && ($(window).width() <= 1314)) {
        $('.attack-table-info-text').width($(window).width() / 2.9);
    } else if ($(window).width() >= 1314 && ($(window).width() <= 1469)) {
        $('.attack-table-info-text').width($(window).width() / 2.7);
    } else if ($(window).width() >= 1470 && ($(window).width() <= 1680)) {
        $('.attack-table-info-text').width($(window).width() / 4.6);
    } else if ($(window).width() >= 1681 && ($(window).width() <= 1820)) {
        $('.attack-table-info-text').width($(window).width() / 4.4);
    } else if ($(window).width() >= 1821) {
        $('.attack-table-info-text').width($(window).width() / 4.2);
    }

    if (document.querySelector('#table_group') !== null) {
        $('.attack-table-info-title').width('110px');
        $('.attack-table-info-text').width($('.attack-table-info-text').width() - 35);

    }

    for (let i of document.querySelectorAll('.attack-table-first-lvl-row')) {
        let divCountryTags = i.querySelector('.countryTags');
        divCountryTags.classList.remove('hidden');
        $(divCountryTags).children('a').addClass('hidden');
        let count = 0;
        let blockWidth = 25;
        let parentWidth = $('.countryTags').parent().width() - 50;
        for (let i of $(divCountryTags).children('.countryTag')) {
            $(i).removeClass('hidden');
            blockWidth = blockWidth + $(i).width() + 10;
            if (blockWidth > parentWidth) {
                $(i).addClass('hidden');
                break;
            }
            count++;
        }
        if (count != $(divCountryTags).children('.countryTag').length) {
            $(divCountryTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
        } else {
            $(divCountryTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
        }
    }


});

$(function () {
    'use strict';

    /* ======================================================================
       Recalculate body margin
       ====================================================================== */

    $('body').css('marginTop', $('.navbar').height() + 1);
    $(window).resize(function () {
        $('body').css('marginTop', $('.navbar').height() + 1);
    });


    /* ======================================================================
       Sticky table headers init
       ====================================================================== */

    // var $sticky_table = $('.attack-table');

    // function activateStickyHeaders($table) {
    //     $table.stickyTableHeaders({
    //         fixedOffset: $('.navbar-fixed-top'),
    //     });
    // }
    // if ($sticky_table) {
    //     activateStickyHeaders($sticky_table);
    // }

    // // Scrolling sticky thead horizontally
    // $sticky_table.parent('.table-responsive').on('scroll', function() {
    //     $sticky_table
    //         .find('.tableFloatingHeaderOriginal')
    //         .first()
    //         .css('left', -$(this).scrollLeft() + $(this).position().left);
    // });

    /* ======================================================================
       Collapsing info row
       ====================================================================== */

    $(document).on('click', '.attack-table-first-row', function (e) {

    if ($(this).find('.hidden-dupl-ip').attr('info') === 'hidden'){
        if (e.target.classList.contains('fa') || e.target.classList.contains('btn')
            || e.target.closest('.no-show-list') || e.target.closest('.modal') !== null) {
            return;
        }
        var this_row = $(this);
        var row_class = $(this).parent('tbody').attr('class');
        var scanner = $('#scanner').css('display');
        let cls_log = this.querySelector('.cls_log').value;
        if (row_class !== 'open' && scanner !== 'block') {
            var home = document.getElementById('home').title;
            var row_id = $(this).find('.col-host').children('.pk_id').val();
            var req_id = $(this).find('.col-host').children('.req_id').val();
            var row_bt = $(this).find('.col-host').children('.row_bt').val();
            $.get(home + 'second_row/?domain=' + window.domain + '&id=' + row_id
                + '&req_id=' + req_id + '&row_bt=' + row_bt + '&cls_log=' + cls_log + '&start=' + window.start_date + '&end=' + window.end_date,
                function (data) {
                }
            ).success(
                function (data, textStatus, xhr) {
                    if (xhr.status == 255) {
                        show_messages_from_response(data);
                        return;
                    }
                    this_row.after(data);
                    this_row
                        .siblings('tr:last-of-type')
                        .find('.attack-table-slidable-block')
                        .slideToggle();
                    if ($(window).width() <= 1030) {
                        $('.attack-table-info-text').width($(window).width() / 3.2);
                    } else if ($(window).width() >= 1031 && ($(window).width() <= 1160)) {
                        $('.attack-table-info-text').width($(window).width() / 3);
                    } else if ($(window).width() >= 1160 && ($(window).width() <= 1314)) {
                        $('.attack-table-info-text').width($(window).width() / 2.9);
                    } else if ($(window).width() >= 1314 && ($(window).width() <= 1469)) {
                        $('.attack-table-info-text').width($(window).width() / 2.7);
                    } else if ($(window).width() >= 1470 && ($(window).width() <= 1680)) {
                        $('.attack-table-info-text').width($(window).width() / 4.6);
                    } else if ($(window).width() >= 1681 && ($(window).width() <= 1820)) {
                        $('.attack-table-info-text').width($(window).width() / 4.4);
                    } else if ($(window).width() >= 1821) {
                        $('.attack-table-info-text').width($(window).width() / 4.2);
                    }

                    if (document.querySelector('#table_group') !== null) {
                        $('.attack-table-info-title').width('110px');
                        $('.attack-table-info-text').width($('.attack-table-info-text').width() - 35);

                    }


                }
            ).error(function (response) {
                show_messages_from_response(response.responseText)
            });
        } else {
            this_row
                .siblings('tr:last-of-type')
                .find('.attack-table-slidable-block')
                .stop()
                .slideToggle();
        }

        var tr = $(this).closest('tr');
        var table = tr.siblings('tr').find('.attack-table-slidable-block-tr table');


        table.find('td:nth-child(1)').width(tr.find('td:nth-child(1)').width());
        table.find('td:nth-child(2)').width(tr.find('td:nth-child(2)').width());

        $(this).parent('tbody').toggleClass('open');

        // activateStickyHeaders($sticky_table); // Required recalculation
        }
    });

    $(document).on('click', '.attack-table-first-lvl-row', function (e) {

                
         let vhost = this.querySelector('input[name=vhost]').value; 
         let group = 'gpoup'
         

        
        var this_row = $(this);
        var row_class = $(this).parent('div').attr('class');
        if ((e.target.classList.contains('tag') || e.target.classList.contains('subtag')
            || e.target.classList.contains('ellipsis-end-tags') || e.target.parentElement.parentElement.classList.contains('countryTag')
            || e.target.classList.contains('countryTag') || e.target.parentElement.classList.contains('countryTag') || e.target.parentElement.classList.contains('tag')
            || e.target.parentElement.classList.contains('subtag'))) {
            return;
        }
        var scanner = $('#scanner').css('display');
        let s = $('.attack-table-filter').val();
        let list = this.parentElement.querySelector('input[name=group_list]');
        let divCountryTags = this.querySelector('.countryTags');
        if (list === null) {
            list = this.parentElement.querySelector('input[name=attack_table]');
        }
        if (row_class !== 'open' && scanner !== 'block') {
            this.style.background = 'rgba(153, 184, 212, 0.4)';
            this.querySelector('.fa').classList.remove('fa-caret-right');
            if (list !== null) {
                list.parentElement.classList.remove('hidden');
                this.querySelector('.subtags').classList.remove('hidden');
                this.querySelector('.fa').classList.add('fa-caret-down');

            } else {
                this.querySelector('.fa').classList.add('fa-refresh');

                var home = document.getElementById('home').title;
                let bt = [this.querySelector('input[name=bt]').value];
                let vhost = this.querySelector('input[name=vhost]').value;
                let description = [this.querySelector('input[name=description]').value];
                let possible = [];
                let cc = [];
                if (this.querySelector('.selected-tags input[name=cc]') !== null) {
                    for (let i of this.querySelectorAll('.selected-tags input[name=cc]')) {
                        cc.push(i.value);
                    }

                }
                $.post(
                    home + "get_logs_group/",
                    {
                        data: JSON.stringify({
                            domain: window.domain,
                            lvl: 2,
                            vhost: vhost,
                            description: description,
                            bt: bt,
                            possible: possible,
                            search: s,
                            start: window.start_date,
                            end: window.end_date,
                            group:group,
                        }),

                        csrfmiddlewaretoken: window.csrftoken,
                    }
                )
                    .success(function (data, textStatus, xhr) {
                            if (xhr.status == 255) {
                                show_messages_from_response(data);
                                return;
                            }
                            if (this_row[0].parentElement.querySelector('input[name=attack_table]') !== null) {
                                this_row[0].parentElement.querySelector('input[name=attack_table]').parentElement.remove();
                            }
                            this_row.after(data);

                            this_row[0].querySelector('.fa').classList.remove('fa-refresh');
                            this_row[0].querySelector('.fa').classList.add('fa-caret-down');
                        }
                    ).error(function (response) {
                    show_messages_from_response(response.responseText)
                });

            
	}
        } else {
            this.style.background = '';
            if (list !== null) {
                list.parentElement.classList.add('hidden');
            }
            $(divCountryTags).children('a').addClass('hidden');
            let count = 0;
            let blockWidth = 25;
            let parentWidth = $('.countryTags').parent().width() - 50;
            for (let i of $(divCountryTags).children('.countryTag')) {
                $(i).removeClass('hidden');
                blockWidth = blockWidth + $(i).width() + 10;
                if (blockWidth > parentWidth) {
                    $(i).addClass('hidden');
                    break;
                }
                count++;
            }
            if (count !== $(divCountryTags).children('.countryTag').length) {
                $(divCountryTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
            } else {
                $(divCountryTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
            }

            this.querySelector('.subtags').classList.add('hidden');
            this.querySelector('.fa').classList.remove('fa-caret-down');
            this.querySelector('.fa').classList.add('fa-caret-right');
        }

        $(this).parent('div').toggleClass('open');

    });

    $(document).on('click', '.countryTag', function (e) {
        let this_row = $(this.parentElement.parentElement.parentElement);
        let divIsOpen = this_row.parent('div')[0].classList.contains('open');
        let notfilter = this.classList.contains('selected-tags');
        if (this_row[0].querySelector('.subtag.selected-tags') === null) {
            this_row[0].querySelector('.subtags').classList.add('hidden');
        }
        //$('.countryTag').removeClass('selected-tags');
        $(this).addClass('selected-tags');
        let s = $('.attack-table-filter').val();
        let home = document.getElementById('home').title;
        let bt = [];
        let vhost = this.querySelector('input[name=vhost]').value;
        let description = [];
        let possible = [];
        if (this_row[0].querySelector('.subtag.selected-tags') !== null) {
            for (let i of this_row[0].querySelectorAll('.subtag.selected-tags')) {
                bt.push(i.querySelector('input[name=bt]').value);
                description.push(i.querySelector('input[name=description]').value);
                possible.push(i.querySelector('input[name=possible]').value);
            }
        } else if (this_row[0].querySelector('.tag.selected-tags') !== null) {
            for (let i of this_row[0].querySelectorAll('.tag.selected-tags')) {
                bt.push(i.querySelector('input[name=bt]').value);
            }
        }
        let cc = [];
        for (let i of this_row[0].querySelectorAll('.countryTag.selected-tags')) {
            if (!notfilter || this !== i) {
                cc.push(i.querySelector('input[name=cc]').value);
            }

        }

        let divSubTags = this_row[0].querySelector('.subtags');
        let divTags = this_row[0].querySelector('.tags');
        if (this.classList.contains('selected-tags')) {
            if (notfilter) {
                this.classList.remove('selected-tags')
            }
            if (divIsOpen) {
                this_row[0].querySelector('.fa').classList.add('fa-refresh');
                this_row[0].querySelector('.fa').classList.remove('fa-caret-down');
            } else {
                this_row[0].querySelector('.fa').classList.add('fa-refresh');
                this_row[0].querySelector('.fa').classList.remove('fa-caret-right');
            }
            window.currentCountryTags[vhost] = cc;
            setTimeout(function () {
                if (window.currentCountryTags[vhost] == cc) {

                    $.post(
                        home + "get_logs_group/",
                        {
                            data: JSON.stringify({
                                domain: window.domain,
                                lvl: 3,
                                vhost: vhost,
                                description: description,
                                bt: bt,
                                cc: cc,
                                possible: possible,
                                search: s,
                                start: window.start_date,
                                end: window.end_date,
                            }),
                            csrfmiddlewaretoken: window.csrftoken,
                        }
                    )
                        .success(
                            function (data, textStatus, xhr) {
                                if (xhr.status == 255) {
                                    show_messages_from_response(data);
                                    return;
                                }
                                if (this_row[0].parentElement.querySelector('input[name=attack_table]') !== null) {
                                    this_row[0].parentElement.querySelector('input[name=attack_table]').parentElement.remove();
                                }
                                this_row.after(data);
                                $.post(
                                    home + "get_group_tags/",
                                    {
                                        data: JSON.stringify({
                                            domain: window.domain,
                                            lvl: 2,
                                            vhost: [vhost],
                                            description: description,
                                            bt: bt,
                                            cc: cc,
                                            possible: possible,
                                            search: s,
                                            start: window.start_date,
                                            end: window.end_date,
                                        }),
                                        csrfmiddlewaretoken: window.csrftoken,
                                    }
                                ).success(
                                    function (data, textStatus, xhr) {
                                        if (xhr.status == 255) {
                                            show_messages_from_response(data);
                                            return;
                                        }
                                        let selected_tags = [];
                                        if (divSubTags.querySelector('.subtag.selected-tags') !== null) {
                                            for (let i of divSubTags.querySelectorAll('.subtag.selected-tags')) {
                                                selected_tags.push(i.querySelector('input[name=bt]').value
                                                    + i.querySelector('input[name=description]').value
                                                    + i.querySelector('input[name=possible]').value)
                                            }

                                        }

                                        $(divSubTags).empty();
                                        $(divSubTags).append(data);
                                        divSubTags.classList.remove('hidden');
                                        $(divSubTags).children('a').addClass('hidden');
                                        let count = 0;
                                        for (let i of $(divSubTags).children('.subtag')) {
                                            if (count < 6) {
                                                $(i).removeClass('hidden');
                                            }
                                            if (selected_tags.includes(i.querySelector('input[name=bt]').value
                                                + i.querySelector('input[name=description]').value
                                                + i.querySelector('input[name=possible]').value)) {
                                                i.classList.add('selected-tags');
                                                if (i.classList.contains('hidden')) {
                                                    $(i).removeClass('hidden');
                                                }
                                            }
                                            count++;
                                        }
                                        if (count > 6) {
                                            $(divSubTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
                                        } else {
                                            $(divSubTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
                                        }

                                    }
                                ).error(function (response) {
                                    show_messages_from_response(response.responseText)
                                });

                                if (notfilter) {
                                    $.post(
                                        home + "get_country_tags/",
                                        {
                                            data: JSON.stringify({
                                                domain: window.domain,
                                                lvl: 2,
                                                vhost: [vhost],
                                                description: description,
                                                bt: bt,
                                                possible: possible,
                                                cc: cc,
                                                search: s,
                                                start: window.start_date,
                                                end: window.end_date,
                                            }),
                                            csrfmiddlewaretoken: window.csrftoken,
                                        }
                                    ).success(
                                        function (data, textStatus, xhr) {
                                            if (xhr.status == 255) {
                                                show_messages_from_response(data);
                                                return;
                                            }
                                            let divCountryTags = this_row[0].querySelector('.countryTags');
                                            let selected_tags = [];
                                            if (divCountryTags.querySelector('.countryTag.selected-tags') !== null) {
                                                for (let i of divCountryTags.querySelectorAll('.countryTag.selected-tags')) {
                                                    selected_tags.push(i.querySelector('input[name=cc]').value)
                                                }
                                            }

                                            let vhost = this_row[0].querySelector('input[name=vhost]').value;
                                            $(divCountryTags).empty();
                                            for (let cc of data[vhost]) {
                                                let tagCC = document.createElement('a');
                                                tagCC.style = 'margin-left: 5px; margin-right: 5px; text-decoration: none; cursor: pointer;';
                                                tagCC.classList.add('countryTag');
                                                let inpCC = document.createElement('input');
                                                inpCC.type = 'hidden';
                                                inpCC.name = 'cc';
                                                inpCC.value = cc['cc'];
                                                let inpVhost = document.createElement('input');
                                                inpVhost.type = 'hidden';
                                                inpVhost.name = 'vhost';
                                                inpVhost.value = cc['vhost'];
                                                tagCC.appendChild(inpCC);
                                                tagCC.appendChild(inpVhost);
                                                let flag = document.createElement('i');
                                                if (cc['cc'] !== 'None' && cc['cc'] !== '  ' && cc['cc'] !== '#null' && cc['cc'] !== null && cc['cc'] !== '') {
                                                    flag.className = 'fi fis flag-icon flag-icon-squared fi-' + cc['cc'].toLowerCase() + ' attack-table-flag-icon';
                                                    let regionNames = new Intl.DisplayNames(['en'], {type: 'region'});
                                                    let country = regionNames.of(cc['cc'].toUpperCase());
                                                    flag.title = country + ' (' + cc['cc'].toUpperCase() + ')';
                                                } else if (cc['cc'] === '#null') {
                                                    flag.className = 'fa fa-globe unknown-icon';
                                                    flag.title = gettext('Country not defined');
                                                } else {
                                                    flag.className = 'fa fa-globe unknown-icon';
                                                    flag.title = gettext('Private IP');

                                                }

                                                flag.setAttribute('data-html', "true");
                                                flag.setAttribute('data-toggle', "tooltip");
                                                flag.setAttribute('data-placement', "bottom");
                                                $(flag).tooltip({
                                                    trigger: 'hover',
                                                });
                                                let containerCC = document.createElement('span');
                                                containerCC.className = 'tag-flag ';
                                                containerCC.style.paddingBottom = '0.5em';
                                                containerCC.appendChild(flag);
                                                tagCC.appendChild(containerCC);
                                                let countCC = document.createElement('sub');
                                                countCC.style = 'bottom: 0.75em;';
                                                countCC.textContent = ' ' + cc['dcount'];
                                                tagCC.appendChild(countCC);
                                                $(divCountryTags).append(tagCC);
                                            }
                                            let endtags = document.createElement('a');
                                            endtags.className = 'ellipsis-end-tags hidden';
                                            endtags.style = 'margin-left: 3px; text-decoration: none; cursor: pointer;';
                                            endtags.textContent = '...';
                                            $(divCountryTags).append(endtags);
                                            divCountryTags.classList.remove('hidden');
                                            $(divCountryTags).children('a').addClass('hidden');
                                            let count = 0;
                                            let blockWidth = 25;
                                            let parentWidth = $('.countryTags').parent().width() - 50;
                                            for (let i of $(divCountryTags).children('.countryTag')) {
                                                $(i).removeClass('hidden');
                                                blockWidth = blockWidth + $(i).width() + 10;
                                                if (blockWidth > parentWidth) {
                                                    $(i).addClass('hidden');
                                                    break;
                                                }
                                                if (selected_tags.includes(i.querySelector('input[name=cc]').value)) {
                                                    i.classList.add('selected-tags');
                                                    if (i.classList.contains('hidden')) {
                                                        $(i).removeClass('hidden');
                                                    }
                                                }
                                                count++;
                                            }
                                            if (count != $(divCountryTags).children('.countryTag').length) {
                                                $(divCountryTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
                                            } else {
                                                $(divCountryTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
                                            }


                                        }
                                    ).error(function (response) {
                                        show_messages_from_response(response.responseText)
                                    });
                                }

                                this_row[0].querySelector('.fa').classList.remove('fa-refresh');
                                this_row[0].querySelector('.fa').classList.add('fa-caret-down');
                            }
                        ).error(function (response) {
                        show_messages_from_response(response.responseText)
                    });

                }
            }, 750);

        } else {
            this_row[0].querySelector('.fa').classList.remove('fa-refresh');
            this_row[0].querySelector('.fa').classList.add('fa-caret-down');
        }
        if (!divIsOpen) {
            this_row[0].style.background = 'rgba(153, 184, 212, 0.4)';
            this_row.parent('div')[0].classList.add('open');
        }
    });


    $(document).on('click', '.tag', function () {
    
       let vhostis = this.querySelector('input[name=vhost]').value; 
         let group = 'gpoup'
         
   
    
        let this_row = $(this.parentElement.parentElement.parentElement);
        let divIsOpen = this_row.parent('div')[0].classList.contains('open');
        let notfilter = false;
        if (this.classList.contains('selected-tags')) {
            notfilter = true;
            this_row[0].querySelector('.subtags').classList.add('hidden');
        }
        $(this).addClass('selected-tags');
        let s = $('.attack-table-filter').val();
        let home = document.getElementById('home').title;
        let bt = [];
        let vhost = this.querySelector('input[name=vhost]').value;
        let description = [];
        let possible = [];
        let cc = [];
        for (let i of this_row[0].querySelectorAll('.tag.selected-tags')) {
            if (!notfilter || i !== this) {
                bt.push(i.querySelector('input[name=bt]').value);
            }

        }
        let divSubTags = this_row[0].querySelector('.subtags');
        let divCountryTags = this_row[0].querySelector('.countryTags');
        if (this.classList.contains('selected-tags')) {
            if (notfilter) {
                this.classList.remove('selected-tags')
            }
            if (divIsOpen) {
                this_row[0].querySelector('.fa').classList.add('fa-refresh');
                this_row[0].querySelector('.fa').classList.remove('fa-caret-down');
            } else {
                this_row[0].querySelector('.fa').classList.add('fa-refresh');
                this_row[0].querySelector('.fa').classList.remove('fa-caret-right');
            }
            window.currentTags[vhost] = bt;
            setTimeout(function () {
                if (window.currentTags[vhost] == bt) {
                    $.post(
                        home + "get_logs_group/",
                        {
                            data: JSON.stringify({
                                domain: window.domain,
                                lvl: 3,
                                vhost: vhost,
                                description: description,
                                bt: bt,
                                possible: possible,
                                cc: cc,
                                search: s,
                                start: window.start_date,
                                end: window.end_date,
                                group:group
                            }),
                            csrfmiddlewaretoken: window.csrftoken,
                        }
                    ).success(
                        function (data, textStatus, xhr) {
                            if (xhr.status == 255) {
                                show_messages_from_response(data);
                                return;
                            }
                            if (this_row[0].parentElement.querySelector('input[name=attack_table]') !== null) {
                                this_row[0].parentElement.querySelector('input[name=attack_table]').parentElement.remove();

                            }
                            this_row.after(data);
                            $.post(
                                home + "get_group_tags/",
                                {
                                    data: JSON.stringify({
                                        domain: window.domain,
                                        lvl: 2,
                                        vhost: [vhost],
                                        description: description,
                                        bt: bt,
                                        possible: possible,
                                        cc: cc,
                                        search: s,
                                        start: window.start_date,
                                        end: window.end_date,
                                        group:group
                                    }),
                                    csrfmiddlewaretoken: window.csrftoken,
                                }
                            ).success(
                                function (data, textStatus, xhr) {
                                    if (xhr.status == 255) {
                                        show_messages_from_response(data);
                                        return;
                                    }
                                    $(divSubTags).empty();
                                    $(divSubTags).append(data);
                                    divSubTags.classList.remove('hidden');
                                    $(divSubTags).children('a').addClass('hidden');
                                    let count = 0;
                                    for (let i of $(divSubTags).children('.subtag')) {
                                        if (count < 6) {
                                            $(i).removeClass('hidden');
                                        }
                                        count++;
                                    }
                                    if (count > 6) {
                                        $(divSubTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
                                    } else {
                                        $(divSubTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
                                    }

                                }
                            ).error(function (response) {
                                show_messages_from_response(response.responseText)
                            });

                            $.post(
                                home + "get_country_tags/",
                                {
                                    data: JSON.stringify({
                                        domain: window.domain,
                                        lvl: 2,
                                        vhost: [vhost],
                                        description: description,
                                        bt: bt,
                                        possible: possible,
                                        cc: cc,
                                        search: s,
                                        start: window.start_date,
                                        end: window.end_date,
                                        group:group
                                    }),
                                    csrfmiddlewaretoken: window.csrftoken,
                                }
                            ).success(
                                function (data, textStatus, xhr) {
                                    if (xhr.status == 255) {
                                        show_messages_from_response(data);
                                        return;
                                    }
                                    let divCountryTags = this_row[0].querySelector('.countryTags');
                                    let vhost = this_row[0].querySelector('input[name=vhost]').value;
                                    $(divCountryTags).empty();
                                    for (let cc of data[vhost]) {
                                        let tagCC = document.createElement('a');
                                        tagCC.style = 'margin-left: 5px; margin-right: 5px; text-decoration: none; cursor: pointer;';
                                        tagCC.classList.add('countryTag');
                                        let inpCC = document.createElement('input');
                                        inpCC.type = 'hidden';
                                        inpCC.name = 'cc';
                                        inpCC.value = cc['cc'];
                                        let inpVhost = document.createElement('input');
                                        inpVhost.type = 'hidden';
                                        inpVhost.name = 'vhost';
                                        inpVhost.value = cc['vhost'];
                                        tagCC.appendChild(inpCC);
                                        tagCC.appendChild(inpVhost);
                                        let flag = document.createElement('i');
                                        if (cc['cc'] !== 'None' && cc['cc'] !== '  ' && cc['cc'] !== '#null' && cc['cc'] !== null && cc['cc'] !== '') {
                                            flag.className = 'fi fis flag-icon flag-icon-squared fi-' + cc['cc'].toLowerCase() + ' attack-table-flag-icon';
                                            let regionNames = new Intl.DisplayNames(['en'], {type: 'region'});
                                            let country = regionNames.of(cc['cc'].toUpperCase());
                                            flag.title = country + ' (' + cc['cc'].toUpperCase() + ')';
                                        } else if (cc['cc'] === '#null') {
                                            flag.className = 'fa fa-globe unknown-icon';
                                            flag.title = gettext('Country not defined');
                                        } else {
                                            flag.className = 'fa fa-globe unknown-icon';
                                            flag.title = gettext('Private IP');

                                        }

                                        flag.setAttribute('data-html', "true");
                                        flag.setAttribute('data-toggle', "tooltip");
                                        flag.setAttribute('data-placement', "bottom");
                                        $(flag).tooltip({
                                            trigger: 'hover',
                                        });
                                        let containerCC = document.createElement('span');
                                        containerCC.className = 'tag-flag ';
                                        containerCC.style.paddingBottom = '0.5em';
                                        containerCC.appendChild(flag);
                                        tagCC.appendChild(containerCC);
                                        let countCC = document.createElement('sub');
                                        countCC.style = 'bottom: 0.75em;';
                                        countCC.textContent = ' ' + cc['dcount'];
                                        tagCC.appendChild(countCC);
                                        $(divCountryTags).append(tagCC);
                                    }
                                    let endtags = document.createElement('a');
                                    endtags.className = 'ellipsis-end-tags hidden';
                                    endtags.style = 'margin-left: 3px; text-decoration: none; cursor: pointer;';
                                    endtags.textContent = '...';
                                    $(divCountryTags).append(endtags);
                                    divCountryTags.classList.remove('hidden');
                                    $(divCountryTags).children('a').addClass('hidden');
                                    let count = 0;
                                    let blockWidth = 25;
                                    let parentWidth = $('.countryTags').parent().width() - 50;
                                    for (let i of $(divCountryTags).children('.countryTag')) {
                                        $(i).removeClass('hidden');
                                        blockWidth = blockWidth + $(i).width() + 10;
                                        if (blockWidth > parentWidth) {
                                            $(i).addClass('hidden');
                                            break;
                                        }
                                        count++;
                                    }
                                    if (count != $(divCountryTags).children('.countryTag').length) {
                                        $(divCountryTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
                                    } else {
                                        $(divCountryTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
                                    }

                                }
                            ).error(function (response) {
                                show_messages_from_response(response.responseText)
                            });
                            this_row[0].querySelector('.fa').classList.remove('fa-refresh');
                            this_row[0].querySelector('.fa').classList.add('fa-caret-down');
                        }
                    ).error(function (response) {
                        show_messages_from_response(response.responseText)
                    });


                }
            }, 750);


        } else {
            this_row[0].querySelector('.fa').classList.remove('fa-refresh');
            this_row[0].querySelector('.fa').classList.add('fa-caret-down');
        }
        if (!divIsOpen) {
            this_row[0].style.background = 'rgba(153, 184, 212, 0.4)';
            this_row.parent('div')[0].classList.add('open');
        }
    });

    $(document).on('click', '.subtag', function () {
        let this_row = $(this.parentElement.parentElement.parentElement);

        let notfilter = false;
        if (this.classList.contains('selected-tags')) {
            notfilter = true;
        }

        //$('.subtag').removeClass('selected-tags');
        $(this).addClass('selected-tags');
        let s = $('.attack-table-filter').val();
        let home = document.getElementById('home').title;
        let bt = [];
        let vhost = this.querySelector('input[name=vhost]').value;
        let description = [];
        let possible = [];
        let divCountryTags = this_row[0].querySelector('.countryTags');
        let divSubTags = this_row[0].querySelector('.subtags');
        let cc = [];
        for (let i of this_row[0].querySelectorAll('.selected-tags input[name=cc]')) {
            cc.push(i.value);
        }
        if (this_row[0].querySelector('.subtag.selected-tags') !== null) {
            for (let i of this_row[0].querySelectorAll('.subtag.selected-tags')) {
                if (!notfilter || this !== i) {
                    bt.push(i.querySelector('input[name=bt]').value);
                    description.push(i.querySelector('input[name=description]').value);
                    possible.push(i.querySelector('input[name=possible]').value);
                }
            }
        }
        if (this_row[0].querySelector('.tag.selected-tags') !== null
            && (bt.length === 0 && description.length === 0 && possible.length === 0)) {
            for (let i of this_row[0].querySelectorAll('.tag.selected-tags')) {
                bt.push(i.querySelector('input[name=bt]').value);
            }
        }

        if (this.classList.contains('selected-tags')) {
            if (notfilter) {

                this.classList.remove('selected-tags');
            }
            this_row[0].querySelector('.fa').classList.add('fa-refresh');
            this_row[0].querySelector('.fa').classList.remove('fa-caret-down');
            window.currentSubTags[vhost] = [bt, possible, description];
            setTimeout(function () {
                if (window.currentSubTags[vhost][0] == bt &&
                    window.currentSubTags[vhost][1] == possible &&
                    window.currentSubTags[vhost][2] == description) {

                    $.post(
                        home + "get_logs_group/",
                        {
                            data: JSON.stringify({
                                domain: window.domain,
                                lvl: 3,
                                vhost: vhost,
                                description: description,
                                bt: bt,
                                possible: possible,
                                cc: cc,
                                search: s,
                                start: window.start_date,
                                end: window.end_date,
                            }),
                            csrfmiddlewaretoken: window.csrftoken,
                        }
                    ).success(
                        function (data, textStatus, xhr) {
                            if (xhr.status == 255) {
                                show_messages_from_response(data);
                                return;
                            }
                            this_row[0].parentElement.querySelector('input[name=attack_table]').parentElement.remove();
                            this_row.after(data);

                            if (notfilter) {
                                $.post(
                                    home + "get_group_tags/",
                                    {
                                        data: JSON.stringify({
                                            domain: window.domain,
                                            lvl: 2,
                                            vhost: [vhost],
                                            description: description,
                                            bt: bt,
                                            possible: possible,
                                            cc: cc,
                                            search: s,
                                            start: window.start_date,
                                            end: window.end_date,
                                        }),
                                        csrfmiddlewaretoken: window.csrftoken,
                                    }
                                ).success(
                                    function (data, textStatus, xhr) {
                                        if (xhr.status == 255) {
                                            show_messages_from_response(data);
                                            return;
                                        }
                                        let selected_tags = [];
                                        if (divSubTags.querySelector('.subtag.selected-tags') !== null) {
                                            for (let i of divSubTags.querySelectorAll('.subtag.selected-tags')) {
                                                selected_tags.push(
                                                    i.querySelector('input[name=bt]').value
                                                    + i.querySelector('input[name=description]').value
                                                    + i.querySelector('input[name=possible]').value)
                                            }

                                        }

                                        $(divSubTags).empty();
                                        $(divSubTags).append(data);
                                        divSubTags.classList.remove('hidden');
                                        $(divSubTags).children('a').addClass('hidden');
                                        let count = 0;
                                        for (let i of $(divSubTags).children('.subtag')) {
                                            if (count < 6) {
                                                $(i).removeClass('hidden');
                                            }
                                            if (selected_tags.includes(i.querySelector('input[name=bt]').value
                                                + i.querySelector('input[name=description]').value
                                                + i.querySelector('input[name=possible]').value)) {
                                                i.classList.add('selected-tags');
                                                if (i.classList.contains('hidden')) {
                                                    $(i).removeClass('hidden');
                                                }
                                            }
                                            count++;
                                        }
                                        if (count > 6) {
                                            $(divSubTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
                                        } else {
                                            $(divSubTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
                                        }

                                    }
                                ).error(function (response) {
                                    show_messages_from_response(response.responseText)
                                });

                            }

                            $.post(
                                home + "get_country_tags/",
                                {
                                    data: JSON.stringify({
                                        domain: window.domain,
                                        lvl: 2,
                                        vhost: [vhost],
                                        description: description,
                                        bt: bt,
                                        possible: possible,
                                        cc: cc,
                                        search: s,
                                        start: window.start_date,
                                        end: window.end_date,
                                    }),
                                    csrfmiddlewaretoken: window.csrftoken,
                                }
                            ).success(
                                function (data, textStatus, xhr) {
                                    if (xhr.status == 255) {
                                        show_messages_from_response(data);
                                        return;
                                    }
                                    let selected_tags = [];
                                    if (divCountryTags.querySelector('.countryTag.selected-tags') !== null) {
                                        for (let i of divCountryTags.querySelectorAll('.countryTag.selected-tags')) {
                                            selected_tags.push(i.querySelector('input[name=cc]').value)
                                        }
                                    }

                                    let vhost = this_row[0].querySelector('input[name=vhost]').value;
                                    $(divCountryTags).empty();
                                    for (let cc of data[vhost]) {
                                        let tagCC = document.createElement('a');
                                        tagCC.style = 'margin-left: 5px; margin-right: 5px; text-decoration: none; cursor: pointer;';
                                        tagCC.classList.add('countryTag');
                                        let inpCC = document.createElement('input');
                                        inpCC.type = 'hidden';
                                        inpCC.name = 'cc';
                                        inpCC.value = cc['cc'];
                                        let inpVhost = document.createElement('input');
                                        inpVhost.type = 'hidden';
                                        inpVhost.name = 'vhost';
                                        inpVhost.value = cc['vhost'];
                                        tagCC.appendChild(inpCC);
                                        tagCC.appendChild(inpVhost);
                                        let flag = document.createElement('i');
                                        if (cc['cc'] !== 'None' && cc['cc'] !== '  ' && cc['cc'] !== '#null' && cc['cc'] !== null && cc['cc'] !== '') {
                                            flag.className = 'fi fis flag-icon flag-icon-squared fi-' + cc['cc'].toLowerCase() + ' attack-table-flag-icon';
                                            let regionNames = new Intl.DisplayNames(['en'], {type: 'region'});
                                            let country = regionNames.of(cc['cc'].toUpperCase());
                                            flag.title = country + ' (' + cc['cc'].toUpperCase() + ')';
                                        } else if (cc['cc'] === '#null') {
                                            flag.className = 'fa fa-globe unknown-icon';
                                            flag.title = gettext('Country not defined');
                                        } else {
                                            flag.className = 'fa fa-globe unknown-icon';
                                            flag.title = gettext('Private IP');

                                        }

                                        flag.setAttribute('data-html', "true");
                                        flag.setAttribute('data-toggle', "tooltip");
                                        flag.setAttribute('data-placement', "bottom");
                                        $(flag).tooltip({
                                            trigger: 'hover',
                                        });
                                        let containerCC = document.createElement('span');
                                        containerCC.className = 'tag-flag ';
                                        containerCC.style.paddingBottom = '0.5em';
                                        containerCC.appendChild(flag);
                                        tagCC.appendChild(containerCC);
                                        let countCC = document.createElement('sub');
                                        countCC.style = 'bottom: 0.75em;';
                                        countCC.textContent = ' ' + cc['dcount'];
                                        tagCC.appendChild(countCC);
                                        $(divCountryTags).append(tagCC);
                                    }
                                    let endtags = document.createElement('a');
                                    endtags.className = 'ellipsis-end-tags hidden';
                                    endtags.style = 'margin-left: 3px; text-decoration: none; cursor: pointer;';
                                    endtags.textContent = '...';
                                    $(divCountryTags).append(endtags);
                                    divCountryTags.classList.remove('hidden');
                                    $(divCountryTags).children('a').addClass('hidden');
                                    let count = 0;
                                    let blockWidth = 25;
                                    let parentWidth = $('.countryTags').parent().width() - 50;
                                    for (let i of $(divCountryTags).children('.countryTag')) {
                                        $(i).removeClass('hidden');
                                        blockWidth = blockWidth + $(i).width() + 10;
                                        if (blockWidth > parentWidth) {
                                            $(i).addClass('hidden');
                                            break;
                                        }
                                        if (selected_tags.includes(i.querySelector('input[name=cc]').value)) {
                                            i.classList.add('selected-tags');
                                            if (i.classList.contains('hidden')) {
                                                $(i).removeClass('hidden');
                                            }
                                        }
                                        count++;
                                    }
                                    if (count != $(divCountryTags).children('.countryTag').length) {
                                        $(divCountryTags.querySelector('.ellipsis-end-tags')).removeClass('hidden');
                                    } else {
                                        $(divCountryTags.querySelector('.ellipsis-end-tags')).addClass('hidden');
                                    }


                                }
                            ).error(function (response) {
                                show_messages_from_response(response.responseText)
                            });


                            this_row[0].querySelector('.fa').classList.remove('fa-refresh');
                            this_row[0].querySelector('.fa').classList.add('fa-caret-down');
                        }
                    ).error(function (response) {
                        show_messages_from_response(response.responseText)
                    });

                }
            }, 750);


        } else {
            this_row[0].querySelector('.fa').classList.remove('fa-refresh');
            this_row[0].querySelector('.fa').classList.add('fa-caret-down');

        }
    });


    $(document).on('click', '.ellipsis-end-tags', function () {
        let div = this.parentElement;
        div.classList.remove('hidden');
        if (div.classList.contains('countryTags')) {
            let count = 0;
            let countView = $(div).children('.countryTag').not('.hidden').length;
            for (let i of $(div).children('.countryTag.hidden')) {
                $(i).removeClass('hidden');
                if (count > countView) {
                    $(i).addClass('hidden');
                    break;
                }
                count++;
            }
            if (count + countView != $(div).children('.countryTag').length) {
                $(div.querySelector('.ellipsis-end-tags')).removeClass('hidden');
            } else {
                $(div.querySelector('.ellipsis-end-tags')).addClass('hidden');
            }

        } else {
            $(div).children().removeClass('hidden');
            $(div.querySelector('.ellipsis-end-tags')).addClass('hidden');
        }

    });


    $(document).on('click', '.attack-table-second-lvl-row', function () {

        var this_row = $(this);
        var row_class = $(this).parent('div').attr('class');
        var scanner = $('#scanner').css('display');
        let s = $('.attack-table-filter').val();
        let list = this.parentElement.querySelector('input[name=attack_table]');
        if (row_class !== 'open' && scanner !== 'block') {
            this.querySelector('.fa').classList.remove('fa-caret-right');
            if (list !== null) {
                list.parentElement.classList.remove('hidden');
                this.querySelector('.fa').classList.add('fa-caret-down');

            } else {
                this.querySelector('.fa').classList.add('fa-refresh');
                this.style.borderBottom = 0;
                var home = document.getElementById('home').title;
                let bt = this.querySelector('input[name=bt]').value;
                let vhost = this.querySelector('input[name=vhost]').value;
                let rule_id = this.querySelector('input[name=rule_id]').value;
                let description = this.querySelector('input[name=description]').value;
                let body = this.querySelector('input[name=body]').value;
                let possible = this.querySelector('input[name=possible]').value;
                $.get(home + 'get_logs_group/?domain=' + window.domain + '&lvl=' + 3 + '&bt=' + bt + '&vhost=' + vhost
                    + '&rule_id=' + rule_id + '&description=' + description + '&body=' + body
                    + '&possible=' + possible + '&search=' + s + '&start=' + window.start_date + '&end=' + window.end_date,
                    function (data) {
                    }
                ).success(
                    function (data, textStatus, xhr) {
                        if (xhr.status == 255) {
                            show_messages_from_response(data);
                            return;
                        }
                        this_row.after(data);
                        this_row[0].querySelector('.fa').classList.remove('fa-refresh');
                        this_row[0].querySelector('.fa').classList.add('fa-caret-down');
                    }
                ).error(function (response) {
                    show_messages_from_response(response.responseText)
                });
            }

        } else {
            if (list !== null) {
                list.parentElement.classList.add('hidden');
            }
            this.querySelector('.fa').classList.remove('fa-caret-down');
            this.querySelector('.fa').classList.add('fa-caret-right');
            let li = this.parentElement.querySelectorAll('.attack-table-second-lvl-row');
            if (li[li.length - 1] !== this) {
                this.style.borderBottom = '1px solid silver';

            }

        }

        $(this).parent('div').toggleClass('open');

        // activateStickyHeaders($sticky_table); // Required recalculation
    });

    /* ======================================================================
       Select2 init
       ====================================================================== */

    (function () {
        var $_GET = getQueryParams(document.location.search);
        $('select[name="domain"]').val($_GET['domain']).select2({
            placeholder: 'Customer',
            language: 'ru',
            dropdownParent: $('.parent-for-select2'),
        });
    })();

    /* ======================================================================
       Daterangepicker init
       ====================================================================== */

    (function () {
        var $input = $('input[name="daterange"]');

        var today = new Date();
        var prevDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 5);

        var startDate = ('0' + prevDate.getDate()).slice(-2)
            + '.'
            + ('0' + (prevDate.getMonth() + 1)).slice(-2)
            + '.'
            + prevDate.getFullYear();

        var endDate = ('0' + today.getDate()).slice(-2)
            + '.'
            + ('0' + (today.getMonth() + 1)).slice(-2)
            + '.'
            + today.getFullYear();

        var $_GET = getQueryParams(document.location.search);

        startDate = $_GET['start'] || startDate;
        endDate = $_GET['end'] || endDate;

        if (window.start_date != undefined || window.start_date != null) {
            startDate = window.start_date
        }
        if (window.end_date != undefined || window.end_date != null) {
            endDate = window.end_date
        }


        if (document.getElementById('start_date_input') !== null) {
            document.getElementById('start_date_input').value = startDate;
            document.getElementById('end_date_input').value = endDate;

        }

        if (document.getElementById('csv_start_date_input') !== null) {
            document.getElementById('csv_start_date_input').value = startDate;
            document.getElementById('csv_end_date_input').value = endDate;
        }

        $input.daterangepicker({
            "autoApply": true,
            "startDate": startDate,
            "endDate": endDate,
            "locale": {
                "format": "DD.MM.YYYY",
                "separator": " - ",
                "applyLabel": "Apply",
                "cancelLabel": "Cancel",
                "fromLabel": "From",
                "toLabel": "To",
                "customRangeLabel": "Custom.",
                "weekLabel": "Н",
                "daysOfWeek": [
                    gettext("Su"),
                    gettext("Mo"),
                    gettext("Tu"),
                    gettext("We"),
                    gettext("Th"),
                    gettext("Fr"),
                    gettext("Sa")
                ],
                "monthNames": [
                    gettext("January"),
                    gettext("February"),
                    gettext("March"),
                    gettext("April"),
                    gettext("May"),
                    gettext("June"),
                    gettext("July"),
                    gettext("August"),
                    gettext("September"),
                    gettext("October"),
                    gettext("November"),
                    gettext("December")
                ],
                "firstDay": 1
            },
            "linkedCalendars": false,
            "opens": "left"
        });
    })();

    /* ======================================================================
       Update get params
       ====================================================================== */

    $('select[name="domain"], input[name="daterange"]').on('change', function () {
        var params = [];
        var domain = $('select[name="domain"]').val() === undefined ? '' : $('select[name="domain"]').val();
        params.push({
            name: 'domain',
            value: domain,
        });
        var date = $('input[name="daterange"]').val().split(' - ');
        params.push({
            name: 'start',
            value: date[0],
        });
        params.push({
            name: 'end',
            value: date[1],
        });
        updateQueryParams(params);
        if (document.getElementById('start_date_input') !== null) {
            document.getElementById('start_date_input').value = date[0];
            document.getElementById('end_date_input').value = date[1];
        }
        if (document.getElementById('csv_start_date_input') != null) {
            document.getElementById('csv_start_date_input').value = date[0];
            document.getElementById('csv_end_date_input').value = date[1];

        }

    });


    /* ======================================================================
       Attack Table filtration
       ====================================================================== */
    var alreadyload = false;
    (function () {
        let startSearch = false;
        var isLoading = false;

        function debounce(timeout, cb) {
            var expireDate;
            return function () {
                expireDate = Date.now() + timeout;
                setTimeout(function () {
                    if (Date.now() >= expireDate)
                        cb()
                }, timeout);
            }
        }

        function loadMore(groups = false, clear = false) {
            var today = new Date();
            var prevDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 5);

            var startDate = ('0' + prevDate.getDate()).slice(-2)
                + '.'
                + ('0' + (prevDate.getMonth() + 1)).slice(-2)
                + '.'
                + prevDate.getFullYear();

            var endDate = ('0' + today.getDate()).slice(-2)
                + '.'
                + ('0' + (today.getMonth() + 1)).slice(-2)
                + '.'
                + today.getFullYear();

            var $_GET = getQueryParams(document.location.search);

            startDate = $_GET['start'] || startDate;
            endDate = $_GET['end'] || endDate;

            if (document.getElementById('start_date_input') !== null) {
                document.getElementById('start_date_input').value = startDate;
                document.getElementById('end_date_input').value = endDate;
            }

            if (document.getElementById('csv_start_date_input') !== null) {
                document.getElementById('csv_start_date_input').value = startDate;
                document.getElementById('csv_end_date_input').value = endDate;
            }


            var home = document.getElementById('home').title;
            let search_input_text = "document.getElementById('attack_table_search_input').value";
            let loadingContainer = $('.loading-container');

            if (groups) {
                loadingContainer = $('.loading-container.lvl-first');
            }

            $('#attack_searh_history').css('display', 'none');
            $('#input-group').css('margin-top', '0px');
            isLoading = true;
            if ($('#tab_attack_table').is(":visible")) {
                loadingContainer.show();
                alreadyload = true;
                startSearch = false;
                $.get(home + 'logs/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&page=' + window.cur_page + '&search=' + encodeURIComponent(window.search), function (data) {
                    $('#attack_searh_history').css('display', 'none');
                    $('#input-group').css('margin-top', '0px');
                }).success(
                    function (data, textStatus, xhr) {
                        if (xhr.status == 255) {
                            show_messages_from_response(data);
                            return;
                        }
                        if (data === null || data === '') {
                            window.cur_page = 0;
                        }
                        isLoading = false;
                        startSearch = false;
                        if (clear) {
                            $('#table_logs tbody').remove();
                        }
                        if (groups) {
                            $('#table_group').append(data);
                        } else {
                            $('#table_logs').append(data);
                        }

                        $('[data-toggle="tooltip"]').tooltip({
                            trigger: 'hover'
                        });
                        let tab = "attacks";
                        if ($('#tab_attack_charts').is(":visible")) {
                            tab = "charts";
                        }
                        if ($('#scanner').is(":visible")) {
                            tab = "scan";
                        }

                        $.get('list_filters/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&tab=' + tab + '&search=' + encodeURIComponent(window.search)
                        ).success(
                            function (data, textStatus, xhr) {
                                if (xhr.status == 255) {
                                    show_messages_from_response(data);
                                    return;
                                }
                                let dict = JSON.parse(data);
                                $("#attack_searh_history_list").empty();
                                data = JSON.parse(data);
                                for (let i in data) {
                                    if (data[i] !== window.search)
                                        $("#attack_searh_history_list").append('<li class="searh_history_element" value="' + escapeHtml(data[i]) + '">' + escapeHtml(data[i]) + '</li>');

                                }
                                if (data[0] === window.search && data.length == 1) {
                                    $("#attack_searh_history").hide();
                                }
                            }
                        ).error(function (response) {
                            show_messages_from_response(response.responseText)
                        });

                        let search_input = window.search;
                        if (search_input === '#clean') {
                            search_input = ''
                        }

                        $("#attack_searh_history_list").children().each(function () {
                            if ($(this).text() == window.search || $(this).text() === '') {
                                $(this).remove();
                            }
                        });

                        $("#attack_searh_history_list").unbind('click');


                        $("#attack_searh_history_list").on("click", ".searh_history_element", function (event) {
                            $('#attack_table_search_input').val(event.target.textContent);
                            let e = jQuery.Event("keyup");
                            e.key = 'Enter';
                            $('#attack_table_search_input').trigger(e);
                            $('#attack_searh_history').css('display', 'none');
                            $('#input-group').css('margin-top', '0px');
                            window.lastevent = 'click';

                        });

                        loadingContainer.hide();
                        loadingContainer.css('margin-top', '0px');

                        if (search_input !== '' && window.lastevent === '' && $("#attack_searh_history_list").children().length !== 0) {
                            $('#attack_table_search_input').trigger("focus");
                            $("#attack_searh_history").show();

                        }
                        window.lastevent = '';
                        reloadFlagsGroups();
                        reloadTagsGroups();
                    }
                ).error(function (response) {
                    show_messages_from_response(response.responseText)
                });
            }

        }


        function attackTableFilterChange(reset = false, searching = true) {
            startSearch = true;
            window.search = $('.attack-table-filter').val();
            if (reset === true || window.search === '') {
                window.search = '#clean'
            }
            window.cur_page = 1;
            var loadingContainer = $('.loading-container');
            if ($('#tab_attack_charts').is(":hidden")) {
                if (searching) {
                    if (document.getElementById('table_logs') !== undefined && document.getElementById('table_logs') !== null) {
                        $('#table_logs tbody').remove();
                        loadMore(false, true);
                    } else {
                        $('#table_group div').remove();
                        loadMore(true, true);
                    }

                    loadingContainer.css('margin-top', '350px');
                    loadingContainer.show();
                } else {
                    let tab = "attacks";
                    if ($('#tab_attack_charts').is(":visible")) {
                        tab = "charts";
                    }
                    if ($('#scanner').is(":visible")) {
                        tab = "scan";
                    }
                    $.get('list_filters/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&tab=' + tab + '&search=' + encodeURIComponent(window.search)
                    ).success(
                        function (data, textStatus, xhr) {
                            if (xhr.status == 255) {
                                show_messages_from_response(data);
                                return;
                            }
                            let dict = JSON.parse(data);
                            $("#attack_searh_history_list").empty();
                            data = JSON.parse(data);
                            for (let i in data) {
                                if (data[i] !== window.search)
                                    $("#attack_searh_history_list").append('<li class="searh_history_element" value="' + escapeHtml(data[i]) + '">' + escapeHtml(data[i]) + '</li>');

                            }
                            if (data[0] === window.search || data.length == 0) {
                                $("#attack_searh_history").hide();
                            }
                        }
                    ).error(function (response) {
                        show_messages_from_response(response.responseText)
                    });

                    let search_input = window.search;
                    if (search_input === '#clean') {
                        search_input = ''
                    }

                    $("#attack_searh_history_list").children().each(function () {
                        if ($(this).text() == window.search || $(this).text() === '') {
                            $(this).remove();
                        }
                    });

                    $("#attack_searh_history_list").unbind('click');


                    $("#attack_searh_history_list").on("click", ".searh_history_element", function (event) {
                        $('#attack_table_search_input').val(event.target.textContent);
                        let e = jQuery.Event("keyup");
                        e.key = 'Enter';
                        $('#attack_table_search_input').trigger(e);
                        $('#attack_searh_history').css('display', 'none');
                        $('#input-group').css('margin-top', '0px');
                        window.lastevent = 'click';

                    });
                    if (search_input !== '' && window.lastevent === '') {
                        $('#attack_table_search_input').trigger("focus");
                        $("#attack_searh_history").show();

                    }
                    window.lastevent = '';
                }

            }
            //chart_search();
        }

        window.tmp = -1;
        $(window).on("scroll", function () {
            if (window.cur_page === 0 || (document.querySelectorAll('.attack-table-first-lvl-row').length * 50 < window.screen.height)) {
                return;
            }
            var scrollHeight = $(document).height();
            var scrollPosition = $(window).height() + $(window).scrollTop();
            var test = scrollHeight - scrollPosition;
            if (document.getElementById('table_logs') !== undefined && document.getElementById('table_logs') !== null
                && document.getElementById('table_group') === null) {
                if (test / scrollHeight < 0.2) {
                    if (window.tmp == -1) {
                        window.tmp = $(document).height();
                        window.cur_page++;
                        window.lastevent = 'scroll';
                        loadMore();
                    }
                    if (window.tmp != scrollHeight && !isLoading) {
                        window.tmp = $(document).height();
                        window.cur_page++;
                        window.lastevent = 'scroll';
                        loadMore();
                    }
                }
            } else if (document.getElementById('table_group') !== undefined && document.getElementById('table_group') !== null) {
                if (test / scrollHeight < 0.2) {
                    if (window.tmp == -1) {
                        window.tmp = $(document).height();
                        window.cur_page++;
                        window.lastevent = 'scroll';
                        loadMore(true);
                    }
                    if (window.tmp != scrollHeight && !isLoading) {
                        window.tmp = $(document).height();
                        window.cur_page++;
                        window.lastevent = 'scroll';
                        loadMore(true);
                    }
                }
            }

        });

        $('.input-group-addon:not(#previousfilter, #PreviousScanFilter)').on('click', function () {
            if ($('#tab_attack_charts').is(":hidden")) {
                let val = document.getElementById('attack_table_search_input').value;
                let tmp = $("#attack_searh_history_list").children();
                $("#attack_searh_history_list").empty();
                $("#attack_searh_history_list").append('<li class="searh_history_element" value="' + escapeHtml(val) + '">' + escapeHtml(val) + '</li>');
                $("#attack_searh_history_list").append(tmp);
                $('.attack-table-filter').val('');
                window.lastevent = 'click';
                attackTableFilterChange(true, true);
            }

        });

        $('#previousfilter').on('click', function () {
            if ($('#tab_attack_table').is(":visible")) {
                $.get('last_filter/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&page=' + window.cur_page
                ).success(
                    function (data, textStatus, xhr) {
                        if (xhr.status == 255) {
                            show_messages_from_response(data);
                            return;
                        }
                        let search_input = JSON.parse(data);
                        if (search_input === '#clean') {
                            search_input = ''
                        }
                        $('#attack_table_search_input').val(search_input);
                        let e = jQuery.Event("keyup");
                        e.key = 'Enter';
                        $('#attack_table_search_input').trigger(e);
                        window.lastevent = 'click';
                    }
                ).error(function (response) {
                    show_messages_from_response(response.responseText)
                });
            }
            if ($('#tab_attack_charts').is(":visible")) {
                $.get('last_filter/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&page=' + window.cur_page + '&charts=1'
                ).success(
                    function (data, textStatus, xhr) {
                        if (xhr.status == 255) {
                            show_messages_from_response(data);
                            return;
                        }
                        let search_input = JSON.parse(data);
                        if (search_input === '#clean') {
                            search_input = ''
                        }
                        $('#attack_table_search_input').val(search_input);
                        let e = jQuery.Event("keyup");
                        e.key = 'Enter';
                        $('#attack_table_search_input').trigger(e);
                        window.lastevent = 'click';

                    }
                ).error(function (response) {
                    show_messages_from_response(response.responseText)
                });

            }

        });

        $(".fa-list").click(function () {
            //attackTableFilterChange();
            //loadMore();
        });


        $('.attack-table-filter').on('keyup', (event) => {
            if (event.key === 'Enter') {
                attackTableFilterChange(false, true)
            } else {
                attackTableFilterChange(false, false)
            }
        });
        $('#loadMoreBtn').on('click', function () {
            window.cur_page++;
            window.lastevent = 'click';
            loadMore();
        });

    })();

    /* ======================================================================
       Learning mode buttons click
       ====================================================================== */

    $(document).on('click', '.attack-table-learning-mode', function (event) {
        event.stopPropagation();
    });

    /* ======================================================================
       Bootstrap popovers init
    ====================================================================== */

    $('[data-toggle="popover"]').popover()

});

/* ======================================================================
   Table Scan filtration
====================================================================== */

(function () {
    var isLoading = false;
    var alreadyload = false;

    function debounce(timeout, cb) {
        var expireDate;
        return function () {
            expireDate = Date.now() + timeout;
            setTimeout(function () {
                if (Date.now() >= expireDate)
                    cb()
            }, timeout);
        }
    }

    function loadMoreScan() {
        /*preloader*/
        drawScanCharts();
        var home = document.getElementById('home').title;
        var loadingContainer = $('.loading-container');
        var tableHeight = $('.attack-table').height();
        var containerHeight = $(window).outerHeight() - 100;
        var loadingContainerOffset = loadingContainer.height() * 2 + 10;
        var padding = 0;
        let search_text = window.search;
        let prev_page = $(".active").children('.left-sidebar-link-icon').children().attr('class');
        let input_value = $("#search-input").val();
        if (input_value.length >= 1) {
            search_text = input_value;
        }
        if (prev_page === 'fa fa-pie-chart') {
            search_text = "";
            $("#search-input").val("");
        }
        if (tableHeight < containerHeight / 2 - loadingContainerOffset) {
            padding = Math.round(containerHeight / 2 - tableHeight - loadingContainerOffset);
        }
        $('#scanner_attack_searh_history').css('display', 'none');
        $('#scanner_input-group').css('margin-top', '0px');
        loadingContainer.show();
        isLoading = true;
        let tab = "scan";

        $.get(home + 'scanner/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&dyn=' + 1 + '&page=' + window.cur_page + '&search=' + encodeURIComponent(search_text), function (data) {
            loadingContainer.show();
        }).success(
            function (data, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(data);
                    return;
                }
                if (document.getElementById('scan_logs') !== undefined && document.getElementById('scan_logs') !== null
                    && document.getElementById('scan_types') === null) {
                    $('#scan_logs').empty();
                    $('#scan_logs').append(data);
                } else {
                    $('#scan_types').empty();
                    $('#scan_types').append(data);
                }
                $('[data-toggle="tooltip"]').tooltip({
                    trigger: 'hover'
                });

                $.get(home + 'list_filters/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&tab=' + tab + '&search=' + encodeURIComponent(search_text)
                ).success(
                    function (data, textStatus, xhr) {
                        if (xhr.status == 255) {
                            show_messages_from_response(data);
                            return;
                        }
                        let dict = JSON.parse(data);
                        $("#scan_searh_history_list").empty();
                        data = JSON.parse(data);
                        for (let i in data) {
                            if (data[i] !== window.search)
                                $("#scan_searh_history_list").append('<li class="searh_history_element" value="' + escapeHtml(data[i]) + '">' + escapeHtml(data[i]) + '</li>');

                        }
                        if (data[0] === window.search && data.length == 1) {
                            $("#scanner_attack_searh_history").hide();
                        }

                    }
                ).error(function (response) {
                    show_messages_from_response(response.responseText)
                });

                let search_input = window.search;
                if (search_input === '#clean') {
                    search_input = ''
                }

                $("#scan_searh_history_list").children().each(function () {
                    if ($(this).text() == window.search || $(this).text() === '') {
                        $(this).remove();
                    }
                });

                $("#scanner_attack_searh_history").unbind('click');

                $("#scanner_attack_searh_history").on("click", ".searh_history_element", function (event) {
                    $('#search-input').val(event.target.textContent);
                    let e = jQuery.Event("keyup");
                    e.key = 'Enter';
                    $('#search-input').trigger(e);
                    $('#scanner_attack_searh_history').css('display', 'none');
                    $('#scanner_input-group').css('margin-top', '0px');
                    window.lastevent = 'click';
                });

                $('.loading-container').hide();
                if (search_input !== '' && window.lastevent === '' && $("#scan_searh_history_list").children().length !== 0) {
                    $('#search-input').trigger("focus");
                    $("#scanner_attack_searh_history").show();

                }
                window.lastevent = '';
            }
        ).error(function (response) {
            show_messages_from_response(response.responseText)
        });
    }

    function scanTableFilterChange(searching = true) {

        if (searching) {
            window.search = $('#search-input').val();
            if (window.search === '') {
                window.search = '#clean'
            }
            $('#scan_logs tbody').remove();
            loadMoreScan();
        } else {
            let search_text = window.search;
            let home = document.getElementById('home').title;
            let prev_page = $(".active").children('.left-sidebar-link-icon').children().attr('class');
            let input_value = $("#search-input").val();
            if (input_value.length >= 1) {
                search_text = input_value;
            }
            if (prev_page === 'fa fa-pie-chart') {
                search_text = "";
                $("#search-input").val("");
            }

            let tab = "scan";
            $.get(home + 'list_filters/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&tab=' + tab + '&search=' + encodeURIComponent(search_text)
            ).success(
                function (data, textStatus, xhr) {
                    if (xhr.status == 255) {
                        show_messages_from_response(data);
                        return;
                    }
                    let dict = JSON.parse(data);
                    $("#scan_searh_history_list").empty();
                    data = JSON.parse(data);
                    for (let i in data) {
                        if (data[i] !== window.search)
                            $("#scan_searh_history_list").append('<li class="searh_history_element" value="' + escapeHtml(data[i]) + '">' + escapeHtml(data[i]) + '</li>');

                    }
                    if (data[0] === window.search && data.length == 1) {
                        $("#scanner_attack_searh_history").hide();
                    }

                }
            ).error(function (response) {
                show_messages_from_response(response.responseText)
            });

            let search_input = window.search;
            if (search_input === '#clean') {
                search_input = ''
            }

            $("#scan_searh_history_list").children().each(function () {
                if ($(this).text() == window.search || $(this).text() === '') {
                    $(this).remove();
                }
            });

            $("#scanner_attack_searh_history").unbind('click');

            $("#scanner_attack_searh_history").on("click", ".searh_history_element", function (event) {
                $('#search-input').val(event.target.textContent);
                let e = jQuery.Event("keyup");
                e.key = 'Enter';
                $('#search-input').trigger(e);
                $('#scanner_attack_searh_history').css('display', 'none');
                $('#scanner_input-group').css('margin-top', '0px');
                window.lastevent = 'click';
            });

            if (search_input !== '' && window.lastevent === '' && $("#scan_searh_history_list").children().length !== 0) {
                $('#search-input').trigger("focus");
                $("#scanner_attack_searh_history").show();

            }
            window.lastevent = '';
        }

    }

    $(document).on('click', '.tab_attack_scanner', function (e) {
        //scanTableFilterChange();
    });

    $('.input-group-addon:not(#previousfilter, #PreviousScanFilter)').on('click', function () {
        if ($('#scanner').is(":visible")) {
            $('.scan-table-filter').val('');
            window.lastevent = 'click';
            scanTableFilterChange();

        }
    });

    $('#PreviousScanFilter').on('click', function () {
        let home = document.getElementById('home').title;
        if ($('#scanner').is(":visible")) {
            $.get(home + 'last_scan/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&page=' + window.cur_page
            ).success(
                function (data, textStatus, xhr) {
                    if (xhr.status == 255) {
                        show_messages_from_response(data);
                        return;
                    }
                    let scan_input = JSON.parse(data);
                    if (scan_input === '#clean') {
                        scan_input = ''
                    }
                    $('#search-input').val(scan_input);
                    scanTableFilterChange();
                    window.lastevent = 'click';
                }
            ).error(function (response) {
                show_messages_from_response(response.responseText)
            })
        }
    });
    if ($('#scanner').is(":visible")) {
        let home = document.getElementById('home').title;
        $.get(home + 'last_scan/?domain=' + window.domain + '&start=' + window.start_date + '&end=' + window.end_date + '&page=' + window.cur_page + '&num=0'
        ).success(
            function (data, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(data);
                    return;
                }
                let scan_input = JSON.parse(data);
                if (scan_input === '#clean') {
                    scan_input = ''
                }
                $("#scanner_attack_searh_history").children().each(function () {
                    if ($(this).text() == scan_input || $(this).text() === '') {
                        $(this).remove();
                    }
                });
                $('#search-input').val(scan_input);
            }
        ).error(function (response) {
            show_messages_from_response(response.responseText)
        });
    }


    $('.scan-table-filter').on('keyup', (event) => {
        if (event.key === 'Enter') {
            scanTableFilterChange();
        } else {
            scanTableFilterChange(false);
        }
    });

})();


$(document).on('click', '.recheck', function (e) {
    var home = document.getElementById('home').title;
    var csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
    var row_id = e.target.id.split("_")[e.target.id.split("_").length - 1];
    let cls_log = e.target.closest('td').querySelector('.cls_log').value;
    var button_id = e.target.id;
    var par = $(e.target).parent();
    document.getElementById(button_id).parentElement.innerHTML = '';
    $.post(
        home + "scan-request/",
        {
            log_id: row_id,
            cls_log: cls_log,
            csrfmiddlewaretoken: csrftoken
        }
    )
        .success(function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            par.append('<div style="padding-right: 5px" id="reCheck_' + cls_log + '_' + row_id + '">' + gettext('Validation') + '</div>');
            window.list_recheck.push(cls_log + '_' + row_id)
        })
        .error(function (response) {
            show_messages_from_response(response.responseText)
        })
});

$(document).on('click', '.tab_user_settings', function (e) {
    $('.tab_user_settings').addClass('in active');
    $('.tab_attack_charts').removeClass('in active');
    $('.tab_attack_table').removeClass('in active');
    $('.tab_attack_scanner').removeClass('in active');
    $('.tab_attack_traffic').removeClass('in active');
    $('#tab_attack_charts').hide();
    $('.custom-navbar-left').hide();
    $('#overlay').hide();

    let home = document.getElementById('home').title;
    document.location.href = home + 'user_settings/';

    //return true;
});

$(document).on('click', '.tab_attack_table', function (e) {
    let home = document.getElementById('home').title;
    //document.location.href = home;
    $('.tab_attack_table').addClass('in active');
    $('.tab_user_settings').removeClass('in active');
    $('.tab_attack_charts').removeClass('in active');
    $('.tab_attack_scanner').removeClass('in active');
    $('.tab_attack_traffic').removeClass('in active');
    $('#tab_attack_charts').hide();
    $('#overlay').hide();
    document.location.href = home;

    //return false;

});

$(document).on('click', '.tab_attack_charts', function (e) {
    $('.tab_attack_charts').addClass('in active');
    $('.tab_attack_table').removeClass('in active');
    $('.tab_attack_scanner').removeClass('in active');
    $('.tab_attack_traffic').removeClass('in active');
    $('.tab_user_settings').removeClass('in active');
    let home = document.getElementById('home').title;
    $('.custom-navbar-left').show();


    let docHeight = $(document).height();
    if ($("#today_all_attacks").html() === "") {
        $("#overlay")
            .height(docHeight)
            .css({
                'position': 'absolute',
                'top': 0,
                'left': document.getElementById('leftSidebar').offsetWidth,
                'margin-top': '90px',
                'background-color': "rgba(255, 255, 255, 0.6)",
                'width': '100%',
                'z-index': 1020
            });
        $(".loading-container_overlay")
            .css({
                'z-index': 1015,
                'position': 'fixed',
                'opacity': 1,
                'top': 'calc(50% - 50)',
                'left': 'calc(50% - 50)',
            });
        var main_loadingContainer2 = $('.loading-container_overlay');

        $("#overlay").show();
        main_loadingContainer2.show();
    }


    var footer = $('#Footer');
    var search_div = document.getElementById('searchDiv');
    var date_div = document.getElementById('dateDiv');
    var search_div_scan = document.getElementById('searchDivScanner');
    var hamburger = $('button.navbar-toggle');
    var domain_div = document.getElementById('domainDiv');
    let scanner_div = document.getElementById('scanner');
    if (scanner_div !== null) {
        scanner_div.classList.add('hidden');
    }

    footer.hide();
    if ($(window).width() < 992)
        hamburger.show();
    if (typeof (domain_div) != 'undefined' && domain_div != null) {
        domain_div.removeAttribute("style");
    }
    search_div.removeAttribute("style");
    date_div.removeAttribute("style");

    $('#attack_table_search_input').attr("placeholder", "(!)h:example.com and (!)ip:1.1.1.1 and (!)t:SQLi");

    search_div_scan.setAttribute("style", "display:none");


});

$(document).on('click', '.tab_attack_scanner', function (e) {
    let home = document.getElementById('home').title;
    window.cur_page = 1;
    document.location.href = home + 'scanner/';
    return false;
});

function group_id_filter(filter_id) {
    $("#attack_table_search_input").val("group_id:" + filter_id);
    let e = jQuery.Event("keyup");
    e.key = 'Enter';
    $('#attack_table_search_input').trigger(e);
}

function send_request_to_user_email_config() {
    let home = $('#home').text();
    event.preventDefault();
    $.ajax({
        url: home + 'admin_panel/edit_email_config/',
        type: "POST",
        dataType: "html",
        data: $('#edit_form_email_config').serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            location.reload();
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

function get_recheck(dict) {
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').title;
    //event.preventDefault();
    $.ajax({
        url: home + 'get_recheck/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {logs_id: JSON.stringify(dict)},
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = JSON.parse(response);
            for (let i in data) {
                if (i.includes('desc')) {
                    continue;
                }
                let row = document.querySelector('#row_' + i);
                let cls_log = i.split('_')[0];
                let label_recheck = row.querySelector('#reCheck_' + i).parentElement;
                if (data[i] === 0) {
                    label_recheck.innerHTML = '<div id="reCheck_' + i + '" style="padding-right: 15px">' + gettext('Validation') + '</div>';
                } else if (data[i] === 1) {
                    label_recheck.innerHTML = '' +
                        '<button type="button"\n' +
                        '  data-html="true"\n' +
                        '  data-toggle="tooltip"\n' +
                        '  data-placement="bottom"\n' +
                        '  title="' + gettext('recheck') + ': ' + gettext('vulnerability not found') + '"\n' +
                        '  class="btn btn-default recheck"\n' +
                        '  id="reCheck_' + i + '"\n' +
                        '  onmouseover="this.style.backgroundColor=\'#ebeeff\';" onmouseout="this.style.backgroundColor=\'#fafafa\';"\n' +
                        '  style="padding: 2px 7px; border-radius: 50%; vertical-align: revert !important; font-weight: bold;">\n' +
                        'N\n' +
                        '</button>'
                } else if (data[i] === 2) {
                    label_recheck.innerHTML = '' +
                        '<button type="button"\n' +
                        '  data-html="true"\n' +
                        '  data-toggle="tooltip"\n' +
                        '  data-placement="bottom"\n' +
                        '  title="' + gettext('recheck') + ': ' + gettext('vulnerability found') + '"\n' +
                        '  class="btn btn-default recheck"\n' +
                        '  id="reCheck_' + i + '"\n' +
                        '  onmouseover="this.style.backgroundColor=\'#ecffe2\';" onmouseout="this.style.backgroundColor=\'#fafafa\';"' +
                        '  style="color: green; border-color: green; padding: 2px 7px; border-radius: 50%; vertical-align: revert !important; font-weight: bold;">' +
                        'C' +
                        '</button>'
                } else if (data[i] === 3) {
                    let html = '' +
                        '<button type="button"\n' +
                        '  data-html="true"\n' +
                        '  data-toggle="tooltip"\n' +
                        '  data-placement="bottom"\n';
                    if (data[i] === 3 && data[i + '_desc'] !== '') {
                        html += '  title="' + gettext('recheck') + ': ' + data[i + '_desc'][0].toLowerCase() + data[i + '_desc'].slice(1) + '"\n'

                    } else {
                        html += '  title="' + gettext('recheck') + '"\n'

                    }
                    html += '  class="btn btn-default recheck"\n' +
                        '  id="reCheck_' + i + '"\n' +
                        '  onmouseover="this.style.backgroundColor=\'#ffede8\';" onmouseout="this.style.backgroundColor=\'#fafafa\';"' +
                        '  style="color: red; border-color: red; padding: 2px 7px; border-radius: 50%; vertical-align: revert !important; font-weight: bold;">' +
                        'E' +
                        '</button>';
                    label_recheck.innerHTML = html
                }
                window.list_recheck.pop(i)
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

function recheck_status_update() {
    let rows = document.querySelector('#table_logs tr');
    if (rows == null) {
        rows = document.querySelectorAll('#table_group .table.attack-table tr');
    } else {
        rows = document.querySelectorAll('#table_logs tr');
    }
    let dict = {};
    for (let row of rows) {
        let row_id = row.id.replace('row_', '');
        if (row.querySelector('td label #reCheck_' + row_id)) {
            let item_recheck = row.querySelector('td label #reCheck_' + row_id);
            let status = -1;
            if (!item_recheck.innerText.includes('C') && !item_recheck.innerText.includes('N') && !item_recheck.innerText.includes('E')
                && !item_recheck.innerText.includes('R')) {
                status = 0;
                dict[row_id] = status;
            }
        }

    }
    for (let row of window.list_recheck) {
        let cls_log = row.split('_')[0];
        row = row.split('_')[1];
        if (document.querySelector('#reCheck_' + row)) {
            let item_recheck = document.querySelector('#reCheck_' + row);
            let status = -1;
            if (item_recheck.innerText.includes('C')) {
                status = 2;
            } else if (item_recheck.innerText.includes('N')) {
                status = 1;
            } else if (item_recheck.innerText.includes('E')) {
                status = 3;
            } else if (!item_recheck.innerText.includes('R')) {
                status = 0;
            }
            dict[row] = status;
        }

    }
    if (Object.keys(dict).length !== 0) {
        get_recheck(dict);

    }
}

setInterval(recheck_status_update, 5000);

function search_elements_of_tbody(element,page){

let text_of_attr = $(element).attr('info_text').replaceAll(/\s/g, "")
let key = $(element).attr('info_key')

let element_with_key=$(`tbody[info="${ key }"][page="${ page }"]`)

for (let i of element_with_key){

i.style.display = null;
   if ($(i).find('.tag-text').text().replaceAll(/\s/g, "") == text_of_attr){
   }else{
   $(i).css('display', 'none')
   }

}
}

function upload_data_for_group(elem, lvl) {
    let baseElem = elem.parentElement.parentElement.parentElement;
    let vhost = baseElem.querySelector('input[name=vhost]').value; 
    let group = 'gpoup'
         
         
    let s = $('.attack-table-filter').val();

    let block = elem.parentElement.parentElement;
    if (lvl === 2) {
        baseElem = baseElem.querySelector('.attack-table-first-lvl-row');
        let home = document.getElementById('home').title;
        let bt = baseElem.querySelector('input[name=bt]').value;
        let vhost = baseElem.querySelector('input[name=vhost]').value;
        let description = baseElem.querySelector('input[name=description]').value;
        let possible = baseElem.querySelector('input[name=possible]').value;
        let page = parseInt(elem.value) + 1;
        let loadingContainer = $(elem.parentElement.querySelector('.loading-container.second-lvl'));
        elem.remove();
        loadingContainer.show();
        $.get(home + 'get_logs_group/?domain=' + window.domain + '&lvl=' + 2 + '&bt=' + bt + '&vhost=' + vhost + '&description=' + description
            + '&possible=' + possible + '&page=' + page + '&search=' + s + '&upload=1' + '&start=' + window.start_date + '&end=' + window.end_date,
            function (data) {
            }).success(
            function (data, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(data);
                    return;
                }
                loadingContainer[0].parentElement.remove();
                if (data != '') {
                    let lastElem = block.children[block.childElementCount - 1];
                    lastElem.style.borderBottom = '1px solid silver'

                }
                $(block).append(data);
            }
        ).error(function (response) {
            show_messages_from_response(response.responseText)
        });
    } else if (lvl === 3) {
        block = block.querySelector('.table.attack-table');
        let first_log = parseInt(block.children[0].querySelector('.attack-table-first-row').id.replace('row_'));

        if (baseElem.querySelector('.attack-table-second-lvl-row') === null) {
            baseElem = baseElem.querySelector('.attack-table-first-lvl-row');
        } else {
            baseElem = baseElem.querySelector('.attack-table-second-lvl-row');
        }
        let home = document.getElementById('home').title;
        let bt = [];
        let vhost = baseElem.querySelector('input[name=vhost]').value;
        let description = [];
        let possible = [];
        let page = parseInt(elem.value) + 1;
        let loadingContainer = $(elem.parentElement.querySelector('.loading-container.three-lvl'));
        let cc = [];
        elem.remove();
        loadingContainer.show();

        for (let i of baseElem.querySelectorAll('.selected-tags input[name=cc]')) {
            cc.push(i.value);
        }

        if (baseElem.querySelector('.subtag.selected-tags') !== null) {
            for (let i of baseElem.querySelectorAll('.subtag.selected-tags')) {
                bt.push(i.querySelector('input[name=bt]').value);
                description.push(i.querySelector('input[name=description]').value);
                possible.push(i.querySelector('input[name=possible]').value);
            }
        }
        if (baseElem.querySelector('.tag.selected-tags') !== null
            && (bt.length === 0 && description.length === 0 && possible.length === 0)) {
            for (let i of baseElem.querySelectorAll('.tag.selected-tags')) {
                bt.push(i.querySelector('input[name=bt]').value);
            }
        }
        if (bt.length === 0 && description.length === 0 && possible.length === 0) {
            bt.push('');
            description.push('');
            possible.push('');
        }


        $.post(
            home + "get_logs_group/",
            {
                data: JSON.stringify({
                    domain: window.domain,
                    lvl: 3,
                    vhost: vhost,
                    description: description,
                    bt: bt,
                    possible: possible,
                    cc: cc,
                    search: s,
                    page: page,
                    upload: 1,
                    id_log: first_log,
                    start: window.start_date,
                    end: window.end_date,
                    group:group
                }),
                csrfmiddlewaretoken: jQuery("[name=csrfmiddlewaretoken]").val(),
            }
        ).success(
            function (data, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(data);
                    return;
                }
                
                loadingContainer[0].parentElement.remove();

		
		if (group !== 'gpoup'){

                $(block).append(data);
                let btn_load = $(data).find('.loading-container.three-lvl');
                if ($(data).find('.loading-container.three-lvl')[0] !== undefined &&
                    $(data).find('.loading-container.three-lvl')[0] !== null) {
                    btn_load = btn_load[0].parentElement;
                    document.querySelector('tbody > tr > td > div > div.loading-container.three-lvl')
                        .parentElement
                        .parentElement
                        .parentElement
                        .parentElement
                        .remove();
                        
                    $(block.parentElement.parentElement).append($(btn_load));
                }
		}
		
                if(group === 'gpoup'){

                 let table = $(data).find('.table.attack-table').find('tbody')

                $(block).append(table);
                let btn_load = $(data).find('.loading-container.three-lvl');
                if ($(data).find('.loading-container.three-lvl')[0] !== undefined &&
                    $(data).find('.loading-container.three-lvl')[0] !== null) {
                    btn_load = btn_load[0].parentElement;
                    //document.querySelector('div.loading-container.three-lvl')
                        //.parentElement
                        //.parentElement
                        //.parentElement
                        //.parentElement
                        //.remove();
                        
                    $(block.parentElement.parentElement).append($(btn_load));
                
                } 
                }
            }
        ).error(function (response) {
            show_messages_from_response(response.responseText)
        });
    }


}

function drawScanCharts() {
    $("[name='scan-line-chart-filter[]']").each(function () {
        $(this).prop('checked', true);
    });

    $("[name='column_chart_filter[]']").each(function () {
        $(this).prop('checked', true);
    });
    let input_value = $("#search-input").val();
    if (document.querySelector('.title-chart').classList.contains('hidden')) {
        document.querySelector('.title-chart').classList.add('hidden');
    }
    var main_loadingContainer = $('#scan_chart_loading .loading-container_overlay');
    $("#scan_chart_loading").show();
    main_loadingContainer.show();
    let home = document.getElementById('home').title;
    $.get(home + 'get_scan_chart/?&start=' + window.start_date + '&end=' + window.end_date + '&search=' + encodeURIComponent(input_value))
        .success(
            function (data, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(data);
                    return;
                }
                let chart_data = data.data_chart;
                let domain_list = data.domain_list;
                let divFilterList = document.querySelector('#scan_line_chart_filter');
                $(divFilterList).empty();
                for (let filter of domain_list) {
                    let label = document.createElement('label');
                    label.classList.add('checkbox-inline');
                    let checkbox = document.createElement('input');
                    checkbox.type = 'checkbox';
                    checkbox.name = 'scan-line-chart-filter[]';
                    checkbox.className = 'scan-line-chart-filter';
                    checkbox.checked = true;
                    checkbox.value = filter;
                    label.appendChild(checkbox);
                    label.append(filter);
                    divFilterList.appendChild(label)
                }
                drawScanLineChart(chart_data, domain_list);
                document.querySelector('.title-chart').classList.remove('hidden');
                main_loadingContainer.hide();
                $("#scan_chart_loading").hide();
            }
        )
        .error(function (response) {
            show_messages_from_response(response.responseText)
        });


}

function drawScanLineChart(get_data, domain_list) {
    var point_style = 'point {stroke-color: #1a5287; stroke-width: 2; fill-color: none; }';
    var data = new google.visualization.DataTable();
    let colors = {};
    let colorsArray = ['#f24840', '#00b6f4', '#032790', '#eece00', '#a45d1f', '#8a6ac8', '#32BC43',
        '#f20093', '#05f400', '#906852', '#af47ee', '#a45d1f',
        '#c86700', '#00bc6b', '#86bc65', '#7b99bc', 'transparent'];

    data.addColumn('string', 'Date');
    let tmpCounter = 0;
    for (let domain of domain_list) {
        data.addColumn('number', domain);
        colors[domain] = colorsArray[tmpCounter];
        tmpCounter++;
    }
    colors['Empty'] = 'transparent';
    var div_width = $('#scanner').width();
    if (domain_list.length === 0) {
        data.addColumn('number', 'domain');
    } else {
        data.addRows(get_data);

    }

    var options = {
        backgroundColor: 'transparent',
        colors: colorsArray,
        hAxis: {
            textStyle: {
                color: '#7697b7',
                bold: false,
            },
            gridlines: {
                color: 'red',
            },
        },
        vAxis: {
            format: '0',
            textStyle: {
                color: '#7697b7',
                bold: false,
            },
        },
        tooltip: {
            isHtml: true,
            textStyle: {
                fontSize: 14,
            },
        },
        height: 450,
        width: div_width * 0.9,
        legend: {
            position: 'none',
            textStyle: {
                color: '#fafafa',
                backgroundColor: '#134473',
                bold: true,
            },
        },
        chartArea: {top: 30, bottom: 70},
        lineWidth: 2,
        pointSize: 10,
    };

    if (window.innerWidth < 1700) {
        options.width = div_width * 0.9 + 21;
    }

    var chart = new google.visualization.ChartWrapper({
        chartType: 'LineChart',
        containerId: 'scan_line_chart',
        dataTable: data,
        options: options,
    });
    chart.draw();

    var marign = -22 + ((1080 - window.innerHeight) / 10);
    $('#scan_line_chart').css('margin-left', marign);

    if (data.getNumberOfRows() === 0) {
        var new_marign = parseInt($('#scan_line_chart').css('margin-left')) - 8;
        $('#scan_line_chart').css('margin-left', new_marign);

        $('#scan_line_chart_filter').css('margin-top', -45);
    }


    setScanChart = function () {
        state = [];
        $("[name='scan-line-chart-filter[]']:checked").each(function () {
            state.push(this.value)
        });
        if (state.length == 0) {
            data.addColumn('number', 'Empty');
            state.push("Empty");
        }

        var row;
        var view = {
            columns: [0]
        };
        for (var i = 0; i < state.length; i++) {
            view.columns.push(state[i]);
        }

        chart.getOptions().colors = [];
        for (var i = 1; i < view.columns.length; i++) {
            chart.getOptions().colors.push(colors[view.columns[i]]);
        }
        chart.setView(view);
        chart.draw();
    };

    $(".scan-line-chart-filter").change(function () {
        setScanChart();
        if ($(this).prop('checked')) {

        } else {

        }
    });

    document.querySelector('#scan_line_chart_filter').classList.remove('hidden');
}

$(document).on('click', '.scan-row-group', function (e) {

    let is_compare = false;
    if (document.querySelector('#compare-table') != null) {
        is_compare = true;
    }
    var this_row = $(this);
    var row_class = $(this).parent('div').attr('class');
    if (e.target.classList.contains('scan_type') || e.target.parentElement.classList.contains('scan_type')
        || e.target.parentElement.parentElement.classList.contains('scan_type')) {
        return;
    }
    var scanner = $('#scanner').css('display');
    let s = $('#search-input').val();
    let list = this.parentElement.querySelector('.attack-table');
    if (row_class !== 'open' && scanner !== 'none') {
        this.style.background = 'rgba(153, 184, 212, 0.4)';
        this.querySelector('.fa').classList.remove('fa-caret-right');
        if (list !== null) {
            list.parentElement.classList.remove('hidden');
            this_row[0].querySelector('.fa').classList.add('fa-caret-down');
        } else {
            this.querySelector('.fa').classList.add('fa-refresh');

            let type = [];
            let domain = this.querySelector('input[name=domain]').value;
            get_scan_logs(this_row[0], type, domain, s, is_compare);

        }

    } else {
        this.style.background = '';
        if (list !== null) {
            list.parentElement.classList.add('hidden');
        }
        this.querySelector('.fa').classList.remove('fa-caret-down');
        this.querySelector('.fa').classList.add('fa-caret-right');
    }

    $(this).parent('div').toggleClass('open');

});

$(document).on('click', '.scan_type', function () {
    let is_compare = false;
    if (document.querySelector('#compare-table') != null) {
        is_compare = true;
    }

    let this_row = $(this.parentElement.parentElement);
    let divIsOpen = this_row.parent('div')[0].classList.contains('open');
    let notfilter = false;
    if (this.classList.contains('selected-tags')) {
        notfilter = true;
    }
    $(this).addClass('selected-tags');
    let s = $('#search-input').val();
    let domain = this.querySelector('input[name=domain]').value;
    let types = [];

    for (let i of this_row[0].querySelectorAll('.scan_type.selected-tags')) {
        if (!notfilter || i !== this) {
            types.push(i.querySelector('input[name=type]').value);
        }

    }
    if (this.classList.contains('selected-tags')) {
        if (notfilter) {
            this.classList.remove('selected-tags')
        }
        if (divIsOpen) {
            this_row[0].querySelector('.fa').classList.add('fa-refresh');
            this_row[0].querySelector('.fa').classList.remove('fa-caret-down');
        } else {
            this_row[0].querySelector('.fa').classList.add('fa-refresh');
            this_row[0].querySelector('.fa').classList.remove('fa-caret-right');
        }
        get_scan_logs(this_row[0], types, domain, s, is_compare)


    } else {
        this_row[0].querySelector('.fa').classList.remove('fa-refresh');
        this_row[0].querySelector('.fa').classList.add('fa-caret-down');
    }
    if (!divIsOpen) {
        this_row[0].style.background = 'rgba(153, 184, 212, 0.4)';
        this_row.parent('div')[0].classList.add('open');
    }
});

function get_scan_logs(this_row, types, domain, s, is_compare = false) {
    var home = document.getElementById('home').title;
    $.post(
        home + "get_scan_logs/",
        {
            data: JSON.stringify({
                dom: window.domain,
                domain: domain,
                type: types,
                search: s,
                is_compare: is_compare,
                start: window.start_date,
                end: window.end_date,
            }),

            csrfmiddlewaretoken: window.csrftoken,
        })
        .success(function (data, textStatus, xhr) {
                if (xhr.status == 255) {
                    show_messages_from_response(data);
                    return;
                }
                if (this_row.parentElement.querySelector('.attack-table') !== null) {
                    this_row.parentElement.querySelector('.attack-table').parentElement.remove();
                }
                $(this_row).after(data);

                this_row.querySelector('.fa').classList.remove('fa-refresh');
                this_row.querySelector('.fa').classList.add('fa-caret-down');
            }
        ).error(function (response) {
        show_messages_from_response(response.responseText)
    });

}

function upload_data_for_scaner_group(elem) {
    let s = $('#search-input').val();
    let baseElem = elem.parentElement.parentElement.parentElement;
    let block = elem.parentElement.parentElement;
    let is_compare = false;
    if (document.querySelector('#compare-table') != null) {
        is_compare = true;
    }

    block = block.querySelector('.table.attack-table');
    let first_log = parseInt(block.querySelector('.scanner-row').parentElement.id.replace('row_'));
    baseElem = baseElem.querySelector('.scan-row-group');
    let home = document.getElementById('home').title;
    let types = [];
    let domain = baseElem.querySelector('input[name=domain]').value;
    let page = parseInt(elem.value) + 1;
    let loadingContainer = $(elem.parentElement.querySelector('.loading-container.three-lvl'));
    elem.remove();
    loadingContainer.show();

    if (baseElem.querySelector('.scan_type.selected-tags') !== null) {
        for (let i of baseElem.querySelectorAll('.scan_type.selected-tags')) {
            types.push(i.querySelector('input[name=type]').value);
        }
    }
    if (types.length === 0) {
        types.push('');
    }


    $.post(
        home + "get_scan_logs/",
        {
            data: JSON.stringify({
                dom: window.domain,
                domain: domain,
                type: types,
                search: s,
                upload: 1,
                is_compare: is_compare,
                page: page,
                id_log: first_log,
                start: window.start_date,
                end: window.end_date,
            }),

            csrfmiddlewaretoken: window.csrftoken,
        }
    ).success(
        function (data, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(data);
                return;
            }
            loadingContainer[0].parentElement.remove();
            $(block).append(data);
            let btn_load = $(data).find('.loading-container.three-lvl');
            if ($(data).find('.loading-container.three-lvl')[0] !== undefined &&
                $(data).find('.loading-container.three-lvl')[0] !== null) {
                btn_load = btn_load[0].parentElement;
                document.querySelector('tbody > tr > td > div > div.loading-container.three-lvl')
                    .parentElement
                    .parentElement
                    .parentElement
                    .parentElement
                    .remove();
                $(block.parentElement).append($(btn_load));
            }

        }
    ).error(function (response) {
        show_messages_from_response(response.responseText)
    });
}

$(document).on('click', function (e) {
    if (e.target.closest('.pop') == null && e.target.closest('.popover-content') == null && !e.target.classList.contains('.popover-content') && !e.target.classList.contains('.pop')) {
        $('[data-toggle=popover]').each(function () {
            // hide any open popovers when the anywhere else in the body is clicked
            $(this).popover('hide');
        });

    }
});

$(document).on('scroll', function (e) {
    $('[data-toggle=popover]').each(function () {
        // hide any open popovers when the anywhere else in the body is clicked
        $(this).popover('hide');
    });
});

/**
 * Function to show Add key modal window
 */
function show_modal_AddKey() {
    $("#add_key").modal("show");
}

/**
 * Sending a request to add a key
 */
function send_request_to_add_key() {
    let home = document.getElementById('home').title;
    $('#key_exist').css({'display': 'none'});
    $('#key_not_valid').css({'display': 'none'});
    $('#key_error').css({'display': 'none'});
    $('#tariff_not_valid').css({'display': 'none'});
    $('#email_error').css({'display': 'none'});
    $('#add_key_key_input').css({'border-color': '#D5E4F3'});
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + 'waf_settings/add_key/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#add_key_form').serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $('#key_exist').css({'display': 'none'});
            $('#key_not_valid').css({'display': 'none'});
            $('#waf_id_exist').css({'display': 'none'});
            $('#key_error').css({'display': 'none'});
            $('#email_error').css({'display': 'none'});
            $('#error_plan').css({'display': 'none'});
            $('#error_plan').css({'display': 'none'});
            if (response === '{"status": "key exist"}') {
                $('#key_exist').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "not valid"}') {
                $('#key_not_valid').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "waf id exist"}') {
                $('#waf_id_exist').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "error"}') {
                $('#key_error').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "email error"}') {
                $('#email_error').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else if (response === '{"status": "Not available for this plan"}') {
                $('#error_plan').css({'display': 'block'});
                $('#add_key_key_input').css({'border-color': '#f2c6c2'});
            } else {
                let key_length = $("#add_key_key_input").val().length;
                $("#last_row_key_table").before(response);
                $("#add_key_form")[0].reset();
                $("#add_key").modal("hide");
            }
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Sending a request to edit key
 * @param id Key id
 */
function edit_key(id) {
    let home = document.getElementById('home').title;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + 'waf_settings/edit_key/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: $('#edit_key_form_' + id).serialize(),
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            let data = $.parseJSON(response);
            let description = $('#edit_key_input_' + id).val();
            data.keys.forEach(function (item, i, arr) {
                $('#list_key_table_row_description_' + item).text(description);
                $('#delete_key_input_' + item).val(description);
                $('#edit_key_input_' + item).val(description);
            });
            $("#key_edit_" + id).modal("hide");

        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

/**
 * Sending a request to delete key
 * @param id Key id
 */
function removeKey(id) {
    let home = document.getElementById('home').title;
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    event.preventDefault();
    $.ajax({
        url: home + 'waf_settings/remove_key/',
        headers: {'X-CSRFToken': csrftoken},
        type: "POST",
        dataType: "html",
        data: {key_id: id},
        success: function (response, textStatus, xhr) {
            if (xhr.status == 255) {
                show_messages_from_response(response);
                return;
            }
            $("#list_key_table_row_" + id).hide();
        },
        error: function (response) {
            show_messages_from_response(response.responseText)
        }
    });
}

$(document).on('scroll', function (e) {
    $('[data-toggle=popover]').each(function () {
        // hide any open popovers when the anywhere else in the body is clicked
        $(this).popover('hide');
    });
});

function toggle_2fa(input) {
    // todo refactoring: move to user
    // used in two_factor_auth_render.html
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    let home = document.getElementById('home').title;
    $("#success2FA").hide()

    if (input.checked) {
        $("#check_2FA_form").show()
    } else {
        $(".qr_block").hide()
        $("#check_2FA_form").hide()
    }

    $.ajax({
        url: home + 'render_2fa/',
        type: "POST",
        data: {
            box_value: input.checked,
            csrfmiddlewaretoken: csrftoken
        },
        success: function (response) {
            $("#qrcode").attr('src', response.qrcode);
            secret_2FA_key = response.secret_2FA_key;
            if (!input.checked) {
                $(".qr_block").hide();
            } else {
                $(".qr_block").show();
                key2FA.innerText = secret_2FA_key
            }
        },

        error: function (response) {
        }
    });
}


function check_and_turn_on_2fa() {
    // todo refactoring: move to user
    // used in two_factor_auth_render.html
    const csrftoken = document.querySelector('[name=csrfmiddlewaretoken]').value;
    // let home = document.getElementById('home').title;
    let input_code = document.getElementById('code_input').value;

    $.ajax({
        url: home + 'check_and_turn_on_2fa/',
        type: "POST",

        data: {
            csrfmiddlewaretoken: csrftoken,
            code_input: input_code,
            secret_2FA_key: secret_2FA_key
        },


        success: function (response) {
            $("#success2FA").show()
            $("#error2FA").hide()
            $("#check_2FA_form").hide()
        },

        error: function (response) {
            $("#success2FA").hide()
            $("#error2FA").show()
            $("#code_input").val('')
        }
    });
}


$(document).ready(function () {
    // todo refactoring: move to user
    // used in two_factor_auth_render.html
    if (document.querySelector('#qrcode') !== null) {
        $.ajax({
            url: home + 'render_2fa/',
            type: 'GET',
            success: function (response) {
                $("#qrcode").attr('src', response.qrcode);
            }
        });
    }
});

$(document).on('mouseover', '.attack-table-first-row', function (e) {

    if (e.currentTarget.classList.contains('scanner-row')){
        return;
    }
    let ip = e.currentTarget.querySelector('.ips-container').innerText;
    let nextElem = e.currentTarget.parentElement.nextElementSibling;
    let prevElem = e.currentTarget.parentElement.previousElementSibling;
    if (!nextElem || !prevElem){
        return;
    }
    let btn = e.currentTarget.querySelector('.hidden-dupl-ip i');
    
    if ($(btn).attr('info') === undefined){
    let prevNotIP = ip.replaceAll(/(\r\n|\n|\r|\s)/gm, '') !== prevElem.querySelector('.ips-container').innerText.replaceAll(/(\r\n|\n|\r|\s)/gm, '');
    let nextIncludeIP = ip.replaceAll(/(\r\n|\n|\r|\s)/gm, '') === nextElem.querySelector('.ips-container').innerText.replaceAll(/(\r\n|\n|\r|\s)/gm, '');
    if (prevNotIP && nextIncludeIP) {
        let isShow = false;
        if (btn == null) {
            btn = e.currentTarget.querySelector('.show-dupl-ip i')
            isShow = true;
        }
        btn.style.visibility = 'visible';
        if (isShow) {
            btn.title = pgettext('toggle_show_attacks_for_ip', 'Show attacks by IP');
        } else {
            btn.title = pgettext('toggle_show_attacks_for_ip', 'Hide attacks by IP');

        }
        }
    }
}).on('mouseout', '.attack-table-first-row', function (e) {

    let btn = e.currentTarget.querySelector('.hidden-dupl-ip i');

    if ($(btn).attr('info') === undefined){

    if (btn !== null) {
    
        btn.style.visibility = 'hidden';
        btn.title = pgettext('toggle_show_attacks_for_ip', 'Show attacks by IP');
    }
    }
})

$(document).on('click', '.hidden-dupl-ip', function (e) {

    let ip = e.currentTarget.closest('tbody').querySelector('.ips-container').innerText;
    let nextElem = e.currentTarget.closest('tbody').nextElementSibling;
    let listNextElem = [];
    while (nextElem !== null &&
    ip.replaceAll(/(\r\n|\n|\r|\s)/gm, '') === nextElem.querySelector('.ips-container').innerText.replaceAll(/(\r\n|\n|\r|\s)/gm, '')) {
        listNextElem.push(nextElem);
        nextElem = nextElem.nextElementSibling;
    }

    for (let i of listNextElem) {
        $(i).hide();
    }

    e.currentTarget.closest('tbody').querySelector('.hidden-dupl-ip').classList.add('show-dupl-ip');
    e.currentTarget.closest('tbody').querySelector('.hidden-dupl-ip i').classList.remove('fa-angle-up');
    e.currentTarget.closest('tbody').querySelector('.hidden-dupl-ip i').classList.add('fa-angle-down');
    e.currentTarget.closest('tbody').querySelector('.hidden-dupl-ip').classList.remove('hidden-dupl-ip');
    
})


$(document).on('click', '.show-dupl-ip', function (e) {
    let ip = e.currentTarget.closest('tbody').querySelector('.ips-container').innerText;
    let nextElem = e.currentTarget.closest('tbody').nextElementSibling;
    let listNextElem = [];
    while (nextElem !== null &&
    ip.replaceAll(/(\r\n|\n|\r|\s)/gm, '') === nextElem.querySelector('.ips-container').innerText.replaceAll(/(\r\n|\n|\r|\s)/gm, '')) {
        listNextElem.push(nextElem);
        nextElem = nextElem.nextElementSibling;
    }

    for (let i of listNextElem) {
        $(i).show();
    }

    e.currentTarget.closest('tbody').querySelector('.show-dupl-ip').classList.add('hidden-dupl-ip');
    e.currentTarget.closest('tbody').querySelector('.show-dupl-ip i').classList.remove('fa-angle-down');
    e.currentTarget.closest('tbody').querySelector('.show-dupl-ip i').classList.add('fa-angle-up');
    e.currentTarget.closest('tbody').querySelector('.show-dupl-ip').classList.remove('show-dupl-ip');
})
