from django.apps import AppConfig
from reportlab.pdfbase import pdfmetrics
from reportlab.pdfbase.ttfonts import TTFont
from pathlib import Path
from django.conf import settings


class ReportConfig(AppConfig):
    name = 'report'

    def ready(self):
        # todo refactor move fonts to report
        pdfmetrics.registerFont(TTFont('Calibri', Path(settings.BASE_DIR, 'main/static/fonts/Calibril.ttf')))
        pdfmetrics.registerFont(TTFont('Calibril', Path(settings.BASE_DIR, 'main/static/fonts/Calibril.ttf')))
        pdfmetrics.registerFont(TTFont('FreeSans', Path(settings.BASE_DIR, 'main/static/fonts/FreeSans.ttf')))
        pdfmetrics.registerFont(TTFont('RobotoMono-Regular', Path(settings.BASE_DIR, 'main/static/fonts/RobotoMono-Regular.ttf')))
