from django.conf import settings
from django.shortcuts import redirect, render
from django.utils import translation

from main.decorators import time_of_function


@time_of_function
def set_lang(request, lang):
    user_lang = lang
    translation.activate(user_lang)
    if request.session.get(settings.LANGUAGE_COOKIE_NAME) is None:
        request.session[settings.LANGUAGE_COOKIE_NAME] = user_lang
    response = redirect(request.path)
    response.set_cookie(settings.LANGUAGE_COOKIE_NAME, user_lang)
    return response


def check_and_set_lang(context, request):
    if request.COOKIES.get(settings.LANGUAGE_COOKIE_NAME) is None:
        user_lang = settings.LANGUAGE_CODE
        translation.activate(user_lang)
    else:
        user_lang = request.COOKIES.get(settings.LANGUAGE_COOKIE_NAME)
    response = render(request, 'login.html', context)
    if request.COOKIES.get(settings.LANGUAGE_COOKIE_NAME) is None:
        response.set_cookie(settings.LANGUAGE_COOKIE_NAME, user_lang)
    return response
