import logging
from curses import wrapper


def _fake_spool(func):
    @wrapper
    def func_wrapper(**arguments):
        return func(arguments)

    return func_wrapper


def get_spool_decorator(logger=None):
    try:
        from uwsgidecorators import spool
        return spool
    except Exception as e:
        if not logger:
            logger = logging.getLogger(__name__)
        logger.exception(
            f'An error occurred while importing spool: the task will be executed asynchronously. Traceback: {e}')
        return _fake_spool
